<?php
// $Header: /home/CVS/rps/cust/cont_filter.php,v 1.3 2008/03/05 08:17:30 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

	require_once('../includes/db.inc');

  $FldList = array(
	'lcshow' => array(
		'name' => 'Show Contacts/Leads',
		'input' => 'select',
		'values' => array(1=>'Show Contacts', 2=>'Show Leads'),
		'local' => TRUE),
        'customer_id' => array(
                'name'=>'Account',
                'input' => 'select',
                'values' => &$customers_2d['name']),
	'u|reg_date'=> array(
                'name'=>'Registration Date',
                'input' => 'date'),
        'full_name'=>array(
                'name'=>'Name',
                'input' => 'text'),
	'rpp' => array(
                'name'=>'Contacts Per Page',
                'input' => 'rselect',
                'values' => array(10=>10,20=>20,25=>25,50=>50),
		'local' => TRUE)
	);

  $OutputFormat =array(
  	'Name' => array('field' => 'full_name',
  		'sort_field' => 'u.last_name',
  		'eval'=>'$uh=&$obj->unwrap_hash($row);
  			$tmp=html_safe_text(trim($uh[\'last_name\']).", ".$uh[\'first_name\']." ".$uh[\'first_name:\']);',
  		'abc_field' => 'last_name',
  		'abc_title' => 'Last Name',
  		'abc_sql' => "SELECT %s FROM users WHERE !(user_is&".USER_IS_HIDDEN.") AND user_is&".USER_IS_CUSTOMER),
        'Account' => array('field' => 'cname'),
        'Title' => array('field' => 'title'),
        'Email' => array('field' => 'email'),
        'opt-out' => array('field' => 'copt',
        	'sort_field' => 'copt&'.CONT_OPT_EOPTOUT,
        	'eval'=>'$tmp=$row[\'copt\']&'.CONT_OPT_EOPTOUT.'?"opt-out":"no";',
        	'align' => 'center'),
        'Phone' => array('field' => 'tel',
        	'align' => 'center'),
        'call' => array('field' => 'copt',
        	'sort_field' => 'copt&'.CONT_OPT_DONTCALL,
        	'eval'=>'$tmp=$row[\'copt\']&'.CONT_OPT_DONTCALL.'?"dont-call":"ok";',
        	'align' => 'center'),
        'delete' =>array('field' => '',
        	'checkbox'=>'xdelete',
        	'eval' =>'$tmp=$obj->can_delete($row[\'uid\']);',
        	'align' => 'center')
        );

  require_once('includes/cust/contacts.inc');
  require_once('includes/params/user_filters.inc');

  if($is_customer)
	_quit_error("You are not allowed to use this part of the site.");

	$lcont_uid=0;
	$sql_edit=array();

	$start=0;

	$contacts=new Contacts();
	$wfid='cont';
	$filters=new UserFilters($wfid);
	$lfilter=&$filters->get_last_filter($lfid);

  if(isset($_POST['isSearch'])){
	if(isset($_POST['fid']) && $_POST['fid']){
		$fid=$_POST['fid'];
        	header("Location: ".$_SERVER['PHP_SELF']."?lfid=".$fid);
        	exit;
	}

	$lfilter->punset('letter');
	$filters->post2filter($FldList,$lfilter);

        header("Location: ".$_SERVER['PHP_SELF']."?sort=1&hlp=_post");
        exit;
  }

  if(isset($_POST['saveFilter'])){
        $sort=$_POST['sort'];
        $start=$_POST['start'];
        if($_POST['fid'])
                $filters->update_filter_from_id($_POST['fid'],$lfid);
        elseif(is_synopsis($_POST['new_filter']) && $lfid)
                $filters->create_filter_from_id($lfid,$_POST['new_filter']);
        header("Location: ".$_SERVER['PHP_SELF']."?sort=$sort&start=$start&hlp=_post");
        exit;
  }

   if(isset($_POST['checkbox']) && ($_POST['checkbox']=="xdelete")){
   	$sort=$_POST['sort'];
        $start=$_POST['start'];
	if(isset($_POST['xdelete'])) {
		$xdelete=$_POST['xdelete'];
		foreach($xdelete as $del_uid){
			if($contacts->can_delete($del_uid)){
				$query="DELETE FROM contacts WHERE uid=$del_uid";
				if(!@mysql_query($query))
					die2(__FILE__.':'.__LINE__.' Could not delete from contacts table. ');

				$query="DELETE FROM users WHERE uid=$del_uid AND user_is&".USER_IS_CUSTOMER." LIMIT 1";
				if(!@mysql_query($query))
					die2(__FILE__.':'.__LINE__.' Could not delete from users table. ');
			}

		}
	}
	$_POST=array();
	header("Location: ".$_SERVER['PHP_SELF']."?sort=$sort&start=$start&hlp=_post");
	exit;
  }

  $page_title='Contacts and Leads Filter';
  include_once('includes/header.inc');


  if(isset($_GET['sort'])){
  	$sort=$_GET['sort'];

  	if(isset($_GET['letter'])){
  		if($_GET['letter'])
  			$lfilter->pset('letter',$_GET['letter']);
  		else
  			$lfilter->punset('letter');

  		$lfilter->save();
  		// because filters are not re-entrant
  		// sort_and_print wont see the 'letter' parameter
  		header("Location: ".$_SERVER['PHP_SELF']."?sort=$sort&hlp=_post");
		exit;
	}

	$WHERE=$filters->filter2sql_where($lfid);

	$lcshow=$lfilter->pget('lcshow');
	if(!$lcshow || ($lcshow == "1,2") || ($lcshow == "2,1"))
		$lcshow="all";

	$WHERE.=($lcshow==="all"?'':($lcshow==2?"AND c.options&".CONT_OPT_LEAD:"AND ((c.options IS NULL) OR (c.options&".CONT_OPT_LEAD.")=0)"));

	$extra= '
		[<a href="javascript:cont_view_win_open(0)">ADD NEW CONTACT</a>]&nbsp;&nbsp;
		[<a href="cont_import.php">CSV IMPORT</a>]';

	$query="SELECT u.*, c.title, c.tel, u.uid AS rid, c.options AS copt, cust.name AS cname FROM (SELECT *, CONCAT(last_name,', ',first_name) AS full_name FROM users WHERE !(user_is&".USER_IS_HIDDEN.") AND user_is&".USER_IS_CUSTOMER.") AS u LEFT JOIN contacts AS c ON u.uid=c.uid LEFT JOIN customers AS cust ON u.customer_id=cust.cid WHERE 1 $WHERE";
	//echo "$query <br>\n";
	//if(!($result=@mysql_query($query)))
	//	_die2(__FILE__.':'.__LINE__.' Could not select from users table.');
	$filters->sort_and_print($OutputFormat,$query,$contacts,$extra);
	require_once("includes/footer.inc");
	exit;
  }


  if(isset($_GET['lfid']) && $_GET['lfid']){
        $cfid=$_GET['lfid'];
        $cfilter=&$filters->get_filter_by_id($cfid);
        if($cfilter){
                $lfilter=&$cfilter;
                $lfid=$cfid;
        }
  }

  $filters->print_filter_panel($FldList,$lfid);
  include('includes/footer.inc');
?>

