<?php
// $Header: /home/CVS/rps/dashboard.php,v 1.13 2008/03/05 19:27:13 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

define ('DBRD_VIEW_MAIN', 0);
define ('DBRD_VIEW_ACTIVE', 1);

  $hide_header=TRUE;
  $hide_logo=TRUE;
  $RequireLogin=4;
  $RequireLoginErrCallback='_communicate_failure';
  require_once('./includes/db.inc');
  require_once('includes/dashboard.inc');

  $dbrd=new DashBoard();

  if(isset($_GET['dids_order']) && $_GET['dids_order']){
	$dids=array();
	$tmp=stripslashes(trim($_GET['dids_order']));
	if(preg_match("/^(\d+[,\d]+)$/",$tmp,$matches))
		$dids=explode(',',$tmp);
	elseif(preg_match("/^(\d+)$/",$tmp,$matches))
		$dids=array($tmp);
	elseif(!empty($tmp))
		_communicate_failure('Incorrect dids_order specified.');

	if(!isset($_GET['page']) || !$_GET['page'])
		_communicate_failure('No page parameter specified.');


	$dbrd->remove_unknown($uid,$_GET['page'],$dids);

	foreach($dids as $k => $did)
		$dbrd->update_order($did,$k);

	update_client($dbrd,$_GET['page']);
	exit;
  }

  if(isset($_GET['size_did']) && $_GET['size_did']){
	$tmp=stripslashes(trim($_GET['size_did']));
	if(!preg_match("/^(\d+)$/",$tmp,$matches))
		_communicate_failure('Incorrect did parameter specified.');
	$did=$tmp;

	$tmp=stripslashes(trim($_GET['sz']));
	if(!preg_match("/^(\d+)$/",$tmp,$matches))
		_communicate_failure('Incorrect sz parameter specified.');
	$sz=$tmp>3?3:$tmp;

	if(!isset($_GET['page']) || !$_GET['page'])
		_communicate_failure('No page parameter specified.');

	if($sz>0)
		$dbrd->update_size($did,$sz);
	else
		$dbrd->remove($did);

	update_client($dbrd,$_GET['page']);
	exit;
  }

  if(isset($_POST['page'])){
  	if(!$_POST['page'])
		_quit_error('No page parameter specified.');

	$nav_menu=trim(stripslashes($_POST['page']));

	if(isset($_POST['dashlet'])){
		foreach($_POST['dashlet'] as $ycycm){
			$a=explode('/',$ycycm);
			if(count($a)!=2)
				continue;
			$dbrd->add_dashlet($uid,$nav_menu,$a[0],$a[1]);
		}
		header("Location: ".$_SERVER['PHP_SELF']."?edit=".$nav_menu."&reload=true");
		exit;
	}


	if(isset($_POST['did'])){
		$did=$_POST['did'];
		$dp=&new DashletParams($did);
		$save=FALSE;
		foreach($_POST as $yfn => $nfnv){
			if(substr($yfn,0,4)!='yxl_')
				continue;

			$fn=substr($yfn,4);
			$fnv=$dp->pget($fn);

			if(is_array($nfnv))
				$nfnv=implode(',',$nfnv);

			//echo "$fn $fnv '$nfnv'<br>\n";
  			if($nfnv!=$fnv){
  				$dp->pset($fn,$nfnv);
  				$save=TRUE;
  			}
  		}

  		if($save)
  			$dp->save();

		header("Location: ".$_SERVER['PHP_SELF']."?edit=".$nav_menu."&dvm=".DBRD_VIEW_ACTIVE."&did=$did".($save?"&reload=true":''));
		exit;
	}

	header("Location: ".$_SERVER['PHP_SELF']."?edit=".$nav_menu);
	exit;
  }

  if(isset($_POST['feedback'])){
	$feedback = str_replace("\r", "", stripslashes($_POST['feedback']));
 	if(!empty($_POST['feedback']))
		yxl_mail('support@yoxel.com','Feedback',format_text($feedback),"From: ".$_SESSION['uem']);
	header("Location: ".$_POST['return']);
	exit;
  }

  $did=FALSE;
  $dvm=DBRD_VIEW_MAIN;
  if(isset($_GET['dvm']))
	$dvm=$_GET['dvm'];

  if(isset($_GET['did'])){
	$did=$_GET['did'];
	$dvm=DBRD_VIEW_ACTIVE;
  }

  if(isset($_GET['edit']) && $_GET['edit']){
	$nav_menu=trim(stripslashes($_GET['edit']));
	if(isset($_GET['reload']) && ($_GET['reload']=="true"))
		$on_load_str="window.opener.location.reload(true);";
  }else
	_communicate_failure('No page parameter specified.');

  $ycs=$dbrd->get_available_ycs($nav_menu);
  $include=array();
  foreach($ycs as $yc)
	arr_push($include,$dashboard_search_classes[$yc]['inc']);

  foreach($include as $inc)
	require_once($inc);

  $hide_header = true;
  $hide_logo = true;
  $on_resize_str="save_geom('geomDBRD')";
  require_once "includes/header.inc";

  if(isset($_GET['edit']) && $_GET['edit'])
  	view_menu($nav_menu,$dvm,$did);

  if(isset($_GET['edit']) && $_GET['edit'] && ($dvm==DBRD_VIEW_ACTIVE) && $did){
  	$dashlets=&$dbrd->construct_dashboard($nav_menu,$uid,TRUE);
  	if(!isset($dashlets[$did]['edit']) || (count($dashlets[$did]['edit'])<1))
  		_quit_error(" The dashlet is not customizable");

  	$dp=&new DashletParams($did);

  	echo '
<script>
<!--
function go(frm){
        collect_all(frm);
        frm.submit();
        disable_form(frm);
}
//-->
</script>

  <form action="'.$_SERVER['PHP_SELF'].'" method="post">
  <input type="hidden" name="page" value="'.$nav_menu.'">
  <input type="hidden" name="did" value="'.$did.'">
  <table width="98%" class="dgray" border="0" cellpadding="0" cellspacing="1" align="center">
  <caption>Configuration parameters of the dashlet</caption>';

  	foreach($dashlets[$did]['edit'] as $fn => $inf){
  		$yfn='yxl_'.$fn;
		$fnv=$dp->pget($fn);
  		echo '
  <tr class="lgray">
  	<th>'.html_safe_text($inf['title']).'</th>
  	<td>';
  		if(isset($inf['options'])){
			$fnv=explode(',',$fnv);
  			$mult=isset($inf['multiple']) && $inf['multiple'];

  			$ml=0;
  			foreach($inf['options'] as $str)
  				if(($l=mb_strlen($str))>$ml) $ml=$l;
  			if($ml>32) $ml=32;
  			if($ml<8) $ml=5;
  			echo '
  		<select class="selec" style="width: '.$ml.'em" name="'.$yfn.($mult?'[]" multiple size=5':'"').'>';
  			foreach($inf['options'] as $k => $str){
  				echo '
  			<option value="'.$k.'"'.(in_array($k,$fnv)?' selected':'').'>'.html_safe_text($str).'</option>';
  			}
  			echo '
  		</select>';
  		}elseif(isset($inf['yxl_options'])){
  			$fnv=explode(',',$fnv);
			echo gen_yxl_select($yfn,$inf['yxl_options'],$fnv,TRUE);
		}else{
  			if(($fn=='header') && !$fnv && isset($dashlets[$did][$fn]))
  				$fnv=$dashlets[$did][$fn];
  			echo '
  		<input type="text" class="inp" name="'.$yfn.'" value="'.$fnv.'" size="64" maxlength="127">';
  		}

  		echo '
  	</td>
  </tr>';
  	}

	echo '
  </table>
  <center>
  	<input type="button" class="wbtn" name="" value="edit" onClick="go(this.form)">';
  	echo '
  <br><br>
 	<input type="button" class="btn_large" value="  CLOSE WINDOW  " onClick="window.close();">
  </center>
  </form>';
  	require_once('includes/footer.inc');
	exit;
  }

  if(isset($_GET['edit']) && $_GET['edit'] && ($dvm==DBRD_VIEW_ACTIVE)){
	$dashlets=&$dbrd->construct_dashboard($nav_menu,$uid,TRUE);
  	echo '
  <form action="'.$_SERVER['PHP_SELF'].'" method="post">
  <input type="hidden" name="page" value="'.$nav_menu.'">
  <table width="98%" class="dgray" border="0" cellpadding="0" cellspacing="1" align="center">
  <caption>Active dashlets for the current dashboard page</caption>
  <tr class="hgray">
	<th>Order</th>
	<th>ID</th>
  	<th>Module</th>
  	<th align="left">Description</th>
  	<th>Type</th>
  	<th>Customizable</th>
  </tr>
  <tr class="separator">
	<td height="1" colspan=6></td>';

	$order=0;
	foreach(array_keys($dashlets) as $did){
		$dp=&new DashletParams($did);
		if(!($dhdr=$dp->pget('header')))
			$dhdr=$dashlets[$did]['header'];

		$order++;
		echo '
  <tr class="lgray">
	<th>'.$order.'</th>
	<th>'.$did.'</th>
  	<td align="center">'.html_safe_text($dashboard_search_classes[$dashlets[$did]['yoxel_class']]['comment']).'</td>
	<td>'.html_safe_text($dhdr).'</td>
	<td>'.$dashlets[$did]['type'].'</td>
	<td align="center">'.(isset($dashlets[$did]['edit'])?'<a href="'.$_SERVER['PHP_SELF'].'?edit='.$nav_menu.'&dvm='.DBRD_VIEW_ACTIVE.'&did='.$did.'">edit</a>':'no').'</td>';
	}
	echo '
  </table>
  </form>
  <center>
  <br><br>
 	<input type="button" class="btn_large" value="  CLOSE WINDOW  " onClick="window.close();">
  </center>
  </form>';
  	require_once('includes/footer.inc');
	exit;
  }

  if(isset($_GET['edit']) && $_GET['edit'] && ($dvm==DBRD_VIEW_MAIN)){
  	$cm2n=$dbrd->dashlet_usage_count($uid,$nav_menu);
  	echo '
  <form action="'.$_SERVER['PHP_SELF'].'" method="post">
  <input type="hidden" name="page" value="'.$nav_menu.'">
  <table width="98%" class="dgray" border="0" cellpadding="0" cellspacing="1" align="center">
  <caption>Available dashlets that can be added to the dashboard page</caption>';

  	$empty=TRUE;
  	foreach($ycs as $yc){
		$header = '
  <tr bgcolor="white" style="height:2em">
  	<th colspan="4" align="left" valign="bottom">MODULE: '.html_safe_text($dashboard_search_classes[$yc]['comment']).'</th>
  </tr>
  <tr class="hgray">
  	<th align="left">Description</th>
  	<th>Type</th>
  	<th>Active</th>
  	<th>Add</th>
  </tr>
  <tr class="separator">
  	<td colspan="4" height="1"></td>
  </tr>';
		$str="\$obj= new $yc();";
		eval($str);

		$class_methods = get_class_methods($yc);
		$content='';
		foreach($class_methods as $ycm){
			if(substr($ycm,0,11)!='_dashboard_')
				continue;

			$ycycm=$yc.'/'.substr($ycm,11);
                        $str="\$info=\$obj->$ycm(0,$uid,TRUE);";
                        eval($str);

                        if(!$info)
				continue;

			$type='';
                        if(is_array($info)){
				if(count($info)<1)
					continue;
				if(isset($info['only'])){
					$l=strlen($info['only']);
					if(substr($nav_menu,-$l,$l)!=$info['only'])
						continue;
				}

				$hdr=$info['header'];
				$type=$info['type'];
			}else
				$hdr=$info;

			$content.= '
  <tr class="lgray">
  	<td>'.html_safe_text($hdr).'</td>
  	<td align="center">'.$type.'</td>
  	<td align="center">'.(isset($cm2n[$ycycm])?'<a href="'.$dir_name.'/dashboard.php?edit='.$nav_menu.'&dvm='.DBRD_VIEW_ACTIVE.'">'.$cm2n[$ycycm].'</a>':0).'</td>
  	<td align="center">
  		<input type="checkbox" name="dashlet[]" value="'.$ycycm.'" /></td>
  </tr>';
		}
		if($content){
			$empty=FALSE;
			echo $header.$content;
		}
	}
	if($empty)
		echo '
  <tr>
  	<th>(no dashlets available for this page)</th>';
	echo '
  </table>
  <center>';
  	if(!$empty)
  		echo '
  	<input type="submit" class="wbtn" name="submit" value="add"">';
  	echo '
  <br><br>
 	<input type="button" class="btn_large" value="  CLOSE WINDOW  " onClick="window.close();">
  </center>
  </form>';
  	require_once('includes/footer.inc');
	exit;
  }

  function _communicate_failure($msg){
?>

<script language='JavaScript'>
<!--
  alert('<?php echo $msg; ?>');
  if(window.opener)
  	window.close();
  parent.OrganizeDashboard();
//-->
</script>

<?php
  }

 function update_client(&$dbrd,$nav_menu){
	global $uid;

	$did2sz=$dbrd->get_did2sz($uid,$nav_menu);
	$dids=array_keys($did2sz);

	$dids_str=''; $dsz_str='';
        foreach($dids as $k => $did){
                $dids_str.="\n".'  dids['.$k.']='.$did.';';
                $dsz_str.="\n".'  dsz['.$k.']='.$did2sz[$did].';';
        }
?>

<script language='JavaScript'>
<!--

<?php
        echo '
  var dids = new Array();'.$dids_str.'
  var dsz = new Array();'.$dsz_str."\n";
?>

  parent.dids=dids;
  parent.dsz=dsz;
  parent.OrganizeDashboard();

//-->
</script>
<?php
	return;
  }

  function view_menu($nav_menu,$dvm=DBRD_VIEW_MAIN,$did=FALSE){
	  global $dir_name;
	  global $is_customer;

	  if(!$nav_menu)
	  	return;


	$main_here	= ($dvm == DBRD_VIEW_MAIN)?' class="here"' : '';
	$active_here	= ($dvm == DBRD_VIEW_ACTIVE) && !$did?' class="here"' : '';
	$dashlet_here	= ($dvm == DBRD_VIEW_ACTIVE) && $did?' class="here"' : '';
	$dtxt = menu2name($nav_menu);
	if($did)
		$dtxt.=", dashlet $did";

	echo '
         <ul id="topnav">
            <li><a href="'.$dir_name.'/dashboard.php?edit='.$nav_menu.'&dvm='.DBRD_VIEW_MAIN.'" '.$main_here.'>available dashlets</a></li>
            <li><a href="'.$dir_name.'/dashboard.php?edit='.$nav_menu.'&dvm='.DBRD_VIEW_ACTIVE.'" '.$active_here.'>active dashlets</a></li>';
	if($did)
		echo '
            <li><a href="'.$dir_name.'/dashboard.php?edit='.$nav_menu.'&dvm='.DBRD_VIEW_ACTIVE.'&did='.$did.'" '.$dashlet_here.'>customize dashlet</a></li>';
	echo '
	</ul>
	<div class="title" style="width:100%; text-align:center; background-color: #DDE0E1;">'.$dtxt.'</div><br>';
  }

  function menu2name($nav_menu){
	global $top_top_navigation;

	$a=explode('/',$nav_menu);

	$ttnavn='UNKNOWN';
	if(isset($top_top_navigation[$a[0]]))
		$ttnavn=$top_top_navigation[$a[0]]['name'];

	$menu_tag='dbrd_menu2name:'.$a[1];
	$menun='unknown dashboard page';
	if(isset($_SESSION[$menu_tag]))
		$menun=$_SESSION[$menu_tag];

	return "DASHBOARD PAGE: [$ttnavn] $menun";
}
