<?php
// $Header: /home/CVS/rps/ets/ets_query.php,v 1.10 2008/05/04 00:19:13 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('../includes/db.inc');
require_once('includes/ets/ets.inc');

if($is_customer)
	_quit_error("You are not allowed to use this part of the site.");

  $rts = new EvalTracker();
  $pqs_2d=&$rts->pqs_2d;

  $FldList = array(
	'r|pid' => array(
		'name'=>'Product',
		'input' => 'select',
		'values' => &$pqs_2d['name'],
		'vbc'=>TRUE),
	'customer_id'=> array(
		'name'=>'Customer',
		'input' => 'select',
		'values' => &$customers_2d['name'],
		'vbc'=>FALSE),
	'state'=> array(
		'name'=>'State',
		'input' => 'select',
		'values' => &$rts->state2str,
		'vbc'=>TRUE),
	'class'=> array(
		'name'=>'Eval Plan',
		'input' => 'select',
		'values' => &$rts->class2str,
		'vbc'=>TRUE),
	'fixer_uid'=> array(
		'name'=>'Implementer',
		'input' => 'select',
		'values' => '%workers',
		'vbc'=>FALSE),
	'filed_by'=> array(
		'name'=>'Submitter',
		'input' => 'select',
		'values' => '%submitters',
		'vbc'=>TRUE),
	'synopsis'=>array(
		'name'=>'Synopsis',
		'input' => 'text',
		'vbc'=>TRUE),
	'description'=>array(
		'name'=>'Description',
		'input' => 'text',
		'vbc'=>TRUE),
	'rpp' => array(
		'name'=>'Requests Per Page',
		'input' => 'rselect',
		'local' => TRUE,
		'values' => array(10=>10,20=>20,25=>25,50=>50),
		'vbc'=>TRUE)
	);

// Refer to $rts->request_query_sqlstr function that defines an SQL query like this
// SELECT r.rid, q.name AS pq_name, r.synopsis, r.fixer_uid, q.rnd_mgr, r.class, r.state, r.phase_of_rid, r.filed_by, DATE_FORMAT(due_date,'%m/%d/%y') AS ddate, DATE_FORMAT(r.reg_date,'%m/%d/%y') AS rdate FROM eval_requests AS r, products AS q WHERE r.pid=q.pid;


  $OutputFormat =array(
	'ID' => array('field' => 'rid',
			'eval' => '
		$tmp=$row[\'phase_of_rid\']?(\'&#8658;&nbsp;\'.$row[\'rid\']):($row[\'rid\'].\'&nbsp;&nbsp;\');'
		),
	'Due Date' => array('field' => 'ddate'),
	'Account' => array('field' => 'customer_id',
			'eval'=>'$tmp=$customers_2d[\'name\'][$row[\'customer_id\']];'),
	'Product' => array('field' => 'pq_name'),
	'State' => array('field' => 'state',
			'align'=>'center',
			'eval'=>'$tmp=$obj->state2str[$row[\'state\']];'),
	'Responsible' => array('align'=>'center',
			'eval'=>'
		$xstr2uid=array(); $obj->xstr2uid($row,$xstr2uid);
		$ruid=$obj->request_owner($row[\'class\'], $row[\'state\'], $xstr2uid);
		$tmp=YxlUsers::exists($ruid)?YxlUsers::name($ruid):"N/A";'),
	'Synopsis' => array('field_name' => 'synopsis',
				'eval' => '$tmp=html_safe_text($row[\'synopsis\']);'),
	);

  require_once('includes/rts/rts_query_inc.php');

?>


