<?php
// $Header: /home/CVS/rps/includes/base.inc,v 1.176 2008/08/04 19:44:02 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

if(!defined('BASE_INC')){
define('BASE_INC',TRUE);

	define('SECS_IN_HOUR', 3600);
	define('SECS_IN_DAY', 86400);
	define('HOURS_IN_DAY', 24);

	define ('CDB_CREATE_CLOG_TBL', "CREATE TABLE IF NOT EXISTS clog
	    (lid INT UNSIGNED NOT NULL AUTO_INCREMENT,
	    cid INT UNSIGNED default NULL,
	    uid INT UNSIGNED default NULL,
	    date_updated TIMESTAMP,
	    reg_date DATETIME NOT NULL,
	    date DATE,
	    summary VARCHAR(128) NOT NULL,
	    descr text,
	    options INT UNSIGNED DEFAULT 0 NOT NULL,
	    PRIMARY KEY (lid)
	    ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('CUST_OPT_INTERNAL', 0x0001);
	define('CUST_OPT_FORECAST', 0x0002);
	define('CUST_OPT_EVAL', 0x0004);
	define('CUST_OPT_REGC_ALLOWED',0x0008); // Allow using register_contact.php
	define('CUST_OPT_PUBLIC', 0x0010);

	define('CDB_CREATE_CUSTOMERS_TBL', 'CREATE TABLE IF NOT EXISTS customers
		(cid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		name VARCHAR(128) NOT NULL,
		street_addr VARCHAR(64) NOT NULL,
		city VARCHAR(32) NOT NULL,
		state VARCHAR(2) NOT NULL,
		country VARCHAR(32) NOT NULL,
		zip VARCHAR(16) NOT NULL,
		tel VARCHAR(16) NOT NULL,
		fax VARCHAR(16) NOT NULL,
		reg_date DATETIME NOT NULL,
		options INT UNSIGNED NOT NULL,
		sls_mgr_uid INT UNSIGNED NOT NULL,
		cae_mgr_uid INT UNSIGNED NOT NULL,
		company_id INT UNSIGNED DEFAULT 0 NOT NULL,
		parent INT UNSIGNED DEFAULT 0 NOT NULL,
		tech_contact_uid INT UNSIGNED NOT NULL,
		biz_contact_uid INT UNSIGNED NOT NULL,
		bts_class_mask INT UNSIGNED DEFAULT 0 NOT NULL,
		tts_class_mask INT UNSIGNED DEFAULT 0 NOT NULL,
		PRIMARY KEY (cid),
		UNIQUE KEY name (name, parent),
			KEY (tech_contact_uid),
			KEY (biz_contact_uid)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci');

	define('PROD_OPT_INTERNAL', 1);
	define('PROD_OPT_DISABLED', 2);
	define('PROD_OPT_INACTIVE', 4);
	define('PROD_OPT_NOSHOW', 7);
	define('PROD_OPT_EXPORT', 8);

	define('CDB_CREATE_PRODUCTS_TBL', 'CREATE TABLE IF NOT EXISTS products
		(pid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		name VARCHAR(64) NOT NULL,
		parent INT UNSIGNED DEFAULT 0 NOT NULL,
		mrkt_mgr INT UNSIGNED NOT NULL,
		rnd_mgr INT UNSIGNED NOT NULL,
		qa_mgr INT UNSIGNED NOT NULL,
		options INT UNSIGNED NOT NULL,
		reg_date DATETIME NOT NULL,
		PRIMARY KEY (pid),
		UNIQUE KEY (name,parent),
			KEY rnd_mgr (rnd_mgr)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci');


	define('REQ_PRI_UNKNOWN', 0);
	define('REQ_PRI_LOW', 1);
	define('REQ_PRI_MEDIUM', 2);
	define('REQ_PRI_HIGH', 3);
	define('REQ_PRI_CRITICAL', 4);

	$pri2str = array();
	$pri2str[REQ_PRI_LOW] = 'low';
	$pri2str[REQ_PRI_MEDIUM] = 'medium';
	$pri2str[REQ_PRI_HIGH] = 'high';
	$pri2str[REQ_PRI_CRITICAL] = 'critical';
	$bts_pri2str=&$pri2str;
	$tts_pri2str=&$pri2str;
	$rts_pri2str=&$pri2str;

	// Priority And Estimated Time table
	define('CDB_CREATE_PNETS_TBL', "CREATE TABLE IF NOT EXISTS pnets
		(rid INT UNSIGNED NOT NULL,
		uid INT UNSIGNED NOT NULL,
		type INT UNSIGNED NOT NULL,
		xval INT UNSIGNED,
		UNIQUE KEY (rid, uid, type)
		)");

	// Yoxel search phrases
	define('CDB_CREATE_YSPHRASES_TBL', "CREATE TABLE IF NOT EXISTS ysphrases
		(phid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		phrase VARCHAR(255) NOT NULL,
		rts_type VARCHAR(32),
		session_id CHAR(64),
		refn INT UNSIGNED,
		xval INT UNSIGNED,
		PRIMARY KEY (phid),
		UNIQUE KEY (rts_type,phrase),
		FULLTEXT (phrase)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	// Yoxel search associations
	define('CDB_CREATE_YSASSOCIATIONS_TBL', "CREATE TABLE IF NOT EXISTS ysassociations
		(aid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		phid INT UNSIGNED NOT NULL,
		rid INT UNSIGNED NOT NULL,
		uid INT UNSIGNED NOT NULL,
		refn INT UNSIGNED,
		options INT UNSIGNED,
		date_updated TIMESTAMP,
		PRIMARY KEY (aid),
		UNIQUE KEY (uid,phid,rid)
		)");

	// This table is used either to define
	// members of a [release]/[product bundle]/[cc] list for a request.
	define('MEMB_TYPE_RELEASE', 0x0001);
	define('MEMB_TYPE_BTSCC', 0x0002);
	define('MEMB_TYPE_BTSXRID', 0x0003); 	// In this case uid field will hold YoxelRID
						// And xid will hold ExternalRID
	define('MEMB_TYPE_TTSCC', 0x0004);
	define('MEMB_TYPE_TTSXRID', 0x0005);
	define('MEMB_TYPE_ITPROJ', 0x0006);
	define('MEMB_TYPE_CLOGCC', 0x0007);
	define('MEMB_TYPE_PLIST', 0x0008);
	define('MEMB_TYPE_QLIST', 0x0009);
	define('MEMB_TYPE_ETSCC', 0x000a);
	define('MEMB_TYPE_SFSCC', 0x000b);
	define('MEMB_TYPE_CLOG2CONT', 0x000c);
	define('MEMB_TYPE_CLOG2EVAL', 0x000d);

	define('MEMB_TYPE_RPSCC', 0x000e);
	define('MEMB_TYPE_ITPMCC', 0x000f);

	define('CDB_CREATE_MEMBERS_TBL', "CREATE TABLE IF NOT EXISTS members
		(uid INT UNSIGNED NOT NULL,
		xid INT UNSIGNED NOT NULL,
		type INT UNSIGNED NOT NULL,
		UNIQUE KEY (xid, uid, type)
		)");

	$platforms= array('Any', 'FreeBSD,alpha', 'FreeBSD,x86', 'FreeBSD,alpha',
		'FreeBSD,x86', 'FreeBSD,ia64', 'FreeBSD,opt64', 'FreeBSD,sparc',
		'FreeBSD,sparc64', 'Linux,alpha', 'Linux,x86', 'Linux,ia64', 'Linux,opt64',
		'Linux,sparc', 'Linux,sparc64', 'NetBSD,alpha', 'NetBSD,x86', 'NetBSD,ia64',
		'NetBSD,opt64', 'NetBSD,sparc', 'NetBSD,sparc64', 'Solaris,x86',
		'SunOS,sparc', 'SunOS,sparc64', 'Windows,x86');

	define('ALERT_TODO',1);
	define('ALERT_WARN',2);
	define('ALERT_INFO',3);

	$alert2css=array(ALERT_TODO=>'alert_todo',
		ALERT_WARN=>'alert_warn',
		ALERT_INFO=>'alert_info');

	function stripslashes_deep($value) {
		$value = is_array($value) ? array_map('stripslashes_deep', $value) :
					mb_convert_encoding(stripslashes($value), 'UTF-8', 'UTF-8');
      		 return $value;
	}

	function _error_echo($str){
		global $cmd_line_mode;

		if($cmd_line_mode)
			echo "ERROR: $str\n";
		else
			echo '<p style="color: red">'.$str.'</p>';
	}

	$warning_buffer=array();
	function _warning_echo($str,$ignore_buffering=FALSE){
		global $cmd_line_mode;
		global $warning_buffer;

		if($cmd_line_mode)
			echo "WARNING: $str\n";
		elseif(count($warning_buffer) && !$ignore_buffering)
			arr_push($warning_buffer,$str);
		else
			echo '<p style="color: green">'.$str."</p>\n";
	}

	function _warning_buffer(){
		global $warning_buffer;

		if(count($warning_buffer)<1)
			array_push($warning_buffer,'');
	}

	function  _warning_flush(){
		global $warning_buffer;

		foreach($warning_buffer as $str){
			if(!$str) continue;
			echo '<p style="color: green">'.$str."</p>\n";
		}

		$warning_buffer=array();
	}

	// For fatal unexpected errors
	function _die($message,$mysql=FALSE,$hdr=TRUE) {
		global $production_mode;
		global $cmd_line_mode;
		global $YxlErrEmail;
		global $MyDomain;
		global $cid;

		if($mysql)
			$message.=' '.mysql_error().' (Err#'.mysql_errno().')';

		if($production_mode && !$cmd_line_mode)
			_error_echo("The site is currently experiencing technical difficulties.\nWe apologize for any inconvenience.");
		else
			_error_echo($message);

		$from_email="yoxel_web$cid@$MyDomain";
		if(isset($_SESSION['cldn']))
			$from_email=$_SESSION['cldn'].'-'.$_SESSION['uid'].'@'.$MyDomain;

		error_log($message, 1, $YxlErrEmail, "From: YOXEL ERROR <$from_email>\n");
		die;
	}

	function _warn_yoxel($message){
		global $MyDomain;
		global $cid;
		global $YxlErrEmail;

		$from_email="yoxel_web$cid@$MyDomain";
		if(isset($_SESSION['cldn']))
			$from_email=$_SESSION['cldn'].'-'.$_SESSION['uid'].'@'.$MyDomain;

		error_log($message, 1, $YxlErrEmail, "From: YOXEL WARNING <$from_email>\n");
	}

	// This one is safe to call from sw/db.inc as it does not load header.inc
	// sw/db.inc is the only place where it will be used
	// Actully the error handling should be rewritten with OO exceptions
	// I agree the current implementation is kind of messy. Will get to it later...
	function _die0($message, $mysql=TRUE) {
		_die($message, $mysql, FALSE);
	}

	function _die2($message) {
		_die($message, TRUE);
	}

	function _live_error($message,$mysql=FALSE) {
	// For unsatisfied conditions
		if($mysql){
			$me=' '.mysql_error().' (Err#'.mysql_errno().')';
			$message.=' '.$me;
		}
		_error_echo($message);
	}

	function _quit_error($message,$mysql=FALSE) {
	// For unsatisfied conditions
		_live_error($message,$mysql);
		_warn_yoxel($message);
		die;
	}

	function _warning($message,$ignore_buffering=FALSE) { // For warning or info messages
		_warning_echo($message,$ignore_buffering);
	}

	function _just_die($str){
		print $str;
		die;
	}

	$prereq_check_buf=array();
	function prereq_check_set($tag){
		global $prereq_check_buf;
		$prereq_check_buf[$tag]=TRUE;
	}

	function prereq_check($tag){
		global $prereq_check_buf;

		if(isset($prereq_check_buf[$tag]))
			return TRUE;

		return FALSE;
	}

	function prereq_check_warning($tag,$link,$title,$comment,$severity=ALERT_TODO){
		global $dir_name;
		global $prereq_check_buf;
		global $alert2css;

		if(!isset($prereq_check_buf[$tag]))
			return;

		if($link)
			$lstr='<a href="'.$dir_name.'/'.$link.'">&gt;&gt; '.html_safe_text($title).' &lt;&lt;</a>';
		else{
			$lstr='<strong>'.html_safe_text($title).'</strong>';
			$severity=ALERT_INFO;
		}

		echo '
	<div width="100%" align="center">
	<div class="'.$alert2css[$severity].'" align="center">'.$lstr.'
		<hr width="30%">'.$comment.'
	</div>
	</div>';
		unset($prereq_check_buf[$tag]);
	}

	function escape_data($data){
		return mysql_real_escape_string($data);
		//return mysql_escape_string($data);
	}

	function simple_query($str,$qtype=MYSQL_NUM){

		//echo "$str <br>\n";

  		@$SQL = mysql_query($str);
  		if (!$SQL) return null;

  		$res = mysql_fetch_array($SQL,$qtype);
  		mysql_free_result($SQL);
  		if (!$res) return $res;

  		if (count($res) == 1) $res = array_shift($res);

  		return $res;
	}

	function html_sp($str){
		$str = eregi_replace("[[:blank:]]","&nbsp;",$str);

		return $str;
	}

	function html_safe_text($str, $nobr = FALSE){
		$str = str_replace("\r", "", $str);

		//$str=mb_convert_encoding($str, 'HTML-ENTITIES', "UTF-8");
		//$str=str_replace("<","&lt;",$str);
		//$str=str_replace(">","&gt;",$str);

		$str=htmlspecialchars($str,ENT_COMPAT,"UTF-8");

		if (!$nobr)
			$str = nl2br($str);

		return $str;
	}

	function js_safe_text($str){
		$str = str_replace("\r", "", $str);
		$str = str_replace("\n", "", $str);
		$str = str_replace("\\","\\\\",$str);
		$str = str_replace('"','\"',$str);
		return $str;
	}

	function xls_safe_text($str){
		$str = str_replace("\r", "", $str);
		return $str;
	}

	function format_str($str, $maxlen = 75){
		$str = wordwrap($str, $maxlen);

		return $str;
	}

	function format_text($text, $maxlen = 75){
		$text = explode("\n", $text);

		for ($i = 0; $i < count($text); $i++)
			if (substr($text[$i], 0, 2) != '>>')
				$text[$i] = format_str($text[$i]);

		return implode("\n", $text);
	}

	function mysql_table_exists($table){
		$exists = mysql_unbuffered_query("SELECT 1 FROM $table LIMIT 0");
      		if ($exists) return true;
      		return false;
	}

	$customers_2d=array();
	function init_customers($force=FALSE){
		global $customers_2d;
		global $is_customer;

		if(count($customers_2d) && !$force)
			return simple_query("SELECT cid FROM customers ORDER BY cid ASC LIMIT 1");

		$query = "SELECT cid, name, options, parent, sls_mgr_uid, cae_mgr_uid, tech_contact_uid, biz_contact_uid FROM customers ORDER BY cid DESC";
		if(!($result=@mysql_unbuffered_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from customers table.');

		$customers_2d['cn']=array(0=>'unknown');
		$customers_2d['options']=array(0=>0);
		$customers_2d['parent']=array(0=>0);
		$customers_2d['sls_mgr']=array(0=>0);
		$customers_2d['cae_mgr']=array(0=>0);
		$customers_2d['tech_contact']=array(0=>0);
		$customers_2d['biz_contact']=array(0=>0);
		$customers_2d['name']=array(0=>'unknown');
		$first_cust=1;
		while($row=mysql_fetch_row($result)){
			$customers_2d['cn'][$row[0]]=$row[1]?$row[1]:'unknown';
			$customers_2d['options'][$row[0]]=$row[2]?$row[2]:0;
			$customers_2d['parent'][$row[0]]=$row[3]?$row[3]:0;
			$customers_2d['sls_mgr'][$row[0]]=$row[4];
			$customers_2d['cae_mgr'][$row[0]]=$row[5];
			$customers_2d['tech_contact'][$row[0]]=$row[6];
			$customers_2d['biz_contact'][$row[0]]=$row[7];
			$first_cust=$row[0];
		}
		mysql_free_result($result);

		foreach($customers_2d['parent'] as $cid => $p){
			if(!$is_customer || ($is_customer && ($is_customer==$cid))){
				if($p>0)
					$customers_2d['name'][$cid]=$customers_2d['cn'][$p].' - ['.$customers_2d['cn'][$cid].']';
				else
					$customers_2d['name'][$cid]=$customers_2d['cn'][$cid];
			}else
				$customers_2d['name'][$cid]='Hidden Customer Name';
		}
		asort($customers_2d['name']);
		return $first_cust;
	}

	function internal_customer(){
		$customer_id=simple_query("SELECT cid FROM customers WHERE options&".CUST_OPT_INTERNAL." LIMIT 1");
		if(!$customer_id)
			_die2(__FILE__.':'.__LINE__.' Could not select from customers table.');

		return $customer_id;
	}

	function find_customer_by_name($cname,$create=FALSE){
		$custn=escape_data($cname);
		if($cust_id=simple_query("SELECT cid FROM customers WHERE name='$custn'"))
			return $cust_id;

		if(!$create)
			return FALSE;

		$query = "INSERT INTO customers (name, reg_date) VALUES('$custn', NOW() )";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into customers table.');

		return mysql_insert_id();
	}

	function init_users(){}

	function get_active_mu(){
		return YxlUsers::get_active_mu();
	}

	function user_exists($u){
		return YxlUsers::exists($u);
	}

	function date_sql2norm($sql,$short=FALSE){
		$b=explode(' ',$sql);
		$a=explode('-',count($b)?$b[0]:$sql);
		if(count($a)==3)
			$norm=$a[1].'/'.$a[2].'/'.($short?substr($a[0],2,2):$a[0]);
		else
			$norm=$sql;
		return $norm;
	}

	function date_norm2sql($norm){
		$a=explode('/',$norm);
		if(count($a)==3)
			$sql=$a[2].'-'.$a[0].'-'.$a[1];
		else
			$sql=$norm;
		return $sql;
	}

	function is_synopsis($str){
		return(preg_match("/^[\pL\pN\pP\p{Zs}]{1,128}/u",$str));
	}

	function is_description($str){
		return(preg_match("/^.+/",$str));
	}

	function is_passwd($str){
		//return(eregi("^[[:alnum:][:punct:]_~!@#$%^&*()+|]{4,16}$", $str));
		return(preg_match("/^[\pL\pN\p{P}~+|]{4,64}$/u",$str));
	}

	function is_tel($str,$hlp=FALSE){
		if($hlp)
			return "allowed characters: numeric, )(, -, and x";
		return(preg_match("/^\d+[-\d\s]*[xX]?\d+$/",$str) || preg_match("/^\(\d+\)\s*[-\d\s]*[xX]?\d+$/",$str));
	}

	function is_zip($str,$hlp=FALSE){
		if($hlp)
			return "allowed characters: alphanumeric, space and -";
		//return(eregi("^[[:alnum:]]+[[:alnum:][:space:]\-]*$", $str));
		return(preg_match("/^[\pL\pN]+[\pL\pN\p{Zs}\-]*$/u", $str));
	}

	function is_email($str){
		//return(eregi("^[[:alnum:]_.\-]+@[[:alnum:].\-]+\.[a-z]{2,4}$",$str));
		return(preg_match("/^[\d\w_.\-]+@[\d\w.\-]+\.\w{2,4}$/",$str));
	}

	function is_street($str){
		//return(eregi("^[[:alnum:][:space:][:punct:]#]{3,40}$",$str));
		return(preg_match("/^[\pL\pN\pP\p{Zs}]{3,40}$/u",$str));
	}

	function is_city($str){
		return(preg_match("/^[\pL\pP\p{Zs}]{3,40}$/u",$str));
	}

	function is_uname($str){
		//return(eregi("^[[:alnum:]_.\-]{3,32}$",$str));
		return(preg_match("/^[\w\d_.\-]{1,64}$/",$str));
	}

	function is_fname($str,$hlp=FALSE){
		if($hlp)
			return "allowed characters: alphabetic, space and '";
		//return(eregi("^[[:alpha:]]+[[:alpha:] ']*$",$str));
		return(preg_match("/^\p{L}+[\pL\p{Zs}']*$/u",$str));
	}

	function is_lname($str,$hlp=FALSE){
		return is_fname($str,$hlp);
	}

	function is_rel_lbl($str){
		//return(eregi("^[[:alnum:]_. ]{2,16}$",$str));
		return(preg_match("/^[\pL\pN\pP\p{Zs}]{2,16}$/u",$str));
	}

	function is_pq_name($str){
		//return(eregi("^[[:alnum:]_& /\-]{2,32}$",$str));
		return(preg_match("/^[\pL\pN\pP\p{Zs}]{2,32}$/u",$str));
	}

	function is_company_name($str,$hlp=FALSE){
		if($hlp)
			return "allowed characters: alphanumeric, space and .,'-&@";
		//return(eregi("^[[:alnum:][:space:][:punct:]&@]{2,40}$",$str));
		return(preg_match("/^[\pL\pN\pP\p{Zs}]{2,64}$/u",$str));
	}

	function is_date($str){
		//if(!eregi("^[01]?[[:digit:]]/[0123]?[[:digit:]]/[12][[:digit:]]{3,3}$",$str))
		if(!preg_match("/^[01]?\d\/[0123]?\d\/[12]\d{3,3}$/",$str))
			return FALSE;

		$a=explode('/',$str);
		return checkdate($a[0],$a[1],$a[2]);
	}

	function is_num($str){
		//return(eregi("^[[:digit:]]{1,10}$",$str));
		return(preg_match("/^\d{1,10}$/",$str));
	}

	function is_fpnum($str){
		//return(eregi("^[[:digit:]]*\.?[[:digit:]]{1,10}$",$str));
		return(preg_match("/^\d*\.?\d{1,10}$/",$str));
	}

	function arr_push(&$Arr, $val){
		if (in_array($val, $Arr)) return;
		array_push($Arr, $val);
	}

	function arr_unshift(&$Arr, $val){
		if (in_array($val, $Arr)) return;
		array_unshift($Arr, $val);
	}

	function parse_yoxel_id($ln,$ddn,&$regular_account,&$dn,&$un){

		$yoxelid='';

		if(preg_match("/^\s*([\w\-.]+)@([\w\-.]+\.\w{2,4})\s*$/i",$ln,$matches)){
			$un=$matches[1];
			$dn=$matches[2];
			$regular_account=TRUE;
			$yoxelid=$ln;
		}elseif(preg_match("/^\s*([\w\-.]+)@([\w\-]{2,16})\s*/i",$ln,$matches)){
			$un=$matches[1];
			$dn=$matches[2];
			$regular_account=FALSE;
			$yoxelid=$ln;
		}elseif(preg_match("/^\s*([\w\-.]+)\s*$/i",$ln,$matches)){
			$un=$matches[1];
			$dn=trim($ddn);
			$yoxelid=$un.'@'.$dn;
			$regular_account=TRUE;
			error_display('warn_parse_yid');
		}
		return($yoxelid);
	}

	function construct_username($un){
		$n=$un;
		if(strlen($un)<2) $l=3;
		else $l=2;
		for($i=0;$i<100;$i++){
			if($i)
				$n=sprintf('%s%0'.$l.'u', $un, $i);
			//echo "$n <br>";
			if(!simple_query("SELECT uid FROM users WHERE username='$n' LIMIT 1")) return $n;
		}
		_die(__FILE__.':'.__LINE__.' Something is wrong here.');
	}

	function check_users(){
		global $user_is;
		global $uid;

		if($user_is&USER_IS_CUSTOMER) return;
		$query = "SELECT username FROM users WHERE !(user_is&".(USER_IS_CUSTOMER|USER_IS_HIDDEN).") AND uid!=$uid";
		if(!($result = @mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Can not select from users table.');
		if(($rn=mysql_num_rows($result))>0) return;
		if($user_is&USER_IS_M)
			_warning('There are no other registered users in your database besides you.');
		else{ // This should never happen:
			_warning('There are no other registered users in your database besides you.');
			_warn_yoxel('There are no other registered users.');
		}
	}

	function error_alert($msg,$url=FALSE){
		if(!isset($_SESSION['error_alert']))
			$_SESSION['error_alert']=array();
		array_push($_SESSION['error_alert'],$msg);
		if($url){
			header("Location: $url");
			exit;
		}
	}

	function error_display($eid){
		if(!isset($_SESSION['error_display']))
			$_SESSION['error_display']=array();
		array_push($_SESSION['error_display'],$eid);
	}

	function show_error_alerts(){
		if(isset($_SESSION['error_alert'])){
			echo '
<script>
<!--';
			while($s=array_shift($_SESSION['error_alert'])){
				if(!$s || empty($s))
					continue;
				echo '
	alert("'.$s.'");';
			}
			echo '
//-->
</script>';
		}

		if(!isset($_SESSION['error_display']))
			return;
		echo '
<script>
<!--';
		while($eid=array_shift($_SESSION['error_display'])){
			if(!$eid || empty($eid))
				continue;

			echo '
	// '.$eid;

			$c='';
			if(substr($eid,0,4)=="err_")
				$c='red';
			elseif(substr($eid,0,5)=="warn_")
				$c='green';

			echo '
	var eline=document.getElementById("'.$eid.'");
	if(eline){
		eline.style.display="";';
			if($c)
				echo '
		eline.style.color="'.$c.'";';
			echo '
	}';
		}

		echo '
//-->
</script>';
	}

	function email_header_From($prefix){
		global $asp_mode;
		global $MyCName;
		global $MyDomain;
		global $yoxel_signature;

		$fheader='From: "YOXEL-'.$prefix.' '.$MyCName.'" <YOXEL_'.$prefix.'@'.$MyDomain.'>';
		if($asp_mode){
			if(isset($_SESSION['crn']))
				$fheader = 'From: "YOXEL-'.$prefix.' '.$_SESSION['crn'].'" <'.$prefix.$_SESSION['signature'].'@'.$MyDomain.'>';
			else
				$fheader = 'From: "YOXEL-'.$prefix.' '.$MyCName.'" <'.$prefix.$yoxel_signature.'@'.$MyDomain.'>';
		}
		return $fheader;

	}

function company2customer($ext_cid){
	global $yoxel_cid;

	if(!$yoxel_cid)
		_die(__FILE__.':'.__LINE__.' Can not find main yoxel database.');
	$yoxel_db=cid2cdb($yoxel_cid);

	$company_row=simple_query("SELECT real_name, street_addr, city, state, country, zip, tel, fax FROM ".DB_NAME.".companies WHERE cid=$ext_cid");
	if(!$company_row)
		_die2(__FILE__.':'.__LINE__." Could not select from companies table.");

	$ext_cid_db=cid2cdb($ext_cid);
	$mu_row=simple_query("SELECT first_name, last_name, email, uid, spec FROM $ext_cid_db.users WHERE (user_is&".USER_IS_MU.") AND (user_is&".USER_IS_LOCKED.")=0 ORDER BY uid ASC LIMIT 1");
	if(!$mu_row)
		_die2(__FILE__.':'.__LINE__." Could not select from $ext_cid_db.users table.");

	$query = "SELECT cid FROM $yoxel_db.customers WHERE company_id=$ext_cid";
	//echo "$query <br>";
	if(!($result=@mysql_query($query)))
		_die2(__FILE__.':'.__LINE__.' Could not select from customers table.');
	if(mysql_num_rows($result) == 0){
	// Register this company_id as a customer of Yoxel
		$query = "INSERT INTO $yoxel_db.customers (company_id, name, street_addr, city, state, country, zip, tel, fax, sls_mgr_uid, cae_mgr_uid, reg_date) VALUES($ext_cid, '".escape_data($company_row[0])."', '".escape_data($company_row[1])."', '".escape_data($company_row[2])."', '".escape_data($company_row[3])."', '".escape_data($company_row[4])."', '".escape_data($company_row[5])."', '".escape_data($company_row[6])."','".escape_data($company_row[7])."', '".YOXEL_SLS_UID."','".YOXEL_CAE_UID."', NOW())";
		//echo "$query <br>";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__." Could not insert into $yoxel_db.customers table.");
		$cust_id=mysql_insert_id();

		$query = "INSERT INTO $yoxel_db.users (first_name, last_name, email, user_is, customer_id, ext_uid, spec, license, reg_date) VALUES('".escape_data($mu_row[0])."', '".escape_data($mu_row[1])."', '".escape_data($mu_row[2])."', ".USER_IS_CUSTOMER.", $cust_id, $mu_row[3], $mu_row[4], ".LIC_BTS.", NOW())";
		//echo "$query <br>";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__." Can not insert into $yoxel_db.users table.");
		$cust_uid=mysql_insert_id();

		$query = "UPDATE $yoxel_db.customers SET tech_contact_uid=$cust_uid, biz_contact_uid=$cust_uid WHERE cid=$cust_id";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__." Can not update $yoxel_db.customers table.");
	}else{
		$row=mysql_fetch_array($result, MYSQL_NUM);
		mysql_free_result($result);
		$cust_id=$row[0];
		$query = "UPDATE $yoxel_db.customers SET name='".escape_data($company_row[0])."' WHERE cid='$cust_id'";
		//echo "$query <br>";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__.' Could not update customers table.');
	}
	return($cust_id);
}


	function gen_pg_str($link_fstr,$start,$total,$rpp){

		//echo "$start $total $rpp <br>\n";
		$pg_str='';$st=$start;$end=$start;
		for($i=5;$i>=0;$i--){
			if(($start-$i*$rpp)>=0){
        			$st=$start - $i*$rpp;
        			break;
        		}
        	}
        	if($st>0){
        		$pg_str= sprintf($link_fstr,0,0);
        		$pg_str.= " &#183;&#183;&#183; ";
        	}

        	//echo "$i $st<br>\n";
        	for($j=(10-$i);$j>=0;$j--){
			if(($start+$j*$rpp)<$total){
        			$end=$start+$j*$rpp;
        			break;
        		}
        	}

        	//echo "$j $end<br>\n";
		for ($i = $st; $i <= $end; $i += $rpp) {
			if ($i == $start)
				$pg_str.= " <font color=red>".($i / $rpp)."</font>";
			else
				$pg_str.= sprintf($link_fstr,$i,$i / $rpp);

			if (($i + $rpp) <= $end)
				$pg_str.= " &#183; ";
		}
		$lpg=floor(($total-1)/$rpp);
		if(($end/$rpp)<$lpg){
			$pg_str.= " &#183;&#183;&#183; ";
			$pg_str.= sprintf($link_fstr,$lpg*$rpp,$lpg);
		}

		return $pg_str;
	}

	function make_seed(){
		list($usec, $sec) = explode(' ', microtime());
		return (float) $sec + ((float) $usec * 100000);
	}

  function slist2members($xid,$slist,$mtype,$replace=TRUE){

	if($replace){
		$SQLStr = "DELETE FROM members WHERE type=$mtype AND xid=$xid";
		//echo "$SQLStr <br>\n";
		if (!@mysql_query($SQLStr))
			_die2(__FILE__.':'.__LINE__.' Could not delete from members table.');
	}

	if(is_array($slist)){
		if(!count($slist))
			return;
		$slist_arr=&$slist;
	}else{
		if(!$slist)
			return;
		$slist_arr=array();
		$slist_arr=explode(',',$slist);
	}


	$val_str='';
	foreach ($slist_arr as $m){
		if(!$m) continue;
		$val_str.=", ($m, $mtype, $xid)";
	}
	$SQLStr = "INSERT INTO members (uid, type, xid) VALUES ".substr($val_str,1);
	//echo "$SQLStr <br>\n";
	if (!@mysql_query($SQLStr))
		_die2(__FILE__.':'.__LINE__.' Could not insert into members table.');
  }

  function gen_yxl_select($elname,&$all_list,&$sel_list,$with_order=FALSE,$long=TRUE){

	$html='
		<table width="100%">
		<TR>
                       	<td align="center">
               		<input type="hidden" name="'.$elname.'" value="">
                        <select name="_'.$elname.'" size=5 class="selec"'.($long?' style="width:24em"':'').' onChange="sel_add(this)" width="100%">';

	$tmp_name=array();
	foreach($all_list as $k => $v){
		$html.='
				<option value="'.$k.'">'.html_safe_text($v).'</option>';
	}

	$html.='
			</select>
	               	</td>
                       	<td align="center">
       			<input type="button" class="btn_small" value="add >>" disabled><br>
       			<input type="button" name="_'.$elname.'" class="btn_small" value="<< delete" onClick="sel_del(this)">
        		</td>
                       	<td align="center">
                        <select name="__'.$elname.'" size=5 class="selec"'.($long?' style="width:24em"':'').' width="100%">';

	foreach($sel_list as $k){
		if(!$k || !isset($all_list[$k]))
			continue;

		$v=$all_list[$k];
		$html.='
				<option value="'.$k.'">'.htmlentities($v).'</option>';
	}
	$html.= '
                        </select>
			</td>';
	if($with_order)
		$html.= '
			<td>
                	<input type="button" name="_'.$elname.'" class="btn_small" value=" up " onClick="sel_up(this)"><br>
                	<input type="button" name="_'.$elname.'" class="btn_small" value=" down " onClick="sel_down(this)">';
	$html.= '
                        </td>
		</tr>
                </table>';

	return $html;
  }

  function yxl_cnfg_check($const_name){
  	YxlConfigCheck::check_define($const_name);
  }

  function yxl_mail($to, $subject, $message, $headers_str){
  	global $MyDomain;

	$hdrs= split("[\n\r]+", $headers_str);
	$headers=array();
	$headers['To']=$to;
	while($h=array_shift($hdrs)){
		if(!preg_match("/^\s*(\S+)\s*:\s*(\S+.*)\s*/i",$h,$matches))
			continue;

		$hn=ucfirst(strtolower($matches[1]));
		if(($hn=="Cc") || ($hn=="Bcc"))
			$to.=", ".$matches[2];

		if($hn=="Bcc")
			continue;

		$headers[$hn]=$matches[2];
		if(mb_detect_encoding($headers[$hn], "auto")=="UTF-8")
			$headers[$hn]=mb_encode_mimeheader($headers[$hn], 'UTF-8', 'Q', "\n");
	}

	if(!$to || !isset($headers['From'])){
		_warn_yoxel('Problems with headers.');
		return FALSE;
	}

	$headers['Subject']=$subject;
	if(mb_detect_encoding($headers['Subject'], "auto")=="UTF-8")
		$headers['Subject']=mb_encode_mimeheader($headers['Subject'], 'UTF-8', 'Q', "\n");

	if(mb_detect_encoding($message, "auto")=="UTF-8"){
		$headers['Mime-Version']="1.0";
		$headers['Content-Type']="text/plain; charset=UTF-8";
		$headers['Content-Transfer-Encoding']="BASE64";
		$message=base64_encode($message);
	}

	if(!defined('YXL_SMTP_HOST')){
		$to=$headers['To'];
		unset($headers['To']);
		$subject=$headers['Subject'];
		unset($headers['Subject']);

		$headers_str='';
		foreach($headers as $k => $v)
			$headers_str.="$k: $v\n";

		return mail($to, $subject, $message, $headers_str);
	}


	$headers['Message-Id']="<" . md5(uniqid(microtime())) . "@" . $MyDomain . ">";
	$headers['Date']=date("r");

  	$params['host']=YXL_SMTP_HOST;
  	if(defined('YXL_SMTP_PORT') && YXL_SMTP_PORT)
		$params['port']=YXL_SMTP_PORT;

	if(defined('YXL_SMTP_USER')){
		$params['auth']=TRUE;
		$params['username']=YXL_SMTP_USER;
		if(defined('YXL_SMTP_PASSWORD'))
			$params['password']=YXL_SMTP_PASSWORD;
	}

	$smtp = &Mail::factory ('smtp', $params);

	if(($pe=$smtp->send($to,$headers,$message))!==TRUE){
		_warn_yoxel($pe->getMessage());
        	return FALSE;
        }
  }

  function yxl_gen_link($relurl,$txt,$extra){
  	global $dir_name;
  	return '<a href="'.$dir_name.$relurl.'" onClick="ignore_rts_view_save_phrase()" '.$extra.' >'.$txt.'</a>';
  }

} // BASE_INC check

?>
