<?php
// $Header: /home/CVS/rps/includes/config_check.inc,v 1.3 2008/08/05 07:03:49 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

class ConfigCheck {
    function configcheck(){
    	global $root_fdir;

    	if(!file_exists($root_fdir.'/includes/yoxel-config.inc'))
		die("Yoxel configuration is absent (missing includes/yoxel-config.inc file)!");

	require_once('includes/yoxel-config.inc');

	if (version_compare(PHP_VERSION, '5.0.0', '<')) {
		if(version_compare(PHP_VERSION, '4.4.3', '<'))
			die("Yoxel requires PHP4 version 4.4.3 or higher (currently it is ".PHP_VERSION." )!");
	}elseif(version_compare(PHP_VERSION, '5.2.0', '<')){
		die("Yoxel requires PHP5 version 5.2.0 or higher (currently it is ".PHP_VERSION." )!");
	}

	if(!extension_loaded('session'))
		die($this->missing_module_msg('session'));

	if(!extension_loaded('mysql'))
		die($this->missing_module_msg('mysql'));

	if(!extension_loaded('mbstring'))
		die($this->missing_module_msg('mbstring'));

	if(!extension_loaded('pcre'))
		die($this->missing_module_msg('pcre'));

	if(defined('PCRE_VERSION') && PCRE_VERSION){
		$a=explode(' ',PCRE_VERSION);
		$v=array_shift($a);
		if(version_compare($v, '6.6', '<'))
			die("Yoxel requires PHP module PCRE version 6.6 or higher (currently it is $v )!");
	}

    }

    function missing_module_msg($mname){
	return("Yoxel requires PHP module '$mname' to be loaded (see README.txt for more details)!");
    }

    function check_define($const_name){
	if(!defined($const_name) || !constant($const_name))
		_die0("Yoxel configuration is incomplete (missing $const_name setting).");
    }
}

class YxlConfigCheck {
    function InstallCheck() {
        global $yxl_config_check;

        if(!isset($yxl_config_check))
                $yxl_config_check = new ConfigCheck();
    }

    function check_define($cn) {
        global $yxl_config_check;

        YxlConfigCheck::InstallCheck();
        return $yxl_config_check->check_define($cn);
    }
}

?>
