<?php
// $Header: /home/CVS/rps/includes/cust/contacts.inc,v 1.21 2008/07/20 03:59:14 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

	define('USPEC_IT', 1);
	define('USPEC_RND', 2);
	define('USPEC_MRKT', 3);
	define('USPEC_SLS', 4);
	define('USPEC_CAE', 5);
	define('USPEC_QA', 6);
	define('USPEC_FINANCE', 7);
	define('USPEC_EXEC', 8);

	$user_spec2str=array();
	$user_spec2str[USPEC_IT]="IT";
	$user_spec2str[USPEC_RND]="RnD/Engineering";
	$user_spec2str[USPEC_MRKT]="Marketing";
	$user_spec2str[USPEC_SLS]="Sales";
	$user_spec2str[USPEC_CAE]="Consulting/Support";
	$user_spec2str[USPEC_QA]="Quality Assuarance";
	$user_spec2str[USPEC_FINANCE]="Finance/Accounting";
	$user_spec2str[USPEC_EXEC]='Executive';
	$specializations=&$user_spec2str;

	define('USER_IS_MU', 1);
	define('USER_IS_MGR', 2);
	define('USER_IS_M', 3);
	define('USER_IS_LOCKED', 4);
	define('USER_IS_CUSTOMER', 8);
	define('USER_IS_LICADMIN', 16);
	define('USER_IS_HIDDEN', 32);
	define('USER_IS_LDAP', 64);

	//USER PERMISSIONS
	define('UPERM_READ', 1);
	define('UPERM_ADD', 2);
	define('UPERM_EDIT', 4);
	define('UPERM_DEL', 8);

	define('CDB_CREATE_USERS_TBL', "CREATE TABLE IF NOT EXISTS users
		(uid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		username VARCHAR(64),
		first_name VARCHAR(128) NOT NULL,
		last_name VARCHAR(128) NOT NULL,
		password CHAR(64) NOT NULL,
		email VARCHAR(64) NOT NULL,
		spec SMALLINT UNSIGNED DEFAULT 1 NOT NULL,
		report_to INT UNSIGNED NOT NULL,
		reg_date DATETIME NOT NULL,
		user_is INT UNSIGNED DEFAULT '0' NOT NULL,
		customer_id INT UNSIGNED,
		license INT UNSIGNED DEFAULT '0' NOT NULL,
		search TEXT,
		ext_uid INT UNSIGNED NOT NULL,
		added_by INT UNSIGNED NOT NULL,
		last_login DATETIME NOT NULL,
		PRIMARY KEY (uid),
		UNIQUE KEY name (last_name, first_name, customer_id),
			KEY (username),
			KEY (spec),
			KEY (report_to),
			KEY (user_is),
			KEY (password)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('YOXEL_SLS_UID', 1);
	define('YOXEL_CAE_UID', 1);

	$lead_source=array();
	$lead_source[]='=None=';
	$lead_source[]='Cold Call';
	$lead_source[]='Existing Customer';
	$lead_source[]='Self Generated';
	$lead_source[]='Employee';
	$lead_source[]='Partner';
	$lead_source[]='Public Relations';
	$lead_source[]='Direct Mail';
	$lead_source[]='Conference';
	$lead_source[]='Trade Show';
	$lead_source[]='Web Site';
	$lead_source[]='Word of mouth';
	$lead_source[]='Email';
	$lead_source[]='Other';

	$lead_status=array();
	$lead_status[]='New';
	$lead_status[]='Assigned';
	$lead_status[]='In Process';
	$lead_status[]='Recycled';
	$lead_status[]='Dead';

	define('CONT_OPT_LEAD',0x0001);
	define('CONT_OPT_DONTCALL',0x0002);
	define('CONT_OPT_EOPTOUT',0x0004);
	define('CONT_OPT_EBAD',0x0008);

	define('CDB_CREATE_CONTACTS_TBL', 'CREATE TABLE IF NOT EXISTS contacts
		(uid INT UNSIGNED NOT NULL,
		title VARCHAR(128) NOT NULL,
		department VARCHAR(128) NOT NULL,
		street_addr VARCHAR(128) NOT NULL,
		city VARCHAR(32) NOT NULL,
		state CHAR(2) NOT NULL,
		country VARCHAR(32) NOT NULL,
		zip VARCHAR(16) NOT NULL,
		tel VARCHAR(128) NOT NULL,
		fax VARCHAR(128) NOT NULL,
		mtel VARCHAR(128) NOT NULL,
		descr TEXT,
		owner INT UNSIGNED,

		h_street_addr VARCHAR(128) NOT NULL,
		h_city VARCHAR(32) NOT NULL,
		h_state CHAR(2) NOT NULL,
		h_country VARCHAR(32) NOT NULL,
		h_zip VARCHAR(16) NOT NULL,
		htel VARCHAR(128) NOT NULL,
		hfax VARCHAR(128) NOT NULL,
		hemail VARCHAR(64) NOT NULL,

		o_street_addr VARCHAR(128) NOT NULL,
		o_city VARCHAR(32) NOT NULL,
		o_state CHAR(2) NOT NULL,
		o_country VARCHAR(32) NOT NULL,
		o_zip VARCHAR(16) NOT NULL,
		otel VARCHAR(128) NOT NULL,
		ofax VARCHAR(128) NOT NULL,
		oemail VARCHAR(64) NOT NULL,

		lead_source INT UNSIGNED,
		lead_descr TEXT,
		lead_ref_by INT UNSIGNED,
		lead_status INT UNSIGNED NOT NULL DEFAULT 0,
		lead_status_descr TEXT,

		options INT UNSIGNED NOT NULL DEFAULT 0,

		PRIMARY KEY (uid)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci');

class Contacts {

	var $conts_query_sql;
	function contacts(){
		$this->conts_query_sql="SELECT u.uid, u.first_name, u.last_name, u.customer_id, u.email, u.username, u.user_is, c.title, c.tel, c.options FROM users AS u LEFT JOIN contacts AS c ON u.uid=c.uid WHERE !(u.user_is&".USER_IS_HIDDEN.") AND u.user_is&".USER_IS_CUSTOMER;

		if(simple_query("SELECT COUNT(uid) FROM users WHERE user_is&".USER_IS_CUSTOMER." LIMIT 1")<1)
			prereq_check_set('no_contacts');
	}

	function add_contact(&$cont_data){
		global $uid;


		if(!isset($cont_data['u.customer_id']) || !$cont_data['u.customer_id'])
			$cust_id=0;
		else
			$cust_id=$cont_data['u.customer_id'];

		if(!isset($cont_data['u.first_name']) && !isset($cont_data['u.last_name'])){
			_live_error('Neither first name nor last name mapping is specified.');
                        return FALSE;
                }

		$cont_wrapped_data=array();
                foreach(array_keys($cont_data) as $yxlk){
                        if(substr($yxlk,-1,1)==':')
                                continue;
                        //echo $yxlk."<br>\n";
                        if(isset($cont_data[$yxlk.':']))
                                $cont_wrapped_data[$yxlk]=$this->wrap_field($cont_data,$yxlk);
                        else
                                $cont_wrapped_data[$yxlk]=$cont_data[$yxlk];
                }

		$fn=$cont_wrapped_data['u.first_name'];
		$ln=$cont_wrapped_data['u.last_name'];
		$query="SELECT uid FROM users WHERE first_name='".escape_data($fn)."' AND last_name='".escape_data($ln)."' AND ".($cust_id?"customer_id=$cust_id":"(customer_id=0 OR customer_id IS NULL)")." LIMIT 1";
		//echo "$query <br>\n";
		$puid=simple_query($query);
		if($puid){
			_live_error('Contact '.html_safe_text($fn.' '.$ln).' already exists. Skipping ...');
			return FALSE;
		}
		$sql_ins_f=array();
		$sql_ins_v=array();
		foreach($cont_wrapped_data as $k => $v){
			if($v && (substr($k,0,2)=='u.')){
				$fn=substr($k,2);
				array_push($sql_ins_f,$fn);
				if($fn=='password')
					array_push($sql_ins_v,"PASSWORD('".escape_data($v)."')");
				else
					array_push($sql_ins_v,"'".escape_data($v)."'");
			}
		}
		array_push($sql_ins_f,'license');
		array_push($sql_ins_v,LIC_BTS|LIC_KBS);
		array_push($sql_ins_f,'user_is');
		array_push($sql_ins_v,USER_IS_CUSTOMER|USER_IS_LOCKED);
		if(!isset($cont_wrapped_data['u.added_by'])){
			array_push($sql_ins_f,'added_by');
			array_push($sql_ins_v,$uid);
		}
		array_push($sql_ins_f,'reg_date');
		array_push($sql_ins_v,'NOW()');

		$ins_f_str=implode(', ',$sql_ins_f);
		$ins_v_str=implode(', ',$sql_ins_v);

		//echo "Add <br>";
		$query="INSERT INTO users ($ins_f_str) VALUES ($ins_v_str)";
		//echo "$query<br>\n";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into users table.');
		$puid=mysql_insert_id();

		$sql_ins_f=array();
		$sql_ins_v=array();
		foreach($cont_wrapped_data as $k => $v){
			if($v && (substr($k,0,2)=='c.')){
				array_push($sql_ins_f,substr($k,2));
				array_push($sql_ins_v,"'".escape_data($v)."'");
			}
		}
		array_push($sql_ins_f,'uid');
		array_push($sql_ins_v,$puid);

		$ins_f_str=implode(', ',$sql_ins_f);
		$ins_v_str=implode(', ',$sql_ins_v);

		$query="INSERT INTO contacts ($ins_f_str) VALUES ($ins_v_str)";
		//echo "$query<br>\n";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into contacts table.');

		return $puid;
	}

	function unwrap_field($fn,$str){
		$cols='::::::::::::::::::::::::::::::::::::';
		$unwrapped_fields=array();

		$a=explode(':',$str);
		foreach($a as $i => $s){
			$t=substr($cols,0,$i);
			//echo $fn.$t."=$s<br>\n";
			$unwrapped_fields[$fn.$t]=$s;
		}
		return $unwrapped_fields;
	}

	function wrap_field(&$cont_data,$fn){
		$cols='::::::::::::::::::::::::::::::::::::';
		$wf='';
		for($i=0;$i<strlen($cols);$i++){
			$t=substr($cols,0,$i);
			//echo $fn.$t." $wf<br>\n";
			if(!isset($cont_data[$fn.$t]))
				return $wf;

			//echo $fn.$t." '$wf'<br>\n";
			if(strlen($wf) && strlen($cont_data[$fn.$t]))
				$wf.=':'.$cont_data[$fn.$t];
			elseif(!strlen($wf))
				$wf=$cont_data[$fn.$t];
		}
		//echo ">>$fn $wf <br>\n";
		return $wf;
	}

	function import_contact($cont_data){
		if(!count($cont_data))
			return FALSE;

		if(isset($cont_data['cust.name']) && trim($cont_data['cust.name'])){
			$cust_name=trim($cont_data['cust.name']);
			$cust_id=simple_query("SELECT cid FROM customers WHERE !(options&".CUST_OPT_INTERNAL.") AND name='".escape_data($cust_name)."'");
		}else{
			$cont_data['cust.name']='';
			$cust_id=0;
		}
		if(!$cust_id && $cont_data['cust.name']){
			$sql_ins_f=array();
			$sql_ins_v=array();
			foreach($cont_data as $k => $v){
				if(substr($k,0,5)=='cust.'){
					array_push($sql_ins_f,substr($k,5));
					array_push($sql_ins_v,"'".escape_data($v)."'");
				}
			}
			array_push($sql_ins_f,'reg_date');
			array_push($sql_ins_v,'NOW()');

			$ins_f_str=implode(', ',$sql_ins_f);
			$ins_v_str=implode(', ',$sql_ins_v);

			$query="INSERT INTO customers ($ins_f_str) VALUES ($ins_v_str)";
			echo "$query<br>\n";
			if(!@mysql_query($query))
				_die2(__FILE__.':'.__LINE__." Could not insert into customers table.");
			$cust_id=mysql_insert_id();
		}
		$cont_data['u.customer_id']=$cust_id;
		return $this->add_contact($cont_data);
	}

	function &unwrap_hash($hash){
		$unwrapped_data=array();
		$ref=&$unwrapped_data;

		foreach($hash as $hk => $hv){
			$tmp=$this->unwrap_field($hk,$hv);
			//echo "$hk --> "; print_r($tmp);echo "<br>\n";
			foreach($tmp as $k => $v)
				$unwrapped_data[$k]=$v;
			if(!isset($unwrapped_data[$hk.':']))
				$unwrapped_data[$hk.':']='';
			if(!isset($unwrapped_data[$hk.'::']))
				$unwrapped_data[$hk.'::']='';
		}

		return $ref;
	}

	function &get_unwrapped_contact_data($cont_uid){
		global $yxlk2name;

		$real_keys=array();
		foreach(array_keys($yxlk2name) as $yxlk){
			if(substr($yxlk,-1,1)==":")
				continue;
			array_push($real_keys,$yxlk);
		}
		array_push($real_keys,'c.options');
		$sel_fields_str=implode(', ',$real_keys);

		$query="SELECT $sel_fields_str FROM users AS u LEFT OUTER JOIN contacts AS c ON u.uid=c.uid LEFT OUTER JOIN customers AS cust ON u.customer_id=cust.cid WHERE u.uid=$cont_uid";
		//echo "$query <br>\n"; print_r($real_keys);
		$CInfo=simple_query($query);
                if(!$CInfo)
			return FALSE;
//                          _die2(__FILE__.':'.__LINE__.' Could not select from users table.');

		$cinfo_hash=array();
		for($i=0;$i<count($CInfo);$i++)
			$cinfo_hash[$real_keys[$i]]=$CInfo[$i];

		return $this->unwrap_hash($cinfo_hash);
	}

	function update_contact($cont_uid,&$unwrapped_cont_data){

		$sql_u_update=array();
		$sql_c_update=array();

		foreach(array_keys($unwrapped_cont_data) as $yxlk){
			if(substr($yxlk,-1,1)==":")
				continue;

			$wf=$this->wrap_field($unwrapped_cont_data,$yxlk);
			//echo "*** $yxlk $wf <br>\n";

			if(substr($yxlk,0,2)=="u."){
				$fn=substr($yxlk,2);
				array_push($sql_u_update,"$fn='".escape_data($wf)."'");
			}elseif(substr($yxlk,0,2)=="c."){
				$fn=substr($yxlk,2);
				array_push($sql_c_update,"$fn='".escape_data($wf)."'");
			}
		}

                if(count($sql_u_update)){
                	$sql_str=implode(', ',$sql_u_update);
                        $query="UPDATE users SET $sql_str WHERE uid=$cont_uid";
                        //echo "$query <br>";die;
                        if(!@mysql_query($query))
                		_die2(__FILE__.':'.__LINE__.' Could not update users table.');
                }

                if(!simple_query("SELECT uid FROM contacts WHERE uid=$cont_uid LIMIT 1")){
                // New contact record
                	$q="INSERT INTO contacts (uid) VALUES ($cont_uid)";
                        if(!@mysql_query($q))
                		_die2(__FILE__.':'.__LINE__.' Could not insert into contacts table.');
                }

                if(count($sql_c_update)){
                	$sql_str=implode(', ',$sql_c_update);
                        $query="UPDATE contacts SET $sql_str WHERE uid=$cont_uid";
                	//echo "$query <br>";
                        if(!@mysql_query($query))
                        	_die2(__FILE__.':'.__LINE__.' Could not update users table.');

                }
	}

	function &get_contacts_array($cids){
		$cids_sql_str='';
		if($cids){
			foreach($cids as $i => $c)
				if(!$c || !is_numeric($c)) $cids[$i]=0;
			$cids_sql_str=" AND (u.customer_id IN (".implode(',',$cids).")".(in_array(0,$cids)?" OR u.customer_id IS NULL":'').")";
		}

		$query=$this->conts_query_sql.$cids_sql_str;
		$query.=" ORDER BY u.last_name, u.first_name";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from users table.');

		$conts=array();
		while($row=mysql_fetch_array($result,MYSQL_ASSOC))
			$conts[$row['uid']]=$row;

		$ref=&$conts;
		return $ref;
	}

	var $conts_query_result=FALSE;
        function first_contact($subset=FALSE,$nopt=FALSE){

                if($this->conts_query_result && is_resource($this->conts_query_result))
                        mysql_free_result($this->conts_query_result);

		$query=$this->conts_query_sql;
                if(is_array($subset) && count($subset))
                	$query.=' AND u.uid IN ('.implode(',',$subset).')';

		if($nopt)
			$query.=" AND (c.options IS NULL OR !(c.options&$nopt))";

                //echo "$query<br>\n";
                if(!($this->conts_query_result=@mysql_unbuffered_query($query)))
                        _die2(__FILE__.':'.__LINE__.' Could not select from contacts table.');

                return mysql_fetch_array($this->conts_query_result,MYSQL_ASSOC);
        }

        function next_contact(){
                return mysql_fetch_array($this->conts_query_result,MYSQL_ASSOC);
        }

	function construct_full_name($row){
		$ln=$row['last_name'];
		$tmp=$this->unwrap_field('last_name',$ln);
		if(count($tmp))
			$ln=$tmp['last_name'];

		$fn=$row['first_name'];
		$tmp=$this->unwrap_field('first_name',$fn);
		if(count($tmp))
			$fn=$tmp['first_name'];

		return($ln.', '.$fn);
	}

	function can_delete($cont_uid){
		global $uid;
		global $user_is;

		if(!($user_is&USER_IS_MU) && !simple_query("SELECT COUNT(uid) FROM users WHERE uid=$cont_uid AND added_by=$uid"))
			return FALSE;
		elseif(simple_query("SELECT COUNT(rid) FROM requests WHERE filed_by=$cont_uid"))
			return FALSE;
		elseif(simple_query("SELECT COUNT(cid) FROM customers WHERE tech_contact_uid='".$cont_uid."' OR biz_contact_uid='".$cont_uid."'"))
			return FALSE;

		return TRUE;
	}

	function find_user_by_email($uem){
		return(simple_query("SELECT uid FROM users WHERE email='".escape_data("$uem")."' LIMIT 1"));
	}

	function customer($uid){
		$row=simple_query("SELECT customer_id, user_is FROM users WHERE uid=$uid LIMIT 1");
		if(!$row)
                        _die2(__FILE__.':'.__LINE__.' Could not select from users table.');

		if($row[0] || ($row[1]&USER_IS_CUSTOMER))
			return $row[0];

		return internal_customer();
	}
}

$yxlk2outlook = array(
	'u.first_name' => 'First Name',
	'u.first_name:' => 'Middle Name',
	'u.last_name' => 'Last Name',
	'u.last_name:' => 'Suffix',

	'c.department' => 'Department',
	'c.title' => 'Job Title',

	'c.street_addr' => 'Business Street',
	'c.street_addr:' => 'Business Street 2',
	'c.street_addr::' => 'Business Street 3',
	'c.city' => 'Business City',
	'c.state' => 'Business State',
	'c.zip' => 'Business Postal Code',
	'c.country' => 'Business Country',
	'c.tel' => 'Business Phone',
	'c.tel:' => 'Business Phone 2',
	'c.fax' => 'Business Fax',
	'u.email' => 'E-mail Address',

	'c.h_street_addr' => 'Home Street',
	'c.h_street_addr:' => 'Home Street 2',
	'c.h_street_addr::' => 'Home Street 3',
	'c.h_city' => 'Home City',
	'c.h_state' => 'Home State',
	'c.h_zip' => 'Home Postal Code',
	'c.h_country' => 'Home Country',
	'c.htel' => 'Home Phone',
	'c.htel:' => 'Home Phone 2',
	'c.hfax' => 'Home Fax',
	'c.hemail' => 'E-mail 2 Address',

	'c.o_street_addr' => 'Other Street',
	'c.o_street_addr:' => 'Other Street 2',
	'c.o_street_addr::' => 'Other Street 3',
	'c.o_city' => 'Other City',
	'c.o_state' => 'Other State',
	'c.o_zip' => 'Other Postal Code',
	'c.o_country' => 'Other Country',
	'c.otel' => 'Other Phone',
	'c.otel:' => 'Other Phone 2',
	'c.ofax' => 'Other Fax',
	'c.oemail' => 'E-mail 3 Address',

	'c.mtel' => 'Mobile Phone',
	'c.mtel:' => 'Pager',

	'c.descr' => 'Notes',

	'cust.name' => 'Company',
	'cust.tel' => 'Company Main Phone');

//Title
//Private
//Assistant's Name
//Assistant's Phone
//Callback
//Car Phone
//ISDN
//Primary Phone
//Radio Phone
//TTY/TDD Phone
//Telex
//Account
//Anniversary
//Billing Information
//Birthday
//Business Address PO Box
//Categories
//Children
//Directory Server
//E-mail Type
//E-mail Display Name
//E-mail 2 Type
//E-mail 2 Display Name
//E-mail 3 Type
//E-mail 3 Display Name
//Gender
//Government ID Number
//Hobby
//Home Address PO Box
//Initials
//Internet Free Busy
//Keywords
//Language
//Location
//Manager's Name
//Mileage
//Office Location
//Organizational ID Number
//Other Address PO Box
//Priority
//Profession
//Referred By
//Sensitivity
//Spouse
//User 1
//User 2
//User 3
//User 4
//Web Page
	$yxlk2name=array();
	foreach($yxlk2outlook as $k => $v){
		if(substr($k,-1,1)==":")
			continue;
		if($k=="u.email")
			$yxlk2name[$k]="Business E-mail Address";
		elseif($k=="c.hemail")
			$yxlk2name[$k]="Home E-mail Address";
		elseif($k=="c.oemail")
			$yxlk2name[$k]="Other E-mail Address";
		else
			$yxlk2name[$k]=$v;
		if(isset($yxlk2outlook[$k.':']))
			$yxlk2name[$k.':']=$v.' part2';
		if(isset($yxlk2outlook[$k.'::']))
			$yxlk2name[$k.'::']=$v.' part3';
	}
	$yxlk2name['u.spec']='';
        $yxlk2name['u.customer_id']='';
        $yxlk2name['u.added_by']='';
        $yxlk2name['u.report_to']='';
        $yxlk2name['cust.cae_mgr_uid']='';
        $yxlk2name['cust.sls_mgr_uid']='';
        $yxlk2name['c.owner']='';
	$yxlk2name['c.lead_source']='';
        $yxlk2name['c.lead_descr']='';
        $yxlk2name['c.lead_ref_by']='';
        $yxlk2name['c.lead_status']='';
        $yxlk2name['c.lead_status_descr']='';



?>
