<?php
// $Header: /home/CVS/rps/includes/db.inc,v 1.282 2008/08/07 04:55:03 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

	if(ini_get('register_globals'))
		die("Please set 'register_globals = Off' in your php.ini file");

	$YxlVer='1.23';
        $YxlErrEmail='support';

	$cmd_line_mode=FALSE; $dir_name='';
	$rel_script_name=$_SERVER['PHP_SELF'];
	$root_fdir=getcwd();
	if(isset($_SERVER['SERVER_NAME'])){
		$tmp=preg_replace('/\/+/', '/', $_SERVER['PHP_SELF']);
		if(($p=strpos($_SERVER['SCRIPT_FILENAME'],$tmp))===FALSE)
			die(__FILE__.':'.__LINE__." Could not automatically determine absolute path for Yoxel root directory.<br>\nPHP _SERVER array inconsistency _SERVER[SCRIPT_FILENAME]=".$_SERVER['SCRIPT_FILENAME']." vs. _SERVER[PHP_SELF]=".$_SERVER['PHP_SELF']);

		$root_fdir=substr($_SERVER['SCRIPT_FILENAME'],0,$p);
		$tmp=explode('/',$tmp);
		if(!file_exists($root_fdir.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'rts')){
			array_shift($tmp);
			$root_fdir=$root_fdir.DIRECTORY_SEPARATOR.$tmp[0];
			$dir_name='/'.$tmp[0];
		}
		array_shift($tmp);
		$rel_script_name=implode(DIRECTORY_SEPARATOR,$tmp);
		if(!file_exists($root_fdir.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'rts'))
			die(__FILE__.':'.__LINE__.' Could not automatically determine absolute path for Yoxel root directory.');
	}else
		$cmd_line_mode=TRUE;

	$ytf=DIRECTORY_SEPARATOR.'yoxel_tmp_files';
	// Depricated:	$rel_tmp_dir=$dir_name.$ytf;
	//		$abs_tmp_dir=$root_fdir.$ytf;
	$abs_tmp_dir=DIRECTORY_SEPARATOR.'tmp'.$ytf;
	$temp_file=tempnam(md5(uniqid(rand(),TRUE)),'');
	if($temp_file){
               	$temp_dir=realpath(dirname($temp_file));
               	unlink($temp_file);
		$abs_tmp_dir=$temp_dir.$ytf;
	}
	if(!file_exists($abs_tmp_dir)){
		if(!mkdir($abs_tmp_dir))
			die("Could not create temporary directory: $abs_tmp_dir.");
	}

	if(!isset($production_mode)){
		$production_mode=TRUE;
		$dot_dbg=$root_fdir.DIRECTORY_SEPARATOR.'.debug';
		if(file_exists($dot_dbg))
			$production_mode=FALSE;
	}

	if(!isset($xsw_mode)){
		$xsw_mode=FALSE;
		$dot_xsw=$root_fdir.DIRECTORY_SEPARATOR.'.xsw';
		if(file_exists($dot_xsw))
			$xsw_mode=TRUE;
	}

	if(!isset($asp_mode)){
		$asp_mode=FALSE;
		$dot_asp=$root_fdir.DIRECTORY_SEPARATOR.'.asp';
		if(file_exists($dot_asp))
			$asp_mode=TRUE;
	}

	if(!isset($server_update)){
		$server_update=FALSE;
		$dot_supd=$root_fdir.DIRECTORY_SEPARATOR.'.supd';
		if(file_exists($dot_supd))
			$server_update=TRUE;
	}

	$jpgraph=FALSE;
	if(file_exists($root_fdir.DIRECTORY_SEPARATOR.'jpgraph'))
		$jpgraph=TRUE;

	$ezpdf=FALSE;
	if(file_exists($root_fdir.DIRECTORY_SEPARATOR.'ezpdf'))
		$ezpdf=TRUE;

	$extra=FALSE;
	if(file_exists($root_fdir.DIRECTORY_SEPARATOR.'report'))
		$extra=TRUE;

	set_include_path(get_include_path().PATH_SEPARATOR.$root_fdir);
	$pear=FALSE;
	if(file_exists($root_fdir.DIRECTORY_SEPARATOR.'pear')){
		$pear=TRUE;
		set_include_path(get_include_path().PATH_SEPARATOR.$root_fdir.DIRECTORY_SEPARATOR.'pear');
	}

	require_once('includes/config_check.inc');
	YxlConfigCheck::InstallCheck();

	require_once('includes/i18n/i18n.inc');

	ini_set('mbstring.func_overload',7);
	mb_language("uni");
	mb_detect_order("auto");
	mb_internal_encoding("UTF-8");

	if(!$cmd_line_mode){
		mb_http_output("UTF-8");
		ob_start("mb_output_handler");
		if($production_mode){
			ini_set('display_errors', FALSE);
			error_reporting(0); // Production level
		}else{
			ini_set('display_errors', TRUE);
			error_reporting(E_ALL); // Development level
		}

		if(defined('YXL_SESSION_TOUT_MIN') && is_int(YXL_SESSION_TOUT_MIN))
			session_set_cookie_params(YXL_SESSION_TOUT_MIN*60);
		else
		// 120min per session
			session_set_cookie_params(7200);

		session_start();
	}

	if(defined('YXL_SMTP_HOST') && YXL_SMTP_HOST)
		require_once('Mail.php');

	require_once("includes/base.inc");
	require_once('includes/users.inc');

	if($asp_mode){
		$img_dir=$dir_name.'/asp/img';
		require_once('includes/asp/db.inc');
	}else{
		$at_isp=FALSE;
		$img_dir=$dir_name.'/img';
		require_once('includes/sw/db.inc');
	}

        $YxlErrEmail='support@'.$MyDomain;
	if(defined('YXL_ERR_EMAIL') && is_email(YXL_ERR_EMAIL))
		$YxlErrEmail=YXL_ERR_EMAIL;

	// It is Ok to use these functions now:
	// _die, _die2, _quit_error, _live_error, _warning

	if (($RequireLogin==2) && !($user_is&USER_IS_MU))
		_quit_error('Only Master Users can access this page.');

	if (($RequireLogin==3) && !($user_is&USER_IS_M))
		_quit_error('Only Master Users or Managers can access this page.');

	if($RequireLogin>0){
		// Restore $_POST after login
		if((count($_POST)==0) && isset($_SESSION['saved_post_array'])){
			$_POST=$_SESSION['saved_post_array'];
			$_GET=array();
			unset($_SESSION['saved_post_array']);
		}
	}

	// We are Ok - connected and password checked
	require_once('includes/wf.inc');
	require_once('includes/params/user_params.inc');
	require_once("includes/help.inc");
	if(!$cmd_line_mode && $uid){
		$user_params= new UserParams($uid);
		$help_msg= new HelpMsg();

		$all_users_2d=&YxlUsers::v16compat_init_users();
		$active_users=&YxlUsers::v16compat_active_users();
	}

 	// Convert all escaped variables for GET, POST & COOKIE
	if (get_magic_quotes_gpc()) {
		$_POST = array_map('stripslashes_deep', $_POST);
		$_GET = array_map('stripslashes_deep', $_GET);
		$_COOKIE = array_map('stripslashes_deep', $_COOKIE);
	}

	require_once('includes/menu.inc');

?>
