<?php
// $Header: /home/CVS/rps/includes/help.inc,v 1.6 2008/05/04 00:19:13 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

class HelpMsg {

	var $hlp_prefix_str;

	function helpmsg($init=FALSE) {
		global $uid;
		global $root_fdir;
		global $MyCN;
		global $user_params;

		$this->hlp_prefix_str='hlp';

		if(!$init || !$user_params) return;

		$query='';
		$files=glob($root_fdir. DIRECTORY_SEPARATOR ."*",GLOB_ONLYDIR);
		foreach($files as $ff){
			$sdir=basename($ff);
			if(!is_dir($root_fdir. DIRECTORY_SEPARATOR .$sdir)) continue;
			$hf=$root_fdir. DIRECTORY_SEPARATOR .$sdir. DIRECTORY_SEPARATOR .'_help.inc';
			if(isset($_help))
				$_help=array();
			if(!file_exists($hf) || !is_readable($hf))
				continue;

			require($hf);
			//echo "$hf <br>\n";
			if(!isset($_help))
				continue;

			foreach($_help as $ttnav => $v)
				foreach(array_keys($v) as $dstag)
					$user_params->pset($this->hlp_prefix_str.$ttnav.'/'.$sdir.'/'.$dstag,1);
		}
		$user_params->save();

	}

	function hlp_prefix_str(){
		return $this->hlp_prefix_str;
	}

	function hlp_msg_exists($ttnav){
		global $root_fdir;
		global $rel_script_name;
		global $MyCN;

		$hps=$this->hlp_prefix_str;

		$sdir=dirname($rel_script_name);

		if(isset($_POST[$hps]))
			$stag=substr(basename($rel_script_name),0,-4).$_POST[$hps];
		elseif(isset($_GET[$hps]))
			$stag=substr(basename($rel_script_name),0,-4).$_GET[$hps];
		else
			$stag=substr(basename($rel_script_name),0,-4);

		$hf=$root_fdir. DIRECTORY_SEPARATOR .$sdir. DIRECTORY_SEPARATOR .'_help.inc';
		//echo "$hps $sdir $stag $hf<br>\n";

		if(!file_exists($hf) || !is_readable($hf))
			return '';

		require($hf);
		if(!isset($_help))
			return '';

		if(!isset($_help[$ttnav][$stag]))
			return '';

		return $ttnav.'/'.$sdir.'/'.$stag;
	}

	function get_help($dstag){
		global $root_fdir;
		global $MyCN;

		if(!$dstag)
			return array();

		$a=explode('/',$dstag);
		if(count($a)!=3)
			return array();

		$hf=$root_fdir. DIRECTORY_SEPARATOR .$a[1]. DIRECTORY_SEPARATOR .'_help.inc';

		if(!file_exists($hf) || !is_readable($hf))
			return array();

		require($hf);
		if(!isset($_help))
			return array();

		if(!isset($_help[$a[0]][$a[2]]))
			return array();

		return $_help[$a[0]][$a[2]];

	}

	function output($dstag,$rts_mode=''){
		global $img_dir;
		global $is_customer;
		global $customers_2d;
		global $yoxel_db;
		global $dir_name;


		$hlp=$this->get_help($dstag);
		$hlp_hdr=isset($hlp['hdr'])?$hlp['hdr']:'HOW TO ';
		$hlp_msg=isset($hlp['msg'])?$hlp['msg']:'(help text is not available for this page)';

		if($is_customer)
			init_users();

		if($rts_mode)
			echo '
	<table border="0" cellpadding="0" cellspacing="1" width="100%" align="center" class="dgray">
	<tr class="ddgray">
		<th class="title" colspan="3">'.$hlp_hdr.'</th>
	</tr>';
		else
			echo '
	<table border="1" cellpadding="0" cellspacing="0" width="100%" align="center">';
?>

	<tr>
		<td <?php echo $rts_mode?'class="lgray" colspan="3"':'class="dgray"'; ?>>
		<table border="0" cellpadding="0" cellspacing="0" align='left'>
<?php
		if(!$rts_mode){
?>

		<tr>
			<td valign='top'><img src="<?php echo $img_dir; ?>/tit_grey.gif" width="11" height="14" alt=""></td>
			<td valign='top' class='title'><?php echo $hlp_hdr;?></td>
		</tr>
<?php
		}
?>
		<tr>
			<td></td>
			<td><br><?php echo $hlp_msg; ?><br><br></td></tr>
		</table>
		</td>
	</tr>
	<tr>
		<td <?php echo $rts_mode?'class="lgray" colspan="3"':'class="dgray"'; ?>>
		<table border="0" cellpadding="0" cellspacing="0" align='left'>
		<tr>
			<td valign='top'><img src="<?php echo $img_dir; ?>/tit_dgrey.gif" width="11" height="14" alt=""></td>
			<td valign='top' class='title'>YOXEL SUPPORT</td>
		</tr>
		<tr>
			<td></td>
			<td><br>
<?php
		if($is_customer && isset($customers_2d['cae_mgr'][$is_customer])){
			if($tm=$customers_2d['cae_mgr'][$is_customer]){
				echo '
				E-mail your account manager from ['.$_SESSION['crn'].']: <a  style="text-decoration: underline;" href="mailto:'.YxlUsers::email($tm).'" onfocus="blur()">'.YxlUsers::name($tm).'</a><br>';
			}
		}elseif($is_customer && isset($customers_2d['sls_mgr'][$is_customer])){
			if($bm=$customers_2d['sls_mgr'][$is_customer]){
				echo '
				E-mail your account manager from ['.$_SESSION['crn'].']: <a  style="text-decoration: underline;" href="mailto:'.YxlUsers::email($bm).'" onfocus="blur()">'.YxlUsers::name($bm).'</a><br>';
			}
		}

		echo '
			E-mail <a  style="text-decoration: underline;" href="mailto:support@yoxel.com" onfocus="blur()">Yoxel Support Team</a><br>';
		if(isset($yoxel_db) && $yoxel_db){
			echo '
			<a style="text-decoration: underline;" href="javascript:ext_bts_open()">File a request for Yoxel.Com</a>
			<br><br>';
		}else
			echo '
			<br><br>';
?>
			</td>
		</tr>
		</table>
		</td>
	</tr>
<?php
		if(!$rts_mode)
			echo '
	</table>';
	}

}

?>
