<?php
// $Header: /home/CVS/rps/includes/i18n/i18n.inc,v 1.9 2008/07/19 21:47:25 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

class I18N {
    var $messages;
    var $images;
    var $lang;
    var $msgs_input_charset;

    var $image_base_path = '/usr/local/www/images';
    var $image_base_url = '/images';

    function i18n($lang=FALSE){
    	global $root_fdir;

	$this->lang='en_US';
	$i18n_inc_dir=$root_fdir.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'i18n';
	$i18n_inc=$i18n_inc_dir.DIRECTORY_SEPARATOR.'en_US.inc';

	if(!$lang){
		$lang='en_US';
    		if(isset($_SESSION['lang']) && is_string($_SESSION['lang']))
    			$lang=$_SESSION['lang'];
		elseif(defined('YXL_DEFAULT_LANG') && is_string(YXL_DEFAULT_LANG))
			$lang=YXL_DEFAULT_LANG.'.inc';
	}else
		$_SESSION['lang']=$lang;

	$fn=$i18n_inc_dir.DIRECTORY_SEPARATOR.$lang.'.inc';
	if(file_exists($fn)){
		$this->lang=$lang;
		$i18n_inc=$fn;
	}

	require_once($i18n_inc);
	$this->messages=$messages;

	$this->msgs_input_charset="UTF-8";
	if(isset($msgs_input_charset) && $msgs_input_charset)
		$this->msgs_input_charset=$msgs_input_charset;

	$this->jpgraph_ttf='';
	if(isset($jpgraph_ttf) && $jpgraph_ttf)
		$this->jpgraph_ttf=$jpgraph_ttf;

	$this->ezpdf_output_charset='';
	if(isset($ezpdf_output_charset) && $ezpdf_output_charset)
		$this->ezpdf_output_charset=$ezpdf_output_charset;
    }

    function get_msg($argv) {

    	if(count($argv)<1)
    		_die0("No Message Id specified\n");

    	$msgn=array_shift($argv);
    	$numargs=count($argv);

        if( !isset($this->messages[$msgn]) )
        	_die("Unknown message number: $msgn");

        $mic=$this->msgs_input_charset;

        if($this->messages[$msgn][1]!=$numargs) {
        	return mb_convert_encoding($this->messages[$msgn][0],'UTF-8',$mic);
        }

        $msg=mb_convert_encoding($this->messages[$msgn][0],'UTF-8',$mic);
        switch( $numargs ) {
            case 1:
                $msg = sprintf($msg,$argv[0]);
                break;
            case 2:
                $msg = sprintf($msg,$argv[0],$argv[1]);
                break;
            case 3:
                $msg = sprintf($msg,$argv[0],$argv[1],$argv[2]);
                break;
            case 4:
                $msg = sprintf($msg,$argv[0],$argv[1],$argv[2],$argv[3]);
                break;
            case 5:
                $msg = sprintf($msg,$argv[0],$argv[1],$argv[2],$argv[3],$argv[4]);
                break;
            case 0:
            default:
                $msg = sprintf($msg);
                break;
        }
        return $msg;
    }

    function get_territory(){
    	$a=explode('_',$this->lang);
    	return $a[1];
    }


    function ezpdf_output_charset(){
    	global $ezpdf;

    	if($ezpdf)
    		return $this->ezpdf_output_charset;

    	return FALSE;
    }

    function jpgraph_ttf(){
    	global $jpgraph;

    	if($jpgraph)
    		return $this->jpgraph_ttf;

    	return FALSE;
    }

/*
    function msg($s) {
        if (isset($this->messages[$s])) {
            return $this->messages[$s];
        } else {
            error_log("i18n error:LANG:" .
                "$this->lang,message:'$s'");
        }
    }

    function img($f) {
        if (is_readable("$this->image_base_path/" .
            "$this->lang/$f")) {
            print "$this->image_base_url/$this->lang/$f";
        } elseif (is_readable("$this->image_base_path/" .
            "global/$f")) {
            print "$this->image_base_url/global/$f";
        } else {
            error_log("l10n error:LANG:" .
                      "$this->lang,image:'$f'");
        }
    }
*/

}

class YxlI18N {
    function InstallCheck($lang=FALSE) {
    	global $yxl_i18n;

	if(!isset($yxl_i18n) || $lang)
        	$yxl_i18n = new I18N($lang);
    }

    function get_msg() {
    	global $yxl_i18n;

    	$argv = func_get_args();

	YxlI18N::InstallCheck();
	return $yxl_i18n->get_msg($argv);
    }

    function get_territory() {
    	global $yxl_i18n;

	YxlI18N::InstallCheck();
	return $yxl_i18n->get_territory();
    }

    function jpgraph_ttf() {
    	global $yxl_i18n;

	YxlI18N::InstallCheck();
	return $yxl_i18n->jpgraph_ttf();
    }

    function ezpdf_output_charset() {
    	global $yxl_i18n;

	YxlI18N::InstallCheck();
	return $yxl_i18n->ezpdf_output_charset();
    }
}
?>
