<?php
// $Header: /home/CVS/rps/includes/itpm/itp.inc,v 1.46 2008/04/30 19:08:02 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('includes/itrts/tts.inc');
require_once('includes/project/pps.inc');

	define ('CDB_CREATE_ITPM_HISTORY_TBL', "CREATE TABLE IF NOT EXISTS itpm_history
	    (hid INT UNSIGNED NOT NULL AUTO_INCREMENT,
	    proj_id int UNSIGNED default NULL,
	    uid int UNSIGNED default NULL,
	    state VARCHAR(64) NOT NULL,
	    date DATETIME,
	    descr text,
	    type INT UNSIGNED DEFAULT 0 NOT NULL,
	    xid INT UNSIGNED DEFAULT NULL,
	    xid2 INT UNSIGNED DEFAULT NULL,
	    xid3 INT UNSIGNED DEFAULT NULL,
	    PRIMARY KEY (hid),
		KEY (proj_id),
		KEY (uid),
		KEY (state),
		KEY (date),
		FULLTEXT (descr),
		KEY (type),
		KEY (xid)
	    ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

if(!$cmd_line_mode && $uid){

	$query = CDB_CREATE_ITPM_HISTORY_TBL;
	if(!@mysql_query ($query))
		_die0(__FILE__.':'.__LINE__.' Could not create itpm_history table. ');
}

class ITPlan extends ProjectPlan {

	var $project_info=array();
	var $mail_headers='';
	var $proj_id=0;
	var $log=array();
	var $rid2row=array();
	var $rid2dep=array();
	var $dep2rid=array();
	var $class2str=array();
	var $rts;
	var $inr='';

	function itplan($proj_id=FALSE, $full_mode=TRUE, $ts_overlap_mode=FALSE){
		global $MyDomain;
		global $MyCName;

		$wcal_users=array();

		$this->rts = new TicketTracker;
		$this->queues_2d=&$this->rts->queues_2d;

                $object_params=array(
		'class_tag'=>'itpm',

                'history_tbl' => $this->rts->object_params['history_tbl'],
                'history_proj_decommit_type' => HISTORY_TYPE_ITPM_DECOMMIT,
                'history_proj_plan_type' => HISTORY_TYPE_ITPM_PLAN,
                'pnets_tbl' => $this->rts->object_params['pnets_tbl'],

                'pnet_type_pri' => $this->rts->object_params['pnet_type_pri'],
                'pnet_type_ts' => PNET_TYPE_ITTS,

                'pq_tbl' => $this->rts->object_params['pq_tbl'],
                'pq_fn' => $this->rts->object_params['pq_fn'],

                'proj_id' => $proj_id,
                'proj_tbl' => 'itprojects',
                'proj_class_mask' => $this->rts->rps_class_mask,
                'proj_deadline_fn' => 'proj_deadline',
                'proj_id_fn' => 'proj_id',
                'proj_mem_type' => MEMB_TYPE_ITPROJ,
                'proj_history_tbl' => 'itpm_history',
                'proj_title' => 'IT Project',

                'requests_tbl' => $this->rts->object_params['requests_tbl'],
                'req_in_proj_fn' => $this->rts->object_params['req_in_proj_fn'],
                'req_proj_id_fn' => $this->rts->object_params['req_proj_id_fn'],
                'req_proj_pri_fn' => 'project_pri',
                'req_classes' => $this->rts->classes,
                'req_last_state_mask' => $this->rts->last_state_mask,
                'pm_phases' =>
                	array(
                		array(
                		'proj_state' => 'implement',
                		'mgr_fn' => 'it_mgr',
                		'implementer_fn' => 'fixer_uid',
                		'implementer_spec' => USPEC_IT,
                		'dflt_fix_fn' => 'dflt_fix_time',
                		'start_state_mask' => $this->rts->inwork_state_mask,
                		'done_state_mask' => $this->rts->fixed_state_mask,
                		'plan_start_fn' => 'plan_fix_start',
                		'plan_done_fn' => 'plan_fix_end',
                		'start_fn' => 'inwork_date',
                		'done_fn' => 'fixed_date',
                		'pnet_type' => PNET_TYPE_ITFIX
                		)
                	)
                );

		$this->mail_headers=email_header_From('ITPM');
		$this->proj_m_sign = " Please make sure that your browser has pop-up blocking disabled for this site.\n\n
						Sincerely,
						IT Project Management System";

		parent::projectplan($object_params,$full_mode,$ts_overlap_mode);
		unset($this->class2str[$this->rts->bug_class]);

		if(defined('YXL_ITPM_RDETECTION') && (YXL_ITPM_RDETECTION=='pqmgr'))
                        $this->rdetection_mode=1;
	}

	function file_request($class,$qid,$synop,$phase_of_rid,$depends_on){
		$fields=array();
		$fields['class']=$class;
		$fields['qid']=$qid;
		$fields['synopsis']=$synop;
		$fields['description']=' Preliminary ITPM request: '.$synop;
		if($phase_of_rid)
			$fields['phase_of_rid']=$phase_of_rid;
		if($depends_on)
			$fields['depends_on']=$depends_on;
		$fields['options']=REQ_OPT_RPSTMP;
		return $this->rts->file_request($fields);
	}


	function compute_plan(){
		return $this->compute_plan_1();
	}

	function _dashboard_intro($did,$uid,$info=FALSE){
		global $dir_name;
		global $is_customer;

		if($info)
			return array('header' => 'IT Project Management System (Intro)',
				'default_size' => 2,
				'type' => 'table/text',
				'only' => '/itpm');

		$tbl_str='
	<table border=0 cellpadding=0 cellspacing=1 width="100%" class="dgray" align="center">
	<tr style="height: 1" class="separator">
			<td></td>
	</tr>
	<tr class="lgray">
		<td colspan=6>
		<p>The system allows you to:
	<ul>
		<li>Collaboratively <a href="'.$dir_name.'/itpm/itpm_projects.php" style="text-decoration: underline">create a plan</a> for an IT project based on deadline, effort estimates and priorities.</li>
		<li>Track implementation of the project</li>
		<li>Generate various project reports</li>
	</ul>
	</p>
	<p>To see a list of all ongoing and finished projects please go to the <a href="'.$dir_name.'/itpm/itpm_projects.php" style="text-decoration: underline">summary</a> page. There you will be able to:
	<ul>
		<li>Start a new project</li>
		<li>See status of projects in progress</li>
		<li>See summary reports for finished projects</li>
	</ul>
	</p>
		</td>
	</tr>
	</table>';

		return $tbl_str;
	}

	function _dashboard_requests2close($did,$uid,$info=FALSE){
		global $is_customer;

		if($is_customer)
			return FALSE;

		if(prereq_check('pps_no_projects'))
			return FALSE;

		if($info){
			return array('header' => 'Project requests you need to close',
				'default_size' => 1,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => '#tickets to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
		}
		if(!$lim) $lim=5;

		$pq_sn=$this->rts->object_params['pq_title'];
		$sub_pq_sn=$this->rts->object_params['sub_pq_title'];
		$tbl_str='';

		$query="SELECT r.rid, CONCAT(q.name,'/',r.synopsis), r.state, CONCAT(e.name,'&nbsp;',rl.label) FROM itprojects AS rl INNER JOIN queues AS e ON rl.qid=e.qid INNER JOIN itrequests AS r ON rl.proj_id=r.project_id AND r.in_project='yes' INNER JOIN queues AS q ON r.qid=q.qid WHERE rl.state='done' AND ".$this->rts->sql_fixed_states_str." AND !".$this->rts->sql_last_states_str." AND r.filed_by=$uid ORDER BY rl.state, rl.proj_id, r.plan_fix_end LIMIT 10";
       		//echo "$query <br>\n";
       		if(!($result=@mysql_query($query)))
                	_die2(__FILE__.':'.__LINE__.' Could not select from itprojects table.');

        	if(mysql_num_rows($result)<1)
        		return $tbl_str;

                $tbl_str.= '
        <tr style="height: 1" class="separator">
                        <td colspan=4></td>
        </tr>
        <tr class=lgray>
                <th align="left">Project</th>
                <th>ID</th>
                <th align="left">'.$sub_pq_sn.'/Synopsis</th>
        </tr>';
                while($row=mysql_fetch_array($result, MYSQL_NUM)){
                        $tbl_str.= '
        <tr class="lgray" onmouseover="this.className=\'lgs\';" onmouseout="this.className=\'lgray\';" onClick="tts_view_win_open('.$row[0].')">
                <td>'.$row[3].'</td>
                <td align="center">'.$row[0].'</td>
                <td>'.$row[1].'</td>
        </tr>';
                }

		if($tbl_str)
			$tbl_str= '
		<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
		</table>';
		return $tbl_str;

	}

	function _dashboard_requests2work($did,$uid,$info=FALSE){
		global $is_customer;

		if($is_customer)
			return FALSE;

		if(prereq_check('pps_no_projects'))
			return FALSE;

		if($info){
			return array('header' => 'Project requests to work on',
				'default_size' => 2,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => '#tickets to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
		}
		if(!$lim) $lim=5;

		$pq_sn=$this->rts->object_params['pq_title'];
		$sub_pq_sn=$this->rts->object_params['sub_pq_title'];
		$tbl_str='';

		$query="SELECT r.rid, CONCAT(c.name,'/',r.synopsis), r.state, CONCAT(p.name,'&nbsp;',rl.label), IF(".$this->rts->sql_fixed_states_str.",'test','fix'), DATE_FORMAT(r.plan_fix_start,'%m/%e/%y'), DATE_FORMAT(r.plan_fix_end,'%m/%e/%y') FROM itprojects AS rl INNER JOIN itrequests AS r ON rl.proj_id=r.project_id AND r.in_project='yes' INNER JOIN queues AS c ON r.qid=c.qid INNER JOIN queues AS p ON rl.qid=p.qid WHERE (rl.state='implement' AND !".$this->rts->sql_fixed_states_str." AND r.fixer_uid=$uid) ORDER BY rl.proj_id, r.project_pri";
        	//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
               		_die2(__FILE__.':'.__LINE__.' Could not select from projects table.');
        	if(mysql_num_rows($result)<1)
        		return $tbl_str;
                $tbl_str.= '
        <tr style="height: 1" class="separator">
                        <td colspan=7></td>
        </tr>
        <tr class=lgray>
                <th align="left">Project</th>
                <th>ID</th>
                <th align="left">'.$sub_pq_sn.'/Synopsis</th>
                <th>To Do</th>
                <th>Planned Start</th>
                <th>Planned End</th>
                <th>Sate</th>
        </tr>';
                while($row=mysql_fetch_array($result, MYSQL_NUM)){
                        $tbl_str.= '
        <tr class="lgray" onmouseover="this.className=\'lgs\';" onmouseout="this.className=\'lgray\';" onClick="tts_view_win_open('.$row[0].')">
                <td>'.$row[3].'</td>
                <td align="center">'.$row[0].'</td>
                <td>'.$row[1].'</td>
                <td align="center">'.$row[4].'</td>
                <td align="center">'.$row[5].'</td>
                <td align="center">'.$row[6].'</td>
                <td align="center">'.$this->rts->state2str[$row[2]].'</td>
        </tr>';
                }

		if($tbl_str)
			$tbl_str= '
		<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
		</table>';
		return $tbl_str;
	}
}

	function rps_add_action_item($puid, $synop){
		global $uid;

		if($puid==$uid)
			$np=simple_query("SELECT MAX(pri) FROM ais WHERE (options&".AI_OPT_DONE.")=0
				AND owner='$puid' AND filed_by='$puid' GROUP BY pri");
		else
			$np=simple_query("SELECT MAX(pri) FROM ais WHERE (options&".AI_OPT_DONE.")=0
				AND owner='$puid' AND filed_by!='$puid' GROUP BY pri");
		$np++;

		$query = "INSERT INTO ais (synopsis, owner, pri, filed_by, reg_date)
			VALUES('$synop', '$puid', '$np', '$uid', NOW() )";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__.' Could add ActionItem.');
	}

init_users();
?>
