<?php
// $Header: /home/CVS/rps/includes/itrts/tts.inc,v 1.73 2008/05/28 18:23:33 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */
require_once('includes/db.inc');
require_once('includes/rts/rts.inc');

	define('HISTORY_TYPE_TTS', 8);
	define('HISTORY_TYPE_ITPM_DECOMMIT', 16);
	define('HISTORY_TYPE_ITPM_PLAN', 3);
	define('HISTORY_TYPE_QSET', 32);

	define('PROJ_OPT_TTS', 0x0002);

	define('PNET_TYPE_ITPRI',0x05);
	define('PNET_TYPE_ITFIX',0x06);
	define('PNET_TYPE_ITTS',0x07);

	define ('CDB_CREATE_ITHISTORY_TBL', "CREATE TABLE IF NOT EXISTS ithistory
	    (rid int UNSIGNED default NULL,
	    uid int UNSIGNED default NULL,
	    state int UNSIGNED NOT NULL default '0',
	    date DATETIME,
	    descr text,
	    options INT UNSIGNED DEFAULT 0 NOT NULL,
	    xid INT UNSIGNED DEFAULT NULL,
	    xid2 INT UNSIGNED DEFAULT NULL,
	    xid3 INT UNSIGNED DEFAULT NULL,
	    roptions INT UNSIGNED DEFAULT 0 NOT NULL,
		KEY (rid),
		KEY (uid),
		KEY (state),
		KEY (date),
		FULLTEXT (descr),
		KEY (options),
		KEY (xid)
	    ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('QUE_OPT_INTERNAL', 1);

	define('CDB_CREATE_QUEUES_TBL', 'CREATE TABLE IF NOT EXISTS queues
		(qid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		name VARCHAR(32) NOT NULL,
		parent INT UNSIGNED DEFAULT 0 NOT NULL,
		owner_jr INT UNSIGNED NOT NULL,
		owner_sr INT UNSIGNED NOT NULL,
		it_mgr INT UNSIGNED NOT NULL,
		options INT UNSIGNED NOT NULL,
		reg_date DATETIME NOT NULL,
		PRIMARY KEY (qid),
		UNIQUE KEY (name,parent),
			KEY mgr (it_mgr)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci');

	define('CDB_CREATE_ITREQUESTS_TBL', "CREATE TABLE IF NOT EXISTS itrequests
		(rid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		qid INT UNSIGNED NOT NULL,
		state INT UNSIGNED NOT NULL,
		synopsis VARCHAR(128) NOT NULL,
		description TEXT,
		class SMALLINT UNSIGNED NOT NULL,
		project_pri INT UNSIGNED,
		customer_id INT UNSIGNED NOT NULL,
		customer_pri SMALLINT UNSIGNED DEFAULT ".REQ_PRI_MEDIUM." NOT NULL,
		filed_by INT UNSIGNED NOT NULL,
		phase_of_rid INT UNSIGNED NOT NULL,
		fixer_uid INT UNSIGNED NOT NULL,
		tester_uid INT UNSIGNED NOT NULL,
		project_id INT UNSIGNED,
		in_project ENUM('yes', 'plan', 'maybe', 'no') DEFAULT 'maybe' NOT NULL,
		fixed_in_build VARCHAR(64) NOT NULL,
		reg_date DATETIME NOT NULL,
		plan_pri FLOAT UNSIGNED,
		options INT UNSIGNED NOT NULL,
		critical_order INT UNSIGNED NOT NULL,
		reported_in_build VARCHAR(64) NOT NULL,
		plan_fixer_uid INT UNSIGNED NOT NULL,
		platform INT UNSIGNED DEFAULT 0 NOT NULL,
		xrid INT UNSIGNED DEFAULT 0 NOT NULL,
		xrid_last_import DATETIME NOT NULL,
		depends_on INT UNSIGNED DEFAULT 0 NOT NULL,
		reported_in_rel_id INT UNSIGNED,
		fix_wrk_hrs INT UNSIGNED DEFAULT 0 NOT NULL,
		inwork_date DATETIME,
		fixed_date DATETIME,
		last_date DATETIME,
		plan_fix_start DATETIME,
		plan_fix_end DATETIME,
		complete_pct SMALLINT UNSIGNED,
		cal_fix_start DATETIME,
		cal_fix_end DATETIME,
		verified_date DATETIME,
		test_wrk_hrs INT UNSIGNED DEFAULT 0 NOT NULL,
		dup_rid INT UNSIGNED DEFAULT 0 NOT NULL,
		PRIMARY KEY rid (rid),
			FULLTEXT (synopsis, description),
			KEY (project_pri),
			KEY (plan_pri),
			KEY (filed_by),
			KEY (fixer_uid),
			KEY (phase_of_rid)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('CDB_CREATE_ITPROJECTS_TBL', "CREATE TABLE IF NOT EXISTS itprojects
		(proj_id INT UNSIGNED NOT NULL AUTO_INCREMENT,
		qid INT UNSIGNED NOT NULL,
		state ENUM('plan', 'implement', 'done'),
		label VARCHAR(64) NOT NULL,
		plan_start_date DATETIME,
		implement_start_date DATETIME,
		done_date DATETIME,
		dflt_fix_time MEDIUMINT UNSIGNED DEFAULT '8' NOT NULL,
		proj_deadline DATE,
		estimated_fix_end DATETIME,
		good_fix_rate SMALLINT UNSIGNED DEFAULT '100' NOT NULL,
		type INT UNSIGNED NOT NULL,
		added_by INT UNSIGNED NOT NULL,
		ct_pct TINYINT UNSIGNED DEFAULT '0' NOT NULL,
		avg_fix_hrs MEDIUMINT UNSIGNED,
		description TEXT,
	    	options INT UNSIGNED NOT NULL,
		PRIMARY KEY (proj_id),
			UNIQUE KEY (qid, label)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

if(!$cmd_line_mode && $uid){
	require_once('includes/itrts/default_wf_tts.inc');

	$query = CDB_CREATE_QUEUES_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create queues table. ');

	$nrecords=simple_query("SELECT COUNT(qid) FROM queues");
	if($nrecords<1){
		$query = "INSERT INTO queues (name, owner_jr, owner_sr, it_mgr, reg_date) VALUES('IT', $uid, $uid, $uid, NOW() )";
		if(!@mysql_query($query))
			_die(__FILE__.':'.__LINE__.' Can not add to queues table.');
	}

	$query = CDB_CREATE_ITREQUESTS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create itrequests table. ');

	$query = CDB_CREATE_ITHISTORY_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create ithistory table. ');

	$query = CDB_CREATE_ITPROJECTS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create itprojects table. ');

}

class TicketTracker extends RequestTracker {
	var $xbts=array();
	var $state2str=array();
	var $queues_2d;

	function tickettracker(){
		global $is_customer;

		$object_params = array(
		'wfid' => 'tts',
		'rts_short_name' => 'TTS',
		'rts_long_name' => 'Ticket Tracking System',
		'requests_tbl' => 'itrequests',
		'req_view_script' => '/itrts/tts_view.php',
		'req_email_view_script' => '/itrts/tts.php',
		'pq_tbl' => 'queues',
		'history_tbl' => 'ithistory',
		'history_rts_type' => HISTORY_TYPE_TTS,
		'history_pqset_type' => HISTORY_TYPE_QSET,
		'members_tbl' => 'members',
		'member_cc_type' => MEMB_TYPE_TTSCC,
		'member_pqlist_type' => MEMB_TYPE_QLIST,
		'customer_class_mask_fn' => 'tts_class_mask',
		'pq_fn' => 'qid',
		'pq_owners' => array('owner_jr','owner_sr','it_mgr'),
		'pq_long_title' => sprintf(HDR_LONG_PQ_F,'Environment','Queue'),
		'pq_title' => 'Environment',
		'sub_pq_title' => 'Queue',
		'req_proj_id_fn' => 'project_id',
                'req_in_proj_fn' => 'in_project',

                'proj_tbl' => 'itprojects',
                'proj_id_fn' => 'proj_id',
		'proj_rts_opt' => PROJ_OPT_TTS,

                'pnets_tbl' => 'pnets',
                'pnet_type_pri' => PNET_TYPE_ITPRI,
		'x_native_fields' => array(
			'r.rid' => array(
				'long_name' => 'Request ID',
				'short_name' => 'RID',
				'field_name' => 'rid',
				'field_type' => 'number'
			),
			'r.env' => array(
				'long_name' => 'IT Environment Name',
				'short_name' => 'IT Env.',
				'field_name' => 'qid',
				'field_type' => 'main_pq'
			),
			'r.queue' => array(
				'long_name' => 'IT Queue',
				'short_name' => 'Queue',
				'field_name' => 'qid',
				'field_type' => 'sub_pq'
			),
			'r.state' => array(
				'long_name' => 'Ticket State',
				'short_name' => 'State',
				'field_name' => 'state',
				'field_type' => 'state'
			),
			'r.class' => array(
				'long_name' => 'Ticket Class',
				'short_name' => 'Class',
				'field_name' => 'class',
				'field_type' => 'class'
			),
			'r.customer_pri' => array(
				'long_name' => 'Urgency',
				'short_name' => 'Urgency',
				'field_name' => 'customer_pri',
				'field_type' => 'customer_pri'
			),
			'r.proj_lbl' => array(
				'long_name' => 'Project Label',
				'short_name' => 'Proj.',
				'field_name' => 'label',
				'field_type' => 'text_line'
			),
			'r.reg_date' => array(
				'long_name' => 'Ticket Registration Date',
				'short_name' => 'TRD',
				'field_name' => 'reg_date',
				'field_type' => 'date'
			),
			'r.children' => array(
				'long_name' => 'List of Sub-Requests',
				'short_name' => 'LSR',
				'field_name' => 'rid',
				'field_type' => 'ph_list'
			),
			'r.description' => array(
				'long_name' => 'Description',
				'short_name' => 'Descr.',
				'field_name' => 'description',
				'field_type' => 'text_area',
				'options' => FIELD_OPT_SOFT
			),
			'r.synopsis' => array(
				'long_name' => 'Synopsis',
				'short_name' => 'Synop.',
				'field_name' => 'synopsis',
				'field_type' => 'text_line',
				'options' => FIELD_OPT_SOFT
			),
			'r.filed_by' => array(
				'long_name' => 'Ticket Submitter',
				'short_name' => 'FiledBy',
				'field_name' => 'filed_by',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			),
			'r.fixer_uid' => array(
				'long_name' => 'Ticket owner',
				'short_name' => 'Owner',
				'field_name' => 'fixer_uid',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			),
			'r.pri_votes' => array(
                                'long_name' => 'Priority Votes',
                                'short_name' => 'Votes',
                                'field_name' => 'rid',
                                'field_type' => 'pri_votes'
                        )
		),
		'x_order_by' => array(
			'pri_desc' => array(
				'name' => 'By Urgency',
				'sql' => 'r.customer_pri DESC'),
			'rid_desc' => array(
				'name' => 'By Ticket ID',
				'sql' => 'r.rid ASC'),
			'class_asc' => array(
				'name' => 'By Ticket Class',
				'sql' => 'r.class ASC'),
			'state_asc' => array(
				'name' => 'By Ticket State',
				'sql' => 'r.state ASC'),
			'projpri_asc' => array(
				'name' => 'By Project Priority',
				'sql' => 'IF(r.in_project=\'plan\',r.plan_pri,r.project_pri) ASC'),
			'qid_asc' => array(
				'name' => 'By Environment Name',
				'sql' => 'IF(c.parent,p.name,c.name) ASC'),
			'cid_asc' => array(
				'name' => 'By Queue Name',
				'sql' => 'IF(c.parent,c.name,\'General\') ASC')
		));

		parent::requesttracker($object_params);
		$this->queues_2d=&$this->pqs_2d;
		foreach($this->p2_states as $s => $str)
        		$this->state2str[$s]=$str;
	}

	function construct_queue_sets(){
		return $this->construct_pq_sets();
	}

	function pri2owner($qid,$pri){
		$queues_2d=&$this->pqs_2d;

		if($pri<=REQ_PRI_MEDIUM)
			return($queues_2d['owner_jr'][$qid]);
		return($queues_2d['owner_sr'][$qid]);
	}

	function file_request($fields,$xfields=array(),$cc_list=array()){
		global $uid;
		global $is_customer;
		global $customers_2d;

		$queues_2d=&$this->queues_2d;

		if(!isset($fields['class']))
			_die(__FILE__.':'.__LINE__.' class field is not specified.');

		$class=$fields['class'];
		$fields['state']=$open_state=$this->first_state($fields['class']);
		$nsa_aid=$this->null_state_action($class);
		$lsm=$this->last_state_mask($class);

		if(!isset($fields['qid']) || !$fields['qid'])
			_die(__FILE__.':'.__LINE__.' qid field is not specified.');

		$qid=$fields['qid'];
		$cror=$this->get_cror($qid);
		$fields['critical_order']=$cror;
		if(!isset($fields['synopsis']))
			_die(__FILE__.':'.__LINE__.' synopsis field is not specified.');
		if(!isset($fields['description']))
			_die(__FILE__.':'.__LINE__.' description field is not specified.');
		$descr=$fields['description'];

		if(!isset($fields['customer_id']))
                        $fields['customer_id']=$is_customer?$is_customer:$this->first_customer_id;

		$cust=$fields['customer_id'];

		if(!isset($fields['customer_pri']))
			$fields['customer_pri']=REQ_PRI_MEDIUM;

		if(!isset($fields['filed_by']))
			$fields['filed_by']=$uid;

		if(!isset($fields['options']))
                        $fields['options']=0;

		if($is_customer && ($customers_2d['options'][$is_customer]&CUST_OPT_PUBLIC))
                        $fields['options']|=REQ_OPT_VBC2;

		$fixer=$this->pri2owner($qid,$fields['customer_pri']);

		//$nsa=$this->null_state_action($class);
		//$this->default_value("fixer_uid",$nsa,$xstr2uid);
		if(!$fixer)
			$fixer=$queues_2d['it_mgr'][$qid];
		if(!isset($fields['fixer_uid']))
			$fields['fixer_uid']=$fixer;

		foreach($fields as $k => $v)
			$fields[$k]=escape_data($v);

		$query = "INSERT INTO itrequests (".implode(', ',array_keys($fields)).(isset($fields['reg_date'])?'':', reg_date').") VALUES (".("'".implode("', '",$fields)."'").(isset($fields['reg_date'])?'':', NOW()').")";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into itrequests table.');

		$rid=@mysql_insert_id();

		if(isset($fields['options']) && ($fields['options']&REQ_OPT_RPSTMP))
			$txt="Action: Submit temporary ITPM request";
		else
			$txt="Action: Submit new request";

		$fields['rid']=$rid;
		$this->log_history($fields, $uid, $txt);

		if(count($xfields)){
			$sql_arr=array();
			foreach($xfields as $fid => $v)
				$sql_arr[]="( '".TBLID_ITREQUESTS."', $rid, $fid, 0, '$v' )";
			$sql_str=implode(', ', $sql_arr);
			$query = "INSERT INTO extras ( table_id, id, fid, uid, xfield ) VALUES $sql_str";
			if(!@mysql_query ($query))
				_die(__FILE__.':'.__LINE__.' Could not insert into extras table.');
		}

		if($cc_list){
			$safe_cc=array();
			foreach(explode(',',$cc_list) as $u)
				arr_push($safe_cc,$u);

			foreach($safe_cc as $u)
				$this->add_cc($rid,$u);
		}

		if(isset($fields['options']) && ($fields['options']&REQ_OPT_RPSTMP))
			return $rid;

		$this->notify_by_email($rid,$uid,$descr,$nsa_aid);
		return $rid;
	}

	function &proj_cc_list($proj_id){
                return $this->get_cc_list($proj_id,MEMB_TYPE_ITPMCC);
        }

	function proj_add_cc($proj_id,$u){
                return $this->add_cc($proj_id,$u,MEMB_TYPE_ITPMCC);
        }

        function proj_delete_cc($proj_id,$u){
                return $this->delete_cc($proj_id,$u,MEMB_TYPE_ITPMCC);
        }

	function list_allowed_queues($cid=FALSE){
		if(!$cid)
			return $this->list_allowed_pqs();
		else
			return $this->list_allowed_pqs($cid);
	}

	function xstr2uid(&$RInfo,&$xstr2uid){
		parent::xstr2uid($RInfo,$xstr2uid);
		$xstr2uid['%owner']=$this->pri2owner($RInfo['qid'],$RInfo['customer_pri']);
		$parent=$this->pqs_2d['parent'][$RInfo['qid']]?$this->pqs_2d['parent'][$RInfo['qid']]:$RInfo['qid'];
		$xstr2uid['%env_it_mgr']=$this->pqs_2d['it_mgr'][$parent];
	}

	function request_info($rid,&$xstr2uid,$popup_error=FALSE){

		$this->request_info_sql="SELECT r.*, UNIX_TIMESTAMP(r.reg_date) AS reg_date_tm, UNIX_TIMESTAMP(r.inwork_date) AS inwork_date_tm, UNIX_TIMESTAMP(r.fixed_date) AS fixed_date_tm, UNIX_TIMESTAMP(r.last_date) AS last_date_tm";

		return(parent::request_info($rid,$xstr2uid,$popup_error));
	}

	function process_view_fields(&$RInfo,&$xstr2uid,$action_is_clone){
		global $all_users_2d;
		global $pri2str;

		$SQLStr='';$comment='';
		$res=parent::process_view_fields($RInfo,$xstr2uid,$action_is_clone);
		$SQLStr.=array_shift($res);
		$comment.=array_shift($res);

		if($this->is_rw_field('customer_pri') && isset($_POST['customer_pri'])){
			$pri = $_POST['customer_pri'];
			if (!isset($pri2str[$pri]))
				_die("Unknown priority...");
			$xstr2uid['%owner']=$this->pri2owner($RInfo['qid'],$pri);
		}

		return array($SQLStr,$comment);

	}

	function request_view_tr_PQ(&$RInfo,$xstr2uid,$hdr=''){
		global $all_users_2d;

		$xstr2uid['%owner']=$this->pri2owner($RInfo['qid'],$RInfo['customer_pri']);
		parent::request_view_tr_PQ($RInfo,$xstr2uid,$hdr);
	}

	function request_query_sqlstr(){
		return parent::request_query_sqlstr();
	}

	function _dashboard_intro($did,$uid,$info=FALSE){
		global $dir_name;
		global $is_customer;

		if($info)
			return array('header' => 'IT Ticket Tracking System (Intro)',
				'default_size' => 2,
				'type' => 'table/text',
				'only' => 'it/itrts');

		$tbl_str='
        <table border=0 cellpadding=0 cellspacing=1 width="100%" class=dgray align="center">
	<tr style="height: 1" class="separator">
                <td></td>
        </tr>
        <tr class="lgray">
		<td>
        <ul>
        	<li><a href="'.$dir_name.'/itrts/tts_file.php">Submit</a> tickets: problem reports, support requests</li>
        	<li><a href="'.$dir_name.'/itrts/tts_query.php">Search</a> the tickets database</li>
        	<li><a href="'.$dir_name.'/itrts/tts_cp.php">Prioritize</a> your critical tickets</li>
        	<li>
		<form target="req" action="'.$dir_name.'/itrts/tts_view.php">
        		View'.($is_customer?'':'/Edit').' a ticket if you know its number:<input class="inp" type=text name=id size=6 maxlength=6><input class="btn_small" type=button name=submit value=View onClick="rid_check(this.form)">
		</form>
		</li>
        </ul>
        	</td>
	</tr>
        </table>';

		return $tbl_str;
	}

	function _dashboard_requests2close($did,$uid,$info=FALSE){

		if(prereq_check('rts_no_requests'))
			return FALSE;

		if($info){
			return array('header' => 'Requests you need to close',
				'default_size' => 1,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => '#tickets to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
		}
		if(!$lim) $lim=5;

		$pq_sn=$this->object_params['pq_title'];
		$sub_pq_sn=$this->object_params['sub_pq_title'];

		$tbl_str='';
		$sql=$this->request_query_sqlstr('',FALSE);
		$query = "$sql AND ".$this->sql_fixed_states_str." AND !".$this->sql_last_states_str." AND r.filed_by=$uid AND (r.options&".REQ_OPT_EXTERNAL.")=0 ORDER BY r.fixed_date LIMIT $lim";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from itrequests table.');

		if(mysql_num_rows($result)<1)
			return $tbl_str;
		$tbl_str.= '
	<tr style="height: 1" class="separator">
		<td colspan=3></td>
	</tr>
	<tr class=lgray>
		<th>ID</th>
		<th align="left">'.sprintf(HDR_LONG_SYNOP_F,$pq_sn,$sub_pq_sn,'Synopsis').'</th>
	</tr>';
		while($row=mysql_fetch_array($result, MYSQL_ASSOC)){
			$tbl_str.= '
	<tr class="lgray" onmouseover="this.className=\'lgs\';" onmouseout="this.className=\'lgray\';" onClick="tts_view_win_open('.$row['rid'].')">
		<td align="center">'.$row['rid'].'</td>
		<td>'.html_safe_text($row['pq_name'].' '.$row['synopsis']).'</td>
	</tr>';
		}

		if($tbl_str)
			$tbl_str= '
	<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
	</table>';

		return $tbl_str;
	}
}
?>
