<?php
// $Header: /home/CVS/rps/includes/kbs/kbs.inc,v 1.35 2008/05/28 18:23:33 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('includes/db.inc');
require_once('includes/rts/rts.inc');

	define('KBS_HISTORY_TYPE_REQ', 1);
	define('KBS_HISTORY_TYPE_CSET', 2);

	define('REQ_CLASS_QUESTION', 0x001);
	define('REQ_CLASS_KBS', (REQ_CLASS_QUESTION));

	define('KBS_CTG_OPT_TEMP', 1);

	define('CDB_CREATE_KBS_CATEGORIES_TBL', 'CREATE TABLE IF NOT EXISTS kbs_categories
		(cid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		name VARCHAR(32) NOT NULL,
		parent INT UNSIGNED DEFAULT 0 NOT NULL,
		expert_mgr INT UNSIGNED NOT NULL,
		options INT UNSIGNED NOT NULL,
		reg_date DATETIME NOT NULL,
		PRIMARY KEY (cid),
		UNIQUE KEY (name,parent),
			KEY (expert_mgr)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci');

	define ('CDB_CREATE_KBS_HISTORY_TBL', "CREATE TABLE IF NOT EXISTS kbs_history
	    (rid int UNSIGNED default NULL,
	    uid int UNSIGNED default NULL,
	    state int UNSIGNED NOT NULL default '0',
	    date DATETIME,
	    descr text,
	    options INT UNSIGNED DEFAULT 0 NOT NULL,
	    xid INT UNSIGNED DEFAULT NULL,
	    xid2 INT UNSIGNED DEFAULT NULL,
	    xid3 INT UNSIGNED DEFAULT NULL,
	    roptions INT UNSIGNED DEFAULT 0 NOT NULL,
		KEY (rid),
		KEY (uid),
		KEY (state),
		KEY (date),
		FULLTEXT (descr),
		KEY (options),
		KEY (xid)
	    ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('CDB_CREATE_KBS_REQUESTS_TBL', "CREATE TABLE IF NOT EXISTS kbs_requests
		(rid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		cid INT UNSIGNED NOT NULL,
		state INT UNSIGNED NOT NULL,
		synopsis VARCHAR(128) NOT NULL,
		description TEXT,
		answer TEXT,
		class SMALLINT UNSIGNED NOT NULL,
		customer_id INT UNSIGNED NOT NULL,
		customer_pri SMALLINT UNSIGNED DEFAULT ".REQ_PRI_MEDIUM." NOT NULL,
		filed_by INT UNSIGNED NOT NULL,
		phase_of_rid INT UNSIGNED NOT NULL,
		fixer_uid INT UNSIGNED NOT NULL,
		project_id INT UNSIGNED,
		in_project ENUM('yes', 'plan', 'maybe', 'no') DEFAULT 'maybe' NOT NULL,
		project_pri INT UNSIGNED,
		plan_pri FLOAT UNSIGNED,
		reg_date DATETIME NOT NULL,
		options INT UNSIGNED NOT NULL,
		critical_order INT UNSIGNED NOT NULL,
		plan_fixer_uid INT UNSIGNED NOT NULL,
		depends_on INT UNSIGNED DEFAULT 0 NOT NULL,
		fix_wrk_hrs INT UNSIGNED DEFAULT 0 NOT NULL,
		inwork_date DATETIME,
		fixed_date DATETIME,
		last_date DATETIME,
		plan_fix_start DATETIME,
		plan_fix_end DATETIME,
		complete_pct SMALLINT UNSIGNED,
		cal_fix_start DATETIME,
		cal_fix_end DATETIME,
		dup_rid INT UNSIGNED DEFAULT 0 NOT NULL,
		PRIMARY KEY rid (rid),
			FULLTEXT (synopsis, description),
			FULLTEXT (synopsis, description, answer),
			KEY (cid),
			KEY (in_project, project_id),
			KEY (project_pri),
			KEY (plan_pri),
			KEY (filed_by),
			KEY (fixer_uid),
			KEY (phase_of_rid)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('MEMB_TYPE_KBS_REQ_CC', 0x0001);
	define('MEMB_TYPE_KBS_CLIST', 0x0002);
	define('MEMB_TYPE_KBS_CTG_CC_OPTOUT', 0x0003);
	define('MEMB_TYPE_KBS_REQ_ECC', 0x0004);

	define('CDB_CREATE_KBS_MEMBERS_TBL', "CREATE TABLE IF NOT EXISTS kbs_members
		(uid INT UNSIGNED NOT NULL,
		xid INT UNSIGNED NOT NULL,
		type INT UNSIGNED NOT NULL,
		UNIQUE KEY (xid, uid, type)
		)");

	define('PNET_TYPE_KBS_PRI',0x01);
	define('PNET_TYPE_KBS_EXPRATE',0x05);

	// Priority And Estimated Time table
	define('CDB_CREATE_KBS_PNETS_TBL', "CREATE TABLE IF NOT EXISTS kbs_pnets
		(rid INT UNSIGNED NOT NULL,
		uid INT UNSIGNED NOT NULL,
		type INT UNSIGNED NOT NULL,
		xval INT UNSIGNED,
		UNIQUE KEY (rid, uid, type),
			KEY (xval)
		)");

if(!$cmd_line_mode && $uid){
	require_once('includes/kbs/default_wf_kbs.inc');

	$query = CDB_CREATE_KBS_CATEGORIES_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create kbs_categories table. ');

	$nrecords=simple_query("SELECT COUNT(cid) FROM kbs_categories");
	if($nrecords<1){
		$query = "INSERT INTO kbs_categories (name, expert_mgr, reg_date) VALUES('General', $uid, NOW() )";
		if(!@mysql_query($query))
			_die(__FILE__.':'.__LINE__.' Can not add to kbs_categories table.');
	}

	$query = CDB_CREATE_KBS_REQUESTS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create kbs_requests table. ');

	$query = CDB_CREATE_KBS_HISTORY_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create kbs_history table. ');

	$query = CDB_CREATE_KBS_MEMBERS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create kbs_members table. ');

	$query = CDB_CREATE_KBS_PNETS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create kbs_pnets table. ');
}

class KnowledgeBase extends RequestTracker {
	var $xkbs=array();
	var $cid=FALSE;
	var $pqs_2d;
	var $state2str;

	function knowledgebase($comp_id=FALSE){
		global $is_customer;
		global $cid;
		global $cmd_line_mode;

		$object_params=array(
		'wfid' => 'kbs',
		'rts_short_name' => 'KBS',
		'rts_long_name' => 'Knowledge Base System',
		'requests_tbl' => 'kbs_requests',
		'req_view_script' => '/kbs/kbs_view.php',
		'req_email_view_script' => '/kbs/kbs.php',
		'pq_tbl' => 'kbs_categories',
		'history_tbl' => 'kbs_history',
		'history_rts_type' => KBS_HISTORY_TYPE_REQ,
		'history_pqset_type' => KBS_HISTORY_TYPE_CSET,
		'members_tbl' => 'kbs_members',
		'member_cc_type' => MEMB_TYPE_KBS_REQ_CC,
		'member_pqlist_type' => MEMB_TYPE_KBS_CLIST,
		'customer_class_mask_fn' => '',
		'pq_fn' => 'cid',
		'pq_owners' => array('expert_mgr'),
		'pq_long_title' => sprintf(HDR_LONG_PQ_F,'Category','Sub-category'),
		'pq_title' => 'Category',
		'sub_pq_title' => 'Sub-category',
		'req_proj_id_fn' => 'project_id',
                'req_in_proj_fn' => 'in_project',

                'proj_tbl' => '',
                'proj_id_fn' => 'proj_id',
		'proj_rts_opt' => 0,

                'pnets_tbl' => 'kbs_pnets',
                'pnet_type_pri' => PNET_TYPE_KBS_PRI,
                'pnet_type_expert_rate' => PNET_TYPE_KBS_EXPRATE,
		'ys_extra_field' => 'answer',
		'x_native_fields' => array(
			'r.rid' => array(
				'long_name' => 'Question/Request ID',
				'short_name' => 'RID',
				'field_name' => 'rid',
				'field_type' => 'number'
			),
			'r.ctg' => array(
				'long_name' => 'Category Name',
				'short_name' => 'Category',
				'field_name' => 'cid',
				'field_type' => 'main_pq'
			),
			'r.sctg' => array(
				'long_name' => 'Sub-category Name',
				'short_name' => 'Sub-ctg.',
				'field_name' => 'cid',
				'field_type' => 'sub_pq'
			),
			'r.state' => array(
				'long_name' => 'Question/Request State',
				'short_name' => 'State',
				'field_name' => 'state',
				'field_type' => 'state'
			),
			'r.customer_id' => array(
				'long_name' => 'Customer',
				'short_name' => 'Cust.',
				'field_name' => 'customer_id',
				'field_type' => 'customer'
			),
			'r.reg_date' => array(
				'long_name' => 'Question/Request Registration Date',
				'short_name' => 'QRD',
				'field_name' => 'reg_date',
				'field_type' => 'date'
			),
			'r.description' => array(
				'long_name' => 'Description',
				'short_name' => 'Descr.',
				'field_name' => 'description',
				'field_type' => 'text_area',
				'options' => FIELD_OPT_SOFT
			),
			'r.synopsis' => array(
				'long_name' => 'Synopsis',
				'short_name' => 'Synop.',
				'field_name' => 'synopsis',
				'field_type' => 'text_line',
				'options' => FIELD_OPT_SOFT
			),
			'r.filed_by' => array(
				'long_name' => 'Question/Request Submitter',
				'short_name' => 'FiledBy',
				'field_name' => 'filed_by',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			),
			'r.fixer_uid' => array(
				'long_name' => 'Question/Request Owner',
				'short_name' => 'Owner',
				'field_name' => 'fixer_uid',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			)
		),
		'x_order_by' => array(
			'rid_desc' => array(
				'name' => 'By Question ID',
				'sql' => 'r.rid ASC'),
			'state_asc' => array(
				'name' => 'By Question State',
				'sql' => 'r.state ASC'),
			'pid_asc' => array(
				'name' => 'By Category Name',
				'sql' => 'IF(c.parent,p.name,c.name) ASC'),
			'cid_asc' => array(
				'name' => 'By Sub-category Name',
				'sql' => 'IF(c.parent,c.name,\'General\') ASC')
		));

		if($comp_id)
			$this->cid=$comp_id;
		elseif($cid)
			$this->cid=$cid;
		else
			_die(__FILE__.':'.__LINE__.' cid is not set.');

		parent::requesttracker($object_params);

		foreach($this->p2_states as $s => $str)
        		$this->state2str[$s]=$str;

        	$this->rts_subject_format = "{%action} %pq|%rid: %synop";

		$this->native_fields = array(
			'r.rid' => array(
				'long_name' => 'Request ID',
				'short_name' => 'RID',
				'field_name' => 'rid',
				'field_type' => 'number'
			),
			'r.cid' => array(
				'long_name' => 'Category',
				'short_name' => 'Ctg.',
				'field_name' => 'cid',
				'field_type' => 'main_pq'
			),
			'r.comp' => array(
				'long_name' => 'Sub-category Name',
				'short_name' => 'Sub-Ctg.',
				'field_name' => 'cid',
				'field_type' => 'sub_pq'
			),
			'r.state' => array(
				'long_name' => 'Request State',
				'short_name' => 'State',
				'field_name' => 'state',
				'field_type' => 'state'
			),
			'r.class' => array(
				'long_name' => 'Request Class',
				'short_name' => 'Class',
				'field_name' => 'class',
				'field_type' => 'class'
			),
			'r.customer_id' => array(
				'long_name' => 'Customer',
				'short_name' => 'Cust.',
				'field_name' => 'customer_id',
				'field_type' => 'customer'
			),
			'r.customer_pri' => array(
				'long_name' => 'Customer Priority',
				'short_name' => 'Pri',
				'field_name' => 'customer_pri',
				'field_type' => 'customer_pri'
			),
			'r.reg_date' => array(
				'long_name' => 'Request Registration Date',
				'short_name' => 'RRD',
				'field_name' => 'reg_date',
				'field_type' => 'date'
			),
			'r.children' => array(
				'long_name' => 'List of Sub-Requests',
				'short_name' => 'LSR',
				'field_name' => 'rid',
				'field_type' => 'ph_list'
			),
			'r.description' => array(
				'long_name' => 'Description',
				'short_name' => 'Descr.',
				'field_name' => 'description',
				'field_type' => 'text_area',
				'options' => FIELD_OPT_SOFT
			),
			'r.synopsis' => array(
				'long_name' => 'Synopsis',
				'short_name' => 'Synop.',
				'field_name' => 'synopsis',
				'field_type' => 'text_line',
				'options' => FIELD_OPT_SOFT
			),
			'r.filed_by' => array(
				'long_name' => 'Request Submitter',
				'short_name' => 'FiledBy',
				'field_name' => 'filed_by',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			),
			'r.fixer_uid' => array(
				'long_name' => 'Request Owner',
				'short_name' => 'Fixer',
				'field_name' => 'fixer_uid',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			)
		);

		$this->x_order=array(
			'pri_desc' => array(
				'name' => 'By Priority',
				'sql' => 'r.customer_pri DESC'),
			'rid_desc' => array(
				'name' => 'By Request ID',
				'sql' => 'r.rid ASC'),
			'class_asc' => array(
				'name' => 'By Request Class',
				'sql' => 'r.class ASC'),
			'state_asc' => array(
				'name' => 'By Request State',
				'sql' => 'r.state ASC'),
			'cid_asc' => array(
				'name' => 'By Category Name',
				'sql' => 'IF(c.parent,p.name,c.name) ASC'),
			'cid_asc' => array(
				'name' => 'By Sub-category Name',
				'sql' => 'IF(c.parent,c.name,\'General\') ASC')
		);
	}

	function file_request($fields,$cc_list=FALSE){
		global $uid;
		global $is_customer;
		global $customers_2d;
		global $production_mode;
		global $at_isp;
		global $all_users_2d;

		$req_tbl=$this->object_params['requests_tbl'];

		$pqs_2d=&$this->pqs_2d;

		if(!isset($fields['class']))
			_die(__FILE__.':'.__LINE__.' class field is not specified.');

		$class=$fields['class'];
		$fields['state']=$open_state=$this->first_state($fields['class']);
		$nsa_aid=$this->null_state_action($class);
		$lsm=$this->last_state_mask($class);

		if(!isset($fields['cid']) || !$fields['cid'])
			_die(__FILE__.':'.__LINE__.' cid field is not specified.');

		$cid=$fields['cid'];
		$cror=$this->get_cror($cid);
		//echo "$cror <br>";
		$fields['critical_order']=$cror;

		if(!isset($fields['synopsis']))
			_die(__FILE__.':'.__LINE__.' synopsis field is not specified.');

		if(!isset($fields['description']))
			_die(__FILE__.':'.__LINE__.' description field is not specified.');

		if(!isset($fields['customer_id']))
			$fields['customer_id']=$this->first_customer_id;

		$cust=$fields['customer_id'];

		if(!isset($fields['customer_pri']))
			$fields['customer_pri']=REQ_PRI_MEDIUM;

		if(!isset($fields['filed_by']))
			$fields['filed_by']=$uid;

		if(!isset($fields['options']))
                        $fields['options']=0;

		if($is_customer && ($customers_2d['options'][$is_customer]&CUST_OPT_PUBLIC))
                        $fields['options']|=REQ_OPT_VBC2;

		$xstr2uid=array();
		$xstr2uid['%expert_mgr']=$pqs_2d['expert_mgr'][$cid];
		$xstr2uid['%fixer']=$xstr2uid['%expert_mgr'];
		$xstr2uid['%submitter']=$uid;

		$nsa=$this->null_state_action($class);
		$owner=$this->default_value("fixer_uid",$nsa,$xstr2uid);
		if(!$owner)
			$owner=$uid;
		if(!isset($fields['fixer_uid']))
			$fields['fixer_uid']=$owner;

		$query = "INSERT INTO $req_tbl (".implode(', ',array_keys($fields)).(isset($fields['reg_date'])?'':', reg_date').") VALUES (".("'".implode("', '",$fields)."'").(isset($fields['reg_date'])?'':', NOW()').")";
		//echo "$query <br>\n";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__." Could not insert into $req_tbl table.");

		$rid=@mysql_insert_id();
		$descr=simple_query("SELECT description FROM $req_tbl WHERE rid=$rid");

		$fields['rid']=$rid;
		$this->log_history($fields,$uid,"Action: Submit new question");


		$experts_cc=array();
		foreach($all_users_2d['spec'] as $u => $s){
			if($all_users_2d['user_is'][$u]&(USER_IS_LOCKED|USER_IS_HIDDEN|USER_IS_CUSTOMER))
				continue;
			if(($s!=USPEC_RND) && ($s!=USPEC_IT) && ($s!=USPEC_CAE) && ($s!=USPEC_QA))
				continue;
			if(!$this->ctg_is_subscribed($cid,$u))
				continue;
			arr_push($experts_cc,$u);
		}
		foreach($experts_cc as $u)
			$this->add_cc($rid,$u,MEMB_TYPE_KBS_REQ_ECC);

		if($cc_list){
			$safe_cc=array();
			foreach(explode(',',$cc_list) as $u)
				arr_push($safe_cc,$u);

			foreach($safe_cc as $u)
				$this->add_cc($rid,$u);
		}

		$this->notify_by_email($rid,$uid,$descr,$nsa_aid);
		return $rid;
	}

	 function xstr2uid(&$RInfo,&$xstr2uid){
                parent::xstr2uid($RInfo,$xstr2uid);
                $parent=$this->pqs_2d['parent'][$RInfo['cid']]?$this->pqs_2d['parent'][$RInfo['cid']]:$RInfo['cid'];
                $xstr2uid['%ctg_expert_mgr']=$this->pqs_2d['expert_mgr'][$parent];
        }

	function request_info($rid,&$xstr2uid,$popup_error=FALSE){

		$this->request_info_sql="SELECT r.*, UNIX_TIMESTAMP(r.reg_date) AS reg_date_tm, UNIX_TIMESTAMP(r.inwork_date) AS inwork_date_tm, UNIX_TIMESTAMP(r.fixed_date) AS fixed_date_tm, UNIX_TIMESTAMP(r.last_date) AS last_date_tm";

		return(parent::request_info($rid,$xstr2uid,$popup_error));
	}

	function process_view_fields(&$RInfo,&$xstr2uid,$action_is_clone){
                global $all_users_2d;
                global $pri2str;

                $SQLStr='';$comment='';
                $res=parent::process_view_fields($RInfo,$xstr2uid,$action_is_clone);
                $SQLStr.=array_shift($res);
                $comment.=array_shift($res);

                if($this->is_rw_field('answer') && isset($_POST['answer'])){
                        $answer = $_POST['answer'];
                        $answer = str_replace("\r", "", $answer);
                        if ($answer != $RInfo['answer']){
                                $SQLStr .= ", answer = '".escape_data($answer)."'";
                                $comment .= "Answer is given/changed (skipped)\n";
                        }
                }

                return array($SQLStr,$comment);
        }

	function request_query_sqlstr($cust=TRUE){
		return parent::request_query_sqlstr('',$cust);
	}

	function default_expert(){
		global $all_users_2d;

		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$euid=simple_query("SELECT expert_mgr FROM $pq_tbl WHERE !(options&".KBS_CTG_OPT_TEMP.") AND expert_mgr ORDER BY $pq_fn ASC LIMIT 1");
		if($euid)
			return($euid);

		foreach($all_users_2d['user_is'] as $u => $uis)
			if(($uis&USER_IS_MU) && !($uis&(USER_IS_LOCKED|USER_IS_HIDDEN)))
				return $u;
	}

	function &get_experts($cid=FALSE){
		global $all_users_2d;

		$hist_tbl=$this->object_params['history_tbl'];
                $htypeid=$this->object_params['history_rts_type'];
		$pnets_tbl=$this->object_params['pnets_tbl'];
		$pnets_type=$this->object_params['pnet_type_expert_rate'];
		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];


		$query="SELECT h.uid, SUM(p.xval) AS rtg FROM $hist_tbl AS h".($cid?" INNER JOIN $req_tbl AS r ON h.rid=r.rid AND r.$pq_fn=$cid":'')." INNER JOIN $pnets_tbl AS p ON p.type=$pnets_type AND p.rid=UNIX_TIMESTAMP(h.date) WHERE DATE_SUB(CURDATE(),INTERVAL 1 YEAR) < h.date GROUP BY h.uid ORDER BY rtg DESC";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__." Could not select from $hist_tbl table.");

		$experts=array();
		$ref=&$experts;
		while($row=mysql_fetch_array($result, MYSQL_NUM))
			if($row[1])
				arr_push($experts,$row[0]);

		//if(count($experts))
		//	return $ref;

		// Add all existing expert_mgrs
		$query="SELECT expert_mgr FROM $pq_tbl WHERE !(options&".KBS_CTG_OPT_TEMP.")".($cid?" AND $pq_fn=$cid":'')." AND expert_mgr ORDER BY $pq_fn ASC";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__." Could not select from $pq_tbl table.");

		while($row=mysql_fetch_array($result, MYSQL_NUM))
			arr_push($experts,$row[0]);


		foreach($all_users_2d['spec'] as $u => $s){
                       	if($all_users_2d['user_is'][$u]&(USER_IS_LOCKED|USER_IS_HIDDEN|USER_IS_CUSTOMER))
                       		continue;
                       	if(($s!=USPEC_RND) && ($s!=USPEC_IT) && ($s!=USPEC_CAE))
                               	continue;
			arr_push($experts,$u);
               	}

		if(count($experts))
			return $ref;

		array_push($experts,$this->default_expert());
		return $ref;

	}

	function add_temp_pq($pq_name){
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$pq_name=escape_data($pq_name);

		$pqid=simple_query("SELECT $pq_fn FROM $pq_tbl WHERE parent=0 AND name='$pq_name'");
		if($pqid)
			return $pqid;

		$euid=$this->default_expert();

		$query="INSERT INTO $pq_tbl (name, expert_mgr, options, reg_date) VALUES ('$pq_name', $euid, ".KBS_CTG_OPT_TEMP.", NOW())";
		//die($query);
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__." Could not select from $pq_tbl table.");

		$this->init_pqs(FALSE,TRUE);

		return(mysql_insert_id());
	}

	function ctg_is_subscribed($pqid,$user=FALSE){
		global $uid;

		$mem_tbl=$this->object_params['members_tbl'];
		if(!$user)
			$user=$uid;

		$optout=simple_query("SELECT xid FROM $mem_tbl WHERE uid=$user AND xid=$pqid AND type=".MEMB_TYPE_KBS_CTG_CC_OPTOUT." LIMIT 1");
		if($optout)
			return FALSE;
		return TRUE;
	}

	function ctg_subscribe($pqid){
		global $uid;

		$mem_tbl=$this->object_params['members_tbl'];

		$query="DELETE FROM $mem_tbl WHERE uid=$uid AND xid=$pqid AND type=".MEMB_TYPE_KBS_CTG_CC_OPTOUT;
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__." Could not delete from $mem_tbl table.");
	}

	function ctg_unsubscribe($pqid){
		global $uid;

		$mem_tbl=$this->object_params['members_tbl'];

		$this->ctg_subscribe($pqid);

		$query="INSERT INTO $mem_tbl (uid,xid,type) VALUES ($uid, $pqid, ".MEMB_TYPE_KBS_CTG_CC_OPTOUT.")";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__." Could not select from $mem_tbl table.");
	}

	function request_view_tr_Answer(&$RInfo){
?>
<tr class='lgray' valign='top'>
 <td align="center" colspan="3">
 	<strong>Answer</strong><br>
 	<span style="color:red; display: none" id="answer_info">[updates ignored]</span>
 <?php
	//print '<textarea name="description" rows="3"'.(($bts->is_rw_field('description') && !$rid_is_external)?'':' disabled').' style="width: 100%; color=#ffffff;">'.html_safe_text($RInfo['description'], true).'</textarea>';
	print '<textarea name="answer" rows="10" style="width: 100%;">'.html_safe_text($RInfo['answer'], true).'</textarea>';
?>

 </td>
</tr>
<?php
	}

	function ys_select_frequent_requests($cid,$num=10){
		$req_tbl=$this->object_params['requests_tbl'];
                $pq_fn=$this->object_params['pq_fn'];

		$where=$this->request_query_sqlstr_where();

        	$query="SELECT r.rid, r.synopsis, COUNT(ysa.uid) AS uscore, SUM(ysa.refn) AS rscore FROM $req_tbl AS r LEFT JOIN ysassociations AS ysa ON ysa.rid=r.rid WHERE ".($where?$where:'1').($cid?" AND r.$pq_fn=$cid":'')." GROUP BY r.rid ORDER BY uscore DESC, rscore DESC LIMIT $num";
        	//echo "\n$query <br>\n";
        	if(!($result= @mysql_query($query)))
                	_die2(__FILE__, __LINE__," Could not select from $req_tbl table.");

		return $result;
	}

	function _dashboard_intro($did,$uid,$info=FALSE){
		global $dir_name;
		global $is_customer;

		if($info)
			return array('header' => 'Knowledge Base Management System (Intro)',
				'default_size' => 2,
				'type' => 'table/text',
				'only' => '/kbs');

		$tbl_str='
        <table border=0 cellpadding=0 cellspacing=1 width="100%" class=dgray align="center">
        <tr class="lgray">
		<td>
        <ul>
        	<li><a href="'.$dir_name.'/kbs/kbs_file.php">Submit</a> a product/support related question.</li>
        	<li><a href="'.$dir_name.'/kbs/kbs_filter.php">Filter</a> the database of the questions and answers.</li>
        	<li>
        	<form target="kbs" action="'.$dir_name.'/kbs/kbs_view.php">
        		View/Edit a question/request if you know its number: <input class="inp" type=text name=id size=6 maxlength=6><input class="btn_small" type=button name=submit value=View onClick="rid_check(this.form)">
        	</form>
        	</li>
        </ul>
        	</td>
	</tr>
        </table>';

		return $tbl_str;
	}

	function _dashboard_pie_pq_by_pri($did,$uid,$info=FALSE){
        }

        function _dashboard_cr_bundle($did,$uid,$info=FALSE){
        }
}
?>
