<?php
// $Header: /home/CVS/rps/includes/lms/lms.inc,v 1.18 2008/04/30 19:08:02 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('includes/db.inc');
require_once('includes/rts/rts.inc');


define('LMS_HISTORY_TYPE_REQ',1);
define('LMS_MEMB_TYPE_CC',1);

define('LMS_KEYS_OPT_REL',1);

define('LMS_KEYS_BPTYPE_MONTH',1);
define('LMS_KEYS_BPTYPE_QUARTER',2);
define('LMS_KEYS_BPTYPE_SEMIY',3);
define('LMS_KEYS_BPTYPE_YEAR',4);

$bptype2str[LMS_KEYS_BPTYPE_MONTH]='Monthly';
$bptype2str[LMS_KEYS_BPTYPE_QUARTER]='Quarterly';
$bptype2str[LMS_KEYS_BPTYPE_SEMIY]='Semi-annually';
$bptype2str[LMS_KEYS_BPTYPE_YEAR]='Annually';

	define ('CDB_CREATE_LMS_HISTORY_TBL', "CREATE TABLE IF NOT EXISTS lms_history
	    (rid int UNSIGNED default NULL,
	    uid int UNSIGNED default NULL,
	    state int UNSIGNED NOT NULL default '0',
	    date DATETIME,
	    descr text,
	    options INT UNSIGNED DEFAULT 0 NOT NULL,
	    xid INT UNSIGNED DEFAULT NULL,
	    xid2 INT UNSIGNED DEFAULT NULL,
	    xid3 INT UNSIGNED DEFAULT NULL,
	    roptions INT UNSIGNED DEFAULT 0 NOT NULL,
		KEY (rid),
		KEY (uid),
		KEY (state),
		KEY (date),
		FULLTEXT (descr),
		KEY (options),
		KEY (xid)
	    ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	// release_pri - order of request in current plan/release_pri
	// plan-pri - mutual rel. members priority
	define('CDB_CREATE_LMS_REQUESTS_TBL', "CREATE TABLE IF NOT EXISTS lms_requests
		(rid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		pid INT UNSIGNED NOT NULL,
		state INT UNSIGNED NOT NULL,
		synopsis VARCHAR(128) NOT NULL,
		description TEXT,
		class SMALLINT UNSIGNED NOT NULL,
		customer_id INT UNSIGNED NOT NULL,
		filed_by INT UNSIGNED NOT NULL,
		phase_of_rid INT UNSIGNED NOT NULL,
		fixer_uid INT UNSIGNED NOT NULL,
		reg_date DATETIME NOT NULL,
		options INT UNSIGNED NOT NULL,
		platform INT UNSIGNED DEFAULT 0 NOT NULL,
		depends_on INT UNSIGNED DEFAULT 0 NOT NULL,
		inwork_date DATETIME,
		fixed_date DATETIME,
		test_date DATETIME,
		verified_date DATETIME,
		last_date DATETIME,
		fix_wrk_hrs INT UNSIGNED DEFAULT 0 NOT NULL,
		dup_rid INT UNSIGNED DEFAULT 0 NOT NULL,
		hostid VARCHAR(128),
		booking INT UNSIGNED,
		maintenance INT UNSIGNED,
		paid_date DATETIME NOT NULL,
		project_id INT UNSIGNED,
		in_project ENUM('yes', 'plan', 'maybe', 'no') DEFAULT 'maybe' NOT NULL,
		license TEXT,
		expiration_date DATE,
		PRIMARY KEY rid (rid),
			FULLTEXT (synopsis, description),
			KEY (pid),
			KEY (filed_by),
			KEY (fixer_uid),
			KEY (phase_of_rid)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('CDB_CREATE_LMS_KEYS_TBL', "CREATE TABLE IF NOT EXISTS lms_keys
		(kid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		pid INT UNSIGNED DEFAULT 0 NOT NULL,
		name VARCHAR(128) NOT NULL,
		summary VARCHAR(128) NOT NULL,
		description TEXT,
		init_price FLOAT UNSIGNED,
		tbl_price FLOAT UNSIGNED,
		bill_price FLOAT UNSIGNED,
		free_usern INT UNSIGNED DEFAULT 0 NOT NULL,
		free_lic_monthn INT UNSIGNED DEFAULT 12 NOT NULL,
		bptype INT UNSIGNED NOT NULL,
		options INT UNSIGNED NOT NULL,
		reg_date DATETIME NOT NULL,
		PRIMARY KEY (kid),
			UNIQUE KEY (name),
			KEY (pid)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('CDB_CREATE_LMS_CUTKEYS_TBL', "CREATE TABLE IF NOT EXISTS lms_cutkeys
		(rid INT UNSIGNED DEFAULT 0 NOT NULL,
		kid INT UNSIGNED DEFAULT 0 NOT NULL,
		init_price FLOAT UNSIGNED,
		tbl_price FLOAT UNSIGNED,
		bill_price FLOAT UNSIGNED,
		usern INT UNSIGNED DEFAULT 0 NOT NULL,
		monthn INT UNSIGNED DEFAULT 0 NOT NULL,
		activation_date DATE,
		expiration_date DATE,
		options INT UNSIGNED NOT NULL,
			KEY (rid),
			KEY(kid),
			KEY(expiration_date)
		)");

	define('CDB_CREATE_LMS_MEMBERS_TBL', "CREATE TABLE IF NOT EXISTS lms_members
                (uid INT UNSIGNED NOT NULL,
                xid INT UNSIGNED NOT NULL,
                type INT UNSIGNED NOT NULL,
                UNIQUE KEY (xid, uid, type)
                )");

if(!$cmd_line_mode && $uid){
	require_once('includes/lms/default_wf_lms.inc');

	$query = CDB_CREATE_LMS_REQUESTS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create lms_requests table. ');

	$query = CDB_CREATE_LMS_HISTORY_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create lms_history table. ');

	$query = CDB_CREATE_LMS_KEYS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create lms_keys table. ');

	$query = CDB_CREATE_LMS_CUTKEYS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create lms_cutkeys table. ');

	$query = CDB_CREATE_LMS_MEMBERS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create lms_members table. ');
}

class LicenseManager extends RequestTracker {
	var $cid=FALSE;
	var $state2str;

	function licensemanager($comp_id=FALSE){
		global $is_customer;
		global $cid;
		global $cmd_line_mode;

		$object_params=array(
		'wfid' => 'lms',
		'rts_short_name' => 'LMS',
		'rts_long_name' => 'License Management Systems',
		'requests_tbl' => 'lms_requests',
		'req_view_script' => '/lms/lms_view.php',
		'req_email_view_script' => '/lms/lms.php',
		'pq_tbl' => 'products',
		'history_tbl' => 'lms_history',
		'history_rts_type' => LMS_HISTORY_TYPE_REQ,
		'history_pqset_type' => '',
		'members_tbl' => 'lms_members',
		'member_cc_type' => LMS_MEMB_TYPE_CC,
		'member_pqlist_type' => '',
		'customer_class_mask_fn' => '',
		'pq_fn' => 'pid',
		'pq_owners' => array('mrkt_mgr','rnd_mgr','qa_mgr'),
		'pq_long_title' => sprintf(HDR_LONG_PQ_F,'Product','Component'),
		'pq_title' => 'Product',
		'sub_pq_title' => '',
		'req_proj_id_fn' => 'project_id',
                'req_in_proj_fn' => 'in_project',

                'proj_tbl' => '',
                'proj_id_fn' => '',
		'proj_rts_opt' => 0,

                'pnets_tbl' => '',
                'pnet_type_pri' => FALSE,
		'x_native_fields' => array(
			'r.rid' => array(
				'long_name' => 'Request ID',
				'short_name' => 'RID',
				'field_name' => 'rid',
				'field_type' => 'number'
			),
			'r.state' => array(
				'long_name' => 'Request State',
				'short_name' => 'State',
				'field_name' => 'state',
				'field_type' => 'state'
			),
			'r.class' => array(
				'long_name' => 'Request Class',
				'short_name' => 'Class',
				'field_name' => 'class',
				'field_type' => 'class'
			),
			'r.customer_id' => array(
				'long_name' => 'Customer',
				'short_name' => 'Cust.',
				'field_name' => 'customer_id',
				'field_type' => 'customer'
			),
			'r.reg_date' => array(
				'long_name' => 'Request Registration Date',
				'short_name' => 'RRD',
				'field_name' => 'reg_date',
				'field_type' => 'date'
			),
			'r.description' => array(
				'long_name' => 'Description',
				'short_name' => 'Descr.',
				'field_name' => 'description',
				'field_type' => 'text_area',
				'options' => FIELD_OPT_SOFT
			),
			'r.synopsis' => array(
				'long_name' => 'Synopsis',
				'short_name' => 'Synop.',
				'field_name' => 'synopsis',
				'field_type' => 'text_line',
				'options' => FIELD_OPT_SOFT
			),
			'r.filed_by' => array(
				'long_name' => 'Request Submitter',
				'short_name' => 'FiledBy',
				'field_name' => 'filed_by',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			),
			'r.fixer_uid' => array(
				'long_name' => 'Request Implementer',
				'short_name' => 'Fixer',
				'field_name' => 'fixer_uid',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			),
		),
		'x_order_by' => array(
			'rid_desc' => array(
				'name' => 'By Request ID',
				'sql' => 'r.rid ASC'),
			'class_asc' => array(
				'name' => 'By Request Class',
				'sql' => 'r.class ASC'),
			'state_asc' => array(
				'name' => 'By Request State',
				'sql' => 'r.state ASC')
		));

		if($comp_id)
			$this->cid=$comp_id;
		elseif($cid)
			$this->cid=$cid;
		else
			_die(__FILE__.':'.__LINE__.' cid is not set.');

		parent::requesttracker($object_params,TRUE);
		foreach($this->p2_states as $s => $str)
        		$this->state2str[$s]=$str;

        	$this->rts_subject_format = "{%action} [%cust] %rid: %synop";
	}

	var $keys_query_result=FALSE;
	function first_key($subset=FALSE,$rid=FALSE){

		if($this->keys_query_result && is_resource($this->keys_query_result))
			mysql_free_result($this->keys_query_result);

		$where_sql='';
		if(is_array($subset)){
			if(count($subset))
				$where_sql='WHERE k.kid IN ('.implode(',',$subset).')';
			else
				$where_sql='WHERE 0';
		}


		$query="SELECT k.*".($rid?', ck.usern, ck.monthn, ck.activation_date':'')." FROM lms_keys AS k INNER JOIN products AS p ON k.pid=p.pid";
		if($rid)
			$query.=" LEFT JOIN lms_cutkeys AS ck ON k.kid=ck.kid AND ck.rid=$rid";
		$query.=" $where_sql ORDER BY p.name DESC, k.name DESC";
		//echo "$query<br>\n";
		if(!($this->keys_query_result=@mysql_unbuffered_query ($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from lms_keys table.');

		return mysql_fetch_array($this->keys_query_result,MYSQL_ASSOC);
	}

	function next_key(){
		return mysql_fetch_array($this->keys_query_result,MYSQL_ASSOC);
	}

	function is_key_name($str){
		//return(eregi("^[[:alnum:]_]{1,128}$", $str));
		return(is_synopsis($str));
	}

	function key_exists($kname,$exclude_kid=FALSE){
		$query = "SELECT * FROM lms_keys WHERE name='".escape_data($kname)."'".($exclude_kid?" AND kid!=$exclude_kid":'')." LIMIT 1";
		//echo "$query <br>\n";
                if(!($result= @mysql_query($query)))
                        die2(__FILE__, __LINE__," Could not select from lms_keys table.");

		if(mysql_num_rows($result)<=0)
			return FALSE;

		$row=mysql_fetch_array($result,MYSQL_ASSOC);
		mysql_free_result($result);
                return $row;
	}

	function get_krow($kid){
		$query = "SELECT * FROM lms_keys WHERE kid=$kid LIMIT 1";
		//echo "$query <br>\n";
                if(!($result= @mysql_query($query)))
                        die2(__FILE__, __LINE__," Could not select from lms_keys table.");

		if(mysql_num_rows($result)<=0)
			return FALSE;

		$row=mysql_fetch_array($result,MYSQL_ASSOC);
		mysql_free_result($result);
                return $row;
	}

	function validate_k2v($k2v){

		$ktov=array();

		if(!isset($k2v['name']) || !$k2v['name'])
			return FALSE;

		if(!isset($k2v['pid']) || !$k2v['pid'])
                        return FALSE;

		if(!isset($k2v['summary']) || !$k2v['summary'])
                        return FALSE;

		if(isset($k2v['bill_price']) && $k2v['bill_price'] && (!isset($k2v['bptype']) || !$k2v['bptype']))
                        return FALSE;

		foreach($k2v as $k => $v){
			if(!$v) continue;
			$ktov[$k]="'".escape_data($v)."'";
		}
		return $ktov;
	}

	function key_add($k2v){
		if(!($ktov=$this->validate_k2v($k2v)))
			_die2(__FILE__.':'.__LINE__." Invalid k2v.");

		$ktov['reg_date']='NOW()';

		$query = "INSERT INTO lms_keys (".implode(',',array_keys($ktov)).") VALUES(".implode(',',$ktov).")";
		//echo "$query <br>\n";die();
                if(!@mysql_query($query))
                        _die2(__FILE__, __LINE__," Could not insert into lms_keys table.");
                return mysql_insert_id();
	}

	function key_update($kid,$k2v){
		if(!($ktov=$this->validate_k2v($k2v)))
                        _die2(__FILE__.':'.__LINE__." Invalid k2v.");

		$tmp=array();
		foreach($ktov as $k => $v)
			array_push($tmp,"$k=$v");

		$query = "UPDATE lms_keys SET ".implode(',',$tmp)." WHERE kid=$kid";
                //echo "$query <br>";
                if(!@mysql_query($query))
                        _die2(__FILE__.':'.__LINE__." Could not update lms_keys table.");
	}

	function key_has_requests($pkid){
	}

	function key_remove($pkid){
	}

	function file_request($fields,$cc_list=array(),$xrids=array()){
		global $uid;
		global $customers_2d;
		global $production_mode;
		global $at_isp;
		global $all_users_2d;

		$req_tbl=$this->object_params['requests_tbl'];

		if(!isset($fields['class']))
			_die(__FILE__.':'.__LINE__.' class field is not specified.');

		$class=$fields['class'];
		$fields['state']=$open_state=$this->first_state($fields['class']);
		$nsa_aid=$this->null_state_action($class);
		$lsm=$this->last_state_mask($class);

		if(!isset($fields['synopsis']))
			_die(__FILE__.':'.__LINE__.' synopsis field is not specified.');
		if(!isset($fields['description']))
			_die(__FILE__.':'.__LINE__.' description field is not specified.');
		$descr=$fields['description'];

		if(!isset($fields['customer_id']) || !$fields['customer_id'])
 			_die(__FILE__.':'.__LINE__.' customer_id field is not specified.');

		$cust=$fields['customer_id'];

		if(!isset($fields['filed_by']))
			$fields['filed_by']=$uid;

		$xstr2uid=array();
		$xstr2uid['%cae_mgr']=$customers_2d['cae_mgr'][$cust]?$customers_2d['cae_mgr'][$cust]:$uid;
		$xstr2uid['%sls_mgr']=$customers_2d['sls_mgr'][$cust]?$customers_2d['sls_mgr'][$cust]:$uid;
		$xstr2uid['%fixer']=$uid;
		$xstr2uid['%tester']=$uid;
		$xstr2uid['%submitter']=$uid;
		$xstr2uid['%fixer_mgr']=$all_users_2d['report_to'][$uid]?$all_users_2d['report_to'][$uid]:$uid;
		$xstr2uid['%mgr']=$xstr2uid['%fixer_mgr'];

		$nsa=$this->null_state_action($class);
		$fixer=$this->default_value("fixer_uid",$nsa,$xstr2uid);
		if(!$fixer)
			$fixer=$uid;
		if(!isset($fields['fixer_uid']))
			$fields['fixer_uid']=$fixer;

		foreach(array_keys($fields) as $k)
			$fields[$k]=escape_data($fields[$k]);

		$query = "INSERT INTO $req_tbl (".implode(', ',array_keys($fields)).(isset($fields['reg_date'])?'':', reg_date').") VALUES (".("'".implode("', '",$fields)."'").(isset($fields['reg_date'])?'':', NOW()').")";
		//echo "$query <br>\n";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__." Could not insert into $req_tbl table.");
		$rid=@mysql_insert_id();

		if(isset($fields['options']) && ($fields['options']&REQ_OPT_RPSTMP))
			$txt="Action: Submit temporary RPS request";
		else
			$txt="Action: Submit new request";

		$fields['rid']=$rid;
		$this->log_history($fields,$uid,$txt);

		if($cc_list){
			$safe_cc=array();
			foreach(explode(',',$cc_list) as $u)
				arr_push($safe_cc,$u);

			foreach($safe_cc as $u)
				$this->add_cc($rid,$u);
		}

		if(isset($fields['options']) && ($fields['options']&REQ_OPT_RPSTMP))
			return $rid;

		$this->notify_by_email($rid,$uid,$descr,$nsa_aid,FALSE);
		return $rid;
	}

	function attach_keys($rid,$keys){

		$vals=array();
		for($row=$this->first_key(array_keys($keys));$row;$row=$this->next_key()){
			$initp=$row['init_price']?$row['init_price']:0;
			$tblp=$row['tbl_price']?$row['tbl_price']:0;
			$billp=$row['bill_price']?$row['bill_price']:0;
			array_push($vals,"($rid,".$row['kid'].", $initp, $tblp, $billp, ".$keys[$row['kid']]['kun'].", ".$keys[$row['kid']]['kmn'].", '".date_norm2sql($keys[$row['kid']]['kad'])."', DATE_ADD('".date_norm2sql($keys[$row['kid']]['kad'])."', INTERVAL  ".$keys[$row['kid']]['kmn']." MONTH))");
		}

		$query="DELETE FROM lms_cutkeys WHERE rid=$rid";
		//echo "$query <br>\n";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__." Could not delete from lms_cutkeys table.");

		if(count($vals)<1)
			return;

		$query="INSERT INTO lms_cutkeys (rid, kid, init_price, tbl_price, bill_price, usern, monthn, activation_date, expiration_date) VALUES ".implode(', ',$vals);
		#echo "$query <br>\n";die;
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__." Could not insert into lms_cutkeys table.");
	}

	function get_attached_keys($rid){

		$keys=array();
		if(!$rid) return $keys;

		$query="SELECT ck.kid FROM lms_cutkeys AS ck INNER JOIN lms_keys AS k ON ck.kid=k.kid WHERE ck.rid=$rid ORDER BY k.pid, k.name";
		//echo "$query<br>\n";
		if(!($result=@mysql_unbuffered_query ($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from lms_cutkeys table.');

		while($row=mysql_fetch_array($result))
			arr_push($keys,$row[0]);

		return $keys;
	}

	function xstr2uid(&$RInfo,&$xstr2uid){
		global $customers_2d;

		init_customers();
		parent::xstr2uid($RInfo,$xstr2uid);

		$cust=$RInfo['customer_id'];

		$xstr2uid['%cae_mgr']=($cust && $customers_2d['cae_mgr'][$cust])?$customers_2d['cae_mgr'][$cust]:$xstr2uid['%fixer_mgr'];
		$xstr2uid['%sls_mgr']=($cust && $customers_2d['sls_mgr'][$cust])?$customers_2d['sls_mgr'][$cust]:$xstr2uid['%fixer_mgr'];
	}

	function request_info($rid,&$xstr2uid,$popup_error=FALSE){

		$this->request_info_sql="SELECT r.*, UNIX_TIMESTAMP(r.reg_date) AS reg_date_tm, UNIX_TIMESTAMP(r.inwork_date) AS inwork_date_tm, UNIX_TIMESTAMP(r.fixed_date) AS fixed_date_tm, UNIX_TIMESTAMP(r.last_date) AS last_date_tm";

		return(parent::request_info($rid,$xstr2uid,$popup_error));
	}

	function process_view_fields(&$RInfo,&$xstr2uid,$action_is_clone){
		global $all_users_2d;

		$SQLStr='';$comment='';
		$res=parent::process_view_fields($RInfo,$xstr2uid,$action_is_clone);
		$SQLStr.=array_shift($res);
		$comment.=array_shift($res);

		if ($this->is_rw_field('hostid') && isset($_POST['hostid'])){
			$hstid = trim(stripslashes($_POST['hostid']));
			if ($hstid != $RInfo['hostid']){
				$SQLStr .= ", hostid = '".escape_data($hostid)."'";
				$comment .= "Hostid: ".$RInfo['hostid']." -> ".$hstid."\n";
			}
		}

		if ($this->is_rw_field('booking') && isset($_POST['booking'])){
			$bking = trim(stripslashes($_POST['booking']));
			if ($bking != $RInfo['booking']){
				$SQLStr .= ", booking = '".escape_data($bking)."'";
				$comment .= "Booking Amount: ".$RInfo['booking']." -> ".$bking."\n";
			}
		}

		if ($this->is_rw_field('maintenance') && isset($_POST['maintenance'])){
			$mnt = trim(stripslashes($_POST['maintenance']));
			if ($mnt != $RInfo['maintenance']){
				$SQLStr .= ", maintenance = '".escape_data($mnt)."'";
				$comment .= "Booking Amount: ".$RInfo['maintenance']." -> ".$mnt."\n";
			}
		}

		if ($this->is_rw_field('license') && isset($_POST['license'])){
			$lic = stripslashes($_POST['license']);
			$lic = str_replace("\r", "", $lic);
                        if ($lic != $RInfo['lic']){
                                $SQLStr .= ", license = '".escape_data($lic)."'";
                                $comment .= "License changed (skipped)\n";
                        }
		}

		return array($SQLStr,$comment);

	}

	function request_view_tr_Hostid(&$RInfo,$hdr=FALSE){

		$this->validate_rinfo($RInfo);
?>

<tr class="lgray">
 <th><?php echo $hdr?$hdr:'Hostid'; ?></th>
 <td colspan=2><?php

  if ($this->is_rw_field('hostid'))
  	print '<input name="hostid" class="inp" size="32" maxlength="127" value="'.$RInfo['hostid'].'">';
  else
  	print html_safe_text($RInfo['hostid']);
?></td>
</tr>
<?php
	}

	function request_view_tr_LicenseText(&$RInfo){

		$this->validate_rinfo($RInfo);
?>

<tr class='lgray' valign='top'>
 <td align="center"><strong>License</strong></td>
 <td colspan=2>
<?php
	echo '<textarea name="license" class="textar" rows="8"'.($this->is_rw_field('license')?'':' disabled').' style="width: 100%;">'.html_safe_text($RInfo['license'], true).'</textarea>';
?>
 </td>
</tr>
<?php
	}

	function request_query_sqlstr($cust=TRUE){
		//return parent::request_query_sqlstr(', k.pid',$cust,"LEFT JOIN lms_cutkeys AS ck ON r.rid=ck.rid LEFT JOIN lms_keys AS k ON ck.kid=k.kid");
		return parent::request_query_sqlstr('',$cust,FALSE);
	}

	function _dashboard_intro($did,$uid,$info=FALSE){
		global $dir_name;
		global $is_customer;

		if($info)
			return array('header' => 'License Management System (Intro)',
				'default_size' => 2,
				'type' => 'table/text',
				'only' => '/lms');

		$tbl_str='
        <table border=0 cellpadding=0 cellspacing=1 width="100%" class=dgray align="center">
        <tr class="lgray">
		<td>
        <ul>
        	<li><a href="'.$dir_name.'/lms/lms_file.php">Submit</a> a license request.</li>
        	<li><a href="'.$dir_name.'/lms/lms_filter.php">Filter</a> the database of the license requests.</li>
        	<li>
        	<form target="lms" action="'.$dir_name.'/lms/lms_view.php">
        		View/Edit a request if you know its number: <input class="inp" type=text name=id size=6 maxlength=6><input class="btn_small" type=button name=submit value=View onClick="rid_check(this.form)">
        	</form>
        	</li>
        </ul>
        	</td>
	</tr>
        </table>';

		return $tbl_str;
	}

	function _dashboard_cr_bundle(){}

	function _dashboard_pie_pq_by_pri(){}

	function _dashboard_pie_pq_by_state(){}

	function _dashboard_latest_requests(){}
}
?>
