<?php
// $Header: /home/CVS/rps/includes/menu.inc,v 1.63 2008/03/31 00:42:21 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

	require_once('includes/yoxel_log.inc');

	define('MENU_IS_MAIN', 0x0000);
	define('MENU_MAIN_SERVICES', 0x0001);

	//define('MPM_');

	if($is_customer){
		$ttnav_keys=array();
		if(defined('YXL_CPORTAL_TTNAV') && is_string(YXL_CPORTAL_TTNAV)){
			$ttnav_keys=explode(',',YXL_CPORTAL_TTNAV);
			if(!in_array('sw',$ttnav_keys) && !in_array('psls',$ttnav_keys) && !in_array('it',$ttnav_keys))
				_die0("Incorrectly set config parameter YXL_CPORTAL_TTNAV.");
		}else
			array_push($ttnav_keys,'sw');
	}else
		$ttnav_keys=array('sw','psls','it');

	$top_top_navigation = array();
	if(in_array('sw',$ttnav_keys))
		$top_top_navigation['sw'] = array(
			'name'=>'SOFTWARE',
			'script'=>'rts/view.php');

	if(in_array('psls',$ttnav_keys))
		$top_top_navigation['psls'] = array(
			'name'=>'SALES',
			'script'=>'ets/view.php');

	if(in_array('it',$ttnav_keys))
		$top_top_navigation['it'] = array(
			'name'=>'IT',
			'script'=>'itrts/view.php');


class TopNavigation {

	var $script_tag;
	var $current_menu;
	var $ttnav;
	var $is_dbrd_page=FALSE;

	function topnavigation($ttnav=FALSE) {
		global $root_fdir;
		global $rel_script_name;
		global $ttnav_keys;
		global $top_top_navigation;
		global $uid;

		$script_dir=dirname($rel_script_name);
		$script_tag=substr(basename($rel_script_name),0,-4);

		// Identify which ttnav has current script
		$mf=$root_fdir. DIRECTORY_SEPARATOR .$script_dir. DIRECTORY_SEPARATOR .'_menu.inc';
		//print_r($top_top_navigation);
		//echo "$script_tag {$_SESSION['ttnav']} $mf<br>\n";
		if(isset($_menu))
			unset($_menu);
		if(file_exists($mf) && is_readable($mf))
			require($mf);

		$possible=array();
		foreach(array_keys($top_top_navigation) as $ttnk){
			if(!isset($_menu[$ttnk])) continue;
			foreach(array_keys($_menu[$ttnk]) as $k){
				//print_r($_menu[$ttnk][$k]);
				if(isset($_menu[$ttnk][$k][$script_tag])){
					array_push($possible,$ttnk);
					break;
				}
			}
		}

		if($ttnav && in_array($ttnav,$possible)){
			unset($_SESSION['ttnav']);
			$_SESSION['ttnav']=$ttnav;
			$this->ttnav=$_SESSION['ttnav'];
			return;
		}

		if(isset($_SESSION['ttnav']) && in_array($_SESSION['ttnav'],$possible)){
			$this->ttnav=$_SESSION['ttnav'];
			return;
		}

		if(count($possible)){
			$this->ttnav=array_shift($possible);
			unset($_SESSION['ttnav']);
			$_SESSION['ttnav']=$this->ttnav;
			$_SESSION['ttnavigation']=$this->ttnav;
			return;
		}

		if(!isset($_SESSION['ttnav']) || !$_SESSION['ttnav'])
			$_SESSION['ttnav']=$ttnav_keys[0];
		$this->ttnav=$_SESSION['ttnav'];
	}

	function current_ttnav(){
		return $this->ttnav;
	}

	function current_top_menu() {
		global $root_fdir;
		global $rel_script_name;

		if($this->current_menu)
			return $this->current_menu;

		$ttnav=$this->ttnav;

		$script_dir=dirname($rel_script_name);
		$script_tag=substr(basename($rel_script_name),0,-4);
		$current_menu='';
		$is_dbrd_page=FALSE;

		// Identify which menu current script belongs to
		// Resolve one level of as_if pointers
		for($i=0;$i<2;$i++){
			$mf=$root_fdir. DIRECTORY_SEPARATOR .$script_dir. DIRECTORY_SEPARATOR .'_menu.inc';
			if(isset($_menu))
				unset($_menu);
			if(file_exists($mf) && is_readable($mf))
				require($mf);
			//echo "$ttnav $mf <br>\n";
			//print_r($_menu[$ttnav]);

			if(isset($_menu) && isset($_menu[$ttnav])){
				if(isset($_menu[$ttnav]['as_if'][$script_tag])){
					$tmp=explode('/',$_menu[$ttnav]['as_if'][$script_tag]);
					if(count($tmp)>1){
						$script_dir=$tmp[0];
						$script_tag=$tmp[1];
					}else
						$script_tag=$_menu[$ttnav]['as_if'][$script_tag];
					continue;
				}

				foreach($_menu[$ttnav] as $k => $v){
					if((substr($k,0,4)=='sub_') && isset($v[$script_tag])){
						if($p=strpos($k,':'))
							$current_menu=substr($k,4,$p-4);
						else
							$current_menu=substr($k,4);

						if(!$v[$script_tag]['title']){
							//echo "here $k $script_tag; $i; ";
							$is_dbrd_page=TRUE;
						}
						break;
					}
				}
				break;
			}
		}
		$this->current_menu=$current_menu;
		$this->script_tag=$script_tag;
		$this->is_dbrd_page=$is_dbrd_page;
		return $this->current_menu;
	}

	function current_sub_menu(){
		return isset($this->script_tag)?$this->script_tag:'';
	}

	function script_path_tag(){
		global $rel_script_name;

		return substr($rel_script_name,0,-4);
	}

	function is_dbrd(){
		//echo "in is_dbrd ";
		if(!$this->current_menu)
                        $this->current_top_menu();

                if(!$this->current_menu)
                        return FALSE;

		return  $this->is_dbrd_page;
	}

	function output($hide_menu=FALSE){
		global $root_fdir;
		global $dir_name;
		global $user_params;
		global $rel_script_name;
		global $yoxelog;

		if(!$this->current_menu)
			$this->current_top_menu();

		if(!$this->current_menu)
			return;

		$ttnav=&$this->ttnav;
		$current_menu=&$this->current_menu;
		$script_tag=&$this->script_tag;

		// Construct menu and sub_menu
		$menu_start_script=array();
		$yxl_sub_right=array();
		$yxl_sub_left=array();
		//$files=scandir($root_fdir);  PHP>5
		$menu_lic=array();
		$sub_menu_lic=0;
		$sub_menu_vv=FALSE;

		$files=glob($root_fdir. DIRECTORY_SEPARATOR ."*",GLOB_ONLYDIR);
		foreach($files as $ff){
		// Lets examine all */_menu.inc files to find all definitions related
		// to the current $ttnav. After that construct the menu+sub-menu.

			$f=basename($ff);
			if(!is_dir($root_fdir. DIRECTORY_SEPARATOR .$f))
				continue;
			$mf=$root_fdir. DIRECTORY_SEPARATOR .$f. DIRECTORY_SEPARATOR .'_menu.inc';
			if(isset($_menu))
				unset($_menu);
			if(file_exists($mf) && is_readable($mf))
				require($mf);
			if(!isset($_menu) || !isset($_menu[$ttnav]))
				continue;
			//echo "$mf <br>\n";

			foreach($_menu[$ttnav] as $dtag => $v){
			   // main menu items
			   if($dtag == 'title')
				$menu_dir2name[$f]=$v;

			   // here, only consider main menu data (no aliases)
			   if(substr($dtag,0,4) != 'sub_')
			   	continue;

			   // extract menu item name and part order
			   $yorder=0;
			   if($p=strpos($dtag,':')){
				$y=substr($dtag,4,$p-4);
				$yorder=substr($dtag,$p);
			   }else
				$y=substr($dtag,4);

			   // now find out what license the menu requires
			   // find 'title' element with 'lic'
			   foreach($_menu[$ttnav][$dtag] as $stag => $vv){
				if(!isset($vv['title']) || $vv['title'])
					continue;

				if(isset($vv['lic'])){
					$menu_lic[$y]=$vv['lic'];
					break;
				}
			   }

			   // now walk through all sub-menu items
			   foreach($_menu[$ttnav][$dtag] as $stag => $vv){
				if(!isset($vv['title']))
					continue;

				// found a dashboard page - main menu item start page
				if(!$vv['title']){
					if(!$this->allow_to_show($vv))
						continue;
					$scr=$dir_name.'/'.$f.'/'.$stag.'.php';
					$menu_start_script[$y]=$scr;
					if(($current_menu==$y) && !is_array($sub_menu_vv))
						$sub_menu_vv=$vv;
					continue;
				}

				// no more useful data to collect if not the current menu
				if($current_menu!=$y)
					continue;

				// Filter out forbiden sub-menu items
				$this->add_hide_attribute($ttnav.'/'.$y.'/'.$stag,$vv);
				if(!$this->allow_to_show($vv))
					continue;

				$scr=$dir_name.'/'.$f.'/'.$stag.'.php'.(isset($vv['url_param'])?$vv['url_param']:'');

				// found currently selected sub-menu
				if($stag==$script_tag){
					$sub_menu_vv=$vv;
					$sub_menu_lic=(isset($vv['lic']) && $vv['lic'])?$vv['lic']:
								(isset($menu_lic[$y])?$menu_lic[$y]:0);
					$str='
		<li><a href="'.$scr.'" class="here">'.$vv['title'].'</a></li>';
				}else
					$str='
		<li><a href="'.$scr.'">'.$vv['title'].'</a></li>';

				// if this is the master _menu.inc (no :order specified)
				if($current_menu==$f)
					array_push($yxl_sub_left,$str);
				else{
					if(!isset($yxl_sub_right[$yorder]))
						$yxl_sub_right[$yorder]=array();
					array_push($yxl_sub_right[$yorder],$str);
				}
			   }
			}
		}

		if(isset($user_params)){
			if(!$user_params->pget('top_menu_sw'))
				$user_params->pset('top_menu_sw','myYoxel,rps,rts,kbs,cust,products');

			if(!$user_params->pget('top_menu_it'))
				$user_params->pset('top_menu_it','myYoxel,itpm,itrts,kbs,cust,queues');

			if(!$user_params->pget('top_menu_psls'))
				$user_params->pset('top_menu_psls','myYoxel,sfs,ets,lms,kbs,cust');
		}

		// Need this for dashboards and yoxelog:
		$top_menu_name=isset($menu_dir2name[$current_menu])?$menu_dir2name[$current_menu]:$current_menu;
		$_SESSION['dbrd_menu2name:'.$current_menu]=$top_menu_name;
		if(isset($yoxelog)){
			$url=$rel_script_name.($_SERVER['QUERY_STRING']?"?".$_SERVER['QUERY_STRING']:"");

			$vp_lbl='';
			if($sub_menu_vv['title'])
				$vp_lbl=$top_menu_name.' | '.$sub_menu_vv['title'];

			$yoxelog->log_vp($ttnav,$url,$vp_lbl);
		}

		if(isset($user_params) && $str=$user_params->pget('top_menu_'.$ttnav))
			$tm=explode(',',$str);
		else{
			$tm=array_keys($menu_start_script);
			sort($tm);
		}

		//print_r($menu_start_script);
		//print_r($tm);

		if($hide_menu)
			return $sub_menu_lic;

		echo '
         <ul id="topnav">';
		while($y=array_shift($tm)){
			if(!isset($menu_start_script[$y]))
				continue;

			if(($current_menu!=$y) && isset($menu_lic[$y]) && !($_SESSION['lic']&$menu_lic[$y]))
				continue;

			$scr=$menu_start_script[$y];
			echo '
	<li><a href="'.$scr.'"'.($current_menu==$y?' class="here"':'').'>'.(isset($menu_dir2name[$y])?$menu_dir2name[$y]:$y).'</a></li>';
		}
		echo '
	</ul>
	<ul id="subnav">';

		ksort($yxl_sub_right);
		while($tmp=array_shift($yxl_sub_right))
			$yxl_sub_left=array_merge($yxl_sub_left,$tmp);
		foreach($yxl_sub_left as $str)
			echo $str;
		echo '
         </ul><br>';

		if(!isset($sub_menu_vv['prereq_check']) || (count($sub_menu_vv['prereq_check'])<1))
			return $sub_menu_lic;

		foreach($sub_menu_vv['prereq_check'] as $tag => $a){
			prereq_check_warning($tag,$a[0],$a[1],$a[2]);
		}

		return $sub_menu_lic;
	}

	function allow_to_show(&$tag_info){
		global $is_customer;
		global $user_is;
		global $asp_mode;
		global $jpgraph;
		global $ezpdf;

		if(isset($tag_info['only_asp']) && !$asp_mode)
			return FALSE;

		if(!isset($tag_info['vbc']) && $is_customer)
			return FALSE;
		if(isset($tag_info['vbc']) && !$tag_info['vbc'] && $is_customer)
			return FALSE;

		if(isset($tag_info['only_cust']) && $tag_info['only_cust'] && !$is_customer)
			return FALSE;

		if(isset($tag_info['only_mu']) && !($user_is&USER_IS_MU))
			return FALSE;
		if(isset($tag_info['only_m']) && !($user_is&USER_IS_M))
			return FALSE;
		if(isset($tag_info['only_licm']) && !($user_is&USER_IS_LICADMIN))
			return FALSE;
		if(isset($tag_info['jpgraph']) && !$jpgraph)
			return FALSE;
		if(isset($tag_info['ezpdf']) && !$ezpdf)
			return FALSE;
		if(isset($tag_info['hide']) && $tag_info['hide'])
			return FALSE;

		return TRUE;
	}

	var $hide_list=array();
	function hide_item($stag,$hide=TRUE){
		$ttnav=&$this->ttnav;
		$current_menu=$this->current_top_menu();
		$abs_stag=$ttnav.'/'.$current_menu.'/'.$stag;
		$this->hide_list[$abs_stag]=$hide;
	}

	function add_hide_attribute($abs_stag,&$tag_info){
		$ttnav=&$this->ttnav;
		$current_menu=$this->current_top_menu();
		$current_abs_stag=$ttnav.'/'.$current_menu.'/'.$this->script_tag;

		if(isset($this->hide_list[$abs_stag]))
			$tag_info['hide']=$this->hide_list[$abs_stag];

		if(($current_abs_stag==$abs_stag) && isset($tag_info['hide']) && $tag_info['hide']){
			$ht=$tag_info['hide'].'_title';
			$up=$tag_info['hide'].'_url_param';
			if($tag_info['hide']!==TRUE){
				if(isset($_SESSION[$ht])){
					$tag_info['title']=$tag_info['title'].': '.$_SESSION[$ht];
					unset($_SESSION[$ht]);
				}
				if(isset($_SESSION[$up])){
					$tag_info['url_param']=$_SESSION[$up];
					unset($_SESSION[$up]);
				}
			}
			$tag_info['hide']=FALSE;
		}

	}
}
if(!isset($top_nav_menu)){
	$top_nav_menu= new TopNavigation();
}

?>
