<?php
// $Header: /home/CVS/rps/includes/params/text_params.inc,v 1.5 2008/03/05 08:17:32 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('includes/menu.inc');

class TextParams {

  var $parameter=array();
  var $object_params=array();

  function check_object_params(&$object_params){

	if(!isset($object_params['params_tbl']))
		_die0(__FILE__.':'.__LINE__." object parameter params_tbl is not defined.");
	if(!isset($object_params['params_fn']))
		_die0(__FILE__.':'.__LINE__." object parameter params_fn is not defined.");
	if(!isset($object_params['params_pkey_fn']))
		_die0(__FILE__.':'.__LINE__." object parameter params_pkey_fn is not defined.");
	if(!isset($object_params['params_pkey_id']))
		_die0(__FILE__.':'.__LINE__." object parameter params_pkey_id is not defined.");
	if(!isset($object_params['params_ptxt']))
		_die0(__FILE__.':'.__LINE__." object parameter params_ptxt is not defined.");

  }

  function textparams($object_params){
  	global $info_msg;

	$this->check_object_params($object_params);
	$this->object_params=$object_params;

  	$ptbl=$this->object_params['params_tbl'];
  	$pfn=$this->object_params['params_fn'];
  	$pkey_fn=$this->object_params['params_pkey_fn'];
  	$pkey_id=$object_params['params_pkey_id'];
  	$ptxt=$this->object_params['params_ptxt'];

  	$_t=array();
  	if(!$ptxt)
  		$ptxt = simple_query("SELECT $pfn FROM $ptbl WHERE $pkey_fn = $pkey_id");

	$ptxt='&'.trim($ptxt);
	$_t = explode('&', $ptxt);

	$this->parameter = array();
	foreach($_t as $tmp){
		//echo "$tmp<br>\n";
		if(!$tmp)
			continue;
		$a=explode('=', $tmp);
		if(count($a)==2)
			$this->parameter[$a[0]]=urldecode($a[1]);
		else
			$this->parameter[$a[0]]=FALSE;
	}
  }

  function reset_by_prefix($prefix){
  	$l=strlen($prefix);
  	if(!$prefix || !$l)
  		return;
  	foreach($this->parameter as $k => $v)
		if((substr($k,0,$l) == $prefix) && ($this->parameter[$k]>1))
			$this->parameter[$k]=1;
  }

  function pset($key,$val){
  	//echo "$key=$val <br>\n";
  	$this->parameter[$key]=urlencode($val);
  }

  function punset($key){
  	if(isset($this->parameter[$key]))
		unset($this->parameter[$key]);
  }

  function pget($key){
	if (isset($this->parameter[$key]))
		return urldecode($this->parameter[$key]);
	return FALSE;
  }

  function save(){

  	$ptbl=$this->object_params['params_tbl'];
  	$pfn=$this->object_params['params_fn'];
  	$pkey_fn=$this->object_params['params_pkey_fn'];
  	$pkey_id=$this->object_params['params_pkey_id'];
  	$query='';
	foreach($this->parameter as $k => $v)
		if($v) $query.="&$k=$v";

	$sql="UPDATE $ptbl SET $pfn = '".($query?escape_data(substr($query, 1)):'NULL')."' WHERE $pkey_fn = $pkey_id";
	//echo "$sql<br>\n";
	if (!@mysql_query($sql))
		_die2(__FILE__.':'.__LINE__." Could not update $ptbl table.");
  }

}

?>
