<?php
// $Header: /home/CVS/rps/includes/params/user_filters.inc,v 1.25 2008/06/24 03:10:18 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

if(!defined('USER_FILTERS_INC')){
define('USER_FILTERS_INC',TRUE);

require_once('includes/params/text_params.inc');

	define('FILTER_OPT_SHARED', 1);
	define('FILTER_OPT_LAST', 2);

	define ('CDB_CREATE_FILTERS_TBL', "CREATE TABLE IF NOT EXISTS filters
		(fid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		rts_type VARCHAR(32),
		comment CHAR(128),
		uid int UNSIGNED default NULL,
		params TEXT,
		options INT UNSIGNED DEFAULT 0 NOT NULL,
		date_updated TIMESTAMP,
		PRIMARY KEY (fid),
		FOREIGN KEY (uid) REFERENCES users (uid) on delete cascade
	    ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

if(!$GLOBALS['cmd_line_mode'] && $GLOBALS['uid']){
	$query = CDB_CREATE_FILTERS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create filters table. ');
}

class FilterParams extends TextParams {

  function filterparams($fid,$ptxt){

	$object_params=array(
		'params_tbl' => 'filters',
		'params_fn' => 'params',
		'params_pkey_fn' => 'fid',
		'params_pkey_id' => $fid,
		'params_ptxt' => $ptxt?$ptxt:''
		);
	parent::textparams($object_params);
  }
}

class ParentFilterParams extends FilterParams {

  function parentfilterparams($fid,$ptxt){
	parent::filterparams($fid,$ptxt);
	//f(!$this->pget('_child_filters'))
	//	_die('This class requires list of children to be provided.');
  }

  function get_children_ids(){
  	$a=explode(',',$this->pget('_child_filters'));
  	if(!$a || !$a[0])
  		return array();
  	return $a;
  }

  function save($children_ids){
  	if(count($children_ids))
  		$this->pset('_child_filters',implode(',',$children_ids));
  	parent::save();
  }
}

class UserFilters {
  var $uid;
  var $user_filters;
  var $rts_type;
  var $child_rts_type;

  function userfilters($rts_type,$last_filter_comment=''){
  	global $uid;
  	global $is_customer;
  	global $all_users_2d;

	$this->uid=$uid;
	$this->rts_type=$rts_type;
	$this->child_rts_type=FALSE;
	if($p=strrpos($rts_type,'/'))
		$this->child_rts_type=substr($rts_type,0,$p);

	$nrecords=simple_query("SELECT COUNT(fid) FROM filters WHERE rts_type='$rts_type' AND uid=$uid");
	if($nrecords<1){
		if(!$last_filter_comment)
			$last_filter_comment='MY LAST QUERY';
		$query = "INSERT INTO filters (rts_type, uid, comment, options) VALUES('$rts_type', $uid, '$last_filter_comment', ".FILTER_OPT_LAST.")";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into filters table.');
	}
	$query="SELECT f.fid, f.comment, f.params, f.uid, f.options FROM filters AS f, users AS u WHERE f.uid=u.uid AND f.rts_type='$rts_type' AND (f.uid=$uid OR f.options&".FILTER_OPT_SHARED.")".($is_customer?" AND u.user_is&".USER_IS_CUSTOMER." AND u.customer_id=$is_customer":'');
	//echo "$query <br>\n";
	if(!($result=@mysql_query ($query)))
		_die2(__FILE__.':'.__LINE__.' Could not select from filters table. ');
	$this->user_filters=array();
	$this->user_filters['comment']=array();
	while($row=mysql_fetch_array($result, MYSQL_NUM)){
		if($last_filter_comment && ($row[4]&FILTER_OPT_LAST))
			$this->user_filters['comment'][$row[0]]=$last_filter_comment;
		else
			$this->user_filters['comment'][$row[0]]=$row[1];
		$this->user_filters['params'][$row[0]]=$row[2];
		$this->user_filters['owner'][$row[0]]=$row[3];
		$this->user_filters['options'][$row[0]]=$row[4];
		$this->user_filters['rw'][$row[0]]=(($row[3]==$uid) && !($row[4]&FILTER_OPT_LAST))?TRUE:FALSE;
		//print_r($row);echo "<br>\n";
	}
  }

  function is_shared($fid){
	return $this->user_filters['options'][$fid]&FILTER_OPT_SHARED;
  }

  function is_last($fid){
	return $this->user_filters['options'][$fid]&FILTER_OPT_LAST;
  }

  function get_filter_comment_by_id($fid){
	return $this->user_filters['comment'][$fid];
  }

  function get_filter_owner_by_id($fid){
	return $this->user_filters['owner'][$fid];
  }

  function is_parent(){
  	if($this->child_rts_type)
  		return $this->child_rts_type;
  	return FALSE;
  }

  function &get_parent_filters($fid,$quick_check=FALSE){
  	global $is_customer;

  	$parents=array();
  	$ref=&$parents;

  	$query="SELECT f.fid, f.params, f.comment, f.rts_type FROM filters AS f, users AS u WHERE f.uid=u.uid AND (f.options&".FILTER_OPT_LAST.")=0 AND f.rts_type LIKE '".escape_data($this->rts_type.'/')."%'".($is_customer?" AND u.user_is&".USER_IS_CUSTOMER." AND u.customer_id=$is_customer":'');
	//echo "$query <br>\n";
	if(!($result=@mysql_query ($query)))
		_die2(__FILE__.':'.__LINE__.' Could not select from filters table. ');
	while($row=mysql_fetch_array($result, MYSQL_NUM)){
		//echo "$row[2] <br>\n";
		$fl=new ParentFilterParams($row[0],$row[1]);
		$a=$fl->get_children_ids();
		if(in_array($fid,$a)){
			if(!isset($parents[$row[3]]))
				$parents[$row[3]]=array();
			array_push($parents[$row[3]],$row[0]);
			if($quick_check){
				mysql_free_result($result);
				return $ref;
			}
		}
	}
	return $ref;
  }

  function is_rw($fid,$check_parent=TRUE){

  	if(!$check_parent)
  		return $this->user_filters['rw'][$fid];

  	// Check if any of the parents refers to the child level filter
  	$parents=&$this->get_parent_filters($fid,TRUE);
  	if(count($parents))
  		return FALSE;
	return $this->user_filters['rw'][$fid];
  }

  // Filter that can not be unshared, confusing, huh?
  // Will change the name later to un_unsharable :)
  function is_unshareable($fid){

  	// Check if any of the parents refers to the child level filter
  	$parents=&$this->get_parent_filters($fid);
  	foreach(array_keys($parents) as $p_rts_type){
  		$fls=new UserFilters($p_rts_type);
  		foreach($parents[$p_rts_type] as $pfid){
  			if($fls->is_shared($pfid))
  				return TRUE;
  		}
  	}
	return !$this->is_rw($fid,FALSE);
  }

  function is_shareable($fid){
  	if($this->child_rts_type){
  		$fls=new UserFilters($this->child_rts_type);
  		$fl=new ParentFilterParams($fid,$this->user_filters['params'][$fid]);
		$a=$fl->get_children_ids();
		while($f=array_shift($a))
			if(!$fls->is_shareable($f))
				return FALSE;
  	}
  	if($this->is_rw($fid,FALSE))
  		return TRUE;
  	return FALSE;
  }

  function share($fids){

  	//print_r($fids);

  	if(!count($fids))
  		return;

  	$safe_fids=array();
	while($fid=array_shift($fids)){
		if(!$this->is_shareable($fid))
			continue;
		array_push($safe_fids,$fid);
	}
	if($this->child_rts_type){
  		$fls=new UserFilters($this->child_rts_type);
  		foreach($safe_fids as $fid){
  			$fl=new ParentFilterParams($fid,$this->user_filters['params'][$fid]);
			$fls->share($fl->get_children_ids());
		}
		$this->set_opt($safe_fids,"options|".FILTER_OPT_SHARED);
  	}else
		$this->set_opt($safe_fids,"options|".FILTER_OPT_SHARED);
  }

  function unshare($fids){

  	if(!count($fids))
  		return;

  	$safe_fids=array();
	while($fid=array_shift($fids)){
		if($this->is_unshareable($fid))
			continue;
		array_push($safe_fids,$fid);
	}

	//print_r($safe_fids);die;
	$this->set_opt($safe_fids,"options&(~".FILTER_OPT_SHARED.")");
  }

  function remove_tagged_filters($tag,$id){
  	$rm_fids=array();
  	foreach(array_keys($this->user_filters['rw']) as $fid){
  		$fltr=&$this->get_filter_by_id($fid);
  		if($fltr->pget($tag)==$id){
  			$parents=&$this->get_parent_filters($fid,TRUE);
  			if(count($parents))
  				continue;
  			array_push($rm_fids,$fid);
  		}
  	}
	$this->remove($rm_fids);
  }

  function get_tagged_fids($tag,$id){
  	$fids=array();
  	foreach(array_keys($this->user_filters['rw']) as $fid){
  		$fltr=&$this->get_filter_by_id($fid);
  		if($fltr->pget($tag)==$id)
  			array_push($fids,$fid);
  	}
  	return($fids);
  }

  function remove($fids){
	if(!count($fids))
		return;
	$update_sql_str='';
	while($fid=array_shift($fids)){
		if(!$this->is_rw($fid)) continue;
		$update_sql_str.="OR fid=$fid ";
	}
	$query="DELETE FROM filters WHERE rts_type='".$this->rts_type."' AND uid=".$this->uid." AND (".substr($update_sql_str,2).")";
	if(!@mysql_query($query))
		_die2(__FILE__.':'.__LINE__.' Could not delete from filters table.');
  }

  function set_opt($fids,$opt_str){
	if(!count($fids)) return;
	$update_sql_str='';
	while($fid=array_shift($fids))
		$update_sql_str.="OR fid=$fid ";
	$query="UPDATE filters SET options=$opt_str WHERE rts_type='".$this->rts_type."' AND uid=".$this->uid." AND (".substr($update_sql_str,2).")";
	//die($query);
	if(!@mysql_query($query))
		_die2(__FILE__.':'.__LINE__.' Could not update filters table.');
  }

  function get_filters($rw_only=FALSE,$pps_safe=FALSE){
  	$filters=array();
  	foreach($this->user_filters['rw'] as $fid => $rw){
  		if($rw_only && !$rw)
  			continue;
		if($pps_safe && !$this->filter2sql_where($fid,TRUE))
			continue;
  		$filters[$fid]=$this->user_filters['comment'][$fid];
  	}
	return($filters);
  }

  function &get_last_filter(&$fid){

	foreach($this->user_filters['options'] as $id => $opt)
		if($opt&FILTER_OPT_LAST){
			$fid=$id;
			break;
		}
	if(!$fid)
		return $fid;

	if($this->child_rts_type)
		$lf=&new ParentFilterParams($fid,$this->user_filters['params'][$fid]);
	else
		$lf=&new FilterParams($fid,$this->user_filters['params'][$fid]);
	return $lf;
  }

  function is_valid($fid){
	return isset($this->user_filters['options'][$fid]);
  }

  function &get_filter_by_id($fid){

	$lf=FALSE;
  	if(!isset($this->user_filters['comment'][$fid]))
  		return $lf;

        if($this->child_rts_type)
		$lf=&new ParentFilterParams($fid,$this->user_filters['params'][$fid]);
	else
		$lf=&new FilterParams($fid,$this->user_filters['params'][$fid]);
        return $lf;
  }

  function create_new_filter($comment,$ptxt=''){
	$query = "INSERT INTO filters (rts_type, uid, comment, params) VALUES('".$this->rts_type."', ".$this->uid.", '".escape_data($comment)."', '".escape_data($ptxt)."')";
	if(!@mysql_query($query))
		_die(__FILE__.':'.__LINE__.' Could not insert into filters table.');

	$fid=mysql_insert_id();
	$this->userfilters($this->rts_type);
	return($fid);
  }

  function create_filter_from_id($from_fid,$comment){
  	global $is_customer;

  	$ptxt=simple_query("SELECT f.params FROM filters AS f, users AS u WHERE f.uid=u.uid AND f.rts_type='".$this->rts_type."' AND f.uid=".$this->uid." AND (f.uid=".$this->uid." OR f.options&".FILTER_OPT_SHARED.") AND f.fid=$from_fid".($is_customer?" AND u.user_is&".USER_IS_CUSTOMER." AND u.customer_id=$is_customer":''));
	if(!$ptxt)
		_die2(__FILE__.':'.__LINE__.' Could not select from filters table. ');

	$fid=$this->create_new_filter($comment,$ptxt);
	return($fid);
  }

  function update_filter_comment($fid,$comment=''){
  	global $is_customer;

  	if(!isset($this->user_filters['comment'][$fid]))
  		return;

	if(!$comment)
		return;
	$query = "UPDATE filters SET comment='".escape_data($comment)."' WHERE fid=$fid";
	//echo "$query <br>\n";
	if(!@mysql_query($query))
		_die2(__FILE__.':'.__LINE__.' Could not update filters table.');
	$this->userfilters($this->rts_type);
  }

  function update_filter_from_id($fid,$from_fid){
  	global $is_customer;

  	if(!isset($this->user_filters['comment'][$fid]))
  		return;

  	$ptxt=simple_query("SELECT f.params FROM filters AS f, users AS u  WHERE f.rts_type='".$this->rts_type."' AND f.uid=".$this->uid." AND (f.uid=".$this->uid." OR f.options&".FILTER_OPT_SHARED.") AND f.fid=$from_fid".($is_customer?" AND u.user_is&".USER_IS_CUSTOMER." AND u.customer_id=$is_customer":''));
	if(!$ptxt)
		_die2(__FILE__.':'.__LINE__.' Could not select from filters table. ');
	$query = "UPDATE filters SET params='".escape_data($ptxt)."' WHERE fid=$fid";
	//echo "$query <br>\n";
	if(!@mysql_query($query))
		_die2(__FILE__.':'.__LINE__.' Could not update filters table.');
	$this->userfilters($this->rts_type);
  }


  function filter2sql_where($fid,$pps_safe=FALSE){

  	$WHERE = '';
	if(!$fid || !isset($this->user_filters['comment'][$fid]))
		return $WHERE;

	$filter=&$this->get_filter_by_id($fid);
  	$sel_fields=explode(',',$filter->pget('_type_select'));
	foreach($sel_fields as $Field) {
		$tmp = $filter->pget($Field);
		if (!$tmp) continue;

		$fld=strtr($Field,"|",".");

		//****
		// v1.18 filter engine changes make us run this check
		// Alternatively you can re-generate your saved  filters
		if(in_array($fld,array('pid','cid','qid','state'))) $fld='r.'.$fld;
		//***

		$WHERE  .= " AND $fld IN ($tmp)";

		if($esql=$filter->pget($Field.'_extra_sql')){
			if($pps_safe)
				return '';
	  		$WHERE .= " AND ".$esql;
		}
	}

	$date_fields=explode(',',$filter->pget('_type_date'));
	foreach($date_fields as $Field) {
		if($from= $filter->pget($Field.'_from')){
                	$d=date_norm2sql($from);
                	$fld=strtr($Field,"|",".");

			//****
			// v1.18 filter engine changes make us run this check
			// Alternatively you can re-generate your saved  filters
			if(in_array($fld,array('reg_date'))) $fld='r.'.$fld;
			//****

                	$WHERE .= " AND $fld>='$d'";
                }
                if($to= $filter->pget($Field.'_to')){
                	$d=date_norm2sql($to);
                	$fld=strtr($Field,"|",".");

			//****
			// v1.18 filter engine changes make us run this check
			// Alternatively you can re-generate your saved  filters
			if(in_array($fld,array('reg_date'))) $fld='r.'.$fld;
			//****

                	$WHERE .= " AND $fld<='$d'";
                }
		if($esql=$filter->pget($Field.'_extra_sql')){
			if($pps_safe)
				return '';
	  		$WHERE .= " AND ".$esql;
		}
	}

	$text_fields=explode(',',$filter->pget('_type_text'));
	foreach($text_fields as $Field) {
		if ($s = $filter->pget($Field)){
			$fld=strtr($Field,"|",".");

			//****
			// v1.18 filter engine changes make us run this check
			// Alternatively you can re-generate your saved  filters
			if(in_array($fld,array('description'))) $fld='r.'.$fld;
			//****

			//$s = str_replace("*", "%", $s);
			$s = explode(" ", $s);
			foreach($s as $el)
				$WHERE .= " AND $fld LIKE '%".escape_data($el)."%'";
		}
		if($esql=$filter->pget($Field.'_extra_sql')){
			if($pps_safe)
				return '';
	  		$WHERE .= " AND ".$esql;
		}
	}
	return $WHERE;
  }

  function post2filter(&$FldList,&$fltr){
	global $is_customer;

        $sel_type_str = $date_type_str = $text_type_str = '';
        foreach(array_keys($FldList) as $Field) {
          if ($is_customer && !$FldList[$Field]['vbc'])
		continue;

          switch ($FldList[$Field]['input']){
	    case 'select':
        	$fltr->punset($Field);
		if(!isset($FldList[$Field]['local']) || !$FldList[$Field]['local'])
			$sel_type_str.=','.$Field;
                if (!isset($_POST[$Field])) break;
                eval("$"."tmp = ereg_replace(\"[^0-9,]\", \"\", $"."_POST['$Field']);");
                //echo "$Field --> '$tmp' <br>\n";
                if (!$tmp) break;
                $fltr->pset($Field,$tmp);
		break;

	    case 'date':
		$fltr->punset($Field.'_from');
		$fltr->punset($Field.'_to');
		if(!isset($FldList[$Field]['local']) || !$FldList[$Field]['local'])
			$date_type_str.=','.$Field;
                if (is_date(stripslashes(trim($_POST[$Field.'_from'])))){
			$from = ereg_replace("[ \t\r\n]+", " ", stripslashes(trim($_POST[$Field.'_from'])));
			$fltr->pset($Field.'_from',$from);
                }
                if (is_date(stripslashes(trim($_POST[$Field.'_to'])))){
			$to = ereg_replace("[ \t\r\n]+", " ", stripslashes(trim($_POST[$Field.'_to'])));
			$fltr->pset($Field.'_to',$to);
                }
                break;

	    case 'text':
		$fltr->punset($Field);
		if(!isset($FldList[$Field]['local']) || !$FldList[$Field]['local'])
			$text_type_str.=','.$Field;
                if (!isset($_POST[$Field])) break;
		$s = ereg_replace("[ \t\r\n]+", " ", $_POST[$Field]);
		if (str_replace(" ", "", $s) != '')
			$fltr->pset($Field,$s);
		break;

	    case 'rselect':
        	$fltr->punset($Field);
		if(!isset($FldList[$Field]['local']) || !$FldList[$Field]['local'])
			$sel_type_str.=','.$Field;
                if (!isset($_POST[$Field])) break;
                eval("$"."tmp = ereg_replace(\"[^0-9,]\", \"\", $"."_POST['$Field']);");
                //echo "$Field --> '$tmp' <br>\n";
                if (!$tmp) break;
                $fltr->pset($Field,$tmp);
		break;

	    default:
	    	_die(__FILE__.':'.__LINE__.' Unknown query input type.');
	  }

	  if(isset($FldList[$Field]['extra_sql']) && $FldList[$Field]['extra_sql'])
	  	$fltr->pset($Field.'_extra_sql',$FldList[$Field]['extra_sql']);
	}
	$fltr->pset('_type_select',substr($sel_type_str,1));
	$fltr->pset('_type_date',substr($date_type_str,1));
	$fltr->pset('_type_text',substr($text_type_str,1));

        $fltr->save();
  }

  function print_filter_panel($FldList,$fid=FALSE){
	global $is_customer;
	global $dir_name;

	$lfilter=&$this->get_last_filter($lfid);
	if($fid){
		$cfilter=&$this->get_filter_by_id($fid);
		if($cfilter){
               		$lfilter=&$cfilter;
                	$lfid=$fid;
        	}
	}

	$fls=$this->get_filters(TRUE);
?>

<script language='JavaScript'>
<!--

function form_clear(form)
{
        var i, el;

        for (i = 0; i < form.length; i++){
                el = form.elements[i];

                if (el.type == 'text')        el.value = '';
                if (el.name.charAt(0) == '_') el.selectedIndex = -1;
                if (el.name.substr(0, 2) == '__') el.options.length = 0;
        }
        form.lfid.selectedIndex = 0;
}

function form_set_filter(form,fid){
<?php
	foreach($fls as $fid => $fname){
		$f=&$this->get_filter_by_id($fid);
		echo '
	if(fid=='.$fid.'){
	/* Filter \''.$fname.'\' */';
		foreach(array_keys($FldList) as $Field){
        	  if ($is_customer && !$FldList[$Field]['vbc'])
        	  	continue;

		  switch ($FldList[$Field]['input']){
		    case 'select':
			$values=&$FldList[$Field]['values'];
			$a=explode(',',$f->pget($Field));
			for($i=0;$p=array_shift($a);$i++)
				if(isset($values[$p]))
					echo '
		sel=document.getElementsByName("__'.$Field.'");
		sel[0].options['.$i.']=new Option("'.$values[$p].'",'.$p.',false,false);';
				else
					$i--;
			break;

		    case 'date':
			$df=$f->pget($Field.'_from');
			$dt=$f->pget($Field.'_to');
			echo '
		dt=document.getElementsByName("'.$Field.'_from");
		dt[0].value="'.$df.'";
		dt=document.getElementsByName("'.$Field.'_to");
		dt[0].value="'.$dt.'";';
                	break;

		    case 'text':
			$s=$f->pget($Field);
			echo '
		txt=document.getElementsByName("'.$Field.'");
		txt[0].value="'.$s.'";';
			break;

		    case 'rselect':
			$values=&$FldList[$Field]['values'];
			$key=$f->pget($Field);
			if(($indx=array_search($key,array_keys($values)))!==FALSE)
				echo '
		rsel=document.getElementsByName("'.$Field.'");
		rsel[0].options.selectedIndex='.$indx.';';
			break;

		    default:
			_die(__FILE__.':'.__LINE__.'Unknown query input type.');
		  }
		}
		echo '
	}';
	}
?>

}

function go(form,what) {
	if(what == 'pick'){
		i=form.lfid.selectedIndex;
		if(!i)
			return;
		form_clear(form);
		form.lfid.selectedIndex = i;
		form_set_filter(form,form.lfid.options[i].value);
		return;
	}else if(what != 'apply')
		return;
<?php
        foreach(array_keys($FldList) as $Field){
		if ($is_customer && !$FldList[$Field]['vbc'])
			continue;

		if($FldList[$Field]['input']=='date'){
                	echo '
 	dt=document.getElementsByName("'.$Field.'_from");
	if(dt.value)
		if (date_check(dt))
			return alert("Please, enter correct \'from date\'!");

	dt=document.getElementsByName("'.$Field.'_to");
	if(dt.value)
		if (date_check(dt))
			return alert("Please, enter correct \'to date\'!");';
		}
	}
?>
        collect_all(form);
        form.submit();
        disable_form(form);
}

function init() {
        var i, sel, form = document.forms[0];

        for (i = 0; i < form.length; i++){
        	if(form.elements[i].name=="lfid") continue;
                sel = form.elements[i];
                if (sel.name == 'rpp') continue;
                if (sel.type != 'select-one') continue;
                sel.selectedIndex = -1;
        }
}
//-->
</script>

<form action='<?php echo $_SERVER['PHP_SELF']; ?>' method='post'>
<input type='hidden' name='isSearch' value='isSearch'>
<input type='hidden' name='fid' value='0'>
<table width="90%" border=0 align='center' border=0 cellpadding=1 cellspacing=1 class="dgray">
<tr class="lgray" valign="top">
	<td colspan="2" align="right">
	<strong>LOADED FILTER:</strong>
	<select class="selec" style="width: 20em" name="lfid" onChange="go(this.form,'pick')">
		<option value="0">=PICK A FILTER=</option>
<?php
	foreach($fls as $fid => $s)
		echo '
		<option value="'.$fid.'"'.($fid==$lfid?' selected':'').'>'.html_safe_text($s).'</option>';

?>

	</select>

	</td>
	<td colspan="2">
		<input class="wbtn" type="button" value=">>apply<<" onClick="go(this.form,'apply')" />
		<input class="wbtn" type="button" value="clear" onClick="form_clear(this.form)" />
		[<a href="javascript:filters_open('<?php echo $this->rts_type; ?>');">Manage Saved Filters</a>]
	</td>
</tr>
<tr style='height: 1' class='separator'>
 <td style='width: 20%'></td>
 <td style='width: 35%'></td>
 <td style='width: 10%'></td>
 <td style='width: 35%'></td>
</tr>
<tr style='height: 1' class='dgray'>
 <td></td>
 <th>Possible Values</th>
 <td></td>
 <th>Filter Values</th>
</tr>
<?php
        foreach(array_keys($FldList) as $Field){
          if ($is_customer && !$FldList[$Field]['vbc'])
		continue;

          switch ($FldList[$Field]['input']){
	    case 'select':
		$values=&$FldList[$Field]['values'];
		$svalues=explode(',', $lfilter->pget($Field));

		echo '
<tr class="lgray" align="center">
        <th>'.$FldList[$Field]['name'].'</th>
        <td colspan="3">';
		echo gen_yxl_select($Field,$values,$svalues,FALSE,TRUE);
		echo '
        </td>
</tr>';
		break;

	    case 'date':
        	$csf = $lfilter->pget($Field.'_from');
        	$cst = $lfilter->pget($Field.'_to');
		echo '
<tr class="lgray">
        <th>'.$FldList[$Field]['name'].'</th>
        <td align="center">From <input class="inp" name="'.$Field.'_from'.'" size="10" maxlen="10" value="'.$csf.'">mm/dd/yyyy
        </td>
        <td></td>
        <td align="center">To <input class="inp" name="'.$Field.'_to'.'" size="10" maxlen="10" value="'.$cst.'">mm/dd/yyyy
        </td>
</tr>';
		break;

	    case 'text':
        	$cs = $lfilter->pget($Field);
		echo '
<tr class="lgray">
        <th>'.$FldList[$Field]['name'].'</th>
        <td colspan=3 align="center">
                <input type="text" name="'.$Field.'" class="inp" size="100%" maxlength="128" value="'.$cs.'">
        </td>
</tr>';
		break;

	    case 'rselect':
		$cs=$lfilter->pget($Field);
		$values=&$FldList[$Field]['values'];
		echo '
<tr class="lgray" align="center">
        <th>'.$FldList[$Field]['name'].'</th>
        <td colspan="3" align="center">
                <select class="selec" name="'.$Field.'" style="width: 8em">';

		foreach($values as $k => $v){
        		print "                        <option value='$k'";
        		if ($k==$cs)
                		print " selected";
        		print ">$v\n";
		}

		echo '
                </select>
        </td>
</tr>';
		break;

	    default:
	    	_die(__FILE__.':'.__LINE__." Unknown query input type: ".$FldList[$Field]['input'].".");
	  }
	}
?>


<tr style='height: 1' class='separator'>
 <td style='width: 20%'></td>
 <td style='width: 35%'></td>
 <td style='width: 10%'></td>
 <td style='width: 35%'></td>
</tr>
<tr class='dgray'>
	<th></th>
	<th></th>
	<th>
		<input class="wbtn" type="button" value=">>apply<<" onClick="go(this.form,'apply')" />
	</th>
	<th></th>
</tr>
</table>
</form>

<?php
  }

  function sort_and_print(&$OutputFormat,$SQLStr,$obj=FALSE,$extra=''){
  	global $yxl_users;
  	global $all_users_2d;
  	global $customers_2d;
	global $img_dir;

	if(!isset($_GET['sort']))
		_die('Improper use of the function.');

	$fls=$this->get_filters(TRUE);
	$lfilter=&$this->get_last_filter($lfid);
        $rpp = $lfilter->pget('rpp');
        if (!$rpp) $rpp = 25;

        $order_by=array(); $i=0;$abc=$abct='';
        foreach(array_keys($OutputFormat) as $Title){
		$Field=&$OutputFormat[$Title];
		if(!isset($Field['field']) || !$Field['field'])
			continue;

		if(!isset($Field['sort_field']))
			$Field['sort_field']=$Field['field'];

		if(isset($Field['abc_field']) && $Field['abc_field'] && isset($Field['abc_sql']) && $Field['abc_sql']){
			//$abcf='UCASE(LEFT(LTRIM('.$Field['abc_field'].'),1))';
			$abcf=$Field['abc_field'];
			$abc=sprintf($Field['abc_sql'],$abcf);
			if(isset($Field['abc_title']))
				$abct=$Field['abc_title'];

		}

		array_push($order_by,array($Field['sort_field']," ASC",++$i,"$img_dir/arrow_u.png"));
		array_push($order_by,array($Field['sort_field']," DESC",$i-1,"$img_dir/arrow_d.png"));
		$i++;
        }

	$sort = ereg_replace("[^0-9,]", "", $_GET['sort']);
        $sort .= ',0';
        $sort = ereg_replace(",+", ",", $sort);
        $sort = ereg_replace("^,", "", $sort);
        $sort = ereg_replace(",$", "", $sort);

	if (($letter=$lfilter->pget('letter')) && $abc && $abcf)
		$SQLStr .=" AND ($abcf LIKE '$letter%' OR $abcf LIKE '".mb_strtolower($letter)."%' )";

	if($abc){
		//echo "$abc<br>\n";
		if(!($result=@mysql_query($abc)))
			_die2(__FILE__.':'.__LINE__.' Could not select from a table.');

		$first_capital_letters=array();
		while($row = mysql_fetch_row($result)){
			$row[0]=mb_strtoupper(mb_substr($row[0],0,1));
			if($row[0] && !isset($first_capital_letters[$row[0]]))
				$first_capital_letters[$row[0]]=$row[0];
		}
		sort($first_capital_letters);
		$abc='<a href="'.$_SERVER['PHP_SELF'].'?sort='.$sort.'&letter=">ALL</a>';
		foreach($first_capital_letters as $v){
			if($v<'A') continue;
			$abc.= ' <a href="'.$_SERVER['PHP_SELF'].'?sort='.$sort.'&letter='.$v.'">'.$v.'</a>';
		}
	}

        $tArr = explode(',', $sort);
	$OrderBy = $sort = ''; $k=2;
        for ($i = 0; ($i < count($tArr)) && $k; $i++){
                $tmp = $tArr[$i];
                if ($tmp >= count($order_by))
                	continue;
                for ($j = 0; $j < $i; $j++)
                        if (floor($tmp / 2) == floor($tArr[$j] / 2))
                                continue 2;
		$k--;
                $sort .= ",$tmp";
                $OrderBy .= ', '.$order_by[$tmp][0].$order_by[$tmp][1];
        }
        $sort = substr($sort, 1);
        $tArr = explode(',', $sort);
        $OrderBy = substr($OrderBy, 2);

	$SQLStr .= " ORDER BY $OrderBy";
	//echo "$SQLStr <br>\n";
        if(!($SQL = @mysql_query($SQLStr)))
        	_die2(__FILE__.':'.__LINE__." Could not select from requests table.");

	$start=0;
        $total = mysql_num_rows($SQL);
        if (isset($_GET['start']))
		$start = ereg_replace("[^0-9]", "", $_GET['start']);
        if ($start > $total)
		$start = $total - $total % $rpp;
        $start -= $start % $rpp;
        $myName = $_SERVER['PHP_SELF'];

	$colspan=count($OutputFormat);
?>

<script language='JavaScript'>
<!--

function cont_view_win_open(id){
  var nWin, URL = '';

  URL = root_dir + '/cust/cont_edit.php?id=' + id;

  nWin = window.open(URL, '_cont', 'menubar=1,resizable=1,scrollbars=1,' + getXY(700, 480, 'geomCONT'));

  if (!nWin) return alert('Your browser is currently set up to block pop-up windows.\nSince our allication uses this technology, please enable pop-ups\nfor this site and reload the page.');
  nWin.focus();
}

function cntrl_inp(form){
	if(form.fid.selectedIndex){
		form.new_filter.disabled=true;
		form.new_filter.style.visibility="hidden";
	}else{
		form.new_filter.disabled=false;
		form.new_filter.style.visibility="visible";
	}
}

function go(form) {
	if(!form.fid.selectedIndex){
		if (text_check(form.new_filter))
                	return alert("Please, enter new filter name.");
	}
        form.submit();
        disable_form(form);
}

function go_cb(form,action){
<?php
	$cbns=array();
        foreach(array_keys($OutputFormat) as $Title){
        	$Field=&$OutputFormat[$Title];
        	if(isset($Field['checkbox']) && $Field['checkbox']){
			$cbns[$Field['checkbox']]=$Title;
			echo '
	 if (action == "'.$Field['checkbox'].'") {
		if(!confirm(\'Are you sure you want to '.strtolower($Title).'?\'))
		return;
	 }';
	 	}
	}
?>

	form.checkbox.value=action;
	form.submit();
	disable_form(form);
}

//-->
</script>

<table width='95%' border=0 cellpadding=1 cellspacing=1 class='dgray' align='center'>
<form action='<?php echo $_SERVER['PHP_SELF']; ?>' method='post'>
<input type='hidden' name='saveFilter' value='saveFilter'>
<input type='hidden' name='sort' value='<?php echo $sort; ?>'>
<input type='hidden' name='start' value='<?php echo $start; ?>'>
<?php
	if($extra)
		echo '
<tr class="lgray">
	<th colspan="'.$colspan.'">'.$extra.'</th>
</tr>';
?>

<tr class="lgray">
        <td colspan="<?php echo $colspan; ?>" align="right">
        <input class="wbtn" type="button" value="refine" onClick="document.location='<?php echo $myName; ?>'" />
        <input class="wbtn" type="button" value="save as" onClick='go(this.form);' />
        <select class="selec" style="width: 20em" name="fid" onChange="cntrl_inp(this.form);">
                <option value="0">=NEW FILTER=</option>
<?php

        foreach($fls as $fid => $s){
        	if(!$this->is_rw($fid,FALSE))
        		continue;
                echo '
                <option value="'.$fid.'">'.html_safe_text($s).'</option>';
	}

?>

        </select>
        <input class="inp" type="text" name="new_filter" value="" size="32" maxlength="127" />&nbsp;&nbsp;&nbsp;
        [<a href="javascript:filters_open('<?php echo $this->rts_type; ?>')">Manage Saved Filters</a>]
	</td>
</tr>
</form>

<?php

	if($abc)
		echo '
<tr class="lgray">
	<td colspan="'.$colspan.'">'.($abct?"$abct: ":'').$abc.'</td>
</tr>';

	print "<tr class='separator'><td colspan=$colspan></td></tr>\n";
        print "<tr class='dgray' valign='middle'>\n";

        $i=$tArr[0];
        foreach(array_keys($OutputFormat) as $Title){
		$Field=&$OutputFormat[$Title];
		$align=isset($Field['align'])?$Field['align']:'left';
		if(isset($Field['sort_field']) && ($Field['sort_field']==$order_by[$i][0])){
			echo '
	<th align="'.$align.'"><img src="'.$order_by[$i][3].'">&nbsp;<a href="'.$myName.'?sort='.$order_by[$i][2].','.$sort.'">'.$Title.'</a></th>';
		}else{
			if(isset($Field['field']) && $Field['field']){
				for($j=0;$j<count($order_by);$j++)
					if($Field['sort_field']==$order_by[$j][0])
						break;
			echo '
	<th align="'.$align.'"><a href="'.$myName.'?sort='.$j.','.$sort.'">'.$Title.'</a></th>';
			}else
				echo '
	<th align="'.$align.'">'.$Title.'</th>';
		}
        }
        print "</tr>\n";

	if(count($cbns))
		echo '
	<form action="'.$_SERVER['PHP_SELF'].'" method="post">
	<input type="hidden" name="checkbox" value="">
	<input type="hidden" name="sort" value="'.$sort.'">
	<input type="hidden" name="start" value='.$start.'">';

        for($i = 0; $row = mysql_fetch_array($SQL, MYSQL_ASSOC); $i++){
                if ($i < $start) continue;
                if ($i >= ($start + $rpp)) break;

		$wfid=$this->rts_type;
                if($obj && method_exists($obj,'wfid'))
			$wfid=$obj->wfid();

                print "<tr class='lgray' onmouseover='this.className=\"lgs\";' onmouseout='this.className=\"lgray\";'>\n";

        	foreach(array_keys($OutputFormat) as $Title){
			$Field=&$OutputFormat[$Title];
			$align=isset($Field['align'])?$Field['align']:'left';
			$tmp='';$cbn='';
			if(isset($Field['checkbox']) && $Field['checkbox']){
				$cbn=$Field['checkbox'];
				$tmp=TRUE;
				if($Field['eval'] && $Field['eval'])
					eval($Field['eval']);

				$cbok=$tmp;
				$tmp='<input type="checkbox" class="inp" name="'.$cbn.'[]" value="'.$row['rid'].'"'.($cbok?'':' disabled').'>';
			}elseif(isset($Field['eval']) && $Field['eval']){
				eval($Field['eval']);
				//echo $Field['eval']." ----> $tmp<br>\n";
			}elseif(isset($Field['field']) && $Field['field'])
				$tmp=$row[$Field['field']];

			if(!$tmp)
				$tmp='';
                	echo '
	<td align="'.$align.'"'.($cbn?'':'onClick="'.$wfid.'_view_win_open('.$row['rid'].')"').'>'.$tmp.'</td>';
		}
                print "</tr>\n";
        }
        print "<tr class='separator'><td colspan=$colspan></td></tr>\n";
        print "<tr class='lgray'>\n";
        $from = ($i > 0) ? $start + 1 : 0;
        print " <td colspan=$colspan>We are currently displaying $from - ".$i." of a total $total request(s) found. You may refine your search by clicking on <a href='$myName'>this link</a>.</td>\n";
        print "</tr>\n";
        $pg_str=gen_pg_str("<a href='".$_SERVER['PHP_SELF']."?sort=$sort&start=%s&hlp=_post'>%s</a>",$start,$total,$rpp);
	if($pg_str)
		echo '
        <tr class="lgray">
        	<td colspan="'.$colspan.'" align="right">Result Page: <strong>'.$pg_str.'<strong></td>
        </tr>';

        if(count($cbns)){
        	echo '
        <tr class="lgray">
        	<td colspan="'.$colspan.'">';
		foreach($cbns as $k => $v)
			echo '
				<input type="button" class="btn_small" value="'.strtoupper($v).'" onClick="go_cb(this.form,\''.$k.'\')" >';
        	echo '
        		<input type="reset" class="btn_small" value="RESET">
        	</td>
        </tr>
        </form>';
	}
        print "</table>";
  }

}

} // USER_FILER_INC check
?>
