<?php #Calendar functions for project management
// $Header: /home/CVS/rps/includes/project/calendar.inc,v 1.20 2008/06/24 03:10:18 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('includes/wf.inc');

define('CDOFF_OPT_ANYYEAR',1);
define('CDOFF_OPT_ANYMONTH',1);

define('CDB_CREATE_CAL_DAYSOFF_TBL', "CREATE TABLE IF NOT EXISTS cal_daysoff
   (uid INT UNSIGNED DEFAULT 0 NOT NULL,
    start_date DATE,
    duration INT UNSIGNED DEFAULT 1 NOT NULL,
    comment TEXT,
    options INT UNSIGNED DEFAULT 0 NOT NULL,
        KEY (uid,start_date),
        FULLTEXT (comment),
        KEY (options)
   ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

if(!$GLOBALS['cmd_line_mode'] && $GLOBALS['uid']){

   $query = CDB_CREATE_CAL_DAYSOFF_TBL;
   if(!@mysql_query ($query))
	_die2(__FILE__.':'.__LINE__.' Could not create cal_daysoff table. ');

}

// tp - time pointer, seconds returned by time(0) function, possibly time zone adjusted.
//	When translated from ch will always point into a day
//	($work_day_start_hr,work_day_start_hr+$work_day_len_hr] segment
// ch - calendar hour (from 1970). Used for internal calculations only and actually
//	always points into [$work_day_start_hr,$$work_day_start_hr+work_day_len_hr) segment.
// cd - calendar day (from 1970).
// wh - work hour. Each resource is viewed as one having N continious hours available
//	for work. wh points to one hour within [0..N] and basically tells how many hours
//	have already been used. Each wh within [0..N] maps to a calendar hour
//	(different days that are not weekends, vacations, or blocked by some other tasks).

class Calendar {

	// To make my time pointer (tp) show seconds from 1/1/1970 in clients time zone (not GMT)
	// Adjust TZ difference to GMT and client's TZ difference
	// Later substruct $tz_shift from local server $tp (time()) to get the client's $tp.
	var $tz_shift;
	//echo "tz_shift=$this->tz_shift <br>";
	var $a2b_wday=array();
	var $uid_off_days_2d=array();
	var $uid_wrk_days_2d=array();
	var $start_day=0;
	var $end_day=0;
	var $work_day_start_hr=8;
	var $work_day_len_hr=8;
	var $pid=0;
	var $rel_id=0;
	var $dlimit=180;

	function calendar(){

		//echo "client_minus_mine=".$_SESSION['client_minus_mine']." <br>\n";
		$this->tz_shift=mktime(0,0,0,1,1,1970)-(isset($_SESSION['client_minus_mine'])?$_SESSION['client_minus_mine']:0);
		$this->a2b_wday['Sunday']=2;
		$this->a2b_wday['Monday']=FALSE;
		$this->a2b_wday['Tuesday']=FALSE;
		$this->a2b_wday['Wednesday']=FALSE;
		$this->a2b_wday['Thursday']=FALSE;
		$this->a2b_wday['Friday']=FALSE;
		$this->a2b_wday['Saturday']=1;
		$this->uid_off_days_2d=array();
		$this->uid_wrk_days_2d=array();
		$this->uid_impl_days_2d=array();
		$this->uid_test_days_2d=array();
		$this->start_day=0;
		$this->end_day=0;
		$this->work_day_start_hr=8;
		$this->work_day_len_hr=8;
		//echo "Init Calendar class <br>";

		$query="SELECT uid, start_date, duration FROM cal_daysoff WHERE duration>0 AND DATE_ADD(start_date,INTERVAL duration-1 DAY)>=CURDATE()";
		//$query="SELECT uid, UNIX_TIMESTAMP(start_date) AS sutm, duration FROM cal_daysoff WHERE duration>0";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from cal_daysoff table.');

		//$tcd=$this->tp2cd();

		while($row=mysql_fetch_array($result, MYSQL_ASSOC)){
			$cd=$this->date2cd(date_sql2norm($row['start_date']));
			//if(($cd+$row['duration']-1)<$tcd)
			//	continue;

			if(!isset($this->uid_off_days_2d[$row['uid']]))
				$this->uid_off_days_2d[$row['uid']]=array();

			//echo $this->cd2date("m/j/Y",$cd);
			//echo $this->cd2date("m/j/Y",$cd+$row['duration']-1);

			for($i=0;$i<$row['duration'];$i++)
				arr_push($this->uid_off_days_2d[$row['uid']],$cd+$i);
		}
	}

	// Input server TZ based time pointers. That are returned by time() function.
	function init( $start_ch, $end_ch, $users, $booked_time_sql=FALSE){
		global $all_users_2d;

		$this->booked_time_sql=$booked_time_sql;

		//echo "init: $start_ch ".$this->ch2date("Y-m-j H",$start_ch).", $end_ch ".$this->ch2date("Y-m-j H",$end_ch)." <br>";

		if($start_ch>$end_ch)
			_die(__FILE__.':'.__LINE__.' start_tp is greater than end_tp in calendar initialization.');

		$this->start_day=intval($start_ch/HOURS_IN_DAY);
		$this->end_day=intval($end_ch/HOURS_IN_DAY);

		//echo "ca days: $this->start_day -> $this->end_day <br>";
		//echo $this->ch2date("H\h, m/j/Y",$this->start_ch())."<br>\n";
		//echo $this->ch2date("H\h, m/j/Y",$this->end_ch())."<br>\n";

		if($this->end_day>($this->start_day+$this->dlimit()))
			_quit_error(__FILE__.':'.__LINE__.' Requested calendar period is too long: ('.$this->ch2date("m/j/Y",$start_ch).','.$this->ch2date("m/j/Y",$end_ch).').');

		if(!$users)
			_die2(__FILE__.':'.__LINE__.' User list is not provided.');

		if(!in_array(0,$users))
			array_push($users,0);

		if($this->booked_time_sql){
			//echo "$this->booked_time_sql <br>\n";
			if(!($result=@mysql_query($this->booked_time_sql)))
				_die2(__FILE__.':'.__LINE__.' Could not select from projects table.');

			while($row=mysql_fetch_array($result, MYSQL_ASSOC)){
				//print_r($row);
				if(!$row['ph1_is_done']){
					for($d=$this->tp2cd($row['ph1_start']);$d<=$this->tp2cd($row['ph1_end']);$d++)
						$this->uid_impl_days_2d[$row['ph1_fixer']][$d]=$row['rid'];
				}

				if(!isset($row['ph2_fixer']) || !$row['ph2_fixer'])
					continue;

				// May be fixed but not verified
				for($d=$this->tp2cd($row['ph2_start']);$d<=$this->tp2cd($row['ph2_end']);$d++)
					$this->uid_test_days_2d[$row['ph2_fixer']][$d]=$row['rid'];

				//foreach($this->uid_impl_days_2d as $u => $v)
				//	foreach($v as $d => $r)
				//		echo "fixer=$u, implements $r on cal_day=$d ".$this->cd2date("Y-m-j",$d)."<br>\n";
			}
		}

		foreach($users as $uid){
			//echo "init: uid=$uid <br>";
			$this->uid_wrk_days_2d[$uid]=array();
			for($day=$this->start_day;$day<$this->end_day;$day++){
				if($this->is_dayoff($uid,$day) || isset($this->uid_impl_days_2d[$uid][$day]) || isset($this->uid_test_days_2d[$uid][$day]))
					continue;

				array_push($this->uid_wrk_days_2d[$uid], $day);
			}
			//foreach($this->uid_wrk_days_2d[$uid] as $i => $d)
			//	echo "**init: uid=$uid wday=$i cday=$d ".$this->cd2date("Y-m-j",$d)."<br>";
		}
		return $start_ch;
	}

	function is_dayoff($uid,$cday){
		$day_arr=getdate($this->cd2tp($cday,TRUE,__LINE__));
                if($this->a2b_wday[$day_arr['weekday']])
			return TRUE;

		// Company wide holidays
		if(isset($this->uid_off_days_2d[0]) && in_array($cday,$this->uid_off_days_2d[0]))
			return TRUE;

		// Personal time off
		if(isset($this->uid_off_days_2d[$uid]) && in_array($cday,$this->uid_off_days_2d[$uid]))
			return TRUE;

		return FALSE;
	}

	function construct_toff_ranges($uid,$from_tp,$to_tp){
		$fcday=$this->tp2cd($from_tp);
		$tcday=$this->tp2cd($to_tp);

		$doff=array();
		if(isset($this->uid_off_days_2d[$uid]))
			$doff=$this->uid_off_days_2d[$uid];

		sort($doff,SORT_NUMERIC);

		if(isset($this->uid_off_days_2d[0])){
			foreach($this->uid_off_days_2d[0] as $cday)
				arr_push($doff,$cday);
		}

		$ranges=array();
		$sd=$ed=FALSE;
		for($i=0;$i<count($doff);$i++){
			if($doff[$i]<$fcday)
				continue;
			if($doff[$i]>$tcday)
				continue;
			if(!$sd){
				$sd=$ed=$doff[$i];
				continue;
			}

			if($doff[$i]==$doff[$i-1]+1)
				$ed=$doff[$i];
			else{
				array_push($ranges,array($this->cd2date("Y-m-j",$sd),$this->cd2date("Y-m-j",$ed)));
				$sd=$ed=$doff[$i];
			}
		}
		if($sd && $ed)
			array_push($ranges,array($this->cd2date("Y-m-j",$sd),$this->cd2date("Y-m-j",$ed)));

		return $ranges;
	}

	function add_toff($uid,$sdate,$tlen,$comment){

		$sdate=date_norm2sql($sdate);
		if(simple_query("SELECT duration FROM cal_daysoff WHERE uid=$uid AND start_date='$sdate' AND duration=$tlen LIMIT 1"))
			return;

		$query="INSERT INTO cal_daysoff (uid, start_date, duration, comment) VALUES ($uid, '$sdate', $tlen, '".escape_data($comment)."')";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into cal_daysoff table.');
	}

	function remove_toff($uid,&$toffs){
		if(!is_array($toffs) || !count($toffs))
			return FALSE;

		$sql_ands=array();
		foreach($toffs as $str){
			$a=explode(':',$str);
			if(count($a)!=2)
				continue;

			arr_push($sql_ands,"(start_date='".date_norm2sql($this->cd2date("m/j/Y",$a[0]))."' AND duration=".$a[1].")");
		}

		if(!count($sql_ands))
			return FALSE;

		$query="DELETE FROM cal_daysoff WHERE uid=$uid AND (".implode(' OR ',$sql_ands).")";
		//echo "$query <br>\n";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into cal_daysoff table.');
	}

	var $toff_iterator='';
	function first_toff($uid){

		if($this->toff_iterator)
			mysql_free_result($this->toff_iterator);

		$query="SELECT start_date, duration, comment FROM cal_daysoff WHERE uid=$uid AND duration>0 AND DATE_ADD(start_date,INTERVAL duration-1 DAY)>CURDATE()";
		//$query="SELECT start_date, duration, comment FROM cal_daysoff WHERE uid=$uid AND duration>0";
		//echo "$query <br>\n";
		if(!($this->toff_iterator=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from cal_daysoff table.');

		return mysql_fetch_array($this->toff_iterator, MYSQL_ASSOC);
	}

	function next_toff(){
		if(!$this->toff_iterator)
			return FALSE;

		return mysql_fetch_array($this->toff_iterator, MYSQL_ASSOC);
	}

	function total_wdays($uid){
		return count($this->uid_wrk_days_2d[$uid]);
	}

	function ch2whp($uid, $hr, $within_work_hrs=TRUE, $dbg_str=''){

		if($dbg_str)
			$dbg_str="ch2whp[$dbg_str] ";
		else
			$dbg_str="ch2whp ";

		//echo $this->ch2date("Y/m/j H:00",$hr);

		$h=$hr % HOURS_IN_DAY;
		$day=($hr - $h)/ HOURS_IN_DAY;

		if($h>=$this->work_day_start_hr+$this->work_day_len_hr){
			if($within_work_hrs)
				_warning($dbg_str."(out of range ch) #1: $hr % ".HOURS_IN_DAY." = $h.");
			$h=$this->work_day_len_hr-1;
		}elseif($h<$this->work_day_start_hr){
			if($within_work_hrs)
				_warning($dbg_str."(out of range ch) #2: $hr % ".HOURS_IN_DAY." = $h.");
			$h=0;
		}else
			$h-=$this->work_day_start_hr;

		//echo " in ch2whp: uid=$uid hr=$hr cday=$day extra=$h / cend_day=$this->end_day cend=".$this->ch2date("Y/m/j H:00",$this->end_ch())."<br>";

		if($day>=$this->end_day)
			return -1;

		for($gcd=$day;$gcd<$this->end_day;$gcd++){
			//echo "*ch2whp2: cday=$day compare_in_cday=$gcd<br>";
			if(($wd=array_search($gcd,$this->uid_wrk_days_2d[$uid]))!==FALSE){
					$r= $wd*$this->work_day_len_hr+$h;
					//echo "ch2whp: out ch2whp4: wd=$wd, cd=".$this->cd2date("Y/m/j H:00",$gcd).", wh=$r <br>";
					return $r;
			}
		}
		//_die2(__FILE__.':'.__LINE__.' ch2whp: This should never happen.');
		// No working days for this uid <from $day to $this->end_day>
		//echo " !!!!!!!!!!!! ch2whp returning -1 <br>";
		return -1;
	}

	function whp2ch($uid, $whp, $strict=FALSE){

		$h=$whp % $this->work_day_len_hr;
		$wrk_day=($whp - $h) / $this->work_day_len_hr;

		$l=$this->total_wdays($uid);
		$th=$l*$this->work_day_len_hr;
		if($l==0)
			return(-1);
		//echo "in whp2ch: uid=$uid wh=$whp wd=$wrk_day total_days=$l extra_hrs=$h <br>";

		if($whp>=$th){
			//echo "out whp2ch: whp=$whp th=$th <br>";
			if($strict)
				return(-1);
			else{
				$exh=$whp-$th;
				$h = $exh % $this->work_day_len_hr;
				$exd=($exh - $h) / $this->work_day_len_hr;
				$day=$this->uid_wrk_days_2d[$uid][$l-1]+$exd+1;
				// estimating beyond the calendar
				$ch=$day*HOURS_IN_DAY+$this->work_day_start_hr+$h;
				return($ch);
			}
		}

		$day=$this->uid_wrk_days_2d[$uid][$wrk_day];
		$ch=$day*HOURS_IN_DAY+$this->work_day_start_hr+$h;
		//echo "out whp2ch: cday=$day chr=$ch<br>";
		return $ch;

	}

	function extend($uid,$from_ch,$by_wh=FALSE){

		if(!$by_wh)
			$by_wh=7*$this->work_day_len_hr;

		$only_users=array_keys($this->uid_wrk_days_2d);
		if($from_ch>$this->end_ch())
			$this->init($this->start_ch(),$from_ch,$only_users,$this->booked_time_sql);

		$from_whp=$this->ch2whp($uid,$from_ch);
		$h=$by_wh % $this->work_day_len_hr;
		$wrk_day=($by_wh - $h) / $this->work_day_len_hr;
		while($this->whp2ch($uid,$from_whp+$by_wh,TRUE)<0){
			//echo "cal, extend: uid=$uid, from_ch=$from_ch, from_whp=$from_whp, by_wh=$by_wh <br>\n";
			$this->init($this->start_ch(),$this->end_ch()+($wrk_day+1)*HOURS_IN_DAY,$only_users,$this->booked_time_sql);
		}
	}

	function end_ch(){
		return $this->end_day*HOURS_IN_DAY+$this->work_day_start_hr+$this->work_day_len_hr-1;
		//$this->work_day_len_hr;
	}

	function start_ch(){
		if(!$this->start_day)
			_quit_error("The calendar has not been initialized yet.");

		return $this->start_day*HOURS_IN_DAY+$this->work_day_start_hr;
	}

	function dlimit(){
		return $this->dlimit;
	}

	function limit_ch($sch=FALSE){
		if($sch)
			return $sch+($this->dlimit()-1)*HOURS_IN_DAY;

		return $this->start_ch()+($this->dlimit()-1)*HOURS_IN_DAY;
		//$this->work_day_len_hr;
	}

	function ch2date($format,$hr,$within_work_hrs=TRUE,$dbg_str=''){
		$tp=$this->ch2tp($hr,$within_work_hrs,$dbg_str);
		return date($format,$tp);
	}

	function ch2tp($hr,$within_work_hrs=TRUE,$dbg_str=''){
		if($dbg_str)
			$dbg_str="ch2tp[$dbg_str] ";
		else
			$dbg_str="ch2tp ";

		$h=$hr % HOURS_IN_DAY;
		$day=($hr - $h) / HOURS_IN_DAY;

		if(!$within_work_hrs)
			return $hr*SECS_IN_HOUR+$this->tz_shift;

		if($h>=$this->work_day_start_hr+$this->work_day_len_hr){
			_warning($dbg_str."(out of range ch) #1: $hr % ".HOURS_IN_DAY." = $h.");
			$h=$this->work_day_start_hr+$this->work_day_len_hr-1;
		}elseif($h<$this->work_day_start_hr){
			_warning($dbg_str."(out of range ch) #2: $hr % ".HOURS_IN_DAY." = $h.");
			$h=$this->work_day_start_hr;
		}

		$tp=$day*SECS_IN_DAY+$h*SECS_IN_HOUR+$this->tz_shift;
		return($tp);
	}

	function cd2tp($cd,$within_wrk_hrs=TRUE,$dbg_str=''){
		$ch=$cd*HOURS_IN_DAY;
		if($within_wrk_hrs)
			$ch+=$this->work_day_start_hr;

		return $this->ch2tp($ch,$within_wrk_hrs,$dbg_str)+$this->tz_shift;
	}

	function cd2date($format,$cd){
		return(date($format,$this->cd2tp($cd)));
	}

	function date2ch($date=FALSE){
		if($date && !is_date($date))
			_die("date2ch: not a date $date.");

		if($date){
			$darr=explode('/',$date);
			$tp=mktime($this->work_day_start_hr,0,0,$darr[0],$darr[1],$darr[2]);
		}else
			$tp=time();
		return $this->tp2ch($tp);
	}

	function date2tp($date=FALSE){
		return $this->ch2tp($this->date2ch($date));
	}

	function tp2ch($tp,$within_work_hrs=TRUE){
		$hr=intval(($tp-$this->tz_shift)/SECS_IN_HOUR);
		$h=$hr % HOURS_IN_DAY;
		$day = ($hr-$h) / HOURS_IN_DAY;
		//echo "adjust_tp ch=$hr h=$h<br>";

		if(!$within_work_hrs)
			return $day*HOURS_IN_DAY+$h;

		if(($h>=$this->work_day_start_hr) && ($h<$this->work_day_start_hr+$this->work_day_len_hr))
			$nch=$day*HOURS_IN_DAY+$h;
		elseif($h<$this->work_day_start_hr)
			$nch=$day*HOURS_IN_DAY+$this->work_day_start_hr;
		else
			$nch=($day+1)*HOURS_IN_DAY+$this->work_day_start_hr;
		//echo "adjust_tp out ch=$nch <br>";
		return $nch;
	}

	function wh2date($format, $uid, $wrk_hr){
	  $hr=$this->whp2ch($uid, $wrk_hr);
	  return $this->ch2date($format,$hr);
	}

	function total_whs($uid){
		return count($this->uid_wrk_days_2d[$uid])*$this->work_day_len_hr;
	}

	function tp2cd($tp=FALSE){
		if(!$tp)
			$tp=time();
		return intval(($tp-$this->tz_shift)/SECS_IN_DAY);
	}

	function date2cd($date){
		$darr= explode('/',$date);
		$dtp=mktime(0, 0, 0, $darr[0], $darr[1],$darr[2])+$this->tz_shift;
		return $this->tp2cd($dtp);
	}

	function first_work_cd(){
		$today_cd=$this->tp2cd();
		$min_wcd=$this->end_day;
		foreach($this->uid_wrk_days_2d as $uid2day)
			foreach($uid2day as $cd){
				//echo "cd=$cd ".$this->cd2date("Y-m-j",$cd)."<br>\n";
				if(($cd<$min_wcd) && ($cd>$today_cd))
					$min_wcd=$cd;
			}
		//echo "cd=$min_wcd ".$this->cd2date("Y-m-j",$min_wcd)."<br>\n";
		return($min_wcd);
	}
}
?>
