<?php
// $Header: /home/CVS/rps/includes/project/plan_header_inc.php,v 1.25 2008/05/06 18:20:38 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

  $show_tbl=FALSE;
  $tbl_lines='';
  $owner_voted=$uid_voted=FALSE;
  $can_go_next=0;

  if($is_proj_member){

//
// CHECK #1: There are requests in the plan
//

	if($num_of_rids<1)
		$pps->add_alert(ALERT_TODO,"<strong>Add requests/tasks to your plan!</strong>","Use the control panel below to filter through your backlog and find the requests you want to add into your plan.<br>You can also quickly create a new request or add an existing one if you know its ID. ");

//
// CHECK #2: Project members have done prioritization (at least project owner).
// CHECK #2: (applies only when in auto-ordering mode)
//
	$uid2rids=&$pps->members_without_vote();
	if(!in_array($pps->proj_owner(),array_keys($uid2rids)))
		$owner_voted=TRUE;

	if(!in_array($uid,array_keys($uid2rids)))
		$uid_voted=TRUE;

	//print_r($uid2rids);
  	$t=array();
	foreach (array_keys($uid2rids) as $u) {
		$pr_list_str=implode(', ',$uid2rids[$u]);
		if($u==$uid)
			continue;

		$s='<input type="button" class="nbtn" onClick="remind_open('.$proj_id.','.$u.','.REMIND_MEMPRI.')" name="" value="Remind '.YxlUsers::name($u).'">';
		array_push($t,'
<tr>
	<td align="center">'.$pr_list_str.'</td>
</tr>
<tr>
	<td align="center">'.$s.'</td>
</tr>');
	}

	if(count($t)){
		$tbl_lines='
<table width="100%" border=0 cellpadding=0 cellspacing=1>
<tr>
	<th>
		<u>'.$Project['proj_title'].' members that have not done the prioritization.</u>
	</th>
</tr>'.implode("\n",$t).'
</table><br>';
	}

	$imvm=$pps->in_manual_ordering_mode();
	if($owner_voted || ($is_proj_owner && $imvm))
		$can_go_next++;

	if(!$uid_voted){
		if($is_proj_owner){
			if(!$imvm)
				$pps->add_alert(ALERT_TODO,"<strong>Please express your opinion regarding the priorities.</strong>","The voting will help to automatically sort the tasks in your plan.<br>Select your priority for each request (high, medium, low) and click 'update' button.",$tbl_lines);
		}else
			$pps->add_alert(ALERT_WARN,"<strong>Please express your opinion regarding  the priorities.</strong>","The voting will help your project owner to sort the current list of tasks.<br>Select your priority for each request (high, medium, low) and click 'update' button.",$tbl_lines);
	}

//
// CHECK #3: All requests from the plan have been estimated (at least by one resource).
// 

	$t=array(); $tbl_lines=''; $no_estimates=FALSE; $uid_to_estimate=FALSE;
	$ph2check_type=array(1 => REMIND_NOFET, 2 => REMIND_NOTET);
	$ph2check_show=array(1 => 'ef', 2 => 'et');
	for($ph=1;$ph<=$pps->get_phase_num();$ph++){
		$spec=$user_spec2str[$pps->get_phase_info($ph,'implementer_spec')];
		$uid2rids=&$pps->rids_wihtout_any_estimate($ph);
		$users=array_keys($uid2rids);
		if(count($users)>0)
			$no_estimates=$ph;

		if(in_array($uid,$users))
			$uid_to_estimate=$ph;


		$t=array();
		foreach($users as $u){
			if($u==$uid)
				continue;

			array_push($t,'
		<input type="button" class="nbtn" onClick="remind_open('.$proj_id.','.$u.','.$ph2check_type[$ph].')" name="" value="Remind '.YxlUsers::name($u).'">');
		}

		if(count($t)<1)
			continue;

		$prs=implode(', ',$uid2rids[$users[0]]);

		$tbl_lines.='
<table width="100%" border=0 cellpadding=0 cellspacing=1>
<tr>
	<th colspan=2><u>Requests that were not estimated by any ('.$spec.') resource.</u></th>
</tr>
<tr>
	<td align="center">'.$prs.'</td>
</tr>
<tr>
	<td align="center">'.implode(' ',$t).'</td>
</tr>
</table><br>';
	}

	if($no_estimates){
		if($uid_to_estimate)
			$pps->add_alert(ALERT_TODO,"<a href=\"$dir_name".$Project['estimate_script']."?proj_id=$proj_id&pr_list_type=mid\">&gt;&gt; Please enter time estimates. &lt&lt;</a>","Individual request/task estimates help the system to compute time and predict how long the project may take.<br>Enter your own estimates or remind the request/task owners to do so.",$tbl_lines);
		else
			$pps->add_alert(ALERT_WARN,"<strong>Some requests/tasks have not been estimated by anyone.</strong>","Check the details below and remind the requests/tasks owners to estimate their effort.",$tbl_lines);
	}else
		$can_go_next++;
  }

//
// CHECK #4 non-gating: Gather info of requests without estimates by their owners.
// 

   $ph2check_type=array(1 => REMIND_FET, 2 => REMIND_TET);
   for($ph=1;$ph<=$pps->get_phase_num();$ph++){
   	$spec_id=$pps->get_phase_info($ph,'implementer_spec');
	$spec=$user_spec2str[$spec_id];
   	$owner2rids=array();
   	for($i=0;$i<count($pps->ordered_plan);$i++){
   		$row=&$pps->ordered_plan[$i][0];
		$phfixer=$pps->plan_req_info($i,'phase_fixer',$ph);

		if($pps->user_has_et($ph,$row['rid'],$phfixer))
			continue;

		if(!isset($owner2rids[$phfixer]))
			$owner2rids[$phfixer]=array();

		arr_push($owner2rids[$phfixer],$row['rid']);
	}

	$t=array();
	foreach (array_keys($owner2rids) as $u){
		$s='
		<input type="button" class="nbtn" onClick="remind_open('.$proj_id.','.$u.','.$ph2check_type[$ph].')" name="" value="Remind '.YxlUsers::name($u).'"> ';

		array_push($t,'
<tr>
	<td align="center">'.implode(', ',$owner2rids[$u]).'</td>
</tr>
<tr>
	<td align="center">'.$s.'</td>
</tr>
');
	}

	if(count($t)){
		$tbl_lines.='
<table width="100%" border=0 cellpadding=0 cellspacing=1>
<tr>
	<th><u>('.$spec.') owners that have not estimated their effort.</u></th>
</tr>'.implode("\n",$t).'
</table><br>';

		if(in_array($uid,array_keys($owner2rids)))
			$uid_to_estimate=$ph;
		else
			$uid_to_estimate=TRUE;
	}
   }

/*
  	$t=array(); $tbl_lines=''; $uid_to_estimate=FALSE;
	$ph2check_type=array(1 => REMIND_FET, 2 => REMIND_TET);
	for($ph=1;$ph<=$pps->get_phase_num();$ph++){
		$spec_id=$pps->get_phase_info($ph,'implementer_spec');
		$spec=$user_spec2str[$spec_id];
		$uid2rids=&$pps->users_wihtout_rid_estimate($ph);
		foreach (array_keys($uid2rids) as $u){
			if($u==$uid)
				continue;

			$s='
		<input type="button" class="nbtn" onClick="remind_open('.$proj_id.','.$u.','.$ph2check_type[$ph].')" name="" value="Remind '.$all_users_2d['name'][$u].'"> ';

			array_push($t,'
<tr>
	<td align="center">'.implode(', ',$uid2rids[$u]).'</td>
</tr>
<tr>
	<td align="center">'.$s.'</td>
</tr>
');
		}

		if(count($t)){
			$tbl_lines.='
<table width="100%" border=0 cellpadding=0 cellspacing=1>
<tr>
	<th><u>('.$spec.') resources that have not estimated their effort.</u></th>
</tr>'.implode("\n",$t).'
</table><br>';
			$t=array();

			if(in_array($uid,array_keys($uid2rids)))
				$uid_to_estimate=$ph;
			else
				$uid_to_estimate=TRUE;
		}
	}

	if($uid_to_estimate){
		if($uid_to_estimate!==TRUE)
			$pps->add_alert(ALERT_INFO,"<strong>Some requests/tasks have not been estimated by their owners.</strong>","Check the details below and remind the participants to estimate their effort.",$tbl_lines);
		else
			$pps->add_alert(ALERT_INFO,"<a href=\"$dir_name".$Project['estimate_script']."?proj_id=$proj_id\">&gt;&gt; Please enter time estimates. &lt&lt;</a>","Individual request/task estimates help the system to compute time and predict how long the project may take.<br>Enter your own estimates and encourage all involved in the project to do the same.",$tbl_lines);
	}
*/

//
// CHECK #5: Deadline conflict?
// 
	if($is_proj_member){
		if($proj_has_conflicts)
  			$pps->add_alert(ALERT_TODO,"<strong>Deadline conflict!</strong>","There does not seem to be enough time to finish all the requests/tasks in the list (given the deadline and the current resource allocation).<br>Make sure the time sharing parameters and time estimates are entered correctly.<br>Consider balancing the resource load, adjusting the deadline date or reducing the number of tasks in the list.",$tbl_lines);
		else
			$can_go_next++;

  		if($is_proj_owner)
  			$pps->add_alert(ALERT_INFO,"<strong>Optimize or start implementing!</strong>","You can try optimizing the plan by changing resource assignment (encourage all request/task owners to enter  their estimates).<br>See if you would like to account for any dependencies between the tasks.<br>Once you are satisfied with the predicted schedule click 'implement' button above to start the implementation phase.",$tbl_lines);
  		else
  			$pps->add_alert(ALERT_INFO,"<strong>Optimize or start implementing!</strong>","You can try optimizing the plan by changing resource assignment (make sure all request/task owners have entered their estimates).<br>See if you would like to account for any dependencies between the tasks.<br>At this point the project owner can initiate the implementation phase.",$tbl_lines);

	}

  $show_next=$is_proj_owner && ($can_go_next==3) && ($num_of_rids>0);
  $pps->view_menu(PROJ_MENU_MAIN,$Project,$is_proj_owner,$show_next);
  $pps->show_alert();
?>
