<?php
// $Header: /home/CVS/rps/includes/rps/rps.inc,v 1.46 2008/06/30 02:20:54 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('includes/rts/bts.inc');
require_once('includes/project/pps.inc');

	define ('CDB_CREATE_RPS_HISTORY_TBL', "CREATE TABLE IF NOT EXISTS rps_history
	    (hid INT UNSIGNED NOT NULL AUTO_INCREMENT,
	    proj_id int UNSIGNED default NULL,
	    uid int UNSIGNED default NULL,
	    state VARCHAR(64) NOT NULL,
	    date DATETIME,
	    descr text,
	    type INT UNSIGNED DEFAULT 0 NOT NULL,
	    xid INT UNSIGNED DEFAULT NULL,
	    xid2 INT UNSIGNED DEFAULT NULL,
	    xid3 INT UNSIGNED DEFAULT NULL,
	    PRIMARY KEY (hid),
		KEY (proj_id),
		KEY (uid),
		KEY (state),
		KEY (date),
		FULLTEXT (descr),
		KEY (type),
		KEY (xid)
	    ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

if(!$GLOBALS['cmd_line_mode'] && $GLOBALS['uid']){
	$query = CDB_CREATE_RPS_HISTORY_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create rps_history table. ');
}

class ReleasePlan extends ProjectPlan {

	var $release_info;
	var $mail_headers='';
	var $rel_id=0;
	var $log=array();
	var $rid2row=array();
	var $rid2dep=array();
	var $dep2rid=array();
	var $class2str=array();
	var $inr='';


	function releaseplan($rel_id=FALSE, $full_mode=TRUE, $ts_overlap_mode=FALSE){
		global $MyDomain;
		global $MyCName;

		$wcal_users=array();

		$this->rts = new BugTracker;
		$this->products_2d=&$this->rts->products_2d;

                $object_params=array(
		'class_tag' => 'rps',

                'history_tbl' => $this->rts->object_params['history_tbl'],
                'history_proj_decommit_type' => HISTORY_TYPE_RPS_DECOMMIT,
                'history_proj_plan_type' => HISTORY_TYPE_RPS_PLAN,

                'pnets_tbl' => $this->rts->object_params['pnets_tbl'],
                'pnet_type_pri' => $this->rts->object_params['pnet_type_pri'],
                'pnet_type_ts' => PNET_TYPE_SHARE,

                'pq_tbl' => $this->rts->object_params['pq_tbl'],
                'pq_fn' => $this->rts->object_params['pq_fn'],

                'proj_id' => $rel_id,
                'proj_tbl' => 'releases',
                'proj_class_mask' => $this->rts->rps_class_mask,
                'proj_deadline_fn' => 'release_deadline',
                'proj_id_fn' => 'rel_id',
                'proj_mem_type' => MEMB_TYPE_RELEASE,
                'proj_history_tbl' => 'rps_history',
		'proj_title' => 'Release',

                'requests_tbl' => $this->rts->object_params['requests_tbl'],
                'req_in_proj_fn' => $this->rts->object_params['req_in_proj_fn'],
                'req_proj_id_fn' => $this->rts->object_params['req_proj_id_fn'],
                'req_proj_pri_fn' => 'release_pri',
                'req_classes' => $this->rts->classes,
                'req_last_state_mask' => $this->rts->last_state_mask,
                'pm_phases' =>
                	array(
                		array(
                		'proj_state' => 'implement',
                		'mgr_fn' => 'rnd_mgr',
                		'implementer_fn' => 'fixer_uid',
                		'implementer_spec' => USPEC_RND,
                		'dflt_fix_fn' => 'dflt_fix_time',
                		'start_state_mask' => $this->rts->inwork_state_mask,
                		'done_state_mask' => $this->rts->fixed_state_mask,
                		'plan_start_fn' => 'plan_fix_start',
                		'plan_done_fn' => 'plan_fix_end',
                		'start_fn' => 'inwork_date',
                		'done_fn' => 'fixed_date',
                		'pnet_type' => PNET_TYPE_FIX
                		),
                		array(
                		'proj_state' => 'test',
                		'mgr_fn' => 'qa_mgr',
                		'implementer_fn' => 'tester_uid',
                		'implementer_spec' => USPEC_QA,
                		'dflt_fix_fn' => 'dflt_test_time',
                		'start_state_mask' => FALSE,
                		'done_state_mask' => $this->rts->verified_state_mask,
                		'plan_start_fn' => 'plan_test_start',
                		'plan_done_fn' => 'plan_test_end',
                		'start_fn' => FALSE,
                		'done_fn' => 'verified_date',
                		'pnet_type' => PNET_TYPE_TEST
                		)
                	)
                );

		$this->mail_headers=email_header_From('RPS');
		$this->proj_m_sign = " Please make sure that your browser has pop-up blocking disabled for this site.\n\n
								Sincerely,
								Release Planning System";

		parent::projectplan($object_params,$full_mode,$ts_overlap_mode);
		unset($this->class2str[$this->rts->bug_class]);
		$this->release_info=&$this->project_info;

		if(defined('YXL_RPS_RDETECTION') && (YXL_RPS_RDETECTION=='pqmgr'))
			$this->rdetection_mode=1;
	}

	function file_request($class,$pid,$synop,$phase_of_rid,$depends_on){
		$fields=array();
		$fields['class']=$class;
		$fields['pid']=$pid;
		$fields['synopsis']=$synop;
		$fields['description']=' Preliminary RPS request: '.$synop;
		if($phase_of_rid)
			$fields['phase_of_rid']=$phase_of_rid;
		if($depends_on)
			$fields['depends_on']=$depends_on;
		$fields['options']=REQ_OPT_RPSTMP;
		return $this->rts->file_request($fields);
	}

	function is_rel_member($uid){
		return $this->is_proj_member($uid);
	}

	function email_rel_members($subject, $body){
		return $this->email_proj_members($subject, $body);
	}

	function compute_plan(){
		return $this->compute_plan_2();
	}

	function delete_release(){
		return $this->delete_project();
	}

	function _dashboard_intro($did,$uid,$info=FALSE){
		global $dir_name;
                global $is_customer;

                if($info)
                        return array('header' => 'Release Management System (Intro)',
                                'default_size' => 2,
                                'type' => 'table/text',
                                'only' => 'sw/rps');

                $tbl_str='
	<table border=0 cellpadding=0 cellspacing=1 width="100%" class="dgray" align="center">
	<tr style="height: 1" class="separator">
		<td></td>
	</tr>
	<tr class="lgray">
		<td>
	<p>The system allows you to:
	<ul>
		<li>Collaboratively <a href="'.$dir_name.'/rps/rps_status.php" style="text-decoration: underline">create a release plan</a> based on deadline, effort estimates, and priorities.</li>
		<li>Track implementation of the release</li>
		<li>Track testing phase of the release</li>
		<li>Generate various release reports</li>
	</ul>
	</p>
	<p>To see a list of all ongoing and finished releases please go to the <a href="'.$dir_name.'/rps/rps_status.php" style="text-decoration: underline">summary</a> page. There you will be able to:
	<ul>
		<li>Start a new release</li>
		<li>See status of releases in progress</li>
		<li>See summary reports for finished releases</li>
	</ul>
	</p>
	</td>
	</tr>
	</table>';
		return $tbl_str;
	}

	function _dashboard_requests2close($did,$uid,$info=FALSE){
		global $is_customer;

		if($is_customer)
			return FALSE;

		if(prereq_check('pps_no_projects'))
			return FALSE;

		if($info){
			return array('header' => 'Release requests you need to close',
				'default_size' => 1,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => '#requests to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
		}
		if(!$lim) $lim=5;

		$pq_sn=$this->rts->object_params['pq_title'];
		$sub_pq_sn=$this->rts->object_params['sub_pq_title'];
		$tbl_str='';

		$query="SELECT r.rid, CONCAT(c.name,'/',r.synopsis), r.state, CONCAT(p.name,'&nbsp;',rl.label) FROM releases AS rl INNER JOIN products AS p ON rl.pid=p.pid INNER JOIN requests AS r ON rl.rel_id=r.release_id AND r.in_release='yes' INNER JOIN products AS c ON r.pid=c.pid WHERE (rl.state='test' OR rl.state='done') AND ".$this->rts->sql_verified_states_str." AND !".$this->rts->sql_last_states_str." AND r.filed_by=$uid ORDER BY rl.state, rl.rel_id, r.plan_test_end LIMIT $lim";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from releases table.');

		if(mysql_num_rows($result)<1)
			return $tbl_str;

		$tbl_str.= '
	<tr style="height: 1" class="separator">
			<td colspan=4></td>
	</tr>
	<tr class=lgray>
		<th align="left">Release</th>
		<th>ID</th>
		<th align="left">'.$sub_pq_sn.'/Synopsis</th>
	</tr>';
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			$tbl_str.= '
	<tr class="lgray" onmouseover="this.className=\'lgs\';" onmouseout="this.className=\'lgray\';" onClick="view_win_open('.$row[0].')">
		<td>'.$row[3].'</td>
		<td align="center">'.$row[0].'</td>
		<td>'.$row[1].'</td>
	</tr>';
		}

		if($tbl_str)
			$tbl_str= '
		<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
		</table>';
		return $tbl_str;

	}

	function _dashboard_requests2work($did,$uid,$info=FALSE){
		global $is_customer;

		if($is_customer)
			return FALSE;

		if(prereq_check('pps_no_projects'))
			return FALSE;

		if($info){
			return array('header' => 'Release requests to work on',
				'default_size' => 2,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => '#requests to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
		}
		if(!$lim) $lim=5;

		$pq_sn=$this->rts->object_params['pq_title'];
		$sub_pq_sn=$this->rts->object_params['sub_pq_title'];
		$tbl_str='';

		$query="SELECT r.rid, CONCAT(c.name,'/',r.synopsis), r.state, CONCAT(p.name,'&nbsp;',rl.label), IF(".$this->rts->sql_fixed_states_str.",'test','fix'), DATE_FORMAT(r.plan_fix_start,'%m/%e/%y'), DATE_FORMAT(r.plan_fix_end,'%m/%e/%y'), DATE_FORMAT(r.plan_test_start,'%m/%e/%y'), DATE_FORMAT(r.plan_test_end,'%m/%e/%y') FROM releases AS rl INNER JOIN requests AS r ON rl.rel_id=r.release_id AND r.in_release='yes' INNER JOIN products AS c ON r.pid=c.pid INNER JOIN products AS p ON rl.pid=p.pid WHERE !".$this->rts->sql_last_states_str." AND (((rl.state='implement' OR rl.state='test') AND !".$this->rts->sql_fixed_states_str." AND r.fixer_uid=$uid) OR (rl.state='test' AND ".$this->rts->sql_fixed_states_str." AND !".$this->rts->sql_verified_states_str." AND r.tester_uid=$uid)) ORDER BY rl.rel_id, r.release_pri";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from releases table.');

		if(mysql_num_rows($result)<1)
			return $tbl_str;
			$tbl_str.='
	<tr style="height: 1" class="separator">
			<td colspan=7></td>
	</tr>
	<tr class=lgray>
		<th align="left">Release</th>
		<th>ID</th>
		<th align="left">'.$sub_pq_sn.'/Synopsis</th>
		<th>To Do</th>
		<th>Planned Start</th>
		<th>Planned End</th>
		<th>Sate</th>
	</tr>';
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			$tbl_str.= '
	<tr class="lgray" onmouseover="this.className=\'lgs\';" onmouseout="this.className=\'lgray\';" onClick="view_win_open('.$row[0].')">
		<td>'.$row[3].'</td>
		<td align="center">'.$row[0].'</td>
		<td>'.$row[1].'</td>
		<td align="center">'.$row[4].'</td>
		<td align="center">'.($row[4]=='fix'?$row[5]:$row[7]).'</td>
		<td align="center">'.($row[4]=='fix'?$row[6]:$row[8]).'</td>
		<td align="center">'.$this->rts->state2str[$row[2]].'</td>
	</tr>';
		}

		if($tbl_str)
			$tbl_str= '
		<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
		</table>';
		return $tbl_str;
	}
}
?>
