<?php # Class defining timing sharing for resources between different product releases
// $Header: /home/CVS/rps/includes/rps/timeshare.inc,v 1.2 2006/05/22 03:03:50 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('includes/project/calendar.inc');

class TimeShare {

	var $pid;
	var $start_date;
	var $ucts=array(); // % of time a user spends on critical requests
	var $ushare=array(); // % of time a user has for non critical requests
	var $conflict_mngrs=array();
	var $conflict_pids=array();
	var $users=array();
	var $user_in_pids=array();
	var $rel_id;
	function timeshare($pid, $consider_conflict=FALSE){
		global $all_users_2d;

		init_users();
		$this->pid=$pid;
		$cal= new Calendar;
		$this->rel_id=simple_query("SELECT rel_id FROM releases WHERE pid='$pid' AND state='plan' LIMIT 1");
		if(!$this->rel_id)
			_quit_error('No release in planning stage for this product.');
		$rld=simple_query("SELECT release_deadline FROM releases WHERE pid='$pid' AND state!='plan' AND state!='done' AND (options&RPS_OPT_BTS)=0 ORDER BY rel_id DESC, state ASC LIMIT 1");
		if($rld){
			$rld_norm=date_sql2norm($rld);
			$rld_ch=$cal->date2ch($rld_norm);
			if($rld_ch>$start_ch)
				$start_ch=$rld_ch;
		}else
			$start_ch=$cal->adjust_ch($cal->date2ch());
		$this->start_date=$cal->ch2date("m/j/Y",$start_ch);
		$sql_start_date=date_norm2sql($this->start_date);
		if($consider_conflict)
			$this->resource_conflict($sql_start_date);
		$mgr2pids=&$this->mgr_in_pids;
		$pids=&$this->conflict_pids;
		foreach($all_users_2d['name'] as $u => $name){
			$m=$all_users_2d['report_to'][$u];
			if(($all_users_2d['spec'][$u]!=USPEC_RND) && ($all_users_2d['spec'][$u]!=USPEC_QA) && !isset($mgr2pids[$m]) && !isset($mgr2pids[$u])) continue;
			array_push($this->users,$u);
			if(isset($mgr2pids[$m]))
				$this->user_in_pids[$m]=$mgr2pids[$m];
			if(isset($mgr2pids[$u]))
				$this->user_in_pids[$u]=$mgr2pids[$u];
		}

		// Add current pid to $pids and $usr2pids
		$this->conflict_pids[$pid]=FALSE;
		foreach($this->users as $u)
			$this->user_in_pids[$u][$pid]=$pid;

		// Check if we missed any non-conflict pids with user time shares set.
		$sql_u='(uid='.implode(' OR uid=',$this->users).')';
		$query="SELECT rid FROM pnets WHERE type=".PNET_TYPE_SHARE." AND rid!=0 AND $sql_u";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from pnets table.');
		while($row=mysql_fetch_array($result, MYSQL_NUM))
			if(!isset($pids[$row[0]]))
				$pids[$row[0]]=FALSE;


		$pid_ct_pct=simple_query("SELECT ct_pct FROM releases WHERE pid='$pid' ORDER BY state ASC, rel_id DESC LIMIT 1");
		//echo "$pid_ct_pct <br>\n";
		if(!$pid_ct_pct)
			$pid_ct_pct=0;
		$query="SELECT u.uid, IF(p.xval IS NULL,$pid_ct_pct,p.xval) FROM users AS u LEFT JOIN pnets AS p ON p.rid=0 AND u.uid=p.uid AND p.type=".PNET_TYPE_SHARE;
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from releases table.');
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			//echo "uct: $row[0]=$row[1] <br>\n";
			$this->ucts[$row[0]]=$row[1];
			foreach($this->conflict_pids as $pid => $impl)
				if($impl)
					$this->ushare[$pid][$row[0]]=100-$row[1];
		}

		//print_r($ucts); echo "<br>\n";

		$query="SELECT pn.rid, u.uid, pn.xval, IF(pn.xval IS NULL,0,1) FROM users AS u LEFT JOIN pnets AS pn ON u.uid=pn.uid AND pn.type=".PNET_TYPE_SHARE." WHERE (pn.rid=".implode(' OR pn.rid=',array_keys($this->conflict_pids)).")";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from users table.');
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			//echo "pid=$row[0], uid=$row[1], pct=".$row[2].", null=".$row[3]."<br>\n";
			if($row[3])
				$this->ushare[$row[0]][$row[1]]=$row[2];
		}
	}

	function resource_conflict($sql_start_date=FALSE){
		$pid=$this->pid;
		$query = "SELECT r.rid, p.rnd_mgr, p.qa_mgr FROM requests AS r, products AS p WHERE r.pid=p.pid AND r.in_release!='yes' AND (p.parent='$pid' OR r.pid='$pid')";
		//echo "$query <br>";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from requests table.');
		$rnd_mrgs=array();
		$qa_mgrs=array();
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
		// echo "resource_conflict: rnd=$row[1] qa=$row[2] <br>";
			if($row[1]) $rnd_mrgs[$row[1]]=TRUE;
			if($row[2]) $qa_mgrs[$row[2]]=TRUE;
		}

		$plans=array();
		$impls=array();
		$query = "SELECT rel_id, state FROM releases WHERE (state='plan' OR ((state='implement' OR state='test') AND estimated_test_end>".($sql_start_date?"'$sql_start_date'":'NOW()').")) AND pid!=$pid";
		//echo "$query <br>";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from releases.');

		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			//echo "$row[0] $row[1] <br>\n";
			if($row[1]=='plan')
				array_push($plans,$row[0]);
			else
				array_push($impls,$row[0]);
		}

		if(count($plans)){
			$sql_s1='(r.release_id='.implode(' OR r.release_id=',$plans).')';
			$query = "SELECT p.rnd_mgr, p.qa_mgr, IF(p.parent,p.parent,p.pid), r.rid FROM requests AS r, products AS p WHERE r.pid=p.pid AND $sql_s1 AND r.in_release='plan'";
			//echo "$query <br>";
			if(!($result=@mysql_query($query)))
				_die2(__FILE__.':'.__LINE__.' Could not select from requests table.');
			$overlap=FALSE;
			while($row=mysql_fetch_array($result, MYSQL_NUM)){
				if(isset($rnd_mrgs[$row[0]])){
					//echo "resource_conflict, pid=$row[2]: rnd=$row[0] <br>";
					//if(!isset($this->mgr_in_pids[$row[0]]))
					//	$this->mgr_in_pids[$row[0]]=array();
					$this->mgr_in_pids[$row[0]][$row[2]]=$row[2];
				}
				if(isset($qa_mrgs[$row[1]])){
					//echo "resource_conflict, pid=$row[2]: qa=$row[1] <br>";
					//if(!isset($this->mgr_in_pids[$row[1]]))
					//	$this->mgr_in_pids[$row[1]]=array();
					$this->mgr_in_pids[$row[1]][$row[2]]=$row[2];
				}
				$this->conflict_pids[$row[2]]=FALSE;
			}
		}

		if(count($impls)){
			$sql_s1='(r.release_id='.implode(' OR r.release_id=',$impls).')';
			$query = "SELECT p.rnd_mgr, p.qa_mgr, IF(p.parent,p.parent,p.pid) FROM requests AS r, products AS p, users AS u WHERE r.pid=p.pid AND $sql_s1 AND in_release='yes'";
			if(!($result=@mysql_query($query)))
				_die2(__FILE__.':'.__LINE__.' Could not select from requests table.');
			$overlap=FALSE;
			while($row=mysql_fetch_array($result, MYSQL_NUM)){
				if(isset($rnd_mrgs[$row[0]])){
					//echo "resource_conflict, pid=$row[2]: rnd=$row[0] <br>";
					//if(!isset($this->mgr_in_pids[$row[0]]))
					//	$this->mgr_in_pids[$row[0]]=array();
					$this->mgr_in_pids[$row[0]][$row[2]]=$row[2];
					$this->conflict_pids[$row[2]]=TRUE;
				}
				if(isset($qa_mrgs[$row[1]])){
					//echo "resource_conflict, pid=$row[2]: qa=$row[1] <br>";
					//if(!isset($this->mgr_in_pids[$row[1]]))
					//	$this->mgr_in_pids[$row[1]]=array();
					$this->mgr_in_pids[$row[1]][$row[2]]=$row[2];
					$this->conflict_pids[$row[2]]=TRUE;
				}
			}
		}
	}

	function conflict_exists(){
		if(count($this->mgr_in_pids)>1 || count($this->conflict_pids)>1)
			return TRUE;
		return FALSE;
	}

	function user_share($uid, $pid){
		if(isset($this->ushare[$pid][$uid]))
			return $this->ushare[$pid][$uid];
		else
			return 100-$this->user_critical_share($uid);
	}

	function user_has_share($uid, $pid){
		return isset($this->ushare[$pid][$uid]);
	}

	function user_in_pids($uid){
		return isset($this->user_in_pids[$uid])?$this->user_in_pids[$uid]:array();
	}

	function user_critical_share($uid){
		return isset($this->ucts[$uid])?$this->ucts[$uid]:0;
	}

}

?>
