<?php
// $Header: /home/CVS/rps/includes/rts/bts.inc,v 1.164 2008/07/28 20:49:40 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('includes/db.inc');
require_once('includes/rts/rts.inc');

if($GLOBALS['pear'])
	require_once('HTTP/Request.php');

	define('COMP_XBTS_BUGZILLA',0x01);
        define('COMP_XBTS_GNATS',0x02);
        define('COMP_XBTS_USER1',0x03);
        define('COMP_XBTS_MYSQL',0x04);
        define('COMP_XBTS_RETRO',0x05);
        define('COMP_XBTS_TRAC',0x06);
        define('COMP_XBTS_JIRA',0x07);

	define('HISTORY_TYPE_BTS', 1);
	define('HISTORY_TYPE_RPS_DECOMMIT', 2);
	define('HISTORY_TYPE_RPS_PLAN', 3);
	define('HISTORY_TYPE_PSET', 4);

	define('PROJ_OPT_BTS', 0x0001);
	define('REL_OPT_BTS', PROJ_OPT_BTS);

	define('PNET_TYPE_PRI',0x01);
	define('PNET_TYPE_FIX',0x02);
	define('PNET_TYPE_TEST',0x03);
	define('PNET_TYPE_SHARE',0x04);

	define('REQ_CLASS_BUG', 0x001);
	define('REQ_CLASS_ENH', 0x002);
	define('REQ_CLASS_NEW', 0x004);
	define('REQ_CLASS_SUP', 0x008);
	define('REQ_CLASS_BTS', (REQ_CLASS_BUG|REQ_CLASS_ENH|REQ_CLASS_NEW));

	define ('CDB_CREATE_HISTORY_TBL', "CREATE TABLE IF NOT EXISTS history
	    (rid int UNSIGNED default NULL,
	    uid int UNSIGNED default NULL,
	    state int UNSIGNED NOT NULL default '0',
	    date DATETIME,
	    descr text,
	    options INT UNSIGNED DEFAULT 0 NOT NULL,
	    xid INT UNSIGNED DEFAULT NULL,
	    xid2 INT UNSIGNED DEFAULT NULL,
	    xid3 INT UNSIGNED DEFAULT NULL,
	    roptions INT UNSIGNED DEFAULT 0 NOT NULL,
		KEY (rid),
		KEY (uid),
		KEY (state),
		KEY (date),
		FULLTEXT (descr),
		KEY (options),
		KEY (xid)
	    ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	// release_pri - order of request in current plan/release_pri
	// plan-pri - mutual rel. members priority
	define('CDB_CREATE_REQUESTS_TBL', "CREATE TABLE IF NOT EXISTS requests
		(rid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		pid INT UNSIGNED NOT NULL,
		state INT UNSIGNED NOT NULL,
		synopsis VARCHAR(128) NOT NULL,
		description TEXT,
		class SMALLINT UNSIGNED NOT NULL,
		customer_id INT UNSIGNED NOT NULL,
		customer_pri SMALLINT UNSIGNED DEFAULT ".REQ_PRI_MEDIUM." NOT NULL,
		filed_by INT UNSIGNED NOT NULL,
		phase_of_rid INT UNSIGNED NOT NULL,
		fixer_uid INT UNSIGNED NOT NULL,
		tester_uid INT UNSIGNED NOT NULL,
		release_id INT UNSIGNED,
		in_release ENUM('yes', 'plan', 'maybe', 'no') DEFAULT 'maybe' NOT NULL,
		release_pri INT UNSIGNED,
		fixed_in_build VARCHAR(64) NOT NULL,
		reg_date DATETIME NOT NULL,
		plan_pri FLOAT UNSIGNED,
		fix_aiid INT UNSIGNED,
		test_aiid INT UNSIGNED,
		options INT UNSIGNED NOT NULL,
		critical_order INT UNSIGNED NOT NULL,
		reported_in_build VARCHAR(64) NOT NULL,
		plan_fixer_uid INT UNSIGNED NOT NULL,
		plan_tester_uid INT UNSIGNED NOT NULL,
		platform INT UNSIGNED DEFAULT 0 NOT NULL,
		xrid INT UNSIGNED DEFAULT 0 NOT NULL,
		xrid_last_import DATETIME NOT NULL,
		depends_on INT UNSIGNED DEFAULT 0 NOT NULL,
		reported_in_rel_id INT UNSIGNED,
		fix_wrk_hrs INT UNSIGNED DEFAULT 0 NOT NULL,
		test_wrk_hrs INT UNSIGNED DEFAULT 0 NOT NULL,
		inwork_date DATETIME,
		fixed_date DATETIME,
		test_date DATETIME,
		verified_date DATETIME,
		last_date DATETIME,
		plan_fix_start DATETIME,
		plan_fix_end DATETIME,
		plan_test_start DATETIME,
		plan_test_end DATETIME,
		plan_dep_on INT UNSIGNED,
		complete_pct SMALLINT UNSIGNED,
		cal_fix_start DATETIME,
		cal_fix_end DATETIME,
		cal_test_start DATETIME,
		cal_test_end DATETIME,
		dup_rid INT UNSIGNED DEFAULT 0 NOT NULL,
		PRIMARY KEY rid (rid),
			FULLTEXT (synopsis, description),
			KEY (pid),
			KEY (in_release, release_id),
			KEY (release_pri),
			KEY (plan_pri),
			KEY (filed_by),
			KEY (fixer_uid),
			KEY (tester_uid),
			KEY (phase_of_rid)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('CDB_CREATE_RELEASES_TBL', "CREATE TABLE IF NOT EXISTS releases
		(rel_id INT UNSIGNED NOT NULL AUTO_INCREMENT,
		pid INT UNSIGNED NOT NULL,
		state ENUM('plan', 'implement', 'test', 'done'),
		label VARCHAR(64) NOT NULL,
		plan_start_date DATETIME,
		implement_start_date DATETIME,
		test_start_date DATETIME,
		done_date DATETIME,
		dflt_fix_time MEDIUMINT UNSIGNED DEFAULT '8' NOT NULL,
		dflt_test_time MEDIUMINT UNSIGNED DEFAULT '8' NOT NULL,
		release_deadline DATE,
		estimated_fix_end DATETIME,
		estimated_test_end DATETIME,
		good_fix_rate SMALLINT UNSIGNED DEFAULT '100' NOT NULL,
		good_test_rate SMALLINT UNSIGNED DEFAULT '100' NOT NULL,
		options INT UNSIGNED NOT NULL,
		added_by INT UNSIGNED NOT NULL,
		ct_pct TINYINT UNSIGNED DEFAULT '0' NOT NULL,
		avg_fix_hrs MEDIUMINT UNSIGNED,
		avg_test_hrs MEDIUMINT UNSIGNED,
		description TEXT,
		PRIMARY KEY (rel_id),
			UNIQUE KEY (pid, label)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

if(!$GLOBALS['cmd_line_mode'] && $GLOBALS['uid']){
	require_once('includes/rts/default_wf_bts.inc');

	$query = CDB_CREATE_REQUESTS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create requests table. ');

	$query = CDB_CREATE_HISTORY_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create history table. ');

	$query = CDB_CREATE_RELEASES_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create releases table. ');

	$xfields_tbl=sprintf(XFIELDS_TBL_F,WFID_BTS);
	$query = sprintf(CDB_CREATE_XFIELDS_TBL_F,WFID_BTS);
	if(!@mysql_query($query))
                _die2(__FILE__.':'.__LINE__." Can not create $xfields_tbl table.");

	$nrecords=simple_query("SELECT COUNT(fid) FROM $xfields_tbl");
	if($nrecords<1){
		// Add additional eXtra fields that override original fields
		$query = "INSERT INTO $xfields_tbl (long_name, short_name, over_fid, field_type, options)
		VALUES ('Summary', 'Summary', 'r.synopsis', 'text_line', ".FIELD_OPT_X."),
		('Comments', 'Comments', 'r.description', 'text_area', ".FIELD_OPT_X.")";
//		echo "$query <br>";
        	if(!@mysql_query($query))
        		_die2(__FILE__.':'.__LINE__." Can not insert into $xfields_tbl table.");

		// Add additional eXtra fields that do not override original fields
		$query = "INSERT INTO $xfields_tbl (long_name, short_name, field_type, options)
		VALUES ('Request Owner', 'Owner', 'username', ".FIELD_OPT_X."),
		('Customer Requested Date', 'CRD', 'date', ".FIELD_OPT_X."),
		('Original Commit Date', 'OCD', 'date', ".FIELD_OPT_X."),
		('New Commit Date', 'NCD', 'date', ".FIELD_OPT_X.")";
//		echo "$query <br>";
        	if(!@mysql_query($query))
        		_die2(__FILE__.':'.__LINE__." Can not insert into $xfields_tbl table.");

	}

	$extras_tbl=sprintf(EXTRAS_TBL_F,WFID_BTS);
	$query = sprintf(CDB_CREATE_EXTRAS_TBL_F,WFID_BTS);
	if(!@mysql_query($query))
                _die2(__FILE__.':'.__LINE__." Can not create $extras_tbl table.");
}

  $xbts_types=array('BUGZILLA' => COMP_XBTS_BUGZILLA,
	'GNATS' => COMP_XBTS_GNATS,
	'MANTIS' => COMP_XBTS_MYSQL,
	'RETROSPECTIVA' => COMP_XBTS_RETRO,
	'TRAC' => COMP_XBTS_TRAC,
	'JIRA' => COMP_XBTS_JIRA,
	'CUSTOM1' => COMP_XBTS_USER1);

  if(defined('YXL_XBTS_TYPE') && YXL_XBTS_TYPE){
	$xbts_type=strtoupper(YXL_XBTS_TYPE);
	if(isset($xbts_types[$xbts_type])){
		yxl_cnfg_check('YXL_XBTS_BUG_URL');
		$external_bts=array();
		$external_bts['x_bts_type']=$xbts_types[$xbts_type];
		$external_bts['x_bts_url']=YXL_XBTS_BUG_URL;

		$external_bts['x_bts_login'] = defined('YXL_XBTS_LOGIN_ID')?YXL_XBTS_LOGIN_ID:'';
		$external_bts['x_bts_password'] = defined('YXL_XBTS_LOGIN_PASSWORD')?YXL_XBTS_LOGIN_PASSWORD:'';
		$external_bts['x_bts_login_url'] = defined('YXL_XBTS_LOGIN_URL')?YXL_XBTS_LOGIN_URL:'';

		$external_bts['x_bts_import_users'] = '';
	}
  }

class BugTracker extends RequestTracker {
	var $xbts=array();
	var $cid=FALSE;
	var $pqs_2d;
	var $state2str;

	function bugtracker($comp_id=FALSE){
		global $is_customer;
		global $cid;
		global $cmd_line_mode;

		$object_params=array(
		'wfid' => 'bts',
		'rts_short_name' => 'RTS',
		'rts_long_name' => 'Request Tracking System',
		'requests_tbl' => 'requests',
		'req_view_script' => '/rts/wf_bts_view.php',
		'req_email_view_script' => '/rts/bts.php',
		'pq_tbl' => 'products',
		'history_tbl' => 'history',
		'history_rts_type' => HISTORY_TYPE_BTS,
		'history_pqset_type' => HISTORY_TYPE_PSET,
		'members_tbl' => 'members',
		'member_cc_type' => MEMB_TYPE_BTSCC,
		'member_pqlist_type' => MEMB_TYPE_PLIST,
		'customer_class_mask_fn' => 'bts_class_mask',
		'pq_fn' => 'pid',
		'pq_owners' => array('mrkt_mgr','rnd_mgr','qa_mgr'),
		'pq_long_title' => sprintf(HDR_LONG_PQ_F,'Product','Component'),
		'pq_title' => 'Product',
		'sub_pq_title' => 'Component',
		'req_proj_id_fn' => 'release_id',
                'req_in_proj_fn' => 'in_release',

                'proj_tbl' => 'releases',
                'proj_id_fn' => 'rel_id',
		'proj_rts_opt' => PROJ_OPT_BTS,

                'pnets_tbl' => 'pnets',
                'pnet_type_pri' => PNET_TYPE_PRI,
		'x_native_fields' => array(
			'r.rid' => array(
				'long_name' => 'Request ID',
				'short_name' => 'RID',
				'field_name' => 'rid',
				'field_type' => 'number'
			),
			'r.pid' => array(
				'long_name' => 'Product Name',
				'short_name' => 'Prod.',
				'field_name' => 'pid',
				'field_type' => 'main_pq'
			),
			'r.comp' => array(
				'long_name' => 'Component Name',
				'short_name' => 'Comp.',
				'field_name' => 'pid',
				'field_type' => 'sub_pq'
			),
			'r.state' => array(
				'long_name' => 'Request State',
				'short_name' => 'State',
				'field_name' => 'state',
				'field_type' => 'state'
			),
			'r.class' => array(
				'long_name' => 'Request Class',
				'short_name' => 'Class',
				'field_name' => 'class',
				'field_type' => 'class'
			),
			'r.customer_id' => array(
				'long_name' => 'Customer',
				'short_name' => 'Cust.',
				'field_name' => 'customer_id',
				'field_type' => 'customer'
			),
			'r.customer_pri' => array(
				'long_name' => 'Customer Priority',
				'short_name' => 'Pri',
				'field_name' => 'customer_pri',
				'field_type' => 'customer_pri'
			),
			'r.release_id' => array(
				'long_name' => 'Release Label',
				'short_name' => 'Rel',
				'field_name' => 'label',
				'field_type' => 'text_line'
			),
			'r.reg_date' => array(
				'long_name' => 'Request Registration Date',
				'short_name' => 'RRD',
				'field_name' => 'reg_date',
				'field_type' => 'date'
			),
			'r.children' => array(
				'long_name' => 'List of Sub-Requests',
				'short_name' => 'LSR',
				'field_name' => 'rid',
				'field_type' => 'ph_list'
			),
			'r.xrid' => array(
				'long_name' => 'External Request ID',
				'short_name' => 'XRID',
				'field_name' => 'xrid',
				'field_type' => 'number'
			),
			'r.description' => array(
				'long_name' => 'Description',
				'short_name' => 'Descr.',
				'field_name' => 'description',
				'field_type' => 'text_area',
				'options' => FIELD_OPT_SOFT
			),
			'r.synopsis' => array(
				'long_name' => 'Synopsis',
				'short_name' => 'Synop.',
				'field_name' => 'synopsis',
				'field_type' => 'text_line',
				'options' => FIELD_OPT_SOFT
			),
			'r.filed_by' => array(
				'long_name' => 'Request Submitter',
				'short_name' => 'FiledBy',
				'field_name' => 'filed_by',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			),
			'r.fixer_uid' => array(
				'long_name' => 'Request Implementer',
				'short_name' => 'Fixer',
				'field_name' => 'fixer_uid',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			),
			'r.tester_uid' => array(
				'long_name' => 'Request Tester',
				'short_name' => 'Tester',
				'field_name' => 'tester_uid',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			),
			'r.pri_votes' => array(
                                'long_name' => 'Priority Votes',
                                'short_name' => 'Votes',
                                'field_name' => 'rid',
                                'field_type' => 'pri_votes'
                        )
		),
		'x_order_by' => array(
			'pri_desc' => array(
				'name' => 'By Priority',
				'sql' => 'r.customer_pri DESC'),
			'rid_desc' => array(
				'name' => 'By Request ID',
				'sql' => 'r.rid ASC'),
			'class_asc' => array(
				'name' => 'By Request Class',
				'sql' => 'r.class ASC'),
			'state_asc' => array(
				'name' => 'By Request State',
				'sql' => 'r.state ASC'),
			'xrid_asc' => array(
				'name' => 'By External Request ID',
				'sql' => 'r.xrid ASC'),
			'relpri_asc' => array(
				'name' => 'By Release Priority',
				'sql' => 'IF(r.in_release=\'plan\',r.plan_pri,r.release_pri) ASC'),
			'pid_asc' => array(
				'name' => 'By Product Name',
				'sql' => 'IF(c.parent,p.name,c.name) ASC'),
			'cid_asc' => array(
				'name' => 'By Component Name',
				'sql' => 'IF(c.parent,c.name,\'General\') ASC')
		));

		if($comp_id)
			$this->cid=$comp_id;
		elseif($cid)
			$this->cid=$cid;
		else
			_die(__FILE__.':'.__LINE__.' cid is not set.');

		parent::requesttracker($object_params);
		$this->products_2d=&$this->pqs_2d;

		foreach($this->p2_states as $s => $str)
        		$this->state2str[$s]=$str;
		$this->init_xbts();
	}

	function construct_product_sets(){
		return $this->construct_pq_sets();
	}

	function init_xbts(){
                global $root_fdir;
                global $dbc;
                global $asp_mode;
                global $external_bts;

                $cid=$this->cid;
                $xbts=&$this->xbts;
                if($asp_mode){
                        $query = "SELECT x_bts_type, AES_DECRYPT(x_bts_url, '".DB_PASSWD."') AS x_bts_url, x_bts_html_parser, AES_DECRYPT(x_bts_login, '".DB_PASSWD."') AS x_bts_login, AES_DECRYPT(x_bts_password, '".DB_PASSWD."') AS x_bts_password, AES_DECRYPT(x_bts_login_url, '".DB_PASSWD."') AS x_bts_login_url, options&".COMP_OPT_XBTS_COMPACT." AS compact FROM ".DB_NAME.".companies WHERE cid=$cid";
                        //echo "$query <br>\n";
                        if(!($result=@mysql_query($query,$dbc)))
                                _die2(__FILE__.':'.__LINE__.' Could not select from companies table.');
                        $xbts=mysql_fetch_array($result, MYSQL_ASSOC);
                }elseif(isset($external_bts)){
                        $xbts=$external_bts;
			if(!isset($xbts['x_bts_login_url']))
				$xbts['x_bts_login_url']='';

			if(!isset($xbts['x_bts_login']))
				$xbts['x_bts_login']='';

			if(!isset($xbts['x_bts_password']))
				$xbts['x_bts_password']='';
		}else
			return;

                //foreach($xbts as $k => $v)
                //      echo "$k --> $v <br>\n";
                if($xbts['x_bts_type'] && $xbts['x_bts_url']){
                        //echo $xbts['x_bts_url']."<br>\n";
                        if(isset($xbts['x_bts_html_parser']) && $xbts['x_bts_html_parser']){
                                $parse_script=$root_fdir.'/parsers/'.$xbts['x_bts_html_parser'];
                                if(!file_exists($parse_script))
                                        _die(__FILE__.':'.__LINE__.'Can not find x_bts_html_parser: '.$parse_script);

                                $xbts['x_bts_html_parser']=$parse_script;
                        }else{
                                if($xbts['x_bts_type']==COMP_XBTS_GNATS)
                                        $parse_script=$root_fdir.'/parsers/parse_gnats_pr_html.pl';
                                elseif($xbts['x_bts_type']==COMP_XBTS_USER1)
                                        $parse_script=$root_fdir.'/parsers/parse_user1_pr_html.pl';
                                elseif($xbts['x_bts_type']==COMP_XBTS_MYSQL)
                                        $parse_script=$root_fdir.'/parsers/parse_mysql_pr_html.pl';
				elseif($xbts['x_bts_type']==COMP_XBTS_RETRO)
                                        $parse_script=$root_fdir.'/parsers/parse_retro_pr_html.pl';
				elseif($xbts['x_bts_type']==COMP_XBTS_TRAC)
                                        $parse_script=$root_fdir.'/parsers/parse_trac_pr_html.pl';
				elseif($xbts['x_bts_type']==COMP_XBTS_JIRA)
                                        $parse_script=$root_fdir.'/parsers/parse_jira_pr_html.pl';
                                else
                                        $parse_script=$root_fdir.'/parsers/parse_bugzilla_pr_html.pl';

                                if(!file_exists($parse_script))
                                        _die(__FILE__.':'.__LINE__.' Could not find default html_parser: '.$parse_script);
                                $xbts['x_bts_html_parser']=$parse_script;
                        }
                }
        }

        function exists_xbts(){
		return (isset($this->xbts['x_bts_type']) && $this->xbts['x_bts_type'] && isset($this->xbts['x_bts_url']) && $this->xbts['x_bts_url']);
	}

	function file_request($fields,$xfields=array(),$cc_list=array(),$xrids=array()){
		global $uid;
		global $is_customer;
		global $customers_2d;

		$pqs_2d=&$this->pqs_2d;

		if(!isset($fields['class']))
			_die(__FILE__.':'.__LINE__.' class field is not specified.');

		$class=$fields['class'];
		$fields['state']=$open_state=$this->first_state($fields['class']);
		$nsa_aid=$this->null_state_action($class);
		$lsm=$this->last_state_mask($class);

		if(!isset($fields['pid']) || !$fields['pid'])
			_die(__FILE__.':'.__LINE__.' pid field is not specified.');

		$pid=$fields['pid'];
		$cror=$this->get_cror($pid);
		$fields['critical_order']=$cror;
		if(!isset($fields['synopsis']))
			_die(__FILE__.':'.__LINE__.' synopsis field is not specified.');
		if(!isset($fields['description']))
			_die(__FILE__.':'.__LINE__.' description field is not specified.');
		$descr=$fields['description'];

		if(!isset($fields['customer_id']))
			$fields['customer_id']=$is_customer?$is_customer:$this->first_customer_id;

		$cust=$fields['customer_id'];

		if(!isset($fields['customer_pri']))
			$fields['customer_pri']=REQ_PRI_MEDIUM;

		if(!isset($fields['filed_by']))
			$fields['filed_by']=$uid;

		if(!isset($fields['options']))
			$fields['options']=0;

		if($is_customer && ($customers_2d['options'][$is_customer]&CUST_OPT_PUBLIC))
			$fields['options']|=REQ_OPT_VBC2;

		$xstr2uid=array();
		$xstr2uid['%rnd_mgr']=$pqs_2d['rnd_mgr'][$pid];
		$xstr2uid['%qa_mgr']=$pqs_2d['qa_mgr'][$pid];
		$xstr2uid['%cae_mgr']=$customers_2d['cae_mgr'][$cust]?$customers_2d['cae_mgr'][$cust]:($pqs_2d['rnd_mgr'][$pid]?$pqs_2d['rnd_mgr'][$pid]:$uid);
		$xstr2uid['%sls_mgr']=$customers_2d['sls_mgr'][$cust];
		$xstr2uid['%fixer']=$uid;
		$xstr2uid['%tester']=$uid;
		$xstr2uid['%submitter']=$uid;

		$nsa=$this->null_state_action($class);
		$fixer=$this->default_value("fixer_uid",$nsa,$xstr2uid);
		if(!$fixer)
			$fixer=$uid;
		if(!isset($fields['fixer_uid']))
			$fields['fixer_uid']=$fixer;

		$tester=$this->default_value("tester_uid",$nsa,$xstr2uid);
		if(!$tester)
			$tester=$uid;
		if(!isset($fields['tester_uid']))
			$fields['tester_uid']=$tester;

		if(isset($fields['reported_in_rel_id']) && $fields['reported_in_rel_id']){
			$inr=simple_query("SELECT state FROM releases WHERE rel_id=".$fields['reported_in_rel_id']);
			if($inr && ($inr!='done') && ($fields['customer_pri']!=REQ_PRI_CRITICAL)){
				$fields['release_id']=$fields['reported_in_rel_id'];
				$fields['in_release']=($inr=='plan')?'plan':'yes';
			}
		}

		foreach($fields as $k => $v)
                        $fields[$k]=escape_data($v);

		$query = "INSERT INTO requests (".implode(', ',array_keys($fields)).(isset($fields['reg_date'])?'':', reg_date').") VALUES (".("'".implode("', '",$fields)."'").(isset($fields['reg_date'])?'':', NOW()').")";
		//echo "$query <br>\n";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into requests table.');

		$rid=@mysql_insert_id();

		if(isset($fields['options']) && ($fields['options']&REQ_OPT_RPSTMP))
			$txt="Action: Submit temporary RPS request";
		else
			$txt="Action: Submit new request";

		$fields['rid']=$rid;
		$this->log_history($fields,$uid,$txt);

		if(count($xfields)){
			$sql_arr=array();
			foreach($xfields as $fid => $v)
				$this->update_xfid_extra_for_rid($rid,$fid,$v);
		}

		if($cc_list){
			$safe_cc=array();
			foreach(explode(',',$cc_list) as $u)
				arr_push($safe_cc,$u);

			foreach($safe_cc as $u)
				$this->add_cc($rid,$u);
		}

		if(count($xrids)){
			$ta=array();
			foreach($xrids as $k => $v)
				if(trim($v)) array_push($ta,"('$rid', '".MEMB_TYPE_XRID."', '".trim($v)."')");
			$query = "INSERT INTO members (uid, type, xid) VALUES ".implode(', ',$ta);
			if(!@mysql_query ($query))
				_die(__FILE__.':'.__LINE__.' Could not insert into members table.');
		}
		if(isset($fields['options']) && ($fields['options']&REQ_OPT_RPSTMP))
			return $rid;

		$this->notify_by_email($rid,$uid,$descr,$nsa_aid,FALSE);
		return $rid;
	}

	function &proj_cc_list($proj_id){
		return $this->get_cc_list($proj_id,MEMB_TYPE_RPSCC);
	}

	function proj_add_cc($proj_id,$u){
		return $this->add_cc($proj_id,$u,MEMB_TYPE_RPSCC);
	}

	function proj_delete_cc($proj_id,$u){
                return $this->delete_cc($proj_id,$u,MEMB_TYPE_RPSCC);
        }

	function _read_hf($hf,&$pr_info){

		if(!isset($pr_info['xrid']) || !$pr_info['xrid']){
			_live_error('XRID is not specified.');
			return FALSE;
		}
		$ext_pr_num=$pr_info['xrid'];

		if (!file_exists($hf)){
			_live_error("External PR $ext_pr_num ($hf) does not exist.");
			return FALSE;
	   	}

	    	$str=file_get_contents($hf);
	    	$lines=explode("\n%%\n%%\n",$str);
	    	foreach($lines as $k => $v){
			$colon_pos=strpos($v,':');
			$key=substr($v,0,$colon_pos);
			if(!$key) continue;
			$val=substr($v,$colon_pos+1);
			if($val == "--")
				$val='';
			$pr_info[$key]=$val;
	   	}
		if(!isset($pr_info['product']) || empty($pr_info['product'])){
			_live_error('Product name is absent for external PR'.$ext_pr_num.'. Could be a problem with the parser or this external PR# does not exist.');
			return FALSE;
		}
		if(isset($pr_info['component']) && empty($pr_info['component'])){
			_live_error('Component name is absent for external PR'.$ext_pr_num.'. Could be a problem with the parser or this external PR# does not exist.');
			return FALSE;
		}
		if(!isset($pr_info['syn']) || empty($pr_info['syn'])){
			_live_error('Synopsis is absent for external PR'.$ext_pr_num.'. Could be a problem with the parser or this external PR# does not exist.');
			return FALSE;
		}
		if(!isset($pr_info['descr'])){
			_live_error('Description is absent for external PR'.$ext_pr_num.'. Could be a problem with the parser or this external PR# does not exist.');
			return FALSE;
		}
		return TRUE;
	}

	function get_external_pr_info($ext_pr_num, &$pr_info, $hf_dir=FALSE){
		global $abs_tmp_dir;

                $ua='Mozilla/5.0 (X11; U; FreeBSD i386; en-US; rv:1.7.5) Gecko/20050123 Firefox/1.0';

		if(!$ext_pr_num)
			return FALSE;

		$xbts=&$this->xbts;
		if(!$xbts['x_bts_url'] || !$xbts['x_bts_html_parser']){
			error_log('Can not import external PR. No appropriate setup has been done yet.');
			return FALSE;
		}

		//print_r($xbts);
		//echo sprintf($xbts['x_bts_url'],$ext_pr_num)."<br>\n";die;

                $_url=$xbts['x_bts_url'];
		$req =& new HTTP_Request(sprintf($xbts['x_bts_url'],$ext_pr_num));

		if($xbts['x_bts_type']==COMP_XBTS_BUGZILLA){
                        if($xbts['x_bts_login_url'] && $xbts['x_bts_login'] && $xbts['x_bts_password']){
				// With extra login, when Bugzilla_logincookie is reset for every new sessions
                                $req =& new HTTP_Request(sprintf($xbts['x_bts_url'],$ext_pr_num),
							array ('allowRedirects'=>TRUE, 'maxRedirects'=>2));
                                $req->setMethod(HTTP_REQUEST_METHOD_POST);
                                $req->addPostData('Bugzilla_login', $xbts['x_bts_login']);
                                $req->addPostData('Bugzilla_password', $xbts['x_bts_password']);
                                $req->addPostData('id', $ext_pr_num);
                        }elseif($xbts['x_bts_login'] && $xbts['x_bts_password']){
                                $req->addCookie("Bugzilla_login", $xbts['x_bts_login']);
                                $req->addCookie("Bugzilla_logincookie", $xbts['x_bts_password']);
                        }
		}elseif($xbts['x_bts_type']==COMP_XBTS_TRAC){
                        if($xbts['x_bts_login_url'] && $xbts['x_bts_login'] && $xbts['x_bts_password']){
                		$req->removeHeader('User-Agent');
                		$req->addHeader('User-Agent',$ua);
                		$response=$req->sendRequest();

				foreach($req->_response->_cookies as $cookie_arr){
					if(in_array($cookie_arr['name'],array('trac_form_token','trac_session')))
						$tc[$cookie_arr['name']]=$cookie_arr['value'];
				}

                                $req =& new HTTP_Request($xbts['x_bts_login_url'],
							array ('allowRedirects'=>TRUE, 'maxRedirects'=>2));
                                $req->setMethod(HTTP_REQUEST_METHOD_POST);
                                $req->addCookie("trac_session", $tc['trac_session']);
                                $req->addCookie("trac_form_token", $tc['trac_form_token']);
                                $req->addPostData('__FORM_TOKEN', $tc['trac_form_token']);
                                $req->addPostData('user', $xbts['x_bts_login']);
                                $req->addPostData('password', $xbts['x_bts_password']);
                                $req->addPostData('referer', sprintf($xbts['x_bts_url'],$ext_pr_num));
                        }
		}elseif($xbts['x_bts_type']==COMP_XBTS_JIRA){
                        if($xbts['x_bts_login_url'] && $xbts['x_bts_login'] && $xbts['x_bts_password']){
                                $req =& new HTTP_Request($xbts['x_bts_login_url'],
							array ('allowRedirects'=>TRUE, 'maxRedirects'=>2));
                                $req->setMethod(HTTP_REQUEST_METHOD_POST);
                                $req->addPostData('os_username', $xbts['x_bts_login']);
                                $req->addPostData('os_password', $xbts['x_bts_password']);
                                $req->addPostData('os_destination', sprintf($xbts['x_bts_url'],$ext_pr_num));
                                //$req->addPostData('os_cookie', 'true');
                        }
                }elseif($xbts['x_bts_type']==COMP_XBTS_GNATS){
                        if($xbts['x_bts_login'] && $xbts['x_bts_password'])
                                $req->addCookie("gnatsweb-db-default",
					'password&'.$xbts['x_bts_password'].'&user&'.$xbts['x_bts_login']);
                }elseif($xbts['x_bts_type']==COMP_XBTS_USER1){
                        if(!$xbts['x_bts_login_url']){
                                error_log('**Can not import external PR. No appropriate setup has been done yet.');
                                return FALSE;
                        }
                        $_url=$xbts['x_bts_login_url'];

                        if($xbts['x_bts_login'] && $xbts['x_bts_password']){
				// As of 1.23 this needs to be handled without re-direct
                                $req =& new HTTP_Request($xbts['x_bts_login_url'],
					array ('allowRedirects'=>TRUE, 'maxRedirects'=>2));
                                $req->setMethod(HTTP_REQUEST_METHOD_POST);
                                $req->addPostData('login', $xbts['x_bts_login']);
                                $req->addPostData('pass', $xbts['x_bts_password']);
                                $req->addPostData('referer_page',sprintf($xbts['x_bts_url'],$ext_pr_num));
                        }else{
                                error_log('Can not import external PR. Login/password is not provided.');
                                return FALSE;
                        }
                }

		// Just in case, do it always
		if($xbts['x_bts_login'] && $xbts['x_bts_password'])
			$req->setBasicAuth($xbts['x_bts_login'], $xbts['x_bts_password']);

                $req->removeHeader('User-Agent');
                $req->addHeader('User-Agent',$ua);
                $response=$req->sendRequest();

		if (PEAR::isError($response)) {
			error_log($response->getMessage());
			return FALSE;
		}

	    	$html=$req->getResponseBody();
		//foreach($req->getResponseHeader() as $k => $v)
		//	echo "$k ---> $v <br>\n";

		if($hf_dir){
                        $a=explode('://',$_url);
                        $b=explode('/',$a[1]);
                        $hf_dir=$abs_tmp_dir.'/'.$b[0];
                        if (!file_exists($hf_dir)){
                                mkdir($hf_dir,0777);
                                chmod($hf_dir,0777);
                        }
                        $abs_fname = $hf_dir.'/pr'.$ext_pr_num;
                }else{
                        if (!file_exists($abs_tmp_dir)){
                                mkdir ($abs_tmp_dir,0777);
                                chmod($abs_tmp_dir,0777);
                        }
                        $abs_fname = tempnam($abs_tmp_dir.'/','yoxel_');
                }

                $fp = fopen($abs_fname,'w');
                fwrite($fp,$html);
                fclose($fp);
                chmod($abs_fname,0644);
                system($xbts['x_bts_html_parser']." $abs_fname",$retval);
	   	if($retval){
	   	 	error_log('Either the external PR#'.$ext_pr_num.' does not exist or we could not parse it.');
			return FALSE;
		}

	   	if(!$this->_read_hf($abs_fname.'.hf',$pr_info))
	   		return FALSE;

		if(!$hf_dir)
			unlink($abs_fname.'.hf');
		unlink($abs_fname);
		return TRUE;
	}

	function import_add_user($email,$uis){
		global $at_isp;

		$a=explode('<',$email);
		$b=explode('>',$a[1]);
		$se=escape_data(trim($b[0]));

		$c=explode('@',$se);
		$sun=escape_data(construct_username($c[0]));

		$d=explode(' ',$a[0]);
		$sfn=escape_data(array_shift($d));
		$sln=escape_data(implode(' ',$d));

		if($at_isp) $uis|=USER_IS_HIDDEN;

		$nuid=simple_query("SELECT uid FROM users WHERE email='$se' LIMIT 1");
		if(!$nuid){ // Add this user
			$query="INSERT INTO users (username, first_name, last_name, email, user_is, reg_DATE) VALUES ('$sun', '$sfn', '$sln', '$se', $uis, NOW())";
			if(!@mysql_query ($query))
				_die2(__FILE__.':'.__LINE__.' Could not insert into users table.');
			$nuid=mysql_insert_id();
		}else{
			$query="UPDATE users SET first_name='$sfn', last_name='$sln', user_is=$uis, reg_DATE=NOW() WHERE uid=$nuid";
			if(!@mysql_query ($query))
				_die2(__FILE__.':'.__LINE__.' Could not update users table.');
		}
		//echo "$sfn, $sln, $sun: $nuid<br>\n";
		return $nuid;
	}

	function import_hash($ext_pr_num, $hf, $customer_id=0, $prod_regex=FALSE, $ph_of_rid=0){
		$pr=array();
		$pr['xrid']=$ext_pr_num;
		if(!$this->_read_hf($hf,$pr))
			return FALSE;
		//echo "xpr: "; print_r($pr); echo "<br>\n";
		echo " ".$pr['state']." ";
		return($this->_import_pr($pr,$customer_id,$prod_regex,$ph_of_rid));
	}

	function import_external_pr($ext_pr_num, $customer_id=0, $prod_regex=FALSE, $ph_of_rid=0, $hf_dir=FALSE){
		$pr=array();
		$pr['xrid']=$ext_pr_num;
		if(!$this->get_external_pr_info($ext_pr_num,$pr,$hf_dir))
			return FALSE;
		//echo "xpr: "; print_r($pr); echo "<br>\n"; die;
		return($this->_import_pr($pr,$customer_id,$prod_regex,$ph_of_rid));
	}

	function _import_pr(&$pr, $customer_id=0, $prod_regex=FALSE, $ph_of_rid=0){
		global $uid;
		global $bts_pri2str;
		global $cmd_line_mode;
		global $at_isp;

		$bts_class2str=&$this->class2str;
		$state2str=&$this->state2str;

		if(!isset($pr['xrid']) || !$pr['xrid']){
			_live_error('XRID is not specified.');
			return FALSE;
		}
		$ext_pr_num=$pr['xrid'];

		if(!isset($uid) || !$uid)
			$uid=0;
		//echo "import_external_pr $ext_pr_num uid='$uid' <br>\n";

		if(!($class=array_search($pr['class'],$bts_class2str))){
			_live_error('Unknown class: '.$pr['class']);
			return FALSE;
		}
		$cpri=array_search($pr['pri'],$bts_pri2str);
		if(!($state=array_search($pr['state'],$state2str))){
			_live_error('Unknown state: '.$pr['state']);
			return FALSE;
		}

		$ism=$this->inwork_state_mask[$class];
		$fsm=$this->fixed_state_mask[$class];
		$vsm=$this->verified_state_mask[$class];
		$lsm=$this->last_state_mask($class);

		$rid=simple_query("SELECT rid, fixer_uid, tester_uid, filed_by, options, state FROM requests WHERE xrid=$ext_pr_num LIMIT 1");
		if(!$rid){
			if($prod_regex && !preg_match($prod_regex,$pr['product'],$matches))
				return -1;

			// Do not import new verified|closed PRs in the crontab mode
			if($cmd_line_mode && ($state&($lsm|$vsm)))
				return -1;

			//if($cmd_line_mode && ($state&$lsm) && isset($pr['dup_xrid']))
			//	return -1;
		}elseif(!($rid[4]&REQ_OPT_EXTERNAL))
				return -1;

		$xbts=&$this->xbts;
		//echo "xpr: "; print_r($pr); echo "<br>\n";
		$skip_descr=isset($xbts['compact']) && $xbts['compact'] && $cmd_line_mode;

		// Check customer
		if(!$customer_id)
			$customer_id=internal_customer();

		//if(!$at_isp && isset($pr['submitter']))
		//	$submitter=$this->import_add_user($pr['submitter'],USER_IS_CUSTOMER|USER_IS_LOCKED);

		//if(isset($pr['fixer']))
		//	$fixer=$this->import_add_user($pr['fixer']);

		//if(isset($pr['tester']))
		//	$tester=$this->import_add_user($pr['tester']);

		$mu=YxlUsers::get_active_mu();

		// Check product
		$pqinfo=$this->pq_find_by_name($pr['product'],TRUE);
		$pid=$pqinfo['pid'];
		$rnd_mgr=$pqinfo['rnd_mgr'];
		$qa_mgr=$pqinfo['qa_mgr'];

		// Check version
		if(isset($pr['version']))
			$rn=$pr['version'];
		else
			$rn=FALSE;

		$inr=FALSE;
		if($rn){
			$tmp=explode(' ',substr($rn,0,16));
			$rn=escape_data(trim($tmp[0]));
			$rel_row=simple_query("SELECT rel_id, state FROM releases WHERE pid=$pid AND label='$rn'");
			//echo "rel_id=$rel_id, label=$rn <br>\n";
			if(!$rel_row){
			// Add new release label
				$query = "INSERT INTO releases (pid, state, label, done_date, options) VALUES($pid, 'done', '$rn', NOW(), ".REL_OPT_BTS." )";
				//echo "$query <br>\n";
				if(!@mysql_query ($query))
					_die2(__FILE__.':'.__LINE__.' Could not insert into releases table.');
				$rel_id=mysql_insert_id();
			}else{
				$rel_id=$rel_row[0];
				if(($rel_row[1]!='done') && ($cpri!=REQ_PRI_CRITICAL))
					$inr=$rel_row[1]=='plan'?'plan':'yes';
			}
		}else
			$rel_id=0;

		// Check component
		if(isset($pr['component']))
			$cn=substr($pr['component'],0,63);
		else
			$cn=FALSE;

		if($cn){
			$pqinfo=$this->pq_find_by_name($cn,TRUE,$pid);
			$cid=$pqinfo['pid'];
			$rnd_mgr=$pqinfo['rnd_mgr'];
			$qa_mgr=$pqinfo['qa_mgr'];
		}else
			$cid=$pid;

		// Check customer
		if(isset($pr['cust']) && $pr['cust']){
			$cust_id=find_customer_by_name($pr['cust'],TRUE);
		}else
			$cust_id=$customer_id;

		$syn=escape_data($pr['syn']);
		$d=escape_data($pr['descr']);

		$rd='NOW()';$rdtm=FALSE;
		if(isset($pr{'reg_date'})){
			$rdtm=strtotime($pr{'reg_date'});
			if($rdtm && ($rdtm>0))
				$rd="FROM_UNIXTIME($rdtm)";
			else
				$rdtm=FALSE;
			//$rd="STR_TO_DATE(".$pr{'reg_date'}.",'%Y-%m-%d-%H.%i.%s')";
		}

		$last_changed=FALSE;
		if(isset($pr{'modified'})){
			$last_changed=strtotime($pr{'modified'});
			if($last_changed<0)
				$last_changed=FALSE;
		}

		$dup_rid=0;
		if(isset($pr['dup_xrid']) && $pr['dup_xrid']){
			$dup_xrid=$pr['dup_xrid'];
			$dup_rid=simple_query("SELECT rid FROM requests WHERE xrid=$dup_xrid LIMIT 1") or $dup_rid=0;
			//echo "$dup_xrid, $dup_rid. <br>\n";
		}

		init_customers(TRUE);
		$this->init_pqs(FALSE,TRUE);

		// Check if this external PR already exists as Yoxel RID
		if($rid){
		// Update existing RID
			$fixer=$rid[1];
			$tester=$rid[2];
			$submitter=$rid[3];
			$prev_state=$rid[5];
			$rid=$rid[0];

			//echo "Udating $prev_state $state<br>"; die();
			$opt_str='';
			if(isset($pr{'vbc'})){
				if($pr{'vbc'})
					$opt_str=", options=options|".REQ_OPT_VBC;
				else
					$opt_str=", options=options&~".REQ_OPT_VBC;
			}

			$bld_str='';
			if(isset($pr{'bldo'}))
				$bld_str.= ", reported_in_build='".escape_data($pr{'bldo'})."'";

			if(isset($pr{'bldc'}))
				$bld_str= ", fixed_in_build='".escape_data($pr{'bldc'})."'";

			$chng_sql_str=$this->detect_state_change($rid,$state,$last_changed);
			//if($chng_sql_str) echo "$chng_sql_str <br>\n";

			$query = "UPDATE requests SET pid=$cid, state=$state, synopsis='$syn', description=".($skip_descr?"NULL":"'$d'").", class=$class, customer_id=$cust_id, customer_pri=$cpri".($ph_of_rid?", phase_of_rid=$ph_of_rid":'').", ".($fixer?'':"fixer_uid=".($uid?$uid:$mu).", ").($tester?'':"tester_uid=".($uid?$uid:$mu).", ").($submitter?'':"filed_by=".($uid?$uid:$mu).", ").($inr?", release_id=$rel_id, in_release='$inr'":'')."reported_in_rel_id=$rel_id, xrid_last_import=NOW(), reg_date=$rd, dup_rid=$dup_rid $opt_str $bld_str $chng_sql_str WHERE rid=$rid";
			//echo "$query <br>";
			if(!@mysql_query ($query))
				_die2(__FILE__.':'.__LINE__.' Could not update requests table.');

			$RInfo=$this->request_info($rid,$xstr2uid);
			if(($state!=$prev_state) && $cmd_line_mode)
				$this->log_history($RInfo,$uid?$uid:$mu,"External PR$ext_pr_num state change detected.");
		}else{
		// CREATE NEW RID
			//echo "Creating <br>";
			$opt=REQ_OPT_EXTERNAL|REQ_OPT_X|REQ_OPT_VBC;
			if(isset($pr{'vbc'}) && !$pr{'vbc'})
					$opt&=~REQ_OPT_VBC;
			if(isset($pr{'bldo'}))
				$bldo=escape_data($pr{'bldo'});
			else
				$bldo='';

			$cror=$this->get_cror($pid);

			$query = "INSERT INTO requests (pid, state, synopsis, description, class, customer_id, customer_pri, filed_by, phase_of_rid, fixer_uid, tester_uid, reported_in_rel_id, reported_in_build, reg_date, options, xrid, xrid_last_import, critical_order, dup_rid".($inr?", release_id, in_release":'').") VALUES ($cid, $state, '$syn', ".($skip_descr?"NULL":"'$d'").", $class, $cust_id, $cpri, ".($uid?$uid:$mu).", $ph_of_rid, $rnd_mgr, $qa_mgr, $rel_id, '$bldo', $rd, $opt, $ext_pr_num, NOW(), $cror, $dup_rid".($inr?", $rel_id, '$inr'":'').")";
			//echo "$query <br>";
			if(!@mysql_query ($query))
				_die2(__FILE__.':'.__LINE__.' Could not insert into requests table.');
			$rid=mysql_insert_id();

			$upd_sql=array();
			if($last_changed){
				if($state&$lsm)
					array_push($upd_sql,"last_date=FROM_UNIXTIME($last_changed)");
				elseif($state&$vsm)
					array_push($upd_sql,"verified_date=FROM_UNIXTIME($last_changed)");
				elseif($state&$fsm){
					array_push($upd_sql,"fixed_date=FROM_UNIXTIME($last_changed)");
					//echo $pr{'reg_date'}."/".$pr{'modified'};
					$ft=$this->delta_wrk_hrs($rdtm,$last_changed,$rnd_mgr);
					if($ft>=0)
						array_push($upd_sql,"fix_wrk_hrs=$ft");
					//echo " ---> $ft hrs<br>\n";
				}elseif($state&$ism)
					array_push($upd_sql,"inwork_date=FROM_UNIXTIME($last_changed)");
			}
			if(count($upd_sql)){
				$upd_sql_str=implode(', ',$upd_sql);
				$query = "UPDATE requests SET $upd_sql_str WHERE rid=$rid";
				//echo "$query <br>";
				if(!@mysql_query ($query))
					_die2(__FILE__.':'.__LINE__.' Could not update requests table.');
			}
			$RInfo=$this->request_info($rid,$xstr2uid);
			$this->log_history($RInfo,$uid?$uid:$mu,"Importing PR$ext_pr_num from external BTS.");
		}

		if($rid<=0)
			return $rid;

		// Check x_fields
		if(!$this->have_extra())
			return $rid;

		foreach($pr as $k => $v){
			if(substr($k,0,2) != 'x_')
				continue;
			$xk=trim(substr($k,2));
			if(!($fid=$this->get_xfid_by_short_name($xk)))
				continue;
			//echo "$xk $v $fid <br>\n";
			$this->update_xfid_extra_for_rid($rid,$fid,$v);
		}

		return $rid;
	}

	function list_allowed_products($cid=FALSE){
		return $this->list_allowed_pqs($cid);
	}

	function _dashboard_intro($did,$uid,$info=FALSE){
		global $dir_name;
		global $is_customer;

		if($info)
			return array('header' => 'Request Tracking System (Intro)',
				'default_size' => 2,
				'type' => 'table/text',
				'only' => '/rts');

		$tbl_str='
        <table border=0 cellpadding=0 cellspacing=1 width="100%" class=dgray align="center">
	<tr style="height: 1" class="separator">
		<td></td>
	</tr>
        <tr class="lgray">
		<td>
        <ul>
        	<li><a href="'.$dir_name.'/rts/wf_bts_file.php">Submit</a> requests: support, bug'.($is_customer?' and':',').' enhancement'.($is_customer?'':', and new development').'</li>
        	<li><a href="'.$dir_name.'/rts/wf_bts_query.php">Search</a> the requests database</li>
        	<li><a href="'.$dir_name.'/rts/wf_bts_cp.php">Prioritize</a> your critical requests</li>
        	<li><form target="req" action="'.$dir_name.'/rts/wf_bts_view.php">
			View'.($is_customer?'':'/Edit').' a request if you know its number:<input class="inp" type=text name=id size=6 maxlength=6><input class="btn_small" type=button name=submit value=View onClick="rid_check(this.form)">
			</form>
		</li>';

        if($this->exists_xbts() && !$is_customer)
                $tbl_str.= '
        <li>Import one or more requests from your external BTS:
        	<form action="'.$_SERVER['PHP_SELF'].'" method="post">
        	<table border=0 cellpadding=0 cellspacing=0 valign=top>
        	<tr>
                	<td valign=top align=left><input class="inp" type="text" name="xrids" size="48" maxlength="256" value="'.(isset($_POST['xrids'])?$_POST['xrids']:'').'" /></td>
                	<td><input class="btn_small" type=submit name=submit value=Import></td>
        	</tr>
        	<tr>
                	<td>For example (external bug numbers): 234, 456, 23, ...</td>
                	<td></td>
        	</tr>
        	</table>
        	</form>
	</li>';
                $tbl_str.= '
        </ul>
        </td></tr>
        </table>';

		return $tbl_str;
	}

	function _dashboard_imported_requests($did,$uid,$info=FALSE){
		global $dir_name;
		global $is_customer;

		if(!$this->exists_xbts() || !($_SESSION['lic']&LIC_X) || $is_customer)
			return FALSE;

		if(prereq_check('rts_no_requests'))
			return FALSE;

		if($info){
			return array('header' => 'Recently Imported External Requests',
				'default_size' => 2,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => '#requests to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
		}
		if(!$lim)
			$lim=5;

		$pq_sn=$this->object_params['pq_title'];
		$sub_pq_sn=$this->object_params['sub_pq_title'];

		$tbl_str='';

		$sql=$this->request_query_sqlstr('',FALSE);
		$query="$sql AND r.options&".REQ_OPT_EXTERNAL." ORDER BY r.xrid_last_import DESC LIMIT $lim";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from releases table.');

		if(mysql_num_rows($result)<1)
			return $tbl_str;

		$tbl_str.= '
	<tr style="height: 1" class="separator">
		<td colspan=5></td>
	</tr>
	<tr class=lgray>
		<th>XID</th>
		<th align="left">'.sprintf(HDR_LONG_SYNOP_F,$pq_sn,$sub_pq_sn,'Synopsis').'</th>
		<th>Sate</th>
	</tr>';
		while($row=mysql_fetch_array($result, MYSQL_ASSOC)){
			$tbl_str.= '
	<tr class="lgray" onmouseover="this.className=\'lgs\';" onmouseout="this.className=\'lgray\';" onClick="view_win_open('.$row['rid'].')">
		<td align="center">'.$row['xrid'].'</td>
		<td>'.html_safe_text($row['pq_name'].' '.$row['synopsis']).'</td>
		<td align="center">'.$this->state2str[$row['state']].'</td>
	</tr>';
		}

		if($tbl_str)
			$tbl_str= '
		<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
		</table>';
		return $tbl_str;
	}

	function _dashboard_requests2close($did,$uid,$info=FALSE){
		global $dir_name;
		global $is_customer;

		if(prereq_check('rts_no_requests'))
			return FALSE;

		if($info){
			return array('header' => 'Requests you need to close',
				'default_size' => 1,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => '#requests to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
		}
		if(!$lim) $lim=5;

		$pq_sn=$this->object_params['pq_title'];
		$sub_pq_sn=$this->object_params['sub_pq_title'];

		$tbl_str='';
		$sql=$this->request_query_sqlstr('',FALSE);
		$query = "$sql AND ".$this->sql_verified_states_str." AND !".$this->sql_last_states_str." AND r.filed_by=$uid AND (r.options&".REQ_OPT_EXTERNAL.")=0 ORDER BY r.verified_date LIMIT $lim";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from requests table.');

		if(mysql_num_rows($result)<1)
			return $tbl_str;
		$tbl_str.= '
	<tr style="height: 1" class="separator">
		<td colspan=3></td>
	</tr>
	<tr class=lgray>
		<th>ID</th>
		<th align="left">'.sprintf(HDR_LONG_SYNOP_F,$pq_sn,$sub_pq_sn,'Synopsis').'</th>
	</tr>';
		while($row=mysql_fetch_array($result, MYSQL_ASSOC)){
			$tbl_str.= '
	<tr class="lgray" onmouseover="this.className=\'lgs\';" onmouseout="this.className=\'lgray\';" onClick="view_win_open('.$row['rid'].')">
		<td align="center">'.$row['rid'].'</td>
		<td>'.html_safe_text($row['pq_name'].' '.$row['synopsis']).'</td>
	</tr>';
		}

		if($tbl_str)
			$tbl_str= '
	<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
	</table>';

		return $tbl_str;
	}

	function xstr2uid(&$RInfo,&$xstr2uid){
		global $customers_2d;

		init_customers();
		parent::xstr2uid($RInfo,$xstr2uid);

		$parent=$this->pqs_2d['parent'][$RInfo['pid']]?$this->pqs_2d['parent'][$RInfo['pid']]:$RInfo['pid'];

		$xstr2uid['%prod_rnd_mgr']=$this->pqs_2d['rnd_mgr'][$parent];
		$xstr2uid['%prod_qa_mgr']=$this->pqs_2d['qa_mgr'][$parent];
		$xstr2uid['%cae_mgr']=$RInfo['customer_id']?$customers_2d['cae_mgr'][$RInfo['customer_id']]:0;
		$xstr2uid['%sls_mgr']=$RInfo['customer_id']?$customers_2d['sls_mgr'][$RInfo['customer_id']]:0;
	}

	function request_info($rid,&$xstr2uid,$popup_error=FALSE){

		$this->request_info_sql="SELECT r.*, UNIX_TIMESTAMP(r.reg_date) AS reg_date_tm, UNIX_TIMESTAMP(r.inwork_date) AS inwork_date_tm, UNIX_TIMESTAMP(r.fixed_date) AS fixed_date_tm, UNIX_TIMESTAMP(r.verified_date) AS verified_date_tm, UNIX_TIMESTAMP(r.last_date) AS last_date_tm";

		return(parent::request_info($rid,$xstr2uid,$popup_error));
	}

	function process_view_fields(&$RInfo,&$xstr2uid,&$releases_2d,$action_is_clone){
		global $all_users_2d;

		$SQLStr='';$comment='';
		$res=parent::process_view_fields($RInfo,$xstr2uid,$action_is_clone);
		$SQLStr.=array_shift($res);
		$comment.=array_shift($res);

		if ($this->is_rw_field('reported_in_rel_id') && isset($_POST['reported_in_rel_id'])){
			$rel_id = $_POST['reported_in_rel_id'];
			if (($rel_id != $RInfo['reported_in_rel_id']) && ($rel_id || $RInfo['reported_in_rel_id'])){
				$SQLStr .= ", reported_in_rel_id = '$rel_id'";
				$comment .= "Reported in release: ".(isset($releases_2d['lbl'][$RInfo['reported_in_rel_id']])?$releases_2d['lbl'][$RInfo['reported_in_rel_id']]:'N/A')." -> ".(isset($releases_2d['lbl'][$rel_id])?$releases_2d['lbl'][$rel_id]:'N/A')."\n";
			}
		}

		if ($this->is_rw_field('reported_in_build') && isset($_POST['reported_in_build'])){
			$rib = $_POST['reported_in_build'];
			if ($rib != $RInfo['reported_in_build']){
				$SQLStr .= ", reportd_in_build = '$rib'";
				$comment .= "Reported in build: {$RInfo['reported_in_build']} -> $rib\n";
			}
		}

		if ($this->is_rw_field('fixed_in_build') && isset($_POST['fixed_in_build'])){
			$fib = $_POST['fixed_in_build'];
			if ($fib != $RInfo['fixed_in_build']){
				$SQLStr .= ", fixed_in_build = '$fib'";
				$comment .= "Fixed in build: {$RInfo['fixed_in_build']} -> $fib\n";
			}
		}

		return array($SQLStr,$comment);

	}

	function request_view_tr_Tester(&$RInfo,$xstr2uid,$est_hrs=TRUE){
		global $all_users_2d;
		global $uid;

		$class=$RInfo['class'];
		$vsm=$this->verified_state_mask[$class];
		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;
?>
<tr class='lgray'>
 <th>Tester</th>
 <td colspan=2><?php

  if ($this->is_rw_field('tester_uid') || $rid_is_external){
  	$nsa=$this->null_state_action($class);
  	$pmgr_uid=$this->default_value('tester_uid',$nsa,$xstr2uid);
  	$mgr_uid=$uid;
	print "\n  <select name='tester_uid' class='selec'>\n";
	print "   <option value=''>Please, select user..........\n";

	foreach ($all_users_2d['name'] AS $xUid => $xName){
		if ($all_users_2d['user_is'][$xUid] & USER_IS_LOCKED) continue;
		if ($all_users_2d['user_is'][$xUid] & USER_IS_CUSTOMER) continue;
		if (($mgr_uid != $xUid) && ($mgr_uid != $all_users_2d['report_to'][$xUid]) && ($pmgr_uid != $xUid) && ($RInfo['tester_uid'] != $xUid)) continue;
		print "		<option value='$xUid'".(($xUid == $RInfo['tester_uid'])?" selected":"").">$xName\n";
	}
	print "  </select>\n";
  }else{
	if (isset($all_users_2d['name'][$RInfo['tester_uid']]))
		print "<a href='mailto:".$all_users_2d['email'][$RInfo['tester_uid']]."'>".$all_users_2d['name'][$RInfo['tester_uid']]."</a>";
	else
		print 'N/A';
  }

  if($est_hrs!==TRUE){
  // When the parameter is actually specified

  	if($RInfo['state']&$vsm)
  		print "&nbsp;&nbsp;[estimated: ".($est_hrs===FALSE?'N/A':$est_hrs)." hrs]";

  	if($rid_is_external && ($RInfo['state']&$vsm)){
		$tt=$this->detect_state_change($RInfo['rid'],$RInfo['state'],FALSE,TRUE);
		if($RInfo['test_wrk_hrs'])
			$tt=$RInfo['test_wrk_hrs'];

  		echo '&nbsp;&nbsp;[actual: <input type="text" class="inp" size="4" maxlength="6" value="'.$tt.'" name="test_wrk_hrs">hrs]';
  	}

  	if(!$rid_is_external && $this->is_rw_field('test_wrk_hrs')){
		$tt=$this->detect_state_change($RInfo['rid'],$vsm,FALSE,TRUE);
		if(($RInfo['state']&$vsm) && $RInfo['test_wrk_hrs'])
                        $tt=$RInfo['test_wrk_hrs'];

  		echo '&nbsp;&nbsp;[actual: <input type="text" class="inp" size="4" maxlength="6" value="'.$tt.'" name="test_wrk_hrs">hrs]';
  	}elseif(!$rid_is_external && ($RInfo['state']&$vsm) && ($RInfo['test_wrk_hrs']!==FALSE))
  		print "&nbsp;&nbsp;[actual: ".$RInfo['test_wrk_hrs']." hrs]";
  }
?></td>
</tr>
<?php
	}

	function request_query_sqlstr($cust=TRUE){
		return parent::request_query_sqlstr('',$cust);
	}

	function x_add_proj_templates($proj_id,$lbl,$fid){

                $xtemplates=new UserFilters($this->wfid().'/xtemplates');

                $tid=$xtemplates->create_new_filter("__release_planning $lbl");
                $xt=&$xtemplates->get_filter_by_id($tid);
                $xt->pset('show_fields','r.rid,r.comp,r.synopsis,r.state,r.pri_votes');
                $xt->pset('structure','h1,c1');
                $xt->pset('name:h1','Planned Requests');
                $xt->pset('filter:c1',$fid);
                $xt->pset('order1:c1','relpri_asc');
                $xt->pset('output_limit:c1',100);
		$xt->pset('_proj_tag',$proj_id);
		$xt->pset('_proj_phase','plan');
                $xt->save(array($fid));

                $tid=$xtemplates->create_new_filter("__release_tracking $lbl");
                $xt=&$xtemplates->get_filter_by_id($tid);
                $xt->pset('show_fields','r.rid,r.comp,r.synopsis,r.state,r.fixer_uid,r.tester_uid');
                $xt->pset('structure','h1,c1');
                $xt->pset('name:h1','Planned Requests');
                $xt->pset('filter:c1',$fid);
                $xt->pset('order1:c1','relpri_asc');
                $xt->pset('output_limit:c1',100);
		$xt->pset('_proj_tag',$proj_id);
		$xt->pset('_proj_phase','track');
                $xt->save(array($fid));
	}

	function x_remove_proj_templates($proj_id){
		$xtemplates=new UserFilters($this->wfid().'/xtemplates');
		$xtemplates->remove_tagged_filters('_proj_tag',$proj_id);
	}
}

	define('AI_OPT_DONE', 1);
	define('AI_OPT_PRIVATE', 2);

	define('CDB_CREATE_AIS_TBL', 'CREATE TABLE IF NOT EXISTS ais
		(aiid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		synopsis VARCHAR(128) NOT NULL,
		pri SMALLINT UNSIGNED NOT NULL,
		owner INT UNSIGNED NOT NULL,
		filed_by INT UNSIGNED NOT NULL,
		customer_id INT UNSIGNED NOT NULL,
		description MEDIUMBLOB,
		options INT UNSIGNED NOT NULL,
		reg_date DATETIME NOT NULL,
		due_date DATE,
		PRIMARY KEY (aiid),
			KEY (pri),
			KEY (owner),
			KEY (filed_by),
			KEY (due_date)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci');

if(!$GLOBALS['cmd_line_mode'] && $GLOBALS['uid']){
	$query = CDB_CREATE_AIS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create ais table. ');
}

class ActionItems {

	function actionitems(){
		if(!simple_query("SELECT COUNT(aiid) FROM ais LIMIT 1"))
			prereq_check_set('ais_no_records');
	}

	function _dashboard_requests($did,$uid,$info=FALSE){
		global $dir_name;
		global $is_customer;

		if($is_customer)
			return FALSE;

		if(prereq_check('rts_no_requests'))
			return FALSE;

		if(prereq_check('ais_no_records'))
			return FALSE;

		if($info){
			return array('header' => 'Your top priority Action Items',
				'default_size' => 1,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => '#AIs to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
		}
		if(!$lim) $lim=5;

		$tbl_str='';
		$query = "SELECT aiid, synopsis, pri FROM ais WHERE (options&".AI_OPT_DONE.")=0 AND owner=$uid ORDER BY IF(DATE_ADD(CURDATE(),INTERVAL 3 DAY)>due_date,due_date,NULL) DESC, pri ASC LIMIT $lim";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Can not select from AI table.');
		if(mysql_num_rows($result)){
			$tbl_str.= '
			<tr style="height: 1" class="separator">
				<td colspan=3></td>
			</tr>
			<tr class=lgray>
				<td colspan=3><ol>';
			while($row=mysql_fetch_array($result, MYSQL_NUM)){
			$tbl_str.= '
				<li>'.$row[1].'</li>';
			}
			$tbl_str.= '
				</ol>
				</td>
			</tr>';
		}
		if($tbl_str)
			$tbl_str= '
		<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
		</table>';
		return $tbl_str;
	}
}
?>
