<?php
// $Header: /home/CVS/rps/includes/rts/rts.inc,v 1.205 2008/07/18 05:33:41 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('includes/db.inc');
require_once('includes/params/user_filters.inc');
require_once('includes/project/calendar.inc');

define('RTS_VIEW_IS_MAIN',0x00);
define('RTS_VIEW_IS_HISTORY',0x01);
define('RTS_VIEW_IS_EXTRA',0x02);
define('RTS_VIEW_IS_HELP',0x03);
define('RTS_VIEW_IS_CLOG',0x04);
define('RTS_VIEW_IS_CLOG2',0x05);

define('REMIND_MEMPRI', 0x00);
define('REMIND_NOFET', 0x01);
define('REMIND_NOTET', 0x02);
define('REMIND_FET', 0x03);
define('REMIND_TET', 0x04);

define('REQ_OPT_VBC', 1); // Visible by one customer
define('REQ_OPT_X', 2); // Include in X-reports
define('REQ_OPT_EXTERNAL', 4);
define('REQ_OPT_RPSTMP', 8);
define('REQ_OPT_RPSAUTO', 16);
define('REQ_OPT_VBC2', 32); // Visible by any customer


define('SQL_PQ',"CONCAT('[',IF(c.parent=0,CONCAT(c.name,' - General'),CONCAT(p.name, ' - ', c.name)),']')");
define('SQL_LONG_SYNOP', "CONCAT(r.rid,': ',".SQL_PQ.",' ',r.synopsis)");
define('HDR_LONG_SYNOP_F',"[%s - %s] %s");
define('HDR_LONG_PQ_F',"[%s - %s]");

define('SQL_SUB_PQ',"CONCAT('[',IF(c.parent=0,'General',c.name),']')");
define('SQL_SHORT_SYNOP',"CONCAT(r.rid,': ',".SQL_SUB_PQ.",' ',r.synopsis)");
define('HDR_SHORT_SYNOP_F',"[%s] %s");



// The following xfields table is used to list eXtra/custom fields
// that can be used by eXtra reporting subsystem.
// In addition to that it defines a special relation between some original and some
// custom fields. Some original fields that are marked as SOFT can be overridden
// by a custom field in eXtra reports. For that the custom field should be of the
// same type and contain the field id (fid) of the original field in over_fid
// column.
define('FIELD_OPT_X', 1);  	// x-field (not original) field for table_id table
define('FIELD_OPT_SOFT', 2);	// ones that can be overridden

define('XFIELDS_TBL_F', 'xfields_%s');
define('CDB_CREATE_XFIELDS_TBL_F', "CREATE TABLE IF NOT EXISTS ".XFIELDS_TBL_F."
	(fid INT UNSIGNED NOT NULL AUTO_INCREMENT,
	long_name VARCHAR(128),
	short_name VARCHAR(64),
	field_name VARCHAR(128),
	field_type VARCHAR(64),
	over_fid VARCHAR(64),
	options INT UNSIGNED DEFAULT 0 NOT NULL,
	PRIMARY KEY (fid)
	)");

// This table will carry the actual data entered by user for
// a particular custom field and request ID. So id is really rid from
// table_id (requests/itrequests/...) table. fid is the field id from xfields
// table. uid - user id of the person who entered this data. xfield is the
// data itself.
define('EXTRAS_TBL_F', 'extras_%s');
define('CDB_CREATE_EXTRAS_TBL_F', "CREATE TABLE IF NOT EXISTS ".EXTRAS_TBL_F."
	(id INT UNSIGNED NOT NULL,
	fid INT UNSIGNED NOT NULL,
	uid INT UNSIGNED DEFAULT 0 NOT NULL,
	options INT UNSIGNED NOT NULL,
	xfield TEXT,
	UNIQUE KEY (id,fid,uid)
	)");



class RequestTracker extends WorkFlow {
	var $first_customer_id;
	var $rts_from_header;
	var $rts_subject_format;
	var $rts_msg_signature;
	var $object_params;
	var $class2str=array();
	var $bug_class;
	var $x_fields_2d=array();
	var $x_field_type=array();

	function check_object_params(&$object_params){

		if(!isset($object_params['wfid']))
			_die(__FILE__.':'.__LINE__." object parameter wfid is not defined.");
		if(!isset($object_params['rts_short_name']))
			_die(__FILE__.':'.__LINE__." object parameter rts_short_name is not defined.");
		if(!isset($object_params['rts_long_name']))
			_die(__FILE__.':'.__LINE__." object parameter rts_long_name is not defined.");
		if(!isset($object_params['requests_tbl']))
			_die(__FILE__.':'.__LINE__." object parameter requests_tbl is not defined.");
		if(!isset($object_params['req_view_script']))
			_die(__FILE__.':'.__LINE__." object parameter req_view_script is not defined.");
		if(!isset($object_params['req_email_view_script']))
			_die(__FILE__.':'.__LINE__." object parameter req_email_view_script is not defined.");
		if(!isset($object_params['history_tbl']))
			_die(__FILE__.':'.__LINE__." object parameter history_tbl is not defined.");
		if(!isset($object_params['history_rts_type']))
			_die(__FILE__.':'.__LINE__." object parameter history_rts_type is not defined.");
		if(!isset($object_params['history_pqset_type']))
			_die(__FILE__.':'.__LINE__." object parameter history_pqset_type is not defined.");

		if(!isset($object_params['members_tbl']))
			_die(__FILE__.':'.__LINE__." object parameter members_tbl is not defined.");
		if(!isset($object_params['member_cc_type']))
			_die(__FILE__.':'.__LINE__." object parameter member_cc_type is not defined.");
		if(!isset($object_params['member_pqlist_type']))
			_die(__FILE__.':'.__LINE__." object parameter member_pqlist_type is not defined.");

		if(!isset($object_params['customer_class_mask_fn']))
			_die(__FILE__.':'.__LINE__." object parameter customer_class_mask_fn is not defined.");
		if(!isset($object_params['pq_tbl']))
			_die(__FILE__.':'.__LINE__." object parameter pq_tbl is not defined.");
		if(!isset($object_params['pq_fn']))
			_die(__FILE__.':'.__LINE__." object parameter pq_fn is not defined.");
		if(!isset($object_params['pq_owners']))
			_die(__FILE__.':'.__LINE__." object parameter pq_owners is not defined.");
		if(!isset($object_params['pq_long_title']))
			_die(__FILE__.':'.__LINE__." object parameter pq_long_title can not be empty.");
		if(!isset($object_params['pq_title']))
			_die(__FILE__.':'.__LINE__." object parameter pq_title can not be empty.");
		if(!isset($object_params['sub_pq_title']))
			_die(__FILE__.':'.__LINE__." object parameter sub_pq_title can not be empty.");
		if(!isset($object_params['req_proj_id_fn']))
			_die(__FILE__.':'.__LINE__." object parameter req_proj_id_fn can not be empty.");
		if(!isset($object_params['req_in_proj_fn']))
			_die(__FILE__.':'.__LINE__." object parameter req_in_proj_fn can not be empty.");

		if(!isset($object_params['proj_tbl']))
			_die(__FILE__.':'.__LINE__." object parameter proj_tbl is not defined.");
		if(!isset($object_params['proj_id_fn']))
			_die(__FILE__.':'.__LINE__." object parameter proj_id_fn is not defined.");
		if(!isset($object_params['proj_rts_opt']))
                        _die(__FILE__.':'.__LINE__." object parameter proj_rts_opt is not defined.");

		if(!isset($object_params['pnets_tbl']))
			_die(__FILE__.':'.__LINE__." object parameter pnets_tbl is not defined.");
		if(!isset($object_params['pnet_type_pri']))
			_die(__FILE__.':'.__LINE__." object parameter pnet_type_pri is not defined.");

		if(!isset($object_params['x_native_fields']) || (count($object_params['x_native_fields'])<1))
			_die(__FILE__.':'.__LINE__." object parameter x_native_fields is not defined.");

		if(!isset($object_params['x_order_by']) || (count($object_params['x_order_by'])<1))
			_die(__FILE__.':'.__LINE__." object parameter x_order_by is not defined.");
	}

	function requesttracker(&$object_params,$main_pqs_only=FALSE){
		global $is_customer;
		global $MyDomain;
		global $MyCName;
		global $yoxel_signature;
		global $asp_mode;
		global $cmd_line_mode;

		$this->check_object_params($object_params);
		$this->object_params=$object_params;
		$wfid=$object_params['wfid'];
		parent::workflow($wfid);
		$this->first_customer_id=init_customers();
		$this->init_pqs($main_pqs_only);

		if(count($this->pqs_2d['name'])<1)
			prereq_check_set('rts_no_pqs');

		$req_tbl=$this->object_params['requests_tbl'];
		if(!simple_query("SELECT COUNT(rid) FROM $req_tbl LIMIT 1"))
			prereq_check_set('rts_no_requests');

		$this->bug_class=0;
		foreach($this->classes['options'] as $k => $o){
                	if($is_customer)
				if($o&WFREQCLASS_OPT_PRIVATE) continue;

			$this->class2str[$k]=$this->classes['name'][$k];
			if($this->classes['type'][$k]==WFREQCLASS_TYPE_BUG)
				$this->bug_class=$k;
        	}

		$prefix=$this->object_params['rts_short_name'];
		$prefix2=$this->object_params['rts_long_name'];

		$this->rts_from_header = email_header_From($prefix);
		$this->rts_subject_format = "{%action} %ppq/%spq|%rid: %synop";

		$this->rts_msg_signature = "  Please make sure that your browser has pop-up blocking disabled for this site, because the site uses pop-up windows.\n\n\t\t\t\t\t\t\t\tSincerely,\n\t\t\t\t\t\t\t\t$prefix2";

		if(!$cmd_line_mode)
			$this->init_extra();

		$this->x_field_type = array(
			'date' => array(
				'name' => 'DATE',
				'align' => 'center'),
			'number' => array(
				'name' => 'NUMBER',
				'align' => 'center'),
			'text_line' => array(
				'name' => 'TEXT LINE',
				'align' => 'left'),
			'text_area' => array(
				'name' => 'TEXT AREA',
				'align' => 'left'),
			'username' => array(
				'name' => 'USERNAME',
				'align' => 'center'),
			'class' => array(
				'name' => 'REQUEST CLASS',
				'align' => 'center'),
			'state' => array(
				'name' => 'REQUEST STATE',
				'align' => 'center'),
			'rel' => array(
				'name' => 'RELEASE LABEL',
				'align' => 'center'),
			'customer' => array(
				'name' => 'CUSTOMER NAME',
				'align' => 'center'),
			'customer_pri' => array(
				'name' => 'CUSTOMER PRIORITY',
				'align' => 'center'),
			'main_pq' => array(
				'name' => 'PRODUCT NAME',
				'align' => 'left'),
			'sub_pq' => array(
				'name' => 'COMPONENT NAME',
				'align' => 'left'),
			'ph_list' => array(
				'name' => 'LIST OF SUB-REQUESTS',
				'align' => 'left'),
			'pri_votes' => array(
				'name' => 'PRIORITY VOTES',
				'align' => 'left')
		);
	}

	function str2class($str){
		return array_search(strtolower($str),$this->class2str);
	}

	function get_pq_title(){
		return $this->object_params['pq_title'];
	}

	function get_sub_pq_title(){
		return $this->object_params['sub_pq_title'];
	}

	function get_pq_long_title(){
		return $this->object_params['pq_long_title'];
	}

	function get_pq_fn(){
		return $this->object_params['pq_fn'];
	}

	function get_proj_rts_opt(){
		return $this->object_params['proj_rts_opt'];
	}

	function pq_exists($pq_name,$parent=FALSE,$except_pqid=FALSE){
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$query = "SELECT $pq_fn FROM $pq_tbl WHERE name='".escape_data($pq_name)."'".($parent!==FALSE?" AND parent=$parent":'').($except_pqid?" AND $pq_fn!=$except_pqid":'');
		//echo "$query <br>\n";
		if(!($result= @mysql_query($query)))
			die2(__FILE__, __LINE__," Could not select from $pq_tbl table.");

		if(mysql_num_rows($result)>0)
			return TRUE;

		return FALSE;
	}

	function pq_find_by_name($pq_name,$create=FALSE,$parent=0){
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];
		$pq_owners=&$this->object_params['pq_owners'];

                $owners_str='';
                foreach($pq_owners as $owner)
                        $owners_str.=", $owner";

                $pn=escape_data($pq_name);
                $query="SELECT $pq_fn $owners_str FROM $pq_tbl WHERE name='$pn'".($parent?" AND parent=$parent":'')." LIMIT 1";
                //echo "$query <br>\n";
                if($pqrow=simple_query($query,MYSQL_ASSOC)){
			$pqrow['pqid']=$pqrow[$pq_fn];
			return $pqrow;
		}

		// Add new Product/Queue
		if(!$create)
			return FALSE;

		$mu=get_active_mu();
		foreach($pq_owners as $owner)
			$pqinfo[$owner]=$mu;

		$pqinfo[$pq_fn]=$this->pq_add($pq_name,$pqinfo,$parent);
		$pqinfo['pqid']=$pqrow[$pq_fn];
		return $pqinfo;
	}

	function pq_add($pq_name,$mgrs,$parent=0){
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$query = "INSERT INTO $pq_tbl (name, parent, reg_date, ".implode(',',array_keys($mgrs)).") VALUES('".escape_data($pq_name)."', $parent, NOW(), ".implode(", ",array_values($mgrs)).")";
		if(!@mysql_query ($query))
			_die2(__FILE__, __LINE__," Could not insert into $pq_tbl table.");
		return mysql_insert_id();
	}

	function pq_update($pqid,$pq_name,$mgrs,$parent,$clear_opt=FALSE){
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$sql_str='';
		if($clear_opt)
			$sql_str=', options=options&~'.$clear_opt;

		$mstr='';
		foreach($mgrs as $m => $u)
			$mstr.=", $m=$u";

		$adjust_children=FALSE;
		if($parent && ($parent!=simple_query("SELECT parent FROM $pq_tbl WHERE $pq_fn=$pqid")))
			$adjust_children=TRUE;

		$query = "UPDATE $pq_tbl SET name='".escape_data($pq_name)."', parent=$parent $mstr $sql_str WHERE $pq_fn=$pqid";
		//echo "$query <br>";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__." Could not update  $pq_tbl table.");

		if($adjust_children){
			$query = "UPDATE $pq_tbl SET parent=$parent WHERE parent=$pqid";
			//echo "$query <br>";
			if(!@mysql_query($query))
				_die2(__FILE__.':'.__LINE__." Could not update $pq_tbl table.");
		}
	}

	function pq_has_requests($pqid){
		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		return simple_query("SELECT COUNT(rid) FROM $req_tbl WHERE $pq_fn=$pqid");
	}

	function pq_is_parent($pqid){
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		return simple_query("SELECT COUNT($pq_fn) FROM $pq_tbl WHERE parent=$pqid");
	}

	function pq_parent($pqid){
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		return simple_query("SELECT parent FROM $pq_tbl WHERE $pq_fn=$pqid");
	}

	function pq_has_project($pqid){
		$proj_tbl=$this->object_params['proj_tbl'];
		$proj_id_fn=$this->object_params['proj_id_fn'];
		$proj_rts_opt=$this->object_params['proj_rts_opt'];
		$pq_fn=$this->object_params['pq_fn'];

		if(!$proj_tbl)
			return FALSE;

		return simple_query("SELECT COUNT($proj_id_fn) FROM $proj_tbl WHERE $pq_fn=$pqid && !(options&$proj_rts_opt)");
	}

	function pq_remove($pqid){
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];
		$query="DELETE FROM $pq_tbl WHERE $pq_fn=$pqid LIMIT 1";
		if(!@mysql_query($query))
			die2(__FILE__.':'.__LINE__." Could not delete from $pq_tbl table. ");
	}

	function is_pq_owner($pqid,$uid){
		$pq_owners=&$this->object_params['pq_owners'];
		foreach($pq_owners as $tag)
			if(isset($this->pqs_2d[$tag][$pqid]) && ($this->pqs_2d[$tag][$pqid]==$uid))
				return TRUE;

		return FALSE;
	}

	var $pqs_2d=array();
	function &init_pqs($main_pqs_only=FALSE,$force=FALSE){

		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];
		$pq_owners=&$this->object_params['pq_owners'];

		$pqs_2d=&$this->pqs_2d;
		$owners_str='';
		foreach($pq_owners as $owner)
			$owners_str.=", p1.$owner";

		if(!$force && count($pqs_2d))
			return $pqs_2d;

		$query = "SELECT p1.$pq_fn, p1.name, p1.parent, p1.options, if(p1.parent=0,p1.$pq_fn,p1.parent) AS pp $owners_str FROM $pq_tbl AS p1 ".($main_pqs_only?" WHERE p1.parent=0":'')." ORDER BY pp, p1.parent, p1.name";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__." Could not select from $pq_tbl table.");
		$pqs_2d['name']=array();
		$pqs_2d['parent']=array();
		$pqs_2d['options']=array();
		$pqs_2d['oname']=array();
		foreach($pq_owners as $owner)
			$pqs_2d[$owner]=array();
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			if($row[2])
				$pqs_2d['name'][$row[0]]='- '.$row[1];
			else
				$pqs_2d['name'][$row[0]]=$row[1];
			$pqs_2d['oname'][$row[0]]=$row[1];
			//echo $pqs_2d['name'][$row[0]]." <br>";
			$pqs_2d['parent'][$row[0]]=$row[2];
			$pqs_2d['options'][$row[0]]=$row[3];
			for($i=0;$i<count($pq_owners);$i++){
				$owner=$row[5+$i];
				if(!$owner)
					$owner=1;
				$pqs_2d[$pq_owners[$i]][$row[0]]=$owner;
				//echo $pq_owners[$i]." ".$row[5+$i]."<br>";
			}
		}
		return $this->pqs_2d;
	}

	function is_external(&$RInfo){
		$this->validate_rinfo($RInfo);

		return ($RInfo['options']&REQ_OPT_EXTERNAL);
	}

	function log_history(&$RInfo,$uid,$descr){

		$this->validate_rinfo($RInfo);

		$wfid=$this->wfid;
		$tbl=$this->object_params['history_tbl'];
		$typeid=$this->object_params['history_rts_type'];

		$query = "INSERT INTO $tbl (rid, uid, state, date, roptions, descr, options) VALUES (".$RInfo['rid'].", $uid, ".$RInfo['state'].", NOW(), ".$RInfo['options'].", '".escape_data($descr)."', $typeid)";
		//echo "$query<br>\n";die;
		if (!mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into '.$tbl.' table.');
	}

	function log_pq_set($uid,&$pq_set){

		$wfid=$this->wfid;
		$tbl=$this->object_params['history_tbl'];
		$pqset_type=$this->object_params['history_pqset_type'];

		$str=implode(':',$pq_set);
		//echo "$str<br>\n";
		$query="DELETE FROM $tbl WHERE DATE_SUB(CURDATE(),INTERVAL 30 DAY) > date AND options=$pqset_type";
		if (!mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could delete from '.$tbl.' table');

		$query="SELECT descr FROM $tbl WHERE options=$pqset_type ORDER BY date DESC";
		if (!($result=mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select '.$tbl.' table');

		//print_r($prod_set);
		while($row=mysql_fetch_array($result,MYSQL_NUM)){
			$hpqs=explode(':',$row[0]);
			$a1=array_diff($pq_set,$hpqs); //print_r($a1);
			$a2=array_diff($hpqs,$pq_set); //print_r($a2);

			if(!count($a1) && !count($a2))
				return;

			$i1=array_intersect($pq_set,$hpqs); //print_r($i1);
			if(count($i1))
				break;
		}
		$query = "INSERT INTO $tbl (uid, date, descr, options) VALUES ($uid, NOW(), '".escape_data($str)."', $pqset_type)";
		if (!mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into '.$tbl.' table');
	}

	function construct_pq_sets(){

		$wfid=$this->wfid;
		$tbl=$this->object_params['history_tbl'];
		$pqset_type=$this->object_params['history_pqset_type'];

		$pqids=$this->list_allowed_pqs();

		//$pqids=array();
		//$pq_parent=&$this->pqs_2d['parent'];
		//foreach($pq_parent as $k => $v){
		//	if($v) continue;
		//	array_push($pqids,$k);
		//}

		$query = "SELECT descr, uid FROM $tbl WHERE options=$pqset_type ORDER BY date DESC LIMIT 10";
		if (!($result=mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not insert into '.$tbl.' table');

		$pq_sets=array();
		while($row=mysql_fetch_array($result,MYSQL_NUM)){
			$hpqs=explode(':',$row[0]);
			$hpqs=array_intersect($hpqs,$pqids);
			//echo "hpqs= "; print_r($hpqs); echo "<br>\n";

			$ok2add=TRUE;
			foreach($pq_sets as $pa){
				$i1=array_intersect($pa,$hpqs);
				if(count($i1))
					break;
				//echo "i1= "; print_r($i1); echo "<br>\n";
			}

			if($ok2add){
				$id=implode(':',$hpqs);
				$pq_sets[$id]=$hpqs;
				$pqids=array_diff($pqids,$hpqs);
				//echo "pids= "; print_r($pqids); echo "<br>\n";
			}
		}
		foreach($pqids as $p)
			$pq_sets[$p]=array($p);

		return $pq_sets;
	}

	function add_cc($rid,$uid,$type=FALSE){

		$wfid=$this->wfid;
		$mem_tbl=$this->object_params['members_tbl'];
		if(!$type)
			$type=$this->object_params['member_cc_type'];

		$SQLStr = "INSERT INTO $mem_tbl (uid, type, xid) VALUES ($uid, $type, $rid)";
		//echo "$SQLStr <br>\n";
		if (!@mysql_query($SQLStr))
			_die2(__FILE__.':'.__LINE__." Could not insert into $mem_tbl table.");
	}

	function delete_cc($rid,$uid,$type=FALSE){

		$wfid=$this->wfid;
		$mem_tbl=$this->object_params['members_tbl'];
		if(!$type)
			$type=$this->object_params['member_cc_type'];

		$SQLStr = "DELETE FROM $mem_tbl WHERE uid = $uid AND type = $type AND xid =  $rid";
		if (!@mysql_query($SQLStr))
			_die2(__FILE__.':'.__LINE__." Could not update $mem_tbl table.");
	}

	function &get_cc_list($rid,$type=FALSE){

		$wfid=$this->wfid;
		$mem_tbl=$this->object_params['members_tbl'];
		if(!$type)
			$type=$this->object_params['member_cc_type'];

		$query="SELECT m.uid FROM $mem_tbl AS m, users AS u WHERE u.uid = m.uid AND m.type = $type AND m.xid = $rid";
		//echo "$query <br>\n";
		if (!($SQL=mysql_query($query)))
			_die2(__FILE__.':'.__LINE__." Could not select from $mem_tbl table.");

		$cc_list=array();
		$ref=&$cc_list;
		while($row = mysql_fetch_row($SQL)){
			$CC = $row[0];
			if(!YxlUsers::exists($CC) || !YxlUsers::email($CC)){
				_warn_yoxel("Database inconsistency[get_cc_list]: CC/member(wfid=$wfid,uid=$CC,rid=$rid) that does not exist in users table.");
				continue;
			}
			$cc_list[$CC]=$CC;
		}
		return $ref;
	}

	function add_to_cc_list(&$cc_list,$CC){

		$wfid=$this->wfid;
		$type=$this->object_params['member_cc_type'];

		if(!YxlUsers::exists($CC) || !YxlUsers::email($CC)){
			_warn_yoxel("Database inconsistency[add_to_cc_list]: CC/member(wfid=$wfid,uid=$CC) that does not exist in users table.");
			return;
		}

		$cc_list[$CC]=$CC;
	}

	function construct_email($uid){

		$email=YxlUsers::email($uid,TRUE);
		$name=YxlUsers::name($uid,TRUE);
		$a=explode('[',$name);
		if(isset($a[0]) && $a[0])
			return '"'.$a[0].'" <'.$email.'>';
		return '"'.$name.'" <'.$email.'>';
	}

	function split_cc_list($all_cc,&$internal_cc,&$external_cc){
		global $customers_2d;

		foreach($all_cc as $CC){
			$em=$this->construct_email($CC);
			if(YxlUsers::user_is($CC)&USER_IS_CUSTOMER){
				$cust=YxlUsers::customer($CC);
				$external_cc[$cust][$CC]=$em;
			}else
				$internal_cc[$CC]=$em;
		}
	}

	function detect_state_change($rid,$new_state,$change_tm=FALSE,$test=FALSE){

		$wfid=$this->wfid;
		$rtbl=$this->object_params['requests_tbl'];
		$htbl=$this->object_params['history_tbl'];
		$htypeid=$this->object_params['history_rts_type'];

		$sql_str='';
		$ft=$tt=0;

		$xstr2uid=array();
		$RInfo=$this->request_info($rid,$xstr2uid);

		$ism=$this->inwork_state_mask[$RInfo['class']];
		$fsm=$this->fixed_state_mask[$RInfo['class']];
		$vsm=$this->verified_state_mask[$RInfo['class']];
		$lsm=$this->last_state_mask($RInfo['class']);

		$prev_unf_state=simple_query("SELECT state, UNIX_TIMESTAMP(date) FROM $htbl WHERE rid=$rid AND options=$htypeid AND !(state&$fsm) AND state&$ism ORDER BY date ASC LIMIT 1");
		if(!$prev_unf_state)
			$prev_unf_state=simple_query("SELECT state, UNIX_TIMESTAMP(date) FROM $htbl WHERE rid=$rid AND options=$htypeid AND !(state&$fsm) ORDER BY date DESC LIMIT 1");
		if($prev_unf_state){
			$prev_unf_time=$prev_unf_state[1];
			$prev_unf_state=$prev_unf_state[0];
		}

		$prev_unv_state=simple_query("SELECT state, UNIX_TIMESTAMP(date) FROM $htbl WHERE rid=$rid AND options=$htypeid AND !(state&$vsm) AND state&$fsm AND ORDER BY date ASC LIMIT 1");
		if(!$prev_unv_state)
			$prev_unv_state=simple_query("SELECT state, UNIX_TIMESTAMP(date) FROM $htbl WHERE rid=$rid AND options=$htypeid AND !(state&$vsm) ORDER BY date DESC LIMIT 1");
		if($prev_unv_state){
			$prev_unv_time=$prev_unv_state[1];
			$prev_unv_state=$prev_unv_state[0];
		}

		$change_sql="NOW()";
		if($change_tm){
			$change_sql="FROM_UNIXTIME($change_tm)";
			if(($RInfo['state']&$lsm) && ($new_state&$lsm)){
				$sql_str.=", last_date=$change_sql";
				if(!$RInfo['verified_date_tm'] && ($new_state&$vsm))
					$sql_str.=", verified_date=$change_sql";
				if(!$RInfo['fixed_date_tm'] && ($new_state&$fsm))
					$sql_str.=", fixed_date=$change_sql";
				if(!$RInfo['inwork_date_tm'] && ($new_state&$fsm))
					$sql_str.=", inwork_date=$change_sql";
			}elseif(($RInfo['state']&$vsm) && ($new_state&$vsm)){
				$sql_str.=", verified_date=$change_sql";
				if(!$RInfo['fixed_date_tm'] && ($new_state&$fsm))
					$sql_str.=", fixed_date=$change_sql";
				if(!$RInfo['inwork_date_tm'] && ($new_state&$fsm))
					$sql_str.=", inwork_date=$change_sql";
			}elseif(($RInfo['state']&$fsm) && ($new_state&$fsm)){
				$sql_str.=", fixed_date=$change_sql";
				if(!$RInfo['inwork_date_tm'])
					$sql_str.=", inwork_date=$change_sql";
			}elseif(($RInfo['state']&$ism) && ($new_state&$ism))
				$sql_str.=", inwork_date=$change_sql";
		}

		// If turned into inwork state
		if(!($RInfo['state']&$ism) && ($new_state&$ism)){
			if(!$RInfo['inwork_date_tm'])
				$sql_str.=", inwork_date=$change_sql";
		}

		// If turned into fixed state
		if(!($RInfo['state']&$fsm) && ($new_state&$fsm)){
			if($prev_unf_state)
				$ft=$this->delta_wrk_hrs($prev_unf_time,time(),$RInfo['fixer_uid']);
			//if(!$RInfo['fixed_date'])
				$sql_str.=", fixed_date=$change_sql";
			if(!$RInfo['inwork_date_tm'])
				$sql_str.=", inwork_date=".($prev_unf_state?"FROM_UNIXTIME($prev_unf_time)":$change_sql);
		}

		// If turned into verified state
		if(!($RInfo['state']&$vsm) && ($new_state&$vsm)){
			if(!isset($RInfo['tester_uid']))
				$RInfo['tester_uid']=$RInfo['fixer_uid'];
			if($prev_unv_state)
				$tt=$this->delta_wrk_hrs($prev_unv_time,time(),$RInfo['tester_uid']);
			//if(!$RInfo['verified_date'])
			if(isset($RInfo['verified_date']))
				$sql_str.=", verified_date=$change_sql";
			if(!$RInfo['fixed_date_tm'] && ($new_state&$fsm))
				$sql_str.=", fixed_date=".($prev_unv_state?"FROM_UNIXTIME($prev_unv_time)":$change_sql);
			if(!$RInfo['inwork_date_tm'] && ($new_state&$fsm))
				$sql_str.=", inwork_date=".($prev_unf_state?"FROM_UNIXTIME($prev_unf_time)":$change_sql);
		}

		// If turned into closed state
		if(!($RInfo['state']&$lsm) && ($new_state&$lsm)){
			$sql_str.=", last_date=$change_sql";
			if(isset($RInfo['verified_date']) && !$RInfo['verified_date_tm'] && ($new_state&$vsm))
				$sql_str.=", verified_date=$change_sql";
			if(!$RInfo['fixed_date_tm'] && ($new_state&$fsm))
				$sql_str.=", fixed_date=".($prev_unv_state?"FROM_UNIXTIME($prev_unv_time)":$change_sql);
			if(!$RInfo['inwork_date_tm'] && ($new_state&$fsm))
				$sql_str.=", inwork_date=".($prev_unf_state?"FROM_UNIXTIME($prev_unf_time)":$change_sql);
		}

		if($fsm==$vsm){ // For requests like SUPPORT
			$h=$ft%2;
			$ft=$tt=($ft-$h)/2;
		}

		if($test && $ft){
			if($RInfo['fix_wrk_hrs'])
				$ft=$RInfo['fix_wrk_hrs']+$ft;
			return $ft;
		}elseif($test && $tt){
			if($RInfo['test_wrk_hrs'])
				$tt=$RInfo['test_wrk_hrs']+$tt;
			return $tt;
		}elseif($test)
			return 0;

		if($ft)
			$sql_str.=", fix_wrk_hrs=fix_wrk_hrs+$ft";
		if(isset($RInfo['test_wrk_hrs']) && $tt)
			$sql_str.=", test_wrk_hrs=test_wrk_hrs+$tt";

		return($sql_str);
	}

	// Compute wrk hrs between previous and new states
	function delta_wrk_hrs($from_tm,$to_tm,$uid){
		$cal= new Calendar;
		$end_ch=$cal->tp2ch($to_tm?$to_tm:time());
		if(!$from_tm)
			return 0;

		$start_ch=$cal->tp2ch($from_tm);
		if($start_ch>$end_ch)
			return 0;

		if(($d=($end_ch-$start_ch))>$cal->dlimit*HOURS_IN_DAY)
			return(intval(5*$d/7));

		$cal->init($start_ch,$end_ch,array($uid));
		if(($d=($end_ch-$start_ch))<=HOURS_IN_DAY)
			return(intval($d>$cal->work_day_len_hr?$cal->work_day_len_hr:$d));

		return($cal->total_whs($uid));
	}

	function &read_history(&$RInfo){
		global $is_customer;
		global $uid;

		$this->validate_rinfo($RInfo);

		$htbl=$this->object_params['history_tbl'];
		$htypeid=$this->object_params['history_rts_type'];

		$ropt_mask=~0;
		if($is_customer){
			if($is_customer==$RInfo['customer_id'])
				$ropt_mask=REQ_OPT_VBC|REQ_OPT_VBC2;
			else
				$ropt_mask=REQ_OPT_VBC2;
		}

		$pnets_tbl='';
		if($this->with_expert_rating()){
			$pnets_tbl=$this->object_params['pnets_tbl'];
			$pnets_type=$this->object_params['pnet_type_expert_rate'];

			$query="SELECT h.uid, h.state, UNIX_TIMESTAMP(h.date) AS date, h.descr, h.roptions, p.xval AS exp_rating FROM $htbl AS h LEFT JOIN  $pnets_tbl AS p ON p.type=$pnets_type AND p.uid=$uid AND p.rid=UNIX_TIMESTAMP(h.date) WHERE h.rid=".$RInfo['rid']." AND h.options=$htypeid ORDER BY date";
		}else
			$query="SELECT uid, state, UNIX_TIMESTAMP(date) AS date, descr, roptions FROM $htbl AS h WHERE rid = ".$RInfo['rid']." AND options=$htypeid ORDER BY date";
		//echo "$query <br>\n";
		if(!($SQL = @mysql_query($query)))
			_die2("Could not select from $htbl table.");

		$first_state=$this->first_state($RInfo['class']);
		for ($Hist = array(), $state = $first_state, $i=0; $Event = mysql_fetch_array($SQL,MYSQL_ASSOC); ){
			$i++;
			// Do not show hidden information
			// Always show 1st record (submission)
			// ??? Also show what is added by this customer
			//&& (YxlUsers::customer($Event['uid'])!=$is_customer)
			if($is_customer)
				if(!($Event['roptions']&$ropt_mask) && ($i!=1))
					continue;

			$Event['old_state'] = $state;
			$state = $Event['state'];
			$Event['name']=$Event['email']='N/A';
			if(YxlUsers::exists($Event['uid'])){
				$Event['name'] = YxlUsers::name($Event['uid']);
				$Event['email'] = YxlUsers::email($Event['uid']);
			}

			$Event['descr']=$this->hide_tagged_info($Event['descr'],$is_customer);
			if($Event['descr'])
				array_push($Hist, $Event);
		}
		mysql_free_result($SQL);
		$ref=&$Hist;
		return($ref);
	}

	function hide_tagged_info($txt,$hide){
                if($hide){
                        $tmp=preg_replace('/<user>.*?<\/user>/', 'Hidden Name', $txt);
                        //$tmp=preg_replace('/<edih.*>.*?<\/edih>/', 'Hidden Content', $tmp);
                        if(preg_match('/<edih[^>]*>(.*?)<\/edih>/i',$tmp,$matches))
				$tmp='';
                }else{
                        $tmp=preg_replace('/<user>(.*?)<\/user>/', '$1', $txt);
                        $tmp=preg_replace('/<edih[^>]*>(.*?)<\/edih>/', '$1', $tmp);
                }
                return $tmp;
        }

	function list_allowed_pqs($cid=FALSE){
		global $is_customer;

		$wfid=$this->wfid;
		$mem_tbl=$this->object_params['members_tbl'];
		$mem_pqlist_type=$this->object_params['member_pqlist_type'];
		$pqs_2d=&$this->pqs_2d;

		if($is_customer && $cid)
			_die2(__FILE__.':'.__LINE__.' External user is not allowed to use this mode.');

		$allowed_pqids=array();
		if(!$is_customer && !$cid){
			foreach($pqs_2d['parent'] as $pid => $p){
				if($p) continue;
				array_push($allowed_pqids,$pid);
			}
			return $allowed_pqids;
		}

		if(!$cid)
			$cid=$is_customer;

		// $is_customer constains the customer_id in this case
		$query = "SELECT xid FROM $mem_tbl WHERE type=$mem_pqlist_type AND uid=$cid";
		if (!($result=mysql_query($query)))
			_die2(__FILE__.':'.__LINE__." Could not select from $mem_tbl table.");
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			if(!isset($pqs_2d['name'][$row[0]])) continue;
			if($pqs_2d['parent'][$row[0]]) continue;
			array_push($allowed_pqids,$row[0]);
		}
		return $allowed_pqids;
	}

	function update_allowed_pqs($cid,$cust_pqs){
		global $is_customer;

		$mem_tbl=$this->object_params['members_tbl'];
		$pqlist_type=$this->object_params['member_pqlist_type'];

		if($is_customer && $cid)
			_die2(__FILE__.':'.__LINE__.' External user is not allowed to use this mode.');

		$query = "DELETE FROM $mem_tbl WHERE uid=$cid AND type=$pqlist_type";
		if (!mysql_query($query))
			_die2(__FILE__.':'.__LINE__." Could not delete from $mem_tbl table.");

		if(!count($cust_pqs))
			return;
		$sql_str='';
		while($pid=array_pop($cust_pqs))
			$sql_str.=", ($pid, $cid, $pqlist_type)";
		$query = "INSERT INTO $mem_tbl (xid, uid, type) VALUES ".substr($sql_str,2);
		//echo "$query <br>\n";
		if (!mysql_query($query))
			_die2(__FILE__.':'.__LINE__." Could not insert into $mem_tbl table.");
	}

	function list_allowed_classes($cid=FALSE){
		global $is_customer;

		$wfid=$this->wfid;
		$ccm_fn=$this->object_params['customer_class_mask_fn'];
		$c2s=&$this->class2str;

		if($is_customer && $cid)
			_die2(__FILE__.':'.__LINE__.' External user is not allowed to use this mode.');

		if(!$is_customer && !$cid){
			$allowed_classes=array_keys($c2s);
			return $allowed_classes;
		}

		if(!$cid)
			$cid=$is_customer;

		$query = "SELECT $ccm_fn FROM customers WHERE cid=$cid";
		//echo "$query <br>\n";
		if (!($result=mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from customers table.');

		if(mysql_num_rows($result)<1)
			_die("Unknown customer id = $cid.");

		$ccm=mysql_fetch_array($result, MYSQL_NUM);
		$ccm=$ccm[0];

		$allowed_classes=array();
		foreach($c2s as $c => $s){
			if(!($c&$ccm))
				continue;
			array_push($allowed_classes,$c);
		}
		return $allowed_classes;
	}

	function update_allowed_classes($cid,$cust_class_mask=0){
		global $is_customer;

		$ccm_fn=$this->object_params['customer_class_mask_fn'];

		if($is_customer && $cid)
			_die2(__FILE__.':'.__LINE__.' External user is not allowed to use this mode.');

		$query = "UPDATE customers SET $ccm_fn=$cust_class_mask WHERE cid=$cid";
		//echo "$query <br>\n";
		if (!mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not update customers table.');
	}

	function list_possible_blockers($RInfo,$num){

		$this->validate_rinfo($RInfo);

		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$pqs_2d=&$this->pqs_2d;
		$pqid=$RInfo[$pq_fn];
		if($pqid)
			$pqid=$pqs_2d['parent'][$RInfo[$pq_fn]]?$pqs_2d['parent'][$RInfo[$pq_fn]]:$RInfo[$pq_fn];
		$current_dep_rid=$RInfo['depends_on'];
		$rid=$RInfo['rid'];

		// 4.1 and up ...
		$query="SELECT r1.rid, r1.syn, r2.phn  FROM
			(SELECT r.rid,
				".SQL_LONG_SYNOP." AS syn
			FROM $req_tbl AS r INNER JOIN $pq_tbl AS c ON r.$pq_fn=c.$pq_fn
				LEFT JOIN $pq_tbl AS p ON c.parent=p.$pq_fn
			WHERE (r.$pq_fn=$pqid OR c.parent=$pqid) AND rid!=$rid AND (!".$this->sql_last_states_str." OR r.rid=$current_dep_rid) ORDER BY r.rid DESC LIMIT $num)
		AS r1 LEFT JOIN
			(SELECT COUNT(rid) AS phn, phase_of_rid FROM $req_tbl GROUP BY phase_of_rid)
		AS r2 ON r1.rid=r2.phase_of_rid";
		//echo "$query <br>\n";

		if(!($result=@mysql_query($query)))
   			_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table [$query].");


		$rids=array();
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			if(!$row[2])
				$row[2]=0;
			array_push($rids,array($row[0],$row[2],$row[1]));
			//array_push($rids,$row);
		}

		return $rids;
	}

	function list_possible_titles($pqid,$except_rid,$num){

		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		// 4.1 and up ...
		$query="SELECT r1.rid, r1.syn, r2.phn FROM
			(SELECT r.rid, ".SQL_LONG_SYNOP." AS syn
			FROM $req_tbl AS r
			INNER JOIN $pq_tbl AS c ON r.$pq_fn=c.$pq_fn
			LEFT JOIN $pq_tbl AS p ON c.parent=p.$pq_fn
			WHERE (c.$pq_fn=$pqid OR c.parent=$pqid) AND !".$this->sql_last_states_str." AND !r.phase_of_rid AND !r.depends_on AND r.rid!=$except_rid ORDER BY r.rid DESC LIMIT $num)
		AS r1 LEFT JOIN
			(SELECT COUNT(rid) AS phn, phase_of_rid FROM $req_tbl GROUP BY phase_of_rid)
		AS r2 ON r1.rid=r2.phase_of_rid";
		//echo "$query<br>\n";

		if(!($result=@mysql_query($query)))
   			_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table.");

		$rids=array();
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			if(!$row[2])
				$row[2]=0;
			array_push($rids,array($row[0],$row[2],$row[1]));
		//	array_push($rids,$row);
		}

		return $rids;
	}

	function get_long_synop($rid,$subpq_only=FALSE){

		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		if($subpq_only)
			$query="SELECT ".SQL_SHORT_SYNOP." FROM $req_tbl AS r, $pq_tbl AS c LEFT JOIN $pq_tbl AS p ON c.parent=p.$pq_fn WHERE r.$pq_fn=c.$pq_fn AND rid=$rid";
		else
			$query="SELECT ".SQL_LONG_SYNOP." FROM $req_tbl AS r, $pq_tbl AS c LEFT JOIN $pq_tbl AS p ON c.parent=p.$pq_fn WHERE r.$pq_fn=c.$pq_fn AND rid=$rid";

		return(simple_query($query));
	}

	function get_request_phases($RInfo,&$opt_mask){

		$this->validate_rinfo($RInfo);

		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];
		$rid=$RInfo['rid'];

		$result = mysql_query("SELECT r.rid, ".SQL_LONG_SYNOP.", r.state, r.class FROM $req_tbl AS r, $pq_tbl AS c LEFT JOIN $pq_tbl AS p ON c.parent=p.$pq_fn WHERE r.$pq_fn=c.$pq_fn AND phase_of_rid = $rid ORDER BY r.rid DESC");
		if (!$result)
			_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table.");

		for ($PhList = array(); $row = mysql_fetch_row($result); )
			array_push($PhList,$row);

		if ($RInfo['phase_of_rid']){
			//_warn_yoxel('not allowed');
			return($PhList);
		}

		foreach(array_keys($PhList) as $k)
			$opt_mask|=$this->forbidden4parent_next_wfstate_opt(array_pop($PhList[$k]),array_pop($PhList[$k]));

		return($PhList);
	}

	function get_cror($pqid){

		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$main_pqid=simple_query("SELECT IF(parent,parent,$pq_fn) FROM $pq_tbl WHERE $pq_fn=$pqid");

		$cror_r=simple_query("SELECT r.rid, r.critical_order FROM $req_tbl AS r INNER JOIN $pq_tbl AS c ON r.$pq_fn=c.$pq_fn WHERE (r.$pq_fn=$main_pqid OR c.parent=$main_pqid) AND r.customer_pri=".REQ_PRI_CRITICAL." AND !".$this->sql_last_states_str." ORDER BY r.critical_order DESC LIMIT 1");
		if(!$cror_r)
			$cror=1;
		else
			$cror=++$cror_r[1];
		return $cror;
	}

	function update_cror($rid,$cror){
		$req_tbl=$this->object_params['requests_tbl'];

		if(!is_int($cror))
			$cror=0;

		$query ="UPDATE $req_tbl SET critical_order=$cror WHERE rid=$rid";
                //echo "$query <br>";
                if(!($result=@mysql_query($query)))
                	_die2(__FILE__.':'.__LINE__." Can not update $req_tbl table.");
	}

	function clone_request($rid){
		global $uid;

		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$query="SELECT * FROM $req_tbl WHERE rid=$rid";
		//echo "$query<br>\n";
		if(!($result=@mysql_query($query)))
   			_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table.");
   		if(!($row=mysql_fetch_array($result, MYSQL_ASSOC)))
   			return FALSE;

   		unset($row['rid']);
   		unset($row['reg_date']);
   		$row['filed_by']=$uid;
   		$row['options']&=~REQ_OPT_VBC;

   		$fstr=implode(', ',array_keys($row));
   		$row=array_map("escape_data",$row);
   		$vstr=implode("', '",$row);
   		$query="INSERT INTO $req_tbl ($fstr, reg_date) VALUES ('$vstr', NOW())";
   		//echo "$query <br>\n";
   		if(!@mysql_query($query))
   			_die2(__FILE__.':'.__LINE__." Could not insert into $req_tbl table.");
   		$cloned_rid=mysql_insert_id();
   		return($cloned_rid);
	}

	function prepare_to_phase($rid,$in_proj,$proj_id,$title_rid){

		$req_tbl=$this->object_params['requests_tbl'];
		$req_proj_id_fn=$this->object_params['req_proj_id_fn'];
		$req_in_proj_fn=$this->object_params['req_in_proj_fn'];

		if(!$title_rid)
			return ", phase_of_rid=0";

		if(simple_query("SELECT COUNT(rid) FROM $req_tbl WHERE phase_of_rid=$rid"))
			return ", phase_of_rid=0";

		$title=simple_query("SELECT r.$req_in_proj_fn, r.$req_proj_id_fn FROM $req_tbl AS r WHERE r.rid=$title_rid") or _die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table");
		//print_r($title);die;

		$title_is_parent=simple_query("SELECT COUNT(rid) FROM $req_tbl WHERE phase_of_rid=$title_rid");

		$ok=FALSE;
		$SQLStr='';
		if(($in_proj!='yes' && $in_proj!='plan')){
		// request is not in any project
			if(($title[0]=='yes' || $title[0]=='plan') && $title[1])
				$SQLStr .= ", $req_in_proj_fn=".$title[0].", $req_proj_id_fn=".$title[1];
				$ok=TRUE;
		}elseif(($title[0]!='yes' && $title[0]!='plan') || ($in_proj==$title[0] && $proj_id==$title[1]) || $title_is_parent)
		// title is not in any project ||
		// req & title are in the same project
			$ok=TRUE;

		if($ok){
			if (!@mysql_query("UPDATE $req_tbl SET depends_on=0 WHERE rid=$title_rid"))
				_die2(__FILE__.':'.__LINE__." Could not update $req_tbl table.");
			$SQLStr .= ", phase_of_rid=$title_rid";
		}
		return $SQLStr;
	}

	function request_view_update(&$RInfo,$sql_set_str){

		$this->validate_rinfo($RInfo);

		$req_tbl=$this->object_params['requests_tbl'];

		$query = "UPDATE $req_tbl SET $sql_set_str WHERE rid = ".$RInfo['rid'];
		//echo "$query <br>"; die;
		if (!mysql_query($query))
			_die2(__FILE__.':'.__LINE__." Could not update $req_tbl table.");

		if(!$RInfo['phase_of_rid'])
			return;

		$except_wfstate_opt_mask=$this->forbidden4parent_next_wfstate_opt($RInfo['class'],$RInfo['state']);
		$PInfo=simple_query("SELECT class, state FROM $req_tbl WHERE rid=".$RInfo['phase_of_rid']);
		if(!$PInfo)
			_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table.");
		if($this->request_state_is_wfstate($PInfo[0],$PInfo[1],$except_wfstate_opt_mask)){
			$query = "UPDATE $req_tbl SET state={$RInfo['state']} WHERE rid=".$RInfo['phase_of_rid'];
			if (!mysql_query($query))
				_die2(__FILE__.':'.__LINE__." Could not update $req_tbl table.");
		}
	}

	function xstr2uid(&$RInfo,&$xstr2uid){
		global $uid;
		global $yxl_users;

		$this->validate_rinfo($RInfo);
		$pq_fn=$this->object_params['pq_fn'];

		foreach(array_keys($RInfo) as $k){
			if((substr($k,-4,4)=="_uid"))
				$xstr2uid['%'.substr($k,0,strlen($k)-4)]=$RInfo[$k];

			if($k=="filed_by")
				$xstr2uid['%submitter']=$RInfo[$k];
		}

		$pqid=$RInfo[$pq_fn];
		if($pqid){
			foreach(array_keys($this->pqs_2d) as $k){
				if((substr($k,-4,4)=="_mgr") && $this->pqs_2d[$k][$pqid])
					$xstr2uid['%'.$k]=$this->pqs_2d[$k][$pqid];
				if((substr($k,0,6)=="owner_") && $this->pqs_2d[$k][$pqid])
					$xstr2uid['%'.$k]=$this->pqs_2d[$k][$pqid];
			}
		}

		$xstr2uid['%fixer_mgr']=$xstr2uid['%fixer'];
		if(YxlUsers::exists($xstr2uid['%fixer'])){
			$xstr2uid['%fixer_mgr']=YxlUsers::report_to($xstr2uid['%fixer']);
			if(!$xstr2uid['%fixer_mgr'])
				$xstr2uid['%fixer_mgr']=$xstr2uid['%fixer'];
		}

		$xstr2uid['%mgr']=$uid;
		if(YxlUsers::exists($uid)){
			$xstr2uid['%mgr']=YxlUsers::report_to($uid);
			if(!$xstr2uid['%mgr'])
				$xstr2uid['%mgr']=$uid;
		}
	}

	function process_view_fields(&$RInfo,&$xstr2uid,$action_is_clone){
		global $customers_2d;
		global $platforms;
		global $pri2str;
		global $uid;

		$this->validate_rinfo($RInfo);

		$req_tbl=$this->object_params['requests_tbl'];
		$req_proj_id_fn=$this->object_params['req_proj_id_fn'];
		$req_in_proj_fn=$this->object_params['req_in_proj_fn'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];
		$pq_gn=$this->object_params['pq_long_title'];
		$pq_sn=$this->object_params['pq_title'];
		$pq_owners=&$this->object_params['pq_owners'];
		$pqs_2d=&$this->pqs_2d;
		$lsm=$this->last_state_mask($RInfo['class']);
		$rid_is_external = ($RInfo['options']&REQ_OPT_EXTERNAL);
		$update_cror=FALSE;
		$SQLStr='';$comment='';

		if($this->is_rw_field('depends_on') && isset($_POST['depends_on'])){
			if(($don=$_POST['depends_on'])!=$RInfo['depends_on']){
				$SQLStr .= ", depends_on=$don";
				$comment .= "Request dependency: ".$RInfo['depends_on']." -> ".$don."\n";
			}
		}

		if($this->is_rw_field('dup_rid') && isset($_POST['dup_rid'])){
			$dupe=stripslashes(trim($_POST['dup_rid']));
			if(($dupe!=$RInfo['rid']) && ($dupe!=$RInfo['depends_on']) && ($dupe!=$RInfo['phase_of_rid'])){
				$SQLStr .= ", dup_rid=$dupe";
				$comment .= "Duplicate Of: ".$RInfo['dup_rid']." -> ".$dupe."\n";
			}
		}

		if($this->is_rw_field('class') && isset($_POST['req_class'])){
			$cl = $_POST['req_class'];
			if (!isset($this->classes['name'][$cl]))
				_die("Unknown class...");
			if ($cl != $RInfo['class']){
				$SQLStr .= ", class = $cl";
				$comment .= "Class: ".$this->classes['name'][$RInfo['class']]." -> ".$this->classes['name'][$cl]."\n";
				$RInfo['class']=$cl;
			}
		}

		if($this->is_rw_field($pq_fn) && isset($_POST[$pq_fn])){
			$pq = $_POST[$pq_fn];
			$opq = $RInfo[$pq_fn];
			if (!isset($pqs_2d['name'][$pq]))
				_die("Unknown $pq_fn ....");

        		if ($pq != $opq){
				$SQLStr .= ", $pq_fn=$pq";
				$comment .= "$pq_gn changed: ";
				if ($pqs_2d['parent'][$opq])
					$comment .= $pqs_2d['name'][$pqs_2d['parent'][$opq]].'/'.substr($pqs_2d['name'][$opq], 2);
				else
					$comment .= $pqs_2d['name'][$opq];
					$comment .= ' -> ';
				if ($pqs_2d['parent'][$pq])
					$comment .= $pqs_2d['name'][$pqs_2d['parent'][$pq]].'/'.substr($pqs_2d['name'][$pq], 2);
				else
					$comment .= $pqs_2d['name'][$pq];
				$comment .= "\n";
				$update_cror=TRUE;
				$RInfo[$pq_fn]=$pq;
        		}

        		foreach($pq_owners as $o)
        			$xstr2uid['%'.$o]=$pqs_2d[$o][$pq];

        		//$SQLStr .= ", fixer_uid = ".$pqs_2d['rnd_mgr'][$product];
			//$SQLStr .= ", tester_uid = ".($pqs_2d['qa_mgr'][$product]?$pqs_2d['qa_mgr'][$product]:$RInfo['filed_by']);

			if(isset($_POST['fixer_uid']) && !$this->is_rw_field('fixer_uid'))
				unset($_POST['fixer_uid']);

			if(isset($_POST['tester_uid']) && !$this->is_rw_field('tester_uid'))
				unset($_POST['tester_uid']);
		}

		if($this->is_rw_field('synopsis') && isset($_POST['synopsis'])){
			$synopsis = $_POST['synopsis'];
			if (strlen($synopsis) > 128)
				_die("Synopsis too long...");
			if ($synopsis != $RInfo['synopsis']){
				$SQLStr .= ", synopsis = '".escape_data($synopsis)."'";
				$comment .= "Synopsis: '{$RInfo['synopsis']}' -> '$synopsis'\n";
			}
		}

		if(($rid_is_external || $this->is_rw_field('filed_by')) && isset($_POST['submitter'])){
			$filer = $_POST['submitter'];
			if(!$filer)
				$filer=$uid;
			if (!YxlUsers::exists($filer))
				_die("Unknown submitter $filer ...");

			if ($RInfo['filed_by'] != $filer){
				$SQLStr .= ", filed_by = $filer";
				$comment .= "Submitter: <user>".($RInfo['filed_by']?YxlUsers::name($RInfo['filed_by']):'N/A')."</user> -> <user>".YxlUsers::name($filer)."</user>\n";
			}
		}

		if(($rid_is_external || $this->is_rw_field('fixer_uid')) && isset($_POST['fixer_uid'])){
			$fxer = $_POST['fixer_uid'];
			if (!YxlUsers::exists($fxer))
				_die("Unknown fixer...");

			if ($RInfo['fixer_uid'] != $fxer){
				$SQLStr .= ", fixer_uid = $fxer";
				$comment .= "Fixer: <user>".($RInfo['fixer_uid']?YxlUsers::name($RInfo['fixer_uid']):'N/A')."</user> -> <user>".YxlUsers::name($fxer)."</user>\n";
			}
		}

		if(($rid_is_external || $this->is_rw_field('fix_wrk_hrs')) && isset($_POST['fix_wrk_hrs'])){
			if(!($wh=$_POST['fix_wrk_hrs']))
				$wh=0;

			if ($RInfo['fix_wrk_hrs'] != $wh){
				$SQLStr .= ", fix_wrk_hrs = $wh";
				$comment .= "Fix Work Hours: ".$RInfo['fix_wrk_hrs']." -> ".$wh."\n";
			}
		}

		if(($rid_is_external || $this->is_rw_field('tester_uid')) && isset($_POST['tester_uid'])){
			$tter = $_POST['tester_uid'];
			if (!YxlUsers::exists($tter))
				_die("Unknown tester...");

			if ($RInfo['tester_uid'] != $tter){
				$SQLStr .= ", tester_uid = $tter";
				$comment .= "Tester: <user>".($RInfo['tester_uid']?YxlUsers::name($RInfo['tester_uid']):'N/A')."</user> -> <user>".YxlUsers::name($tter)."</user>\n";
			}
		}

		if(($rid_is_external || $this->is_rw_field('test_wrk_hrs')) && isset($_POST['test_wrk_hrs'])){
			if(!($wh=$_POST['test_wrk_hrs']))
				$wh=0;

			if ($RInfo['test_wrk_hrs'] != $wh){
				$SQLStr .= ", test_wrk_hrs = $wh";
				$comment .= "Test Work Hours: ".$RInfo['test_wrk_hrs']." -> ".$wh."\n";
			}
		}

		if($this->is_rw_field('complete_pct') && isset($_POST['complete_pct'])){
			$complete_pct = $_POST['complete_pct'];
			if (($complete_pct<0) || ($complete_pct>100))
				_die(__FILE__.':'.__LINE__.'Bad complete_pct ...');
			if ($complete_pct != $RInfo['complete_pct']){
				$SQLStr .= ",  complete_pct=$complete_pct";
				$comment .= 'Fix Completeness: '.$RInfo['complete_pct'].' -> '.$complete_pct."\n";
			}
		}

		if($this->is_rw_field('due_date') && isset($_POST['due_date']) && is_date(stripslashes(trim($_POST['due_date'])))){
			$due_date=date_norm2sql(stripslashes(trim($_POST['due_date'])));
			if ($due_date != $RInfo['due_date']){
				$SQLStr .= ", due_date = '".escape_data($due_date)."'";
				$comment .= "Due Date: ".date_sql2norm($RInfo['due_date'])." -> ".date_sql2norm($due_date)."\n";
			}
		}

		if($this->is_rw_field('platform') && isset($_POST['platform'])){
			$platform = $_POST['platform'];
			if (!isset($platforms[$platform]))
				_die(__FILE__.':'.__LINE__.'Unknown platform...');
			if ($platform != $RInfo['platform']){
				$SQLStr .= ", platform = $platform";
				$comment .= 'Platfrom: '.$platforms[$RInfo['platform']].' -> '.$platforms[$platform]."\n";
			}
		}

		if($this->is_rw_field('customer_id') && isset($_POST['customer_id'])){
			$cust = $_POST['customer_id'];
			if (!isset($customers_2d['name'][$cust]))
				_die("Unknown customer...");
			if ($cust != $RInfo['customer_id']){
				$SQLStr .= ", customer_id = $cust";
				$OCInfo = $customers_2d['name'][$RInfo['customer_id']];
				$NCInfo = $customers_2d['name'][$cust];
				$comment .= "<edih>Customer: $OCInfo -> $NCInfo</edih>\n";
			}
			foreach(array_keys($customers_2d) as $k){
        			if(substr($k,-4)=="_mgr"){
        				$mgr=$customers_2d[$k][$cust];
        				$xstr2uid['%'.$k]=$mgr?$mgr:$uid;
        			}
        		}
		}

		if($this->is_rw_field('customer_pri') && isset($_POST['customer_pri'])){
			$pri = $_POST['customer_pri'];
			if (!isset($pri2str[$pri]))
				_die("Unknown priority...");
			if ($pri != $RInfo['customer_pri']){
				$SQLStr .= ", customer_pri = $pri";
				$comment .= "Customer priority: ".$pri2str[$RInfo['customer_pri']]." -> ".$pri2str[$pri]."\n";
				$update_cror=TRUE;
			}
		}

		if($this->is_rw_field('vbc') && isset($_POST['vbc'])){
			if($_POST['vbc'] == '2'){
				if(($RInfo['options']&REQ_OPT_VBC2)==0){
					$RInfo['options'] &= ~REQ_OPT_VBC;
					$RInfo['options'] |= REQ_OPT_VBC2;
					$comment = "<edih>Visible to all customers.</edih>\n";
				}
			}elseif($_POST['vbc'] == '1'){
				if(($RInfo['options']&REQ_OPT_VBC)==0){
					$RInfo['options'] &= ~REQ_OPT_VBC2;
					$RInfo['options'] |= REQ_OPT_VBC;
					$comment = "<edih>Visible to submitter customer.</edih>\n";
				}
			}else{
				if($RInfo['options']&(REQ_OPT_VBC|REQ_OPT_VBC2)){
					$RInfo['options'] &= ~(REQ_OPT_VBC|REQ_OPT_VBC2);
					$comment = "<edih>Invisible to customers.</edih>\n";
				}
			}
		}

		if($this->is_rw_field('phase_of_rid') && isset($_POST['phase_of_rid'])){
			$por=$_POST['phase_of_rid'];
			if(($por!=$RInfo['phase_of_rid']) && ($action_is_clone || (!$action_is_clone && ($por!=$RInfo['rid'])))){
				$sql_str=$this->prepare_to_phase($RInfo['rid'],$RInfo[$req_in_proj_fn],$RInfo[$req_proj_id_fn],$por);
				if($sql_str){
					$SQLStr .= $sql_str;
					$comment .= "Parent request: ".($RInfo['phase_of_rid']?$RInfo['phase_of_rid']:'none')." -> ".($por?$por:'none')."\n";
				}
			}
		}

		if($this->is_rw_field('description') && isset($_POST['description'])){
			$description = $_POST['description'];
			$description = str_replace("\r", "", $description);
			if ($description != $RInfo['description']){
				$SQLStr .= ", description = '".escape_data($description)."'";
				$comment .= "Description changed (skipped)\n";
			}
		}

		if($update_cror){
			// When switching from non-critical to critical priority or changing the main product.
			$pq = $_POST[$pq_fn];
			$main_pq = $pqs_2d['parent'][$pq]?$pqs_2d['parent'][$pq]:$pq;
			$cror_r=simple_query("SELECT r.rid, r.critical_order FROM $req_tbl AS r, $pq_tbl AS c WHERE r.$pq_fn=c.$pq_fn AND (r.$pq_fn=$main_pq OR c.parent=$main_pq) AND r.customer_pri=".REQ_PRI_CRITICAL." AND (r.state&$lsm)=0 ORDER BY r.critical_order DESC LIMIT 1");
			if(!$cror_r)
				$cror=1;
			else
				$cror=++$cror_r[1];
			$SQLStr .= ", critical_order = $cror";
		}

		return array($SQLStr,$comment);
	}

	function get_all_dupes($rid){

		$req_tbl=$this->object_params['requests_tbl'];

                $dupes=array();
		$l=array($rid);
		while($r=array_shift($l)){
			$query="SELECT rid FROM $req_tbl WHERE dup_rid=$r";
			if (!($result=mysql_query($query)))
                                _die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table.");

			while($row=mysql_fetch_row($result)){
				if(in_array($row[0],$dupes)){
					_warn_yoxel("Dupe loop detected for rid=$r, dup=$row[0].");
					continue;
				}
                        	array_push($dupes,$row[0]);
				array_push($l,$row[0]);
			}
                }
                return $dupes;
        }

	function request_view_frm_Start(&$RInfo,$frm=TRUE){

		$this->validate_rinfo($RInfo);

		if($frm && !is_string($frm))
			$frm='view_frm';


		echo '
<table width="100%" border=0 cellpadding=2 cellspacing=1 align="center" class="dgray">
<tr class="hgray">
 <th colspan="3" class="title">'.html_safe_text($RInfo['synopsis']).'</th>
</tr>';

		if($frm)
			echo '
<form name="'.$frm.'" method="post" action="'.$_SERVER['PHP_SELF'].'">
<input type="hidden" name="id" value="'.$RInfo['rid'].'">';

	}

	function request_view_tr_IDnDon(&$RInfo){

		$this->validate_rinfo($RInfo);

		$pqs_2d=&$this->pqs_2d;
		$pq_fn=$this->object_params['pq_fn'];

		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;
?>
<tr class="lgray">
 <th width="30%">ID</th>
 <td colspan="2">
<?php
   print $RInfo['rid'];
   if($rid_is_external)
	print " (XID={$RInfo['xrid']})";
   if ($this->is_rw_field('depends_on') || $rid_is_external){
   	$blockers=$this->list_possible_blockers($RInfo,100);
   	if(count($blockers) && !isset($PhList)){
		echo ',&nbsp;<span style="font-weight: bold;">depends on:</span>&nbsp;
   <select class="sel_num" style="width: 30em"; name="depends_on">
   	<option value="0">none</option>';
		while($b=array_shift($blockers)){
			if($b==$RInfo['rid'])
				continue;

   			echo '
	<option value="'.$b[0].($RInfo['depends_on']==$b[0]?' selected':'').'">'.($b[1]?'*':'').html_safe_text($b[2]).'</option>';
		}
  	 	echo '
   </select>';
   	}
   }else
   	echo ',&nbsp;<span style="font-weight: bold;">depends on:</span>&nbsp;'.($RInfo['depends_on']?$RInfo['depends_on']:'none');
?>
 </td>
</tr>
<?php
	}

	function request_view_tr_State(&$RInfo){

		$this->validate_rinfo($RInfo);

		$req_tbl=$this->object_params['requests_tbl'];

		$class=$RInfo['class'];
		$ism=$this->inwork_state_mask[$class];
		$fsm=$this->fixed_state_mask[$class];
		$vsm=$this->verified_state_mask[$class];
		$lsm=$this->last_state_mask($class);
?>
<tr class="hlight">
 <th>State</th>
 <td colspan="2" style="">
 <?php
 	echo '<strong>'.$this->state2str[$RInfo['state']].'</strong>';
 	$dtm=FALSE;
 	if($RInfo['state']&$lsm && $RInfo['last_date_tm'])
 		$dtm=$RInfo['last_date_tm'];
 	elseif(isset($RInfo['verified_date_tm']) && $RInfo['state']&$vsm && $RInfo['verified_date_tm'])
 		$dtm=$RInfo['verified_date_tm'];
 	elseif($RInfo['state']&$fsm && $RInfo['fixed_date_tm'])
 		$dtm=$RInfo['fixed_date_tm'];
 	elseif($RInfo['state']&$ism && $RInfo['inwork_date_tm'])
 		$dtm=$RInfo['inwork_date_tm'];

 	if($dtm){
 		$SDate = date("M d, Y",$dtm);
 		print "&nbsp;on $SDate";
 	}

 	if($this->state_is_dup($RInfo['class'],$RInfo['state'])){
 		$ds=simple_query("SELECT state FROM $req_tbl WHERE rid=".$RInfo['dup_rid']);
 		if($ds)
 			echo '&nbsp;&nbsp;[duplicate of <a href="'.$_SERVER['PHP_SELF'].'?id='.$RInfo['dup_rid'].'">'.$RInfo['dup_rid'].'</a>&nbsp;(<strong>'.$this->state2str[$ds].'</strong>)]';
	}else{
		$dupes=$this->get_all_dupes($RInfo['rid']);
		if(count($dupes)){
			$str='';
			foreach($dupes as $dup){
				$str.=', <a href="'.$_SERVER['PHP_SELF'].'?id='.$dup.'">'.$dup.'<a>';
			}
			// get_long_synop
			echo '&nbsp;&nbsp;['.count($dupes).' duplicate request(s): '.substr($str,2).']';
 		}else
			echo '
 	<span id="dup_rid" style="display: none">
 		&nbsp;&nbsp;[duplicate of <input class="inp" name="dup_rid" size="6" />]
 	<span>';
	}


?>
 </td>
</tr>

<?php
	}

	function request_view_tr_Submitter(&$RInfo){
		global $uid;

		$this->validate_rinfo($RInfo);

		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;
		$RDate = date("M d, Y", $RInfo['reg_date_tm']);
?>
<tr class='lgray'>
 <th>Submitter</th>
 <td colspan=2><?php
   if($rid_is_external){
	$all_uids=YxlUsers::all_uids();

	print '
	<select name="submitter" class="selec">
		<option value="">Please, select user..........';
		foreach ($all_uids as $xUid){

			if (YxlUsers::user_is($xUid) & USER_IS_LOCKED) continue;
			if (YxlUsers::user_is($xUid) & USER_IS_CUSTOMER) continue;
			if (($uid != $xUid) && ($uid != YxlUsers::report_to($xUid)) && (YxlUsers::spec($xUid)!=USPEC_CAE)) continue;

			$xName=YxlUsers::name($xUid);

			print '
		<option value="'.$xUid.'"'.(($xUid == $RInfo['filed_by'])?' selected':'').'>'.$xName;
		}
	print '
	</select>';
   }elseif (YxlUsers::exists($RInfo['filed_by']))
	print "<a href='mailto:".YxlUsers::email($RInfo['filed_by'])."'>".YxlUsers::name($RInfo['filed_by'])."</a>";
   else
	print "N/A";
   print "&nbsp;on $RDate";


?></td>
</tr>
<?php
	}

	function request_view_tr_Class(&$RInfo,$hdr=''){

		$this->validate_rinfo($RInfo);

		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;
?>
<tr class='lgray'>
 <th><?php echo ($hdr?$hdr:'Class'); ?></th>
 <td colspan=2><?php
	if ($this->is_rw_field('class') && !$rid_is_external){
		print "\n  <select name='req_class' class='selec'>\n";
		foreach ($this->classes['name'] as $k => $v)
			print "   <option value='$k'".(($k == $RInfo['class'])?" selected":"").">$v\n";
		print "  </select>\n";
	}else
		print $this->classes['name'][$RInfo['class']];
?></td>
</tr>
<?php
	}

	function request_view_tr_PQ(&$RInfo,$xstr2uid,$hdr=''){

		$this->validate_rinfo($RInfo);

		$pq_gn=$this->object_params['pq_long_title'];
		$pq_fn=$this->object_params['pq_fn'];
		$pqs_2d=&$this->pqs_2d;
		$main_pq=$pqs_2d['parent'][$RInfo[$pq_fn]]?$pqs_2d['parent'][$RInfo[$pq_fn]]:$RInfo[$pq_fn];

		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;
		$class=$RInfo['class'];
?>
<tr class='lgray'>
 <th><?php echo ($hdr?$hdr:$pq_gn); ?></th>
 <td colspan=2><?php
  if ($this->is_rw_field($pq_fn) && !$rid_is_external){
    print "\n  <select name='$pq_fn' class='selec'>\n";
	$cs=$RInfo[$pq_fn];
	foreach ($pqs_2d['name'] as $k => $v) {
		if($pqs_2d['parent'][$k] == 0){
			echo "<option value='$k'".($k==$cs?' selected':'').">$v</option>\n";
			foreach ($pqs_2d['name'] as $kk => $vv) {
				if($pqs_2d['parent'][$kk]!=$k) continue;
				echo "<option value='$kk' ".($kk==$cs?'selected':'').">$vv</option>";
			}
		}
	}
  }else{
  	$nsa=$this->null_state_action($class);
  	$mgr=$this->default_value('fixer_uid',$nsa,$xstr2uid);
  	if($pqs_2d['parent'][$RInfo[$pq_fn]])
  		print $pqs_2d['name'][$main_pq].'&nbsp;'.$pqs_2d['name'][$RInfo[$pq_fn]];
  	else
  		print $pqs_2d['name'][$RInfo[$pq_fn]].'&nbsp;-&nbsp;General';
  	//if($mgr)
  	//	echo ' (default owner: <a href="mailto:'.YxlUsers::email($mgr).'">'.YxlUsers::name($mgr).'</a>)';
  }

?></td>
</tr>
<?php
	}

	function request_view_tr_Synopsis(&$RInfo,$hdr=FALSE){

		$this->validate_rinfo($RInfo);

		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;
?>
<tr class="hlight">
 <th><?php echo $hdr?$hdr:'Synopsis'; ?></th>
 <td colspan=2><?php

  if ($this->is_rw_field('synopsis') && !$rid_is_external)
  	print '<input name="synopsis" class="inp" size="48" maxlength="127" value="'.html_safe_text($RInfo['synopsis']).'">';
  else
  	print html_safe_text($RInfo['synopsis']);
?></td>
</tr>
<?php
	}

	function request_view_tr_Fixer(&$RInfo, $xstr2uid, $hdr='', $fixers=FALSE, $est_hrs=TRUE){
		global $uid;

		$this->validate_rinfo($RInfo);

		$class=$RInfo['class'];
		$fsm=$this->fixed_state_mask[$class];
		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;
		if(!$fixers)
			$fixers=array();
?>
<tr class='lgray'>
 <th><?php echo ($hdr?$hdr:'Fixer'); ?></th>
 <td colspan=2><?php
  if ($this->is_rw_field('fixer_uid') || $rid_is_external){
  	$nsa=$this->null_state_action($class);
  	$pmgr_uid=$this->default_value('fixer_uid',$nsa,$xstr2uid);
  	$mgr_uid=$uid;
	$all_uids=YxlUsers::all_uids();

	print "\n  <select name='fixer_uid' class='selec'>\n";
	print "   <option value=''>Please, select a user ...\n";
	foreach ($all_uids AS $xUid){
		if (YxlUsers::user_is($xUid) & USER_IS_LOCKED)
			continue;
		if (YxlUsers::user_is($xUid) & USER_IS_CUSTOMER)
			continue;
		if (($mgr_uid != $xUid) && ($mgr_uid != YxlUsers::report_to($xUid)) && ($pmgr_uid != $xUid) && ($RInfo['fixer_uid'] != $xUid) && (!in_array($xUid,$fixers)))
			continue;

		$xName=YxlUsers::name($xUid);

		print "		<option value='$xUid'".(($xUid == $RInfo['fixer_uid'])?" selected":"").">$xName\n";
	}
		print "  </select>\n";
  }else{
	if (YxlUsers::exists($RInfo['fixer_uid']))
		print "<a href='mailto:".YxlUsers::email($RInfo['fixer_uid'])."'>".YxlUsers::name($RInfo['fixer_uid'])."</a>";
	else
		print 'N/A';
  }

  if($est_hrs!==TRUE){
  // When the parameter is actually specified

  	if(($RInfo['state']&$fsm))
  		print "&nbsp;&nbsp;[estimated: ".($est_hrs===FALSE?'N/A':$est_hrs)." hrs]";

  	if($rid_is_external && ($RInfo['state']&$fsm)){
		$ft=$this->detect_state_change($RInfo['rid'],$RInfo['state'],FALSE,TRUE);
		if($RInfo['fix_wrk_hrs'])
			$ft=$RInfo['fix_wrk_hrs'];

  		echo '&nbsp;&nbsp;[actual: <input type="text" class="inp" size="4" maxlength="6" value="'.$ft.'" name="fix_wrk_hrs">hrs]';
  	}

  	if(!$rid_is_external && $this->is_rw_field('fix_wrk_hrs')){
		$ft=$this->detect_state_change($RInfo['rid'],$fsm,FALSE,TRUE);
		if(($RInfo['state']&$fsm) && $RInfo['fix_wrk_hrs'])
                        $ft=$RInfo['fix_wrk_hrs'];

  		echo '&nbsp;&nbsp;[actual: <input type="text" class="inp" size="4" maxlength="6" value="'.$ft.'" name="fix_wrk_hrs">hrs]';
  	}elseif(!$rid_is_external && ($RInfo['state']&$fsm) && ($RInfo['fix_wrk_hrs']!==FALSE))
  		print "&nbsp;&nbsp;[actual: ".$RInfo['fix_wrk_hrs']." hrs]";
  }
?></td>
</tr>
<?php
	}

	function request_view_tr_FixCompletePct(&$RInfo){

		$this->validate_rinfo($RInfo);
?>
<tr class='lgray'>
 <th>Fix Completeness</th>
 <td colspan=2><?php
	if ($this->is_rw_field('complete_pct')){
		print '
		<select name="complete_pct" class="selec" style="width: 5em">
		<option value="0">N/A';
		for($p=10;$p<=100;$p=$p+10)
			echo '
			<option value="'.$p.'" '.($RInfo['complete_pct']==$p?' selected':'').'>'.$p.'%';
		echo '
		</select>';
	}else
		print $RInfo['complete_pct']?$RInfo['complete_pct'].'%':'N/A';
?></td>
</tr>
<?php
	}

	function request_view_tr_AddRemoveCC(&$RInfo,$CCList,$inCCList){

		$this->validate_rinfo($RInfo);

		$rid=$RInfo['rid'];
?>
<tr class='lgray' valign='top'>
<?php
	print " <th>CC List<div class='small'>[ <span id='cc_link'>";
	if ($inCCList)
		print "<a href='".$_SERVER['PHP_SELF']."?cc_del=$rid' target='cc'>remove my name</a>";
	else
		print "<a href='".$_SERVER['PHP_SELF']."?cc_add=$rid' target='cc'>add my name</a>";
	print "</span> ]<iframe name='cc' width=1 height=1 frameborder=0 src=''></iframe></th>\n";
	print " <td colspan=2><span id='cc_list'>";

	$CCStr = '';
	foreach($CCList as $CC)
		$CCStr.= ", <a href='mailto:".YxlUsers::email($CC)."'>".YxlUsers::name($CC)."</a>";

	if ($CCStr)
		$CCStr = substr($CCStr,1);

	echo $CCStr;

?></span></td>
</tr>
<?php
	}

	function request_view_tr_Platform(&$RInfo){
		global $platforms;

		$this->validate_rinfo($RInfo);

		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;
?>
	<tr class='lgray'>
 <th>Platform</th>
 <td colspan=2><?php

  if ($this->is_rw_field('platform') && !$rid_is_external){
	print "  <select name='platform' class='selec'>\n";
	foreach($platforms as $pl_id => $pl_name){
		print "   <option value='$pl_id'";
		if ($pl_id == $RInfo['platform']) print " selected";
		print ">$pl_name\n";
	}
	print "  </select>\n";
  }else
	print isset($platforms[$RInfo['platform']])?$platforms[$RInfo['platform']]:'N/A';
?></td>
</tr>
<?php
	}

	function request_view_tr_Customer(&$RInfo,$hl=FALSE){
		global $is_customer;
		global $customers_2d;

		$this->validate_rinfo($RInfo);

		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;
?>
<tr class="<?php echo $hl?'hlight':'lgray'; ?>">
 <th>Customer</th>
 <td colspan=2><?php

  if (!$is_customer && ($this->is_rw_field('customer_id') || $rid_is_external)){
  	print "\n  <select name='customer_id' class='selec' >\n";
  	$cs=$RInfo['customer_id'];
	foreach ($customers_2d['name'] as $k => $v){
		if(!$k) continue;
		echo "<option value='$k' ".($k == $cs?'selected':'').">$v</option>";
	}
	print "  </select>\n";
  }else
  	print $RInfo['customer_id']?$customers_2d['name'][$RInfo['customer_id']]:'N/A';
?></td>
</tr>
<?php
	}

	function request_view_tr_CustUrgency(&$RInfo,$hl=FALSE){
		global $is_customer;
		global $customers_2d;
		global $pri2str;

		$this->validate_rinfo($RInfo);

		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;
?>
<tr class="<?php echo $hl?'hlight':'lgray'; ?>">
 <th>Urgency</th>
 <td colspan=2>
<?php

  if ($this->is_rw_field('customer_pri') || $rid_is_external){
	print "\n  <select name='customer_pri' class='selec'>\n";
	foreach ($pri2str as $k => $v)
		print "   <option value='$k'".(($k == $RInfo['customer_pri'])?" selected":"").">$v\n";
		print "  </select>\n";
  }else
  	print $pri2str[$RInfo['customer_pri']];
?></td>
</tr>
<?php
	}

	function request_view_tr_VBC(&$RInfo){
		global $is_customer;
		global $customers_2d;
		global $pri2str;

		$this->validate_rinfo($RInfo);

		$rid_is_external=$RInfo['options']&REQ_OPT_EXTERNAL;

		if ($is_customer || !$this->is_rw_field('vbc'))
			return;

  		$dsbl=in_array('vbc',array_keys($this->state_rw_fields))?'':' disabled';
		print "<tr class='lgray'>\n";
		print " <th>Visible to Customer</th>\n";
		print " <td colspan=2><input type='radio' name='vbc' value='0'".(($RInfo['options']&(REQ_OPT_VBC|REQ_OPT_VBC2))?"":" checked")."$dsbl>None
		<input type='radio' name='vbc' value='2'".(($RInfo['options']&REQ_OPT_VBC2)?" checked":"")."$dsbl>All
		<input type='radio' name='vbc' value='1'".((($RInfo['options']&REQ_OPT_VBC) && !($RInfo['options']&REQ_OPT_VBC2))?" checked":"")."$dsbl>".($RInfo['customer_id']?html_safe_text($customers_2d['name'][$RInfo['customer_id']]):'Submitter')."
		</td>\n";
		print "</tr>\n";
	}

	function request_view_tr_Parent(&$RInfo,$PhList,$Parent){
		global $is_customer;

		$this->validate_rinfo($RInfo);

		$pq_fn=$this->object_params['pq_fn'];
		$pqs_2d=&$this->pqs_2d;
		$main_pq=$pqs_2d['parent'][$RInfo[$pq_fn]]?$pqs_2d['parent'][$RInfo[$pq_fn]]:$RInfo[$pq_fn];

		if(!$is_customer && !$PhList && $this->is_rw_field('phase_of_rid')){
			$titles=$this->list_possible_titles($main_pq,$RInfo['rid'],100);
			$has_clone_action=$this->request_state_has_clone_action();
			echo '
<tr class="lgray">
  <th>Parent request</th>
  <td colspan=2>
  <select class="selec" style="width: 30em;" name="phase_of_rid" onChange="ph_parent_change(this.form)">
   	<option value="0">none</option>';
   			if($has_clone_action && !$RInfo['phase_of_rid'])
   				echo '
   	<option value="'.$RInfo['rid'].'" class="dgray">this request (for cloning only)</option>';

  			if(count($titles)){
				while($t=array_shift($titles))
   					echo '
	<option value="'.$t[0].'"'.(isset($Parent) && $t[0]==$Parent[0]?' selected':'').'>'.($t[1]?'*':'').html_safe_text($t[2]).'</option>';
			}
  	 		echo '
   </select><br>
   <span id="ph_parent_info">';
			if($Parent)
				echo '
	<a href="'.$_SERVER['PHP_SELF'].'?id='.$Parent[0].'">'.html_safe_text($Parent[1]).'</a>';
			echo '
   </span>
   </td>
</tr>';
		}elseif(!$is_customer && !$PhList && $Parent){
			echo '
<tr class="lgray">
  <th>Parent request</th>
  <td colspan=2>
	<a href="'.$_SERVER['PHP_SELF'].'?id='.$Parent[0].'">'.html_safe_text($Parent[1]).'</a>
  </td>
</tr>';
 		 }
 	}

 	function request_view_tr_SubRequests(&$RInfo,$PhList){

 		$this->validate_rinfo($RInfo);

 		if (!$PhList)
 			return;
		print "<tr class='lgray' valign='top'>\n";
		print " <th>Subrequests</th>\n";
		print " <td colspan=2>";
		while ($Child = array_pop($PhList)){
			print "<a href='".$_SERVER['PHP_SELF']."?id=$Child[0]'>".html_safe_text($Child[1])."</a>";
			if (count($PhList)) print "<br>";
		}
		print "</td>\n";
		print "</tr>\n";
	}

	function request_view_tr_Description(&$RInfo){

		$this->validate_rinfo($RInfo);
?>
<tr class='lgray' valign='top'>
 <td align="center" colspan="3">
 	<strong>Description</strong><br>
 	<span style="color:red; display: none" id="description_info">[updates ignored]</span>
 <?php
	//print '<textarea name="description" rows="3"'.(($bts->is_rw_field('description') && !$rid_is_external)?'':' disabled').' style="width: 100%; color=#ffffff;">'.html_safe_text($RInfo['description'], true).'</textarea>';
	print '<textarea name="description" rows="10" style="width: 100%;">'.html_safe_text($RInfo['description'], true).'</textarea>';
?>

 </td>
</tr>
<?php
	}

	function request_view_tr_Date(&$RInfo,$fn,$hdr){
		global $uid;

		$this->validate_rinfo($RInfo);
?>
<tr class='lgray'>
 <th><?php echo ($hdr?$hdr:'Date'); ?></th>
 <td colspan=2>
<?php

  if ($this->is_rw_field($fn)){
  	//$nsa=$this->null_state_action($class);
  	//$mgr_uid=$this->default_value('tester_uid',$nsa,$xstr2uid);
  	echo '
  	<input class="inp" type="text" name="'.$fn.'" size="10" maxlength="10" value="'.date_sql2norm($RInfo[$fn]).'" /> mm/dd/yyyy';
  }else
 	echo '&nbsp; '.date("M d, Y",$RInfo[$fn.'_tm']);
?></td>
</tr>
<?php
	}

	function request_view_tr_Amount(&$RInfo,$fn,$hdr=FALSE,$sgn=FALSE){
		global $uid;

		$this->validate_rinfo($RInfo);
?>
<tr class='lgray'>
 <th><?php echo ($hdr?$hdr:'Amount'); ?></th>
 <td colspan=2>
<?php

  		if($sgn && is_string($sgn))
			echo $sgn;

  if ($this->is_rw_field($fn)){
  	//$nsa=$this->null_state_action($class);
  	//$mgr_uid=$this->default_value('tester_uid',$nsa,$xstr2uid);
  	echo '
  		<input class="inp" type="text" name="'.$fn.'" size="10" maxlength="10" value="'.$RInfo[$fn].'" />';
  }else
 	echo '&nbsp;'.$RInfo[$fn];
?></td>
</tr>
<?php
	}

	function request_view_tr_Select(&$RInfo,$fn,&$list,$hdr){

		$this->validate_rinfo($RInfo);
?>
	<tr class='lgray'>
 <th><?php echo $hdr; ?></th>
 <td colspan=2><?php

  if ($this->is_rw_field($fn)){
	print "  <select name='$fn' class='selec'>\n";
	foreach($list as $k => $v){
		print "   <option value='$k'";
		if ($k == $RInfo[$fn]) print " selected";
		print ">$v\n";
	}
	print "  </select>\n";
  }else
	print isset($list[$RInfo[$fn]])?$list[$RInfo[$fn]]:'N/A';
?></td>
</tr>
<?php
	}

	function request_view_tr_Action(&$RInfo,&$aList){

		if(!is_array($aList) || (count($aList)<1))
			return;

		$this->validate_rinfo($RInfo);
?>

<tr>
	<td colspan="3" align="center" class="rts_action">
	<select name="actn" style="width:60%" onChange="filter_fields(this.form)">
		<option value="">PLEASE, SELECT AN ACTION!</option>
<?php
		foreach($aList AS $opt){
			$opt = explode(':', $opt);

			$wfaid=$opt[1];
			$txt=$opt[2];

			$extra='class="lt"';
			if($wfaid && isset($this->state_actions['frequency'][$wfaid]) && ($this->state_actions['frequency'][$wfaid]>0)){
				$extra='class="hlt"';
				$txt=$this->state_actions['name'][$wfaid];
			}

			echo '
		<option value="'.$opt[0].':'.$opt[1].'" '.$extra.'>'.$txt.'</option>';

		}
?>

	</select><br>
	<div id="apply_action" style="display:none"><strong>Action Comments</strong><br>
	<textarea name="descr" rows=3 style="width: 80%"></textarea><br><br>
	<input type="button" class="wbtn" name="update" value="APPLY" onClick="go(this.form)">
	</div>
	</td>
</tr>

<?php
}


	function request_view_frm_Close(&$RInfo,$frm=TRUE){

		$this->validate_rinfo($RInfo);
  		if($frm)
  			echo '
</form>';

		echo '
</table>';

		if(isset($_GET['phrase'])){
			$phid=trim($_GET['phrase']);
			$phrase=$this->ys_get_phrase($phid);
			if(!$phrase)
				return;

			echo '
<form name="view_close_form">
<input type="hidden" name="close" value="'.$RInfo['rid'].'">
<input type="hidden" name="phid" value="'.$phid.'">
</form>';

  		}
	}

	function request_view_common_handler(){
		global $uid;
		global $on_unload_str;

		if(isset($_GET['close']) && isset($_GET['phid'])){
			$rid=$_GET['close'];
			$phid=$_GET['phid'];

			// Update relevancy
			if(!@mysql_query("LOCK TABLES ysassociations WRITE"))
				_die2(__FILE__.':'.__LINE__." Could not lock ysassociations table.");

			$aid=simple_query("SELECT aid FROM ysassociations WHERE uid=$uid AND phid=$phid AND rid=$rid");
			if($aid){
				$query="UPDATE ysassociations SET refn=refn+1 WHERE aid=$aid";
				if(!@mysql_query($query))
					_die2(__FILE__.':'.__LINE__." Could not update ysassociations table.");
			}else{
				$query="INSERT INTO ysassociations (uid,phid,rid,refn) VALUES ($uid,$phid,$rid,1)";
				if(!@mysql_query($query))
					_die2(__FILE__.':'.__LINE__." Could not insert into ysassociations table.");
			}

			if(!@mysql_query("UNLOCK TABLES"))
				_die2(__FILE__.':'.__LINE__." Could not unlock ysassociations table.");
			exit;
		}

		if(isset($_GET['exprtg'])){
			if(!$this->with_expert_rating())
				_die('Expert rating is not enabled for this class.');

			$id = ereg_replace("[^0-9]", "", $_GET['exprtg']);
			$xstr2uid=array();
			$RInfo=$this->request_info($id,$xstr2uid);

			if(!isset($_GET['ts']))
				_die('No ts specified.');
			$ts=$_GET['ts'];

			$rtg=0;
			if(isset($_GET['rtg']) && $_GET['rtg'])
				$rtg=$_GET['rtg'];

			$this->set_expert_rating($ts,$rtg);
			echo $ts;
			exit;
		}

		if(isset($_GET['id']) && is_numeric(trim($_GET['id'])) &&
				isset($_GET['phrase']) && is_numeric(trim($_GET['phrase']))){
			$rid=trim($_GET['id']);

			$phid=trim($_GET['phrase']);
			$phrase=$this->ys_get_phrase($phid);
			if(!$phrase)
				return;

			$on_unload_str="rts_view_save_phrase($rid,$phid)";
			return;
		}
	}

	function change_req_state($rid,$state){

		$req_tbl=$this->object_params['requests_tbl'];

		if (!@mysql_query("UPDATE $req_tbl SET state=$state WHERE rid = $rid"))
			_die2(__FILE__.':'.__LINE__." Could not update $req_tbl table.");
	}

	function request_view_script(){
		return($this->object_params['req_view_script']);
	}

	function wfid(){
		return($this->object_params['wfid']);
	}

	function request_query_sqlstr_where(){
		global $is_customer;
		if (!$is_customer)
			return '';
        	return "(r.options&".REQ_OPT_VBC2." OR (r.customer_id=$is_customer AND r.options&".REQ_OPT_VBC."))";
	}

	function order_by_proj_pri_sqlstr(){
		$req_proj_id_fn=$this->object_params['req_proj_id_fn'];
                $req_in_proj_fn=$this->object_params['req_in_proj_fn'];
		$a=explode('_',$req_proj_id_fn);
		$req_proj_pri_fn=$a[0].'_pri';

		return "IF(r.$req_in_proj_fn='plan',r.plan_pri,r.$req_proj_pri_fn) ASC";
	}

	function request_query_sqlstr_fw($cust=FALSE,$ljoin=TRUE){
		global $is_customer;

		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];
		$req_proj_id_fn=$this->object_params['req_proj_id_fn'];
		$proj_tbl=$this->object_params['proj_tbl'];
		$proj_id_fn=$this->object_params['proj_id_fn'];

		//$FW="FROM $req_tbl AS r".($cust?" INNER JOIN customers AS cust ON r.customer_id=cust.cid":'');
		$FW="FROM $req_tbl AS r".($cust?" LEFT OUTER JOIN customers AS cust ON r.customer_id=cust.cid":'');
		if($ljoin && is_string($ljoin))
			$FW.=" $ljoin";
		elseif($ljoin)
			 $FW.=" INNER JOIN $pq_tbl AS c ON r.$pq_fn=c.$pq_fn LEFT OUTER JOIN $pq_tbl AS p ON c.parent=p.$pq_fn".($proj_tbl?" LEFT OUTER JOIN $proj_tbl AS proj ON r.$req_proj_id_fn=proj.$proj_id_fn":'');

		if($where=$this->request_query_sqlstr_where())
			$FW.=" WHERE $where";
		else
			$FW.=" WHERE 1";

        	return $FW;
	}

	function request_query_sqlstr($extra_req_fields='',$cust=FALSE,$ljoin=TRUE){
		global $is_customer;

		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];
		$req_proj_id_fn=$this->object_params['req_proj_id_fn'];
		$proj_tbl=$this->object_params['proj_tbl'];

		$fw=$this->request_query_sqlstr_fw($cust,$ljoin);

		if(($ljoin && is_string($ljoin)) || !$ljoin)
			$SQLStr = "SELECT r.*".($cust?", cust.sls_mgr_uid, cust.cae_mgr_uid":'').", DATE_FORMAT(r.reg_date,'%m/%d/%y') AS rdate, r.$req_proj_id_fn AS proj_id".($proj_tbl?", proj.label AS label":'')." $extra_req_fields $fw";
		else
			$SQLStr = "SELECT r.*, c.*".($cust?", cust.sls_mgr_uid, cust.cae_mgr_uid":'').", ".SQL_PQ." AS pq_name, ".SQL_SUB_PQ." AS subpq_name, DATE_FORMAT(r.reg_date,'%m/%d/%y') AS rdate, r.$req_proj_id_fn AS proj_id".($proj_tbl?", proj.label AS label":'')." $extra_req_fields $fw";
		//echo "$SQLStr <br>\n";

		return $SQLStr;
	}

	function request_delete(&$RInfo){

		$this->validate_rinfo($RInfo);
		$rid=$RInfo['rid'];

		$req_tbl=$this->object_params['requests_tbl'];
		$htbl=$this->object_params['history_tbl'];
		$htype=$this->object_params['history_rts_type'];
		$mem_tbl=$this->object_params['members_tbl'];
		$cctype=$this->object_params['member_cc_type'];

		mysql_query("DELETE FROM  $req_tbl WHERE rid = $rid LIMIT 1");
		mysql_query("DELETE FROM $htbl WHERE rid = $rid");
		mysql_query("DELETE FROM $mem_tbl WHERE xid = $rid AND type = $cctype");
	}

	var $request_info_sql='';
	function request_info($rid,&$xstr2uid,$popup_error){
		global $yxl_users;

		$req_tbl=$this->object_params['requests_tbl'];
		$hist_tbl=$this->object_params['history_tbl'];
		$htypeid=$this->object_params['history_rts_type'];

		if(!$this->request_info_sql)
			$this->request_info_sql="SELECT r.*, UNIX_TIMESTAMP(r.reg_date) AS reg_date_tm, UNIX_TIMESTAMP(r.last_date) AS last_date_tm";

		$from_where=$this->request_query_sqlstr_fw(FALSE,FALSE);

		$query =  $this->request_info_sql." $from_where AND rid=$rid";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table.");

		$RInfo=mysql_fetch_array($result, MYSQL_ASSOC);
		if(!$RInfo){
			if($popup_error=="return"){
				_live_error('Could not find request ID='.$rid.' in the database.');
				return FALSE;
			}elseif($popup_error)
				_quit_error("<script> alert('Could not find request ID=".$rid.".') </script>");
			else
				_quit_error('Could not find request ID='.$rid.' in the database.');
		}

		if($this->state_is_dup($RInfo['class'],$RInfo['state'])){
 			$ds=simple_query("SELECT state FROM $req_tbl WHERE rid=".$RInfo['dup_rid']);
 			if($ds)
 				$RInfo['dup_rid_state']=$ds;
 		}else{
 			$dupes=$this->get_all_dupes($RInfo['rid']);
			if(count($dupes))
				$RInfo['dupes']=implode(',',$dupes);
 		}

		// UID sanity check
		if(isset($yxl_users)){
			$amu=get_active_mu();
			foreach(array_keys($RInfo) as $k){
				if(!(substr($k,-4,4)=="_uid") && !($k=="filed_by"))
					continue;

				if(substr($k,0,5)=="plan_")
					continue;

				if(user_exists($RInfo[$k]) || ($RInfo[$k]==$amu))
					continue;

				_warn_yoxel("$req_tbl RID$rid: $k=".$RInfo[$k]." is invalid, changing it to $amu.");
				$RInfo[$k]=$amu;
				$query="UPDATE $req_tbl SET $k=$amu WHERE rid=$rid";
				if(!@mysql_query($query))
					_die2(__FILE__.':'.__LINE__." Could not update $req_tbl table.");
			}
		}

		// CLASS sanity check
		if(!isset($this->classes['name'][$RInfo['class']])){
			$cs=array_keys($this->classes['name']);
			$c=$cs[0];
			_warn_yoxel("$req_tbl RID$rid: class=".$RInfo['class']." is invalid, changing it to $c.");
			$RInfo['class']=$c;
			$query="UPDATE $req_tbl SET class=$c WHERE rid=$rid";
			if(!@mysql_query($query))
				_die2(__FILE__.':'.__LINE__." Could not update $req_tbl table.");
		}

		// STATE sanity check
		if(!isset($this->p2_states[$RInfo['state']])){
			$ss=array_keys($this->p2_states);
			$s=$ss[0];
			_warn_yoxel("$req_tbl RID$rid: state=".$RInfo['state']." is invalid, changing it to $s.");
			$RInfo['state']=$s;
			$query="UPDATE $req_tbl SET state=$s WHERE rid=$rid";
			if(!@mysql_query($query))
				_die2(__FILE__.':'.__LINE__." Could not update $req_tbl table.");
		}

		$row = simple_query("SELECT state, UNIX_TIMESTAMP(date) FROM $hist_tbl WHERE rid=$rid AND (options=$htypeid OR options=0) ORDER BY date DESC LIMIT 1,1");
                if($row){
                        $RInfo['prev_state'] = $row[0];
                        $RInfo['prev_state_tm'] = $row[1];
                }else{
                        $RInfo['prev_state'] = 0;
                        $RInfo['prev_state_tm'] = 0;
                }

		$this->xstr2uid($RInfo,$xstr2uid);

		return($RInfo);
	}

	function ys_save_phrase($phrase){

		$wfid=$this->object_params['wfid'];
		$sid=session_id();

		if(!@mysql_query("LOCK TABLES ysphrases WRITE"))
			_die2(__FILE__.':'.__LINE__." Could not lock ysphrases table.");

		if(strlen($phrase)>255)
			$phrase=substr($phrase,0,255);

		$query="SELECT phid FROM ysphrases WHERE rts_type='$wfid' AND phrase='".escape_data($phrase)."'";
		//die("$query <br>\n");
		if(!($phid=simple_query($query))){
			$query="INSERT INTO ysphrases (phrase,rts_type,session_id) VALUES ('".escape_data($phrase)."', '$wfid', '$sid')";
			//echo "$query <br>\n";
			if(!@mysql_query($query))
				_die2(__FILE__.':'.__LINE__." Could not insert into ysphrases table.");
			$phid=@mysql_insert_id();
		}

		if(!@mysql_query("UNLOCK TABLES"))
			_die2(__FILE__.':'.__LINE__." Could not unlock ysphrases table.");

		return($phid);
	}

	function ys_get_phrase($phid){
		$wfid=$this->object_params['wfid'];
		return(simple_query("SELECT phrase FROM ysphrases WHERE rts_type='$wfid' AND phid=$phid"));
	}

	function ys_remove_phrase($phid){

		$wfid=$this->object_params['wfid'];
		$sid=session_id();

		if(!@mysql_query("LOCK TABLES ysphrases WRITE"))
			_die2(__FILE__.':'.__LINE__." Could not lock ysphrases table.");
		$phsid=simple_query("SELECT refn FROM ysphrases WHERE rts_type='$wfid' AND phid=$phid");
		if($phsid==$sid){
			$query="DELETE FROM ysphrases WHERE phid=$phid";
			if(!@mysql_query($query))
				_die2(__FILE__.':'.__LINE__." Could not delete from ysphrases table.");
			$phid=FALSE;
		}
		if(!@mysql_query("UNLOCK TABLES"))
			_die2(__FILE__.':'.__LINE__." Could not unlock ysphrases table.");

		return($phid);
	}

	function ys_fixate_phrase($phid){

		$wfid=$this->object_params['wfid'];
		$query="UPDATE ysphrases SET session_id = NULL WHERE phid=$phid";
		//echo "$query <br>\n";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__." Could not update ysphrases table.");

		return($phid);
	}

	function ys_query($phrase,$exp=FALSE){
		global $is_customer;

		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$ysef='';
                if(isset($this->object_params['ys_extra_field']) && $this->object_params['ys_extra_field'])
                        $ysef=$this->object_params['ys_extra_field'];

		$match_sql_str="MATCH (synopsis,description".($ysef?",$ysef":'').") AGAINST ('".escape_data($phrase)."'".($exp?' WITH QUERY EXPANSION':'').")";

		$query="SELECT r.*, ".SQL_PQ." AS pq_name FROM
		(SELECT rid, $pq_fn, synopsis, description, class, state, phase_of_rid ".($ysef?", $ysef":'').", $match_sql_str AS score FROM $req_tbl WHERE".($is_customer?"(options&".REQ_OPT_VBC2." OR  (customer_id=$is_customer AND options&".REQ_OPT_VBC.")) AND":'')." $match_sql_str
		) AS r INNER JOIN $pq_tbl AS c ON r.$pq_fn=c.$pq_fn LEFT OUTER JOIN $pq_tbl AS p ON c.parent=p.$pq_fn ORDER BY r.score DESC";
		//echo "$query <br>\n";
		if(!($res=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table.");
		return $res;
	}

	function ys_highlight_keywords(&$row,$phrase){

		$ysef='';
		if(isset($this->object_params['ys_extra_field']) && $this->object_params['ys_extra_field'])
			$ysef=$this->object_params['ys_extra_field'];

		$ttxt=$row['description']."\n".(($ysef && isset($row[$ysef]))?$row[$ysef]:'');

		$a=explode(' ',$phrase);
		$ttxt=trim($ttxt);
		//echo "$ttxt <br>\n";
		$min=strlen($ttxt); $b=array();
		while($s=array_pop($a)){
			if(strlen($s)<4) continue;
			if(isset($b[$s])) continue;
			$b[$s]=$s;
			$n=strpos(strtolower($ttxt),strtolower($s));
			//echo "s=$s, pos=$n <br>\n";
			$n=strrpos(substr($ttxt,0,$n),"\n");
			if($n){
				$n++;
				if($n<$min) $min=$n;
			}
			//echo ". s=$s, pos=$n, min=$min <br>\n";
		}

		if($min==strlen($ttxt))
			$min=0;

		$n=strpos(substr($ttxt,$min,256),"\n");
		if(!$n) $n=256;
		//echo "min=$min n2=$n<br>\n";
		$str=html_safe_text(substr($ttxt,$min,$n+1));
		while($s=array_pop($b))
			$str=preg_replace("/($s)/i","<strong>$1</strong>",$str);

		return $str;
	}

	function ys_find_best_associations($phrase,$num){
		global $is_customer;

		$req_tbl=$this->object_params['requests_tbl'];
		$pq_tbl=$this->object_params['pq_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$match_sql_str="MATCH (phrase) AGAINST ('".escape_data($phrase)."')";

		$query="SELECT r.rid, r.$pq_fn, r.synopsis, r.description, r.class, r.state, r.phase_of_rid, a.score, a.uscore, a.rscore,a.phrase, ".SQL_PQ." AS pq_name FROM (
			SELECT  rid, ysp.phrase, ysp.score AS score, COUNT(ysa.uid) AS uscore, SUM(ysa.refn) AS rscore FROM (
				SELECT phid, phrase, $match_sql_str AS score FROM ysphrases WHERE $match_sql_str LIMIT $num
			) AS ysp, ysassociations AS ysa WHERE ysa.phid=ysp.phid GROUP BY ysa.phid, ysa.rid ORDER BY uscore DESC, rscore DESC LIMIT 5
		) AS a, $req_tbl AS r, $pq_tbl AS c LEFT JOIN $pq_tbl AS p ON c.parent=p.$pq_fn WHERE a.rid=r.rid AND r.$pq_fn=c.$pq_fn".($is_customer?" AND (r.options&".REQ_OPT_VBC2." OR (r.customer_id=$is_customer AND r.options&".REQ_OPT_VBC."))":'')." ORDER BY a.score DESC, a.uscore DESC, a.rscore DESC";
		//echo "$query <br>\n";
		if(!($res=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table.");
		return $res;

	}

	function req_tbl_name(){
		return($this->object_params['requests_tbl']);
	}

	function have_extra(){
		if(!isset($this->x_fields_2d['options']))
			return FALSE;

		foreach($this->x_fields_2d['options'] as $o)
			if($o&FIELD_OPT_X)
				return TRUE;

		return FALSE;
	}

	function &init_extra($native_only=FALSE){
		global $cid;

		$this->x_fields_2d=array();
		$ref=&$this->x_fields_2d;

		$exported_fields=&$this->object_params['x_native_fields'];
		foreach(array_keys($exported_fields) as $k){
			$this->x_fields_2d['long_name'][$k]=$exported_fields[$k]['long_name'];
			$this->x_fields_2d['short_name'][$k]=$exported_fields[$k]['short_name'];
			$this->x_fields_2d['field_name'][$k]=$exported_fields[$k]['field_name'];
			$this->x_fields_2d['field_type'][$k]=$exported_fields[$k]['field_type'];
			$this->x_fields_2d['over_fid'][$k]='';
			$this->x_fields_2d['options'][$k]=isset($exported_fields[$k]['options'])?
					$exported_fields[$k]['options']:0;
		}

		if($native_only)
			return $ref;

		$xfields_tbl=sprintf(XFIELDS_TBL_F,$this->wfid());
		if(!$cid || !mysql_table_exists($xfields_tbl))
			return $ref;

		$query = "SELECT fid, long_name, short_name, field_name, field_type, over_fid, options FROM $xfields_tbl WHERE options&".FIELD_OPT_X;
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__." Can not select from $xfields_tbl table.");

		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			$this->x_fields_2d['long_name'][$row[0]]=$row[1];
			$this->x_fields_2d['short_name'][$row[0]]=$row[2];
			$this->x_fields_2d['field_name'][$row[0]]=$row[3];
			$this->x_fields_2d['field_type'][$row[0]]=$row[4];
			$this->x_fields_2d['over_fid'][$row[0]]=$row[5];
			$this->x_fields_2d['options'][$row[0]]=$row[6];
		}
		//asort($this->x_fields_2d['long_name']);
		asort($this->x_fields_2d['short_name']);

		return $ref;
	}

	function x_get_order2str(){
		$x_order=$this->object_params['x_order_by'];

		$o2s=array();
		foreach(array_keys($x_order) as $k)
			$o2s[$k]=$x_order[$k]['name'];
		return $o2s;
	}

	function x_get_type2align(){
		$t2a=array();
		foreach(array_keys($this->x_field_type) as $k)
			$t2a[$k]=$this->x_field_type[$k]['align'];
		return $t2a;
	}

	function x_get_type2str(){
		$t2n=array();
		foreach(array_keys($this->x_field_type) as $k)
			$t2n[$k]=$this->x_field_type[$k]['name'];
		return $t2n;
	}

	function &x_get_fields($rid,$xfids){

		$req_tbl=$this->object_params['requests_tbl'];
		$exported_fields=&$this->object_params['x_native_fields'];

		if(count($this->x_fields_2d)<1)
			_die(" eXtra is not initialized yet. ");


		$xfields=array();
		$nfids=array();
		$_xfids=array();
		foreach($xfids as $fid){
			if(isset($exported_fields[$fid]))
				$nfids[$fid]=$exported_fields[$fid]['field_name'];
			else
				array_push($_xfids,$fid);
		}

		if(count($nfids)){
			$nfids_str=implode(',',$nfids);
			$query="SELECT rid, $nfids_str FROM $req_tbl WHERE rid=$rid";
			//echo "$query <br>\n";
			if(!($RInfo=simple_query($query)))
				_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table.");

			$nfks=array_keys($nfids);
			for($i=0;$i<count($nfks);$i++)
				$xfields[$nfks[$i]]=$RInfo[$i+1];
		}

		$extras_tbl=sprintf(EXTRAS_TBL_F,$this->wfid());
		$ref=&$xfields;
		if(count($_xfids)<1)
			return $ref;

		$xfids_str=implode(',',$_xfids);
		$query = "SELECT fid, xfield FROM $extras_tbl WHERE id=$rid AND fid IN ($xfids_str)";
		//echo "$query <br>";
		if(!($xresult=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__." Could not select from $extras_tbl table.");

		while($xr=mysql_fetch_array($xresult, MYSQL_NUM))
			$xfields[$xr[0]]=$xr[1];

		foreach($xfids as $fid)
			if(!isset($xfields[$fid]))
				$xfields[$fid]=FALSE;
		return $ref;
	}



	// $xt_params		- list of template parameters
	// $fns			- list of fields to sql-select from tables
	// $xfids		- x-fields to be shown in the report (from show_fids)
	// $where		- specifies SQL query
	// $data		- return data

	function &x_get_content(&$xt_params, $fns, $xfids, $where){

		if(count($this->x_fields_2d)<1)
			_die(" eXtra is not initialized yet. ");

		$x_order=$this->object_params['x_order_by'];
		$extras_tbl=sprintf(EXTRAS_TBL_F,$this->wfid());

		$x_fields_2d = &$this->x_fields_2d;

		$data=array();
		$ref=&$data;

		if(isset($xt_params['customers']) && count($xt_params['customers']))
			$cust_sql=" AND (r.customer_id=".implode(' OR r.customer_id=',$xt_params['customers']).")";
		else
			$cust_sql='';

		$order_sql=array();
		foreach(array_keys($x_order) as $o){
			if($xt_params['order1']!=$o) continue;
			if(substr($o,0,4)=='pri_')
				array_unshift($order_sql,"IF(r.customer_pri=".REQ_PRI_CRITICAL.",r.critical_order,0) ASC");
			array_unshift($order_sql,$x_order[$o]['sql']);
		}
		$SQLStr = $this->request_query_sqlstr_fw();
		$query ="SELECT r.rid, r.".implode(', r.',$fns).", r.options $SQLStr $where $cust_sql".($xt_params['shr']?'':" AND (r.options&".REQ_OPT_X.")").(count($order_sql)?" ORDER BY ".implode(', ',$order_sql):'').($xt_params['ol']?" LIMIT ".$xt_params['ol']:'');
		//echo "$query <br>"; print_r($xt_params);
		//foreach($fid2rn as $fid => $rn)
		//	echo "$fid --> $rn <br>";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Can not select from requests table.');

		while($r=mysql_fetch_array($result, MYSQL_ASSOC)){
			//print_r($r);

			// If content control, skip non-VBC requests
			if(($xt_params['rtype']==2) && !($r['options']&(REQ_OPT_VBC|REQ_OPT_VBC2))) continue;

			// Get all eXtra fields now
			$xfield_x_template_row=&$this->x_get_fields($r['rid'],$xfids);

			$ol=array();
			if($xt_params['rf']=='HTML'){
				array_push($ol,$r['rid']);
				// hidden request - TRUE, otherwise - FALSE
				array_push($ol,(!($r['options']&(REQ_OPT_VBC|REQ_OPT_VBC2)) || !($r['options']&REQ_OPT_X)));
			}

			//print_r($xt_params['show_fields']);
			foreach($xt_params['show_fields'] as $fid){
				if($x_fields_2d['options'][$fid]&FIELD_OPT_X)
					$val=$xfield_x_template_row[$fid];
				else
					$val=$r[$x_fields_2d['field_name'][$fid]];
				//echo "** $fid ".$x_fields_2d['field_name'][$fid]."-> $val, ";

				$ofid=$x_fields_2d['over_fid'][$fid];
				if($ofid && !$val && ($xt_params['rtype']==1))
					$val=$r[$x_fields_2d['field_name'][$ofid]];
				//echo "$ofid -> $val<br>";
				$val=$this->x_process_field($fid, $val, $r['rid'], $xt_params['rf']);
				array_push($ol,$val);
	                }
			//echo implode(' ',$ol), "<br>";
			array_push($data,$ol);
		}
		return($data);
	}

	function x_set_field_type_processor($ft,&$values,$eval_str=''){
		if(!count($values)) return;
		$this->x_field_type[$ft]['values']=$values;
		if($eval_str)
			$this->x_field_type[$ft]['eval']=$eval_str;
	}

	function x_process_field($fid, $v, $rid, $report_format){
                global $pri2str;
                global $customers_2d;

		$mem_tbl=$this->object_params['members_tbl'];
		$req_tbl=$this->object_params['requests_tbl'];
		$pnets_tbl=$this->object_params['pnets_tbl'];
		$pnet_type_pri=$this->object_params['pnet_type_pri'];

		//echo "fid=".$x_fields_2d['short_name'][$fid]." v=$v <br>";
		if(!$v) return FALSE;
		$ft=$this->x_fields_2d['field_type'][$fid];
		$tmp='';
		if(isset($this->x_field_type[$ft]['eval'])){
			eval($this->x_field_type[$ft]['eval']);
			return $tmp;
		}

		if(isset($this->x_field_type[$ft]['values'])){
			if(isset($this->x_field_type[$ft]['values'][$v]))
					return($this->x_field_type[$ft]['values'][$v]);
				else
					return(FALSE);
		}

		switch($ft){
                        case 'date':
				return(date_sql2norm($v));
                        case 'username':
				return(YxlUsers::name($v));
                        case 'state':
                        	if(isset($this->state2str[$v]))
					return($this->state2str[$v]);
				else
					return(FALSE);
                        case 'class':
                        	if(isset($this->class2str[$v]))
					return($this->class2str[$v]);
				else
					return(FALSE);
                        case 'customer_pri':
				return($pri2str[$v]);
			case 'main_pq':
				if(isset($this->pqs_2d['name'][$v])){
					$p=$this->pqs_2d['parent'][$v];
					if($p)
						return($this->pqs_2d['name'][$p]);
					return $this->pqs_2d['name'][$v];
				}else
					return(FALSE);
			case 'sub_pq':
				if(isset($this->pqs_2d['name'][$v])){
					$p=$this->pqs_2d['parent'][$v];
					if($p)
						return($this->pqs_2d['oname'][$v]);
					return 'General';
				}else
					return(FALSE);
                        case 'customer':
                        	if(isset($customers_2d['name'][$v]))
					return($customers_2d['name'][$v]);
				else
					return(FALSE);
                        case 'number':
				return($v);
			case 'text_line':
				if($report_format == 'HTML')
					$v=html_safe_text($v);
				return($v);
                        case 'text_area':
				if($report_format == 'HTML'){
					$v=html_safe_text($v);
					$v='<pre>'.$v.'</pre>';
				}elseif($report_format == 'XLS')
					$v=xls_safe_text($v);
				return($v);
			case 'ph_list':
				$query = "SELECT rid FROM $req_tbl WHERE phase_of_rid='$v' ORDER BY rid ASC";
				if(!($result=@mysql_query($query)))
					_die2(__FILE__.':'.__LINE__.' Could not select from $req_tbl table.');
				$rids=array();
				while($row=mysql_fetch_array($result, MYSQL_NUM))
					array_push($rids,$row[0]);

				$query = "SELECT xid FROM $mem_tbl WHERE uid='$v' AND type=".MEMB_TYPE_BTSXRID." ORDER BY xid ASC";
				if(!($result=@mysql_query($query)))
					_die2(__FILE__.':'.__LINE__." Could not select from $mem_tbl table.");
				while($row=mysql_fetch_array($result, MYSQL_NUM))
					array_push($rids,'X'.$row[0]);
				if(count($rids))
					return(implode(', ',$rids));
				else
					return('none');
			case 'pri_votes':
				$query = "SELECT uid, xval FROM $pnets_tbl WHERE rid=$rid AND type=$pnet_type_pri";
                                if(!($result=@mysql_query($query)))
                                        _die2(__FILE__.':'.__LINE__." Could not select from $pnets_tbl table.");
                                $str='';
                                while($row=mysql_fetch_array($result, MYSQL_NUM)){
                                        if(!YxlUsers::username($row[0])) continue;
                                        $str.=', '.YxlUsers::username($row[0]).'('.$pri2str[$row[1]].')';
                                }
                                return substr($str,2);
                        default:
                                _die(__FILE__.':'.__LINE__." Processor is not defined for type $ft.");
                }
	}

	function x_exists_proj_template($proj_id,$proj_phase){
                $xtemplates=new UserFilters($this->wfid().'/xtemplates');
                $tids=$xtemplates->get_tagged_fids('_proj_tag',$proj_id);
                if(!count($tids))
                        return FALSE;

                $xtid=FALSE;
                while($tid=array_pop($tids)){
                        $xtid=$tid;
                        $xt=&$xtemplates->get_filter_by_id($tid);
                        if($xt->pget('_proj_phase')==$proj_phase)
                                break;
                }

                return $xtid;

        }

	function get_xfid_by_short_name($sn){
		if(count($this->x_fields_2d)<1)
			_die(" eXtra is not initialized yet. ");

		$sn=strtolower($sn);

		$xfields_tbl=sprintf(XFIELDS_TBL_F,$this->wfid());

		foreach($this->x_fields_2d['short_name'] as $fid => $fsn)
			if(strtolower($fsn)==$sn)
				return $fid;

		return FALSE;
	}

	function update_xfid_extra_for_rid($rid,$fid,$v){
		if(count($this->x_fields_2d)<1)
			_die(" eXtra is not initialized yet. ");
		$extras_tbl=sprintf(EXTRAS_TBL_F,$this->wfid());

		if (!mysql_query("DELETE FROM $extras_tbl WHERE id = $rid AND fid = $fid"))
			_die2(__FILE__.':'.__LINE__." Could not delete from $extras_tbl table.");

		if (!mysql_query("INSERT INTO $extras_tbl (id, fid, uid, options, xfield) VALUES ($rid, $fid, 0, 0, '".escape_data($v)."')"))
			_die2(__FILE__.':'.__LINE__." Could not insert into $extras_tbl table.");
	}

	function get_xfid_extra_for_rid($rid,$fid){
		if(count($this->x_fields_2d)<1)
			_die(" eXtra is not initialized yet. ");
		$extras_tbl=sprintf(EXTRAS_TBL_F,$this->wfid());

		return simple_query("SELECT xfield FROM $extras_tbl WHERE id = $rid AND fid = $fid");
	}

	function add_comment(&$RInfo, $comment, $to, &$remove_pqs, $cc=FALSE){
		global $uid;
		global $https_path;

		$this->validate_rinfo($RInfo);

		$rid=$RInfo['rid'];
		$pqs=&$this->pqs_2d;

		$mem_tbl=$this->object_params['members_tbl'];
		$mtypeid=$this->object_params['member_cc_type'];
		$pqfn=$this->object_params['pq_fn'];
		$view_script=$this->object_params['req_email_view_script'];
		$rtsn=$this->object_params['rts_short_name'];

		$hcomment = "Action: Comment\n".$comment;

		$this->log_history($RInfo, $uid, $hcomment);

		$mail = '  '.YxlUsers::name($uid,TRUE)." has added the following comment for the request #$rid:\n\n  Synopsis:\n>".$RInfo['synopsis']."\n\nComment:";
		$mail .= str_replace("\n", "\n>", format_text(str_replace("\r", "", $comment), 70));
		$mail .= "\n\n  For detailed information about the request, please use the following link:\n\n".$https_path.$view_script."?id=$rid\n\n";
		$mail .= $this->rts_msg_signature;

		// Read CC list
		if (!$cc){
			$SQL = mysql_query("SELECT m.uid FROM $mem_tbl AS m, users AS u WHERE u.uid = m.uid AND m.type=$mtypeid AND m.xid = $rid");
			if (!$SQL)
				_die2(__FILE__.':'.__LINE__." Could not select from $mem_tbl table.");
			for ($cc = array(); $tmp = mysql_fetch_row($SQL); )
				arr_push($cc, $tmp[0]);
			mysql_free_result($SQL);
		}

		$internal_cc=array();
		$external_cc=array();
		arr_unshift($cc, $to);
		if($RInfo['state']&$this->last_state_mask($RInfo['class']))
			arr_unshift($cc, $RInfo['fixer_uid']);

		$this->split_cc_list($cc,$internal_cc,$external_cc);
		//print_r($cc);print_r($internal_cc);print_r($external_cc);

		$Header = $this->rts_from_header;
		$subject=$this->construct_subject($RInfo,'comment');
		$CC='';
		if(count($internal_cc)){
			$To=array_shift($internal_cc);
			$a=explode('"',$To);
			$int_mail  = '  Hello '.$a[1].",\n\n".$mail;

			if(count($internal_cc))
				$CC=implode(', ',$internal_cc);
			if($CC)
				$Header.= "\nCC: $CC";

			yxl_mail($To, $subject, format_text($int_mail), $Header);
		}

		if(!count($external_cc))
			return;

		$mail = "  A comment has been added for the request #$rid:\n\n  Synopsis:\n>".$RInfo['synopsis']."\n\nComment:";
		$mail .= str_replace("\n", "\n>", format_text(str_replace("\r", "", $comment), 70));
		$mail .= "\n\n  For detailed information about the request, please use the following link:\n\n".$https_path.$view_script."?id=$rid\n\n";
		$mail .= $this->rts_msg_signature;

		$Header = $this->rts_from_header;

		foreach(array_keys($external_cc) as $cust){
			if(!($RInfo['options']&REQ_OPT_VBC2) && !($RInfo['options']&REQ_OPT_VBC && ($cust==$RInfo['customer_id'])))
				continue;

			$ecc=&$external_cc[$cust];
			if(!count($ecc))
				continue;

			$To=array_shift($ecc);
			$a=explode('"',$To);
			//$ext_mail  = '  Hello '.$a[1].",\n\n".$mail;
			$ext_mail  = "  Hello $rtsn User,\n\n".$mail;

			if(count($ecc))
				$CC=implode(', ',$ecc);

			if($CC)
				$Header.= "\nCC: $CC";

			yxl_mail($To, $subject, format_text($ext_mail), $Header);
		}
	}

	function notify_by_email($rid, $uid, $comment, $wfaid){
		global $MyDomain;
		global $MyCN;
		global $yoxel_cid;
		global $dir_name;
		global $https_srvr;
		global $is_customer;

		$pq_fn=$this->object_params['pq_fn'];
		$pq_gn=$this->object_params['pq_long_title'];
		$pq_sn=$this->object_params['pq_title'];
		$email_view_script=$this->object_params['req_email_view_script'];


		$rts_from_header=$this->rts_from_header;
		$m_sign=$this->rts_msg_signature;

		$pqs_2d=&$this->pqs_2d;
		$state2str=&$this->state2str;

		$xstr2uid=array();
		$RInfo=$this->request_info($rid,$xstr2uid);

		if(!$RInfo['filed_by'])
			_die(__FILE__.':'.__LINE__." Submitter can not be zero.");

		$RDate  = date("M d Y, h:ia", $RInfo['reg_date_tm']);

		$maps=array();
		foreach($xstr2uid as $k => $u){
			if(!YxlUsers::exists($u))
				continue;

			$maps['name'][$k]=YxlUsers::name($u,TRUE);
			$maps['email'][$k]=$this->construct_email($u);
		}

		$script_php=$dir_name.$email_view_script."?id=$rid";
		$target=base64_encode($script_php);
		$rts_view=$https_srvr.$script_php;


	 	// Current user info
		$current_user_name = YxlUsers::name($uid);

		// comment
		$synop = format_text(str_replace("\r", "",$RInfo['synopsis']), 70);
		$synop = "  Synopsis:".($synop?("\n> ".str_replace("\n", "\n> ", $synop)):"");
		$comment = $this->hide_tagged_info($comment,FALSE);
		$comment = format_text(str_replace("\r", "", $comment), 70);
		$comment = "  Comments:".($comment?("\n> ".str_replace("\n", "\n> ", $comment)):"");
		$comment = "\n\n$synop\n\n$comment\n\n";

		// Last state
		if (isset($RInfo['prev_state'])){
			$lastDate  = date("M d Y, h:ia", $RInfo['prev_state_tm']);
			$lastState = $RInfo['prev_state'];
		}
		//echo "rid=$rid, LastState=$lastState <br>$comment";

		$internal_cc=array();
		$external_cc=array();
		$all_cc=$this->get_cc_list($rid);
        	$this->split_cc_list($all_cc,$internal_cc,$external_cc);
        	//print_r($all_cc);die;

		$MList = array();  // A list of e-mail(s) to be sent
		$query = "SELECT g.xstr, g.xstr2, g.xstr3, g.options, a.email_status, a.next_state FROM wfgroups AS g, wfactions AS a WHERE g.id=a.wf_action_id AND g.id=$wfaid AND g.type=".WFGROUP_TYPE_EMAIL;
		//echo "$query <br>\n";
		if (!($result=mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from wfgroups table.');

		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			$to_uid=$xstr2uid[$row[0]];
			$cust=YxlUsers::customer($to_uid);
			$To=$maps['email'][$row[0]];
			$body=FALSE;
			$Subject=$this->construct_subject($RInfo,$row[4]?$row[4]:$state2str[$row[5]]);

			if(YxlUsers::user_is($to_uid)&USER_IS_CUSTOMER){
				if(!($RInfo['options']&REQ_OPT_VBC2) && !($RInfo['options']&REQ_OPT_VBC && ($cust==$RInfo['customer_id'])))
					continue;
				if($row[2]){
					if($row[3]&WFGROUP_EMAIL_OPT_CC)
						array_push($MList, array($To,$Subject,$row[2],$external_cc[$cust]));
					else
						array_push($MList, array($To,$Subject,$row[2],array()));
				}
			}else{
				if($row[1]){
					if($row[3]&WFGROUP_EMAIL_OPT_CC)
						array_push($MList, array($To,$Subject,$row[1],$internal_cc));
					else
						array_push($MList, array($To,$Subject,$row[1],array()));
				}
			}
		}

		// Send all the e-mails
		foreach($MList as $Mail){
			$To = $Mail[0];
			$Subject = $Mail[1];
			$body=str_replace("%user", $current_user_name, $Mail[2]);
			$body=str_replace("%you", $uid==$to_uid?'You. Thank you':$current_user_name, $body);
			$body=str_replace("%view_link", $rts_view, $body);
			$body=str_replace("%rid", $RInfo['rid'], $body);
			$body=str_replace("%comment", $comment, $body);
			$body=str_replace("%RDate", $RDate, $body);
			$body=str_replace("%crn", company_real_name(), $body);
			if(isset($lastDate))
				$body=str_replace("%lastDate", $lastDate, $body);

			$cmp=create_function('$a, $b', 'return strlen($a)>=strlen($b)?-1:1;');
			uksort($xstr2uid,$cmp);
			foreach(array_keys($xstr2uid) as $k){
				if(!isset($maps['name'][$k])) continue;
				$body=str_replace($k, $maps['name'][$k], $body);
			}

			$Text = format_text($body.$m_sign);
			$Header = $rts_from_header;
			if (isset($Mail[3]) && count($Mail[3]))
				$Header = $rts_from_header."\nCC: ".implode(', ',$Mail[3]);
			//echo "yxl_mail: $To, $Subject, $Text, $Header <br>\n";
			yxl_mail($To, $Subject, $Text, $Header);
    		}
	}

	function construct_subject($RInfo,$action){
		global $customers_2d;

		$pqfn=$this->object_params['pq_fn'];
		$pqs=&$this->pqs_2d;

		$pq=$ppq=$spq='';
		if($RInfo[$pqfn] && ($p=$pqs['parent'][$RInfo[$pqfn]])){
			$pq=$pqs['oname'][$p].'-'.$pqs['oname'][$RInfo[$pqfn]];
			$ppq=$pqs['oname'][$p];
			$spq=$pqs['oname'][$RInfo[$pqfn]];
		}elseif($RInfo[$pqfn]){
			$pq=$pqs['oname'][$RInfo[$pqfn]];
			$ppq=$pqs['oname'][$RInfo[$pqfn]];
			$spq='General';
		}

		$subject=str_replace("%action",$action,$this->rts_subject_format);
		$subject=str_replace("%wfid",$this->wfid(),$subject);
		$subject=str_replace("%rid",$RInfo['rid'],$subject);
		$subject=str_replace("%ppq",$ppq,$subject);
		$subject=str_replace("%spq",$spq,$subject);
		$subject=str_replace("%pq",$pq,$subject);
		if(isset($RInfo['customer_id']) && $RInfo['customer_id'])
			$subject=str_replace("%cust",$customers_2d['name'][$RInfo['customer_id']],$subject);
		$subject=str_replace("%synop",$RInfo['synopsis'],$subject);

		return $subject;
	}

	function validate_rinfo(&$RInfo){
		if(!is_array($RInfo))
			_die(__FILE__.':'.__LINE__.' RInfo should be an array.');

		//print_r($RInfo);

		if(!isset($RInfo['rid']))
			_die(__FILE__.':'.__LINE__.' Incorrect RInfo(rid).');

		if(!isset($RInfo['class']))
			_die(__FILE__.':'.__LINE__.' Incorrect RInfo(class).');

		if(!isset($RInfo['state']))
			_die(__FILE__.':'.__LINE__.' Incorrect RInfo(state).');

		if(!isset($RInfo['options']))
			_die(__FILE__.':'.__LINE__.' Incorrect RInfo(options).');

		if(!isset($RInfo['customer_id']))
			_die(__FILE__.':'.__LINE__.' Incorrect RInfo(customer_id).');

		if(!$RInfo['rid'])
			_die(__FILE__.':'.__LINE__.' Incorrect request id.');
	}

	function with_expert_rating(){
		if(isset($this->object_params['pnet_type_expert_rate']) && $this->object_params['pnet_type_expert_rate'])
			return TRUE;
		return FALSE;
	}

	function set_expert_rating($id,$rtg){
		global $uid;

		if(!$this->with_expert_rating())
			_die('Expert rating is not enabled for this class.');

		$pnets_tbl=$this->object_params['pnets_tbl'];
		$pnets_type=$this->object_params['pnet_type_expert_rate'];

		$query="DELETE FROM $pnets_tbl WHERE type=$pnets_type AND uid=$uid AND rid=$id";
		//echo "$query <br>\n";
                if(!@mysql_query($query))
                        _die(__FILE__.':'.__LINE__." Could not delete from $pnets_tbl table.");

		if(!$rtg)
			return;

		$query="INSERT INTO $pnets_tbl (rid, uid, xval, type) VALUES ($id, $uid, $rtg, $pnets_type)";
		//echo "$query <br>\n";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__." Could not insert into $pnets_tbl table.");

	}

	function &rid2state_at_time($tm,&$rids){

		$htbl=$this->object_params['history_tbl'];
		$typeid=$this->object_params['history_rts_type'];

		$sql_str=count($rids)?' AND rid IN ('.implode(',',$rids).')':' AND 0';
		$query="SELECT rid, state FROM $htbl WHERE options=$typeid AND DATE(FROM_UNIXTIME($tm))>=DATE(date) $sql_str ORDER BY date ASC";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
                	_die2(__FILE__.':'.__LINE__." Could not select from $htbl table.");

		$rs=array(); $ref=&$rs;
		while($row=mysql_fetch_row($result))
			$rs[$row[0]]=$row[1];

		return $ref;
	}

	function significant_pqs($rid_limit=100){

		$pq_fn=$this->object_params['pq_fn'];

		$fw_sql=$this->request_query_sqlstr_fw(FALSE,TRUE);
		$query="SELECT IF(c.parent,c.parent,c.$pq_fn) AS main_pid, COUNT(r.rid) AS nrids $fw_sql GROUP BY main_pid HAVING nrids>$rid_limit";
		//echo "$query<br>\n";
		if(!($result=@mysql_unbuffered_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from requests table. ');
		$prods=array();
		while($row=mysql_fetch_array($result, MYSQL_NUM))
			array_push($prods,$row[0]);
		return($prods);
	}

	function _dashboard_cr_bundle($did,$uid,$info=FALSE){
		global $dir_name;

		if(prereq_check('rts_no_requests'))
			return FALSE;

		$pq_fn=$this->object_params['pq_fn'];
		$pq_sn=$this->object_params['pq_title'];
		$sub_pq_sn=$this->object_params['sub_pq_title'];
		$wfid=$this->wfid();
		$vscr=$this->request_view_script();

		$psets=$this->construct_pq_sets();

		$pset2name=array();
		foreach(array_keys($psets) as $pk){
			$pstr=$pset2name[$pk]='';
			foreach($this->pqs_2d['name'] as $pid => $n){
				if(!in_array($pid,$psets[$pk])) continue;
				$pstr.= '/'.$n;
			}
			if($pstr)
				$pset2name[$pk]=substr($pstr,1);
		}

		if($info){
			return array('header' => 'Critical requests you are responsible for',
				'default_size' => 2,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'pqbundle' => array(
							'title' =>"$pq_sn bundles",
							'options' => $pset2name,
							'multiple' => TRUE),
						'rlimit' => array(
							'title' => '#requests to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5; $pqb_str='';
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
			$hdr=$dp->pget('header');
			$pqb_str=$dp->pget('pqbundle');
		}
		if(!$lim)
			$lim=5;

		if($pqb_str){
			$psets=array();
			$pqbs=explode(',',$pqb_str);
			for($i=0;$i<count($pqbs);$i++)
				$psets[$pqbs[$i]]=explode(':',$pqbs[$i]);
		}

		$sql=$this->request_query_sqlstr('',FALSE);
		$tbl_str=''; $many_bundles=count($psets)>1;
		foreach($psets as $pk => $p){
			//print_r($p);
			$sql_str='';
			foreach($this->pqs_2d['name'] as $pid => $n){
				if(!in_array($pid,$p)) continue;
				$sql_str.= " OR r.$pq_fn=$pid OR c.parent=$pid";
			}
			if($sql_str)
				$sql_str=' AND ('.substr($sql_str,3).')';

			$query = "$sql AND !(".$this->sql_last_states_str.") AND !(".$this->sql_verified_states_str.") AND (r.fixer_uid=$uid AND !(".$this->sql_fixed_states_str.")) AND r.customer_pri=".REQ_PRI_CRITICAL." $sql_str ORDER BY r.critical_order ASC LIMIT $lim";
			//echo "$query <br>";
			if(!($result=@mysql_query($query)))
				_die2(__FILE__.':'.__LINE__.' Can not select from requests table.');
			if(mysql_num_rows($result)){
				$tbl_str.= '
			<tr style="height: 1" class="separator">
				<td colspan=3></td>
			</tr>';

				if($many_bundles)
					$tbl_str.= '
			<tr class=lgray>
				<th align="left" colspan=3>[<a href="'.$dir_name.'/rts/wf_bts_cp.php" style="text-decoration: underline">'.$pset2name[$pk].'</a>]</th>
			</tr>';

				$tbl_str.= '
			<tr class=lgray>
				<th>ID</th>
				<th align="left">'.sprintf(HDR_LONG_SYNOP_F,$pq_sn,$sub_pq_sn,'Synopsis').'</th>
				<th>Sate</th>
			</tr>';
				while($row=mysql_fetch_array($result, MYSQL_ASSOC)){
					$tbl_str.= '
			<tr class="lgray" onmouseover="this.className=\'lgs\';" onmouseout="this.className=\'lgray\';" onClick="view_win_open('.$row['rid'].',\''.$wfid.'\',\''.$vscr.'?id=\')">
				<td align="center">'.$row['rid'].'</td>
				<td>'.html_safe_text($row['pq_name'].' '.$row['synopsis']).'</td>
				<td align="center">'.$this->state2str[$row['state']].'</td>
			</tr>';
				}
				$ok=TRUE;
			}
		}

		if($tbl_str)
			$tbl_str= '
		<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
		</table>';
		return $tbl_str;
	}

	function _dashboard_latest_requests($did,$uid,$info=FALSE){
		global $dir_name;
		global $is_customer;

		if(prereq_check('rts_no_requests'))
			return FALSE;

		if($info){
			return array('header' => 'Recently Filed Requests',
				'default_size' => 1,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => '#requests to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
		}
		if(!$lim)
			$lim=5;

		$pq_sn=$this->object_params['pq_title'];
		$sub_pq_sn=$this->object_params['sub_pq_title'];
		$wfid=$this->wfid();
		$vscr=$this->request_view_script();

		$tbl_str='';
		$sql=$this->request_query_sqlstr('',FALSE);
		$query = "$sql ORDER BY r.rid DESC LIMIT $lim";
		//echo "$query <br>";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Can not select from requests table.');

		if(mysql_num_rows($result)<1)
			return $tbl_str;

		$tbl_str.= '
	<tr style="height: 1" class="separator">
		<td colspan=3></td>
	</tr>
	<tr class=lgray>
		<th>ID</th>
		<th align="left">'.sprintf(HDR_LONG_SYNOP_F,$pq_sn,$sub_pq_sn,'Synopsis').'</th>
	</tr>';
		while($row=mysql_fetch_array($result, MYSQL_ASSOC)){
			$tbl_str.= '
	<tr class="lgray" onmouseover="this.className=\'lgs\';" onmouseout="this.className=\'lgray\';" onClick="view_win_open('.$row['rid'].',\''.$wfid.'\',\''.$vscr.'?id=\')">
		<td align="center">'.$row['rid'].'</td>
		<td>'.html_safe_text($row['pq_name'].' '.$row['synopsis']).'</td>
	</tr>';
		}

		if($tbl_str)
			$tbl_str= '
	<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
	</table>';

		return $tbl_str;
	}

	function _dashboard_filter_requests($did,$uid,$info=FALSE){
		global $dir_name;

		if(prereq_check('rts_no_requests'))
			return FALSE;

		$pq_fn=$this->object_params['pq_fn'];
		$pq_sn=$this->object_params['pq_title'];
		$sub_pq_sn=$this->object_params['sub_pq_title'];
		$x_order=&$this->object_params['x_order_by'];

		$wfid=$this->wfid();
		$vscr=$this->request_view_script();

		$filters=new UserFilters($wfid,"<My Last Filter>");
		$fls=$filters->get_filters();
		$fls[0]='=None=';

		$o2s=$this->x_get_order2str();
		$o2s['none']='=None=';

		$f2n=array();
                foreach($this->x_fields_2d['long_name'] as $k => $ln){
			if($this->x_fields_2d['options'][$k]&FIELD_OPT_X)
				continue;
			if($this->x_fields_2d['field_type'][$k]=="text_area")
				continue;
			$f2n[$k]=$ln;
			$f2n[$k]=$ln;
		}

		if($info){
			return array('header' => 'FILTERED REQUESTS (GENERIC)',
				'default_size' => 2,
				'type' => 'table/text',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'fid' => array(
							'title' =>"Filter",
							'options' => $fls),
						'sfs' => array(
							'title' =>"Show fields",
							'yxl_options' => $f2n),
						'oby' => array(
							'title' =>"Order",
							'options' => $o2s),
						'rlimit' => array(
							'title' => '#requests to show',
							'options' => array(5=>5,10=>10,25=>25)),
					)
				);
		}

		$lim=5; $fid=0; $oby='';
		$sfs=array('r.rid','r.synopsis');
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
			$hdr=$dp->pget('header');
			$fid=$dp->pget('fid');
			if($sfs_str=$dp->pget('sfs'))
				$sfs=explode(',',$sfs_str);
			$oby=$dp->pget('oby');
		}
		if(!$lim)
			$lim=5;

		$cspan=count($sfs);

		$sql_str='';
		if($fid)
			$sql_str=$filters->filter2sql_where($fid);

		if(isset($x_order[$oby]['sql']))
			$oby=$x_order[$oby]['sql'];
		else
			$oby='r.rid DESC';


		$tbl_str='';
		$sql=$this->request_query_sqlstr('',FALSE);
		$query = "$sql $sql_str ORDER BY $oby LIMIT $lim";
		//echo "$query <br>";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Can not select from requests table.');

		if(mysql_num_rows($result)<1)
			return $tbl_str;

		$tbl_str.= '
	<tr style="height: 1" class="separator">
		<td colspan="'.$cspan.'"></td>
	</tr>
	<tr class=lgray>';
		foreach($sfs as $k){
			$ft=$this->x_fields_2d['field_type'][$k];
			$fa=$this->x_field_type[$ft]['align'];
			$tbl_str.= '
		<th align="'.$fa.'">'.html_safe_text($this->x_fields_2d['short_name'][$k]).'</th>';
		}

		$tbl_str.= '
	</tr>';
		while($row=mysql_fetch_array($result, MYSQL_ASSOC)){
			$tbl_str.= '
	<tr class="lgray" onmouseover="this.className=\'lgs\';" onmouseout="this.className=\'lgray\';" onClick="view_win_open('.$row['rid'].',\''.$wfid.'\',\''.$vscr.'?id=\')">';
			foreach($sfs as $k){
				$fn=$this->x_fields_2d['field_name'][$k];
				$ft=$this->x_fields_2d['field_type'][$k];
				$fa=$this->x_field_type[$ft]['align'];
				$val=$this->x_process_field($k,$row[$fn],$row['rid'],'HTML');
				$tbl_str.= '
			<td align="'.$fa.'">'.$val.'</td>';
			}

			$tbl_str.= '
	</tr>';
		}

		if($tbl_str)
			$tbl_str= '
	<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
	</table>';

		return $tbl_str;
	}
	function _dashboard_pie_pq_by_pri($did,$uid,$info=FALSE){
		global $jpgraph;
		global $dir_name;
		global $pri2str;

		if(prereq_check('rts_no_requests'))
			return FALSE;

		$pq_sn=$this->object_params['pq_title'];
		$req_tbl=$this->object_params['requests_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$lim=1;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
			$pqs_str=$dp->pget('pqs');
		}
		if(!$lim) $lim=1;


		$pqs=$this->significant_pqs($lim);

		$pqs_2d=&$this->pqs_2d;
		$pq2name=array();
		foreach($pqs as $pqid){
			if(!isset($pqs_2d['name'][$pqid]))
				continue;
			$pq2name[$pqid]=$pqs_2d['name'][$pqid];
		}

		if($info)
			return array('header' => 'Distribution of unfixed requests by urgency',
				'default_size' => 3,
				'type' => 'chart',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => 'Consider '.strtolower($pq_sn).'s with #requests greater',
							'options' => array(1=>1,10=>10,100=>100)),
						'pqs' => array(
							'title' => $pq_sn,
							'options' => $pq2name,
							'multiple' => TRUE)
						)
					);
		if($pqs_str)
			$pqs=explode(',',$pqs_str);

		$_SESSION['pq_by_pri'.$did]=array();
		$pq2data=&$_SESSION['pq_by_pri'.$did];

		foreach($pqs as $pqid){
			if(!isset($pqs_2d['name'][$pqid]))
				continue;

			$fw=$this->request_query_sqlstr_fw(FALSE,TRUE);
			$query = "SELECT r.rid $fw AND (r.$pq_fn=$pqid OR c.parent=$pqid) AND !(".$this->sql_fixed_states_str.") LIMIT 1";
			if(!simple_query($query))
				continue;

			$query = "SELECT r.customer_pri, COUNT(r.rid) AS cnt $fw AND (r.$pq_fn=$pqid OR c.parent=$pqid) AND !(".$this->sql_fixed_states_str.") GROUP BY r.customer_pri";
			//echo "$query <br>\n";
			if(!($result=@mysql_query($query)))
				_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table. ");

			$pq2data[$pqid]['name']=$pqs_2d['name'][$pqid];
			$pq2data[$pqid]['data']=array();
			foreach(array_keys($pri2str) as $k)
				$pq2data[$pqid]['data'][$k]=0;
			while($row=mysql_fetch_row($result))
				$pq2data[$pqid]['data'][$row[0]]=$row[1];
		}

		$tbl_str='';
		if($jpgraph && count($pq2data))
			$tbl_str.= '
			<tr style="height: 1" class="separator">
				<td></td>
			</tr>
			<tr class=lgray>
				<td align="center"><img src="'.$dir_name.'/rts/chart_pie_prod_by_pri.php?did='.$did.'"></td>
			</tr>
			';
		if($tbl_str)
			$tbl_str= '
		<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
		</table>';

		return $tbl_str;

	}

	function _dashboard_pie_pq_by_state($did,$uid,$info=FALSE){
		global $jpgraph;
		global $dir_name;

		if(prereq_check('rts_no_requests'))
			return FALSE;

		$pq_sn=$this->object_params['pq_title'];
		$req_tbl=$this->object_params['requests_tbl'];
		$pq_fn=$this->object_params['pq_fn'];

		$lim=1;
		if($did){
			$dp=&new DashletParams($did);
			$lim=$dp->pget('rlimit');
			$pqs_str=$dp->pget('pqs');
		}
		if(!$lim) $lim=1;


		$pqs=$this->significant_pqs($lim);
		$state2str=&$this->state2str;

		$pqs_2d=&$this->pqs_2d;
		$pq2name=array();
		foreach($pqs as $pqid){
			if(!isset($pqs_2d['name'][$pqid]))
				continue;
			$pq2name[$pqid]=$pqs_2d['name'][$pqid];
		}

		if($info)
			return array('header' => 'Distribution of requests by state',
				'default_size' => 3,
				'type' => 'chart',
				'edit' => array('header' => array(
							'title' => 'Dashlet Header'),
						'rlimit' => array(
							'title' => 'Consider '.strtolower($pq_sn).'s with #requests greater',
							'options' => array(1=>1,10=>10,100=>100)),
						'pqs' => array(
							'title' => $pq_sn,
							'options' => $pq2name,
							'multiple' => TRUE)
						)
					);

		if($pqs_str)
			$pqs=explode(',',$pqs_str);

		$_SESSION['pq_by_state'.$did]=array();
		$pq2data=&$_SESSION['pq_by_state'.$did];
		$s2s=array();
		foreach($state2str as $v)
			array_push($s2s,substr($v,0,16));

		foreach($pqs as $pqid){
			if(!isset($pqs_2d['name'][$pqid]))
				continue;

			$fw=$this->request_query_sqlstr_fw(FALSE,TRUE);
			$query = "SELECT r.rid $fw AND (r.$pq_fn=$pqid OR c.parent=$pqid) LIMIT 1";
			if(!simple_query($query))
				continue;

			$query = "SELECT r.state, COUNT(r.rid) AS cnt $fw AND (r.$pq_fn=$pqid OR c.parent=$pqid) GROUP BY r.state";
			//echo "$query <br>\n";
			if(!($result=@mysql_query($query)))
				_die2(__FILE__.':'.__LINE__." Could not select from $req_tbl table. ");

			$pq2data[$pqid]['name']=$pqs_2d['name'][$pqid];
			$pq2data[$pqid]['lbl']=$s2s;
			$pq2data[$pqid]['data']=array();
			foreach(array_keys($state2str) as $k)
				$pq2data[$pqid]['data'][$k]=0;
			while($row=mysql_fetch_row($result))
				$pq2data[$pqid]['data'][$row[0]]=$row[1];
		}

		$tbl_str='';
		if($jpgraph && count($pq2data))
			$tbl_str.= '
			<tr style="height: 1" class="separator">
				<td></td>
			</tr>
			<tr class=lgray>
				<td align="center"><img src="'.$dir_name.'/rts/chart_pie_prod_by_state.php?did='.$did.'"></td>
			</tr>
			';
		if($tbl_str)
			$tbl_str= '
		<table width="100%" align="center" valign=top border="0" cellpadding="0" cellspacing="1" class="dgray">'.$tbl_str.'
		</table>';

		return $tbl_str;
	}
}

?>
