<?php # SalesForecastSystem
// $Header: /home/CVS/rps/includes/sfs/sfs.inc,v 1.29 2008/04/30 19:08:02 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */


require_once('includes/db.inc');
require_once('includes/rts/rts.inc');

	define('HISTORY_OPT_SFS', 1);

	define('PNET_TYPE_SFS_PRI',0x01);

	define ('CDB_CREATE_SFS_HISTORY_TBL', "CREATE TABLE IF NOT EXISTS sfs_history
	    (rid int UNSIGNED default NULL,
	    uid int UNSIGNED default NULL,
	    state int UNSIGNED NOT NULL default '0',
	    date DATETIME,
	    descr text,
	    options INT UNSIGNED DEFAULT 0 NOT NULL,
	    xid INT UNSIGNED DEFAULT NULL,
	    xid2 INT UNSIGNED DEFAULT NULL,
	    xid3 INT UNSIGNED DEFAULT NULL,
	    roptions INT UNSIGNED DEFAULT 0 NOT NULL,
		KEY (rid),
		KEY (uid),
		KEY (state),
		KEY (date),
		FULLTEXT (descr),
		KEY (options),
		KEY (xid)
	    ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('CDB_CREATE_FORECASTS_TBL', "CREATE TABLE IF NOT EXISTS forecasts
		(rid INT UNSIGNED NOT NULL AUTO_INCREMENT,
		pid INT UNSIGNED NOT NULL,
		state INT UNSIGNED NOT NULL,
		synopsis VARCHAR(128) NOT NULL,
		description TEXT,
		class SMALLINT UNSIGNED NOT NULL,
		customer_id INT UNSIGNED NOT NULL,
		filed_by INT UNSIGNED NOT NULL,
		phase_of_rid INT UNSIGNED NOT NULL,
		depends_on INT UNSIGNED DEFAULT 0 NOT NULL,
		fixer_uid INT UNSIGNED NOT NULL,
		reg_date DATETIME NOT NULL,

		lead_source INT UNSIGNED,
		expected_close_date DATE,
		booking_amount INT UNSIGNED NOT NULL,
		license VARCHAR(128) NOT NULL,
		lic_num INT UNSIGNED,
		lic_expir_date DATE,
		hostid CHAR(32),

		project_id INT UNSIGNED,
		in_project ENUM('yes', 'plan', 'maybe', 'no') DEFAULT 'maybe' NOT NULL,
		project_pri INT UNSIGNED,
		plan_pri FLOAT UNSIGNED NOT NULL,
		options INT UNSIGNED NOT NULL,
		plan_fixer_uid INT UNSIGNED NOT NULL,
		fix_wrk_hrs INT UNSIGNED DEFAULT 0 NOT NULL,
		inwork_date DATETIME,
		fixed_date DATETIME,
		last_date DATETIME,
		plan_fix_start DATETIME,
		plan_fix_end DATETIME,
		complete_pct SMALLINT UNSIGNED,
		cal_fix_start DATETIME,
		cal_fix_end DATETIME,

		PRIMARY KEY rid (rid),
			FULLTEXT (synopsis, description),
			KEY (project_pri),
			KEY (plan_pri),
			KEY (filed_by),
			KEY (fixer_uid),
			KEY (phase_of_rid)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

if(!$cmd_line_mode && $uid){
	require_once('includes/sfs/default_wf_sfs.inc');

		$query = CDB_CREATE_FORECASTS_TBL;
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__.' Could not create forecasts table. ');

		$query = CDB_CREATE_SFS_HISTORY_TBL;
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__.' Could not create sfs_history table. ');
}

class ForecastTracker extends RequestTracker {
	var $state2str=array();

	function forecasttracker(){
		global $is_customer;

		$object_params = array(
		'wfid' => 'sfs',
		'rts_short_name' => 'SFS',
		'rts_long_name' => 'Sales Forecasting System',
		'requests_tbl' => 'forecasts',
		'req_view_script' => '/sfs/sfs_view.php',
		'req_email_view_script' => '/sfs/sfs.php',
		'history_tbl' => 'sfs_history',
		'history_rts_type' => HISTORY_OPT_SFS,
		'history_pqset_type' => 0,
		'members_tbl' => 'members',
		'member_cc_type' => MEMB_TYPE_SFSCC,
		'member_pqlist_type' => MEMB_TYPE_PLIST,
		'customer_class_mask_fn' => '',
		'pq_tbl' => 'products',
		'pq_fn' => 'pid',
		'pq_owners' => array(),
		'pq_long_title' => 'Product',
		'pq_title' => 'Product',
		'sub_pq_title' => '',
		'req_proj_id_fn' => 'project_id',
                'req_in_proj_fn' => 'in_project',

                'proj_tbl' => '',
                'proj_id_fn' => '',
		'proj_rts_opt' => 0,

                'pnets_tbl' => 'sfs_pnets',
                'pnet_type_pri' => PNET_TYPE_SFS_PRI,
		'x_native_fields' => array(
			'r.rid' => array(
				'long_name' => 'Forecast ID',
				'short_name' => 'FID',
				'field_name' => 'rid',
				'field_type' => 'number'
			),
			'r.pid' => array(
				'long_name' => 'Product Name',
				'short_name' => 'Prod.',
				'field_name' => 'pid',
				'field_type' => 'main_pq'
			),
			'r.state' => array(
				'long_name' => 'Forecast State',
				'short_name' => 'State',
				'field_name' => 'state',
				'field_type' => 'state'
			),
			'r.customer_id' => array(
				'long_name' => 'Customer',
				'short_name' => 'Cust.',
				'field_name' => 'customer_id',
				'field_type' => 'customer'
			),
			'r.booking' => array(
				'long_name' => 'Booking Amount',
				'short_name' => 'Booking',
				'field_name' => 'booking_amount',
				'field_type' => 'number'
			),
			'r.close_date' => array(
				'long_name' => 'Expected Deal Close Date',
				'short_name' => 'Close Date',
				'field_name' => 'expected_close_date',
				'field_type' => 'date'
			),
			'r.reg_date' => array(
				'long_name' => 'Forecast Registration Date',
				'short_name' => 'FRD',
				'field_name' => 'reg_date',
				'field_type' => 'date'
			),
			'r.description' => array(
				'long_name' => 'Description',
				'short_name' => 'Descr.',
				'field_name' => 'description',
				'field_type' => 'text_area',
				'options' => FIELD_OPT_SOFT
			),
			'r.synopsis' => array(
				'long_name' => 'Synopsis',
				'short_name' => 'Synop.',
				'field_name' => 'synopsis',
				'field_type' => 'text_line',
				'options' => FIELD_OPT_SOFT
			),
			'r.filed_by' => array(
				'long_name' => 'Forecast Submitter',
				'short_name' => 'FiledBy',
				'field_name' => 'filed_by',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			),
			'r.fixer_uid' => array(
				'long_name' => 'Forecast Owner',
				'short_name' => 'Owner',
				'field_name' => 'fixer_uid',
				'field_type' => 'username',
				'options' => FIELD_OPT_SOFT
			)
		),
		'x_order_by' => array(
			'rid_desc' => array(
				'name' => 'By Request ID',
				'sql' => 'r.rid ASC'),
			'state_asc' => array(
				'name' => 'By Request State',
				'sql' => 'r.state ASC'),
			'pid_asc' => array(
				'name' => 'By Product Name',
				'sql' => 'IF(c.parent,p.name,c.name) ASC'),
			'booking_desc' => array(
				'name' => 'By Booking Amount',
				'sql' => 'r.booking_amount DESC'),
			'cdate_asc' => array(
				'name' => 'By Close Date',
				'sql' => 'r.expected_close_date ASC')
		));

		parent::requesttracker($object_params,TRUE);

		$this->state2str=&$this->p2_states;
		$this->rts_subject_format = "{%action} [%cust] %ppq|%rid: %synop";
	}

	function file_request($fields,$cc_list=FALSE){
		global $uid;
		global $customers_2d;

		$pqs_2d=&$this->pqs_2d;

		if(!isset($fields['class']))
			$fields['class']=SFS_REQ_CLASS_STD;

		$class=$fields['class'];
		$fields['state']=$open_state=$this->first_state($fields['class']);
		$nsa_aid=$this->null_state_action($class);
		$lsm=$this->last_state_mask($class);

		if(!isset($fields['pid']) || !$fields['pid'])
			_die(__FILE__.':'.__LINE__.' pid field is not specified.');
		$pqid=$fields['pid'];

		if(!isset($fields['synopsis']))
			_die(__FILE__.':'.__LINE__.' synopsis field is not specified.');

		if(!isset($fields['description']))
			_die(__FILE__.':'.__LINE__.' description field is not specified.');

		if(!isset($fields['booking_amount']))
			_die(__FILE__.':'.__LINE__.' booking_amount field is not specified.');

		if(!isset($fields['expected_close_date']))
			_die(__FILE__.':'.__LINE__.' expected_close_date field is not specified.');

		if(!isset($fields['filed_by']))
			$fields['filed_by']=$uid;

		//$xstr2uid['%rnd_mgr']=$rnd_mgr;
		//$xstr2uid['%qa_mgr']=$qa_mgr;
		//$xstr2uid['%cae_mgr']=$cae_mgr;
		//$xstr2uid['%sls_mgr']=$sls_mgr;
		//$xstr2uid['%fixer']=$fixer;
		//$xstr2uid['%tester']=$tester;
		//$xstr2uid['%submitter']=$submitter;

		if(!isset($fields['fixer_uid']))
			$fields['fixer_uid']=$uid;
		$fixer=$fields['fixer_uid'];

		$fields=array_map("escape_data",$fields);

		$query = "INSERT INTO forecasts (".implode(', ',array_keys($fields)).(isset($fields['reg_date'])?'':', reg_date').") VALUES (".("'".implode("', '",$fields)."'").(isset($fields['reg_date'])?'':', NOW()').")";
		//echo "$query <br>\n";
		if(!@mysql_query ($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into forecasts table.');
		$rid=@mysql_insert_id();
		$descr=simple_query("SELECT description FROM forecasts WHERE rid=$rid");

		$txt="Action: Submit a new sales forecast";

		$fields['rid']=$rid;
		$fields['options']=0;
		$this->log_history($fields, $uid, $txt);

		if($cc_list){
			$safe_cc=array();
			foreach(explode(',',$cc_list) as $u)
				arr_push($safe_cc,$u);

			foreach($safe_cc as $u)
				$this->add_cc($rid,$u);
		}

		$this->notify_by_email($rid,$uid,$descr,$nsa_aid);
		return $rid;
	}

	function request_info($rid,&$xstr2uid,$popup_error=FALSE){

		$this->request_info_sql="SELECT r.*, UNIX_TIMESTAMP(r.reg_date) AS reg_date_tm, UNIX_TIMESTAMP(r.inwork_date) AS inwork_date_tm, UNIX_TIMESTAMP(r.fixed_date) AS fixed_date_tm, UNIX_TIMESTAMP(r.last_date) AS last_date_tm, UNIX_TIMESTAMP(r.expected_close_date) AS expected_close_date_tm";

		return(parent::request_info($rid,$xstr2uid,$popup_error));
	}

	function process_view_fields(&$RInfo,&$xstr2uid,$action_is_clone){
		global $all_users_2d;
		global $pri2str;
		global $lead_source;

		$SQLStr='';$comment='';
		$res=parent::process_view_fields($RInfo,$xstr2uid,$action_is_clone);
		$SQLStr.=array_shift($res);
		$comment.=array_shift($res);

		if($this->is_rw_field('lead_source') && isset($_POST['lead_source'])){
			$ls = $_POST['lead_source'];
			if (!isset($lead_source[$ls]))
				_die(__FILE__.':'.__LINE__.'Unknown lead source ...');
			if ($ls != $RInfo['lead_source']){
				$SQLStr .= ", lead_source = $ls";
				$comment .= 'Lead Source: '.$lead_source[$RInfo['lead_source']].' -> '.$lead_source[$ls]."\n";
			}
		}

		if($this->is_rw_field('expected_close_date') && isset($_POST['expected_close_date']) && is_date(stripslashes(trim($_POST['expected_close_date'])))){
			$ecd=date_norm2sql(stripslashes(trim($_POST['expected_close_date'])));
			if ($ecd != $RInfo['expected_close_date']){
				$SQLStr .= ", expected_close_date = '".escape_data($ecd)."'";
				$comment .= "Expected Close Date: ".date_sql2norm($RInfo['expected_close_date'])." -> ".date_sql2norm($ecd)."\n";
			}
		}

		if($this->is_rw_field('booking_amount') && isset($_POST['booking_amount']) ){
			$ba = stripslashes(trim($_POST['booking_amount']));
			if(!is_num($ba) || (strlen($ba)>10))
				$ba=0;
			if ($ba != $RInfo['booking_amount']){
				$SQLStr .= ",  booking_amount= '".escape_data($ba)."'";
				$comment .= "Estimated Booking Amount: '{$RInfo['booking_amount']}' -> '$ba'\n";
			}
		}

		return array($SQLStr,$comment);

	}

	function request_query_sqlstr(){
		return parent::request_query_sqlstr(", DATE_FORMAT(expected_close_date,'%m/%d/%y') AS ecdate ");
	}

	function get_all_dupes($rid){
		return array();
	}

	function _dashboard_intro($did,$uid,$info=FALSE){
		global $dir_name;
		global $is_customer;

		if($info)
			return array('header' => 'Sales Forecasting System (Intro)',
				'default_size' => 2,
				'type' => 'table/text',
				'only' => '/sfs');

		$tbl_str='
        <table border=0 cellpadding=0 cellspacing=1 width="100%" class=dgray align="center">
        <tr class="lgray">
		<td>
        <ul>
        	<li><a href="'.$dir_name.'/sfs/sfs_file.php">Submit</a> a forecast for a product sale</li>
        	<li><a href="'.$dir_name.'/sfs/sfs_query.php">Search</a> sales forecasts database</li>
        	<li>
		<form target="sfs" action="'.$dir_name.'/sfs/sfs_view.php">
        		View/Edit a frcast if you know its number: <input class="inp" type=text name=id size=6 maxlength=6><input class="btn_small" type=button name=submit value=View onClick="rid_check(this.form)">
		</form>
		</li>
        </ul>
        	</td>
	</tr>
        </table>';

		return $tbl_str;
	}

	function _dashboard_cr_bundle($did,$uid,$info=FALSE){
	}

	function _dashboard_latest_requests($did,$uid,$info=FALSE){
	}

	function _dashboard_pie_pq_by_pri($did,$uid,$info=FALSE){
        }

       // function _dashboard_pie_pq_by_state($did,$uid,$info=FALSE){
       // }
}

?>
