<?php
// $Header: /home/CVS/rps/includes/sw/db.inc,v 1.48 2008/07/20 03:59:14 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

	require_once "includes/base.inc";

	yxl_cnfg_check('YXL_MY_DOMAIN');
	yxl_cnfg_check('YXL_MY_COMPANY_NAME');
	yxl_cnfg_check('YXL_MY_CN');

	$MyDomain = YXL_MY_DOMAIN;
	$MyCName = YXL_MY_COMPANY_NAME;
	$MyCN= YXL_MY_CN;

	yxl_cnfg_check('YXL_DB_HOST');
	yxl_cnfg_check('YXL_DB_USER');
	yxl_cnfg_check('YXL_DB_PASSWD');

	if(defined('YXL_AUTH_MODE') && (strtoupper(YXL_AUTH_MODE)=='LDAP')){
		yxl_cnfg_check('YXL_LDAP_SERVER');
		yxl_cnfg_check('YXL_LDAP_BASE_DN');
		yxl_cnfg_check('YXL_LDAP_ATTR_UID');
		yxl_cnfg_check('YXL_LDAP_ATTR_MAIL');

		if(defined('YXL_LDAP_BIND_DN'))
			yxl_cnfg_check('YXL_LDAP_BIND_DN');

		if(defined('YXL_LDAP_GROUP_DN')){
			yxl_cnfg_check('YXL_LDAP_GROUP_DN');
			yxl_cnfg_check('YXL_LDAP_GROUP_CHECK');
		}
	}

	if(isset($_SERVER['SERVER_NAME'])){
		if($production_mode){
			$http_srvr= 'http://'.$_SERVER['SERVER_NAME'];
			$https_srvr= 'https://'.$_SERVER['SERVER_NAME'];

			if(defined('YXL_HTTPS_ALWAYS') && YXL_HTTPS_ALWAYS){
                        	$https_srvr= 'https://'.$_SERVER['SERVER_NAME'];
				$http_srvr= $https_srvr;
			}
		}else{
			$lport=$xsw_mode?':8081':':80';
			$http_srvr= 'http://'.$_SERVER['SERVER_NAME'].$lport;
			$https_srvr= 'http://'.$_SERVER['SERVER_NAME'].$lport;
			if($xsw_mode)
				session_name("PHPSESSID8081");
		}
		$http_path= $http_srvr.$dir_name;
		$https_path= $https_srvr.$dir_name;
	}

	if(!$cmd_line_mode)
		require_once('includes/licenses.inc');

	// Connect to database
	//$dbc = @mysql_pconnect(YXL_DB_HOST, YXL_DB_USER, YXL_DB_PASSWD, MYSQL_CLIENT_COMPRESS|MYSQL_CLIENT_SSL);
	//$cdbc = mysql_connect(YXL_DB_HOST, YXL_DB_USER, YXL_DB_PASSWD);
	if (!($cdbc = mysql_pconnect(YXL_DB_HOST, YXL_DB_USER, YXL_DB_PASSWD)))
		_die0(__FILE__.':'.__LINE__.' Could not connect to the main database. ');

	if(!@mysql_query ("SET NAMES utf8 COLLATE utf8_unicode_ci"))
			_die0(__FILE__.':'.__LINE__.' Could not set connection encoding. ');

	// MySQL Yoxel database is always local_yoxeldb2
	// unless you set the YXL_DB_CID or YXL_DB_NAME config parameters.
	$cid=2;
	$cdb_name=cid2cdb($cid);
	if(!@mysql_query ("CREATE DATABASE IF NOT EXISTS $cdb_name DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci"))
		_die0(__FILE__.':'.__LINE__." Could not create the database $cdb_name. ");

	if (!@mysql_select_db($cdb_name))
   		_die0(__FILE__.':'.__LINE__.' Could not select company database. ');

	require_once('includes/create_tables.inc');

   	$query = CDB_CREATE_USERS_TBL;
	if(!@mysql_query ($query))
		_die0(__FILE__.':'.__LINE__.' Could not create users table. ');

	$nrecords=simple_query("SELECT COUNT(uid) FROM users");
	if($nrecords<1){
		yxl_cnfg_check('YXL_FIRST_UNAME');
		$yxlu=new Users(FALSE);
		$user=array('username'=>YXL_FIRST_UNAME,
			'first_name'=>'Admin', 'last_name'=>'User',
			'email'=>YXL_FIRST_UNAME.'@'.$MyDomain,
			'password'=>YXL_DB_PASSWD,
			'user_is'=>USER_IS_MU);
		$yxlu->add_user($user,FALSE);
	}

	// RequireLogin = 0 - no login is necessary
	// RequireLogin = 1 - login is necessary; default if not specified
	// RequireLogin = 2 - only master users can login
	// RequireLogin = 3 - only master users or managers can login
	// RequireLogin = 4 - login is necessary; special err handling with $RequireLoginErrCallback
	// RequireLogin = 5 - login is necessary; deferred err handling for gwtphp

	if (!isset($RequireLogin))
		$RequireLogin = 1;

	if(($RequireLogin>0) && !isset($_SESSION['ufn'])){
	 // If not logged in
		$err_msg='Your session has timed out. Please refresh your page to login again.';
                if($RequireLogin==4){
                        if(isset($RequireLoginErrCallback) && $RequireLoginErrCallback)
                                $RequireLoginErrCallback($err_msg);
                        else
                                _quit_error($err_msg);
			exit;
		}

		if($RequireLogin!=5){
 			$par = '';
			if(isset($hide_header) && $hide_header)
				$par = '&hide_logo=1';

			if(isset($_POST) && count($_POST))
				$_SESSION['saved_post_array']=$_POST;

			$target = base64_encode($_SERVER['PHP_SELF'].($_SERVER['QUERY_STRING']?"?".$_SERVER['QUERY_STRING']:""));
 			header ("Location: ".$https_path.'/sw/login.php?target='.$target.$par);
 			exit;
 		}

 		$RequireLogin=0;
	}

	$uid = FALSE;
	$user_is = FALSE;
	$is_customer = FALSE;
	$cust_name = FALSE;
	if($RequireLogin>0){
		$uid = $_SESSION['uid'];
		$user_is = $_SESSION['uis'];

		if($user_is&USER_IS_CUSTOMER){
			$is_customer = simple_query("SELECT customer_id FROM users WHERE uid=$uid");
			if(!$is_customer)
				_die0(__FILE__.':'.__LINE__.' Can not select from users table.');

			$r = simple_query("SELECT name, parent FROM customers WHERE cid=$is_customer");
			if(!$r)
				_die0(__FILE__.':'.__LINE__.' Can not select from customers table.');
			$cust_nam=$r[0];
		}
	}

	function cid2cdb($cid){
		if(defined('YXL_DB_NAME')){
			if(!is_string(YXL_DB_NAME))
				_die0("Incorrectly set configuration parameter YXL_DB_NAME.");

			return YXL_DB_NAME;
		}
		return 'local_yoxeldb'.($cid?$cid:'');
	}

	function company_real_name(){
		global $MyCName;

                if(isset($_SESSION['crn']))
                        return $_SESSION['crn'];

		return $MyCName;

        }
?>
