<?php
require_once('includes/cust/contacts.inc');

class Users extends Contacts {

	var $sql_query;
	var $cache_initialized;
        function users($init=TRUE){
		global $customers_2d;
		global $is_customer;

		$this->sql_query = "SELECT uid, username, first_name, last_name, email, user_is, spec, customer_id, report_to, added_by, license FROM users WHERE LENGTH(username) AND !(user_is&".USER_IS_HIDDEN.") AND !(user_is&".USER_IS_CUSTOMER." AND !customer_id)";

        	if(simple_query("SELECT COUNT(uid) FROM users WHERE !(user_is&".USER_IS_CUSTOMER.") LIMIT 1")<1)
			prereq_check_set('no_users');

		init_customers();
		$this->sls_mgr=$this->cae_mgr=FALSE;
		if($is_customer){
			$this->sls_mgr=$customers_2d['sls_mgr'][$is_customer];
			$this->cae_mgr=$customers_2d['cae_mgr'][$is_customer];
		}

		$this->cache_initialized=FALSE;
		if(!$init)
			return;

		$this->v16compat_init_users();
        }

	function update_cache_from_row(&$row){
		global $customers_2d;
		global $is_customer;
		global $MyDomain;
		global $MyCName;

		if(!$row[2])
			return FALSE;

		$sls_mgr=&$this->sls_mgr;
		$cae_mgr=&$this->cae_mgr;

		$cname='';
		$_cname = $row[7]?$customers_2d['name'][$row[7]]:'unknown';

		if($row[5]&USER_IS_CUSTOMER){
			$this->v16compat_all_users_2d['customer'][$row[0]] = $row[7]?$row[7]:0;
			$cname = $_cname;
		}else
			$this->v16compat_all_users_2d['customer'][$row[0]] = FALSE;

		$uem=$this->unwrap_field('email',$row[4]);
		$ufn=$this->unwrap_field('first_name',$row[2]);
		$uln=$this->unwrap_field('last_name',$row[3]);

		if(!$is_customer){
			$this->v16compat_all_users_2d['un'][$row[0]]=$row[1];
			$this->v16compat_all_users_2d['email'][$row[0]]=$uem['email'];
			$this->v16compat_all_users_2d['name'][$row[0]]=$ufn['first_name'];
			$this->v16compat_all_users_2d['name'][$row[0]].=' '.$uln['last_name'].(($row[5]&USER_IS_CUSTOMER)?" [$cname]":"");
		}elseif($is_customer && ($is_customer==$row[7])){
			$this->v16compat_all_users_2d['un'][$row[0]]=$row[1];
			$this->v16compat_all_users_2d['email'][$row[0]]=$uem['email'];
			$this->v16compat_all_users_2d['name'][$row[0]]=$ufn['first_name'];
			$this->v16compat_all_users_2d['name'][$row[0]].=' '.$uln['last_name'];
		}elseif($is_customer && (($row[0]==$sls_mgr) || ($row[0]==$cae_mgr))){
			$this->v16compat_all_users_2d['un'][$row[0]]=$row[1];
			$this->v16compat_all_users_2d['email'][$row[0]]=$uem['email'];
			$this->v16compat_all_users_2d['name'][$row[0]]=$ufn['first_name'];
			$this->v16compat_all_users_2d['name'][$row[0]].=' '.$uln['last_name']." [$MyCName]";
		}else{
			$this->v16compat_all_users_2d['un'][$row[0]]='hidden';
			$this->v16compat_all_users_2d['email'][$row[0]]='yoxel_hidden@'.$MyDomain;
			$this->v16compat_all_users_2d['name'][$row[0]]='Hidden Name';
		}

		$this->v16compat_all_users_2d['_un'][$row[0]]=$row[1];
		$this->v16compat_all_users_2d['_email'][$row[0]]=$uem['email'];
		$this->v16compat_all_users_2d['_name'][$row[0]]=$ufn['first_name'];
		$this->v16compat_all_users_2d['_name'][$row[0]].=' '.$uln['last_name'].(($row[5]&USER_IS_CUSTOMER)?" [$_cname]":"");

		$this->v16compat_all_users_2d['user_is'][$row[0]] = $row[5];
		$this->v16compat_all_users_2d['spec'][$row[0]]=$row[6];
		$this->v16compat_all_users_2d['report_to'][$row[0]]=$row[8];
		$this->v16compat_all_users_2d['added_by'][$row[0]]=$row[9];
		$this->v16compat_all_users_2d['license'][$row[0]]=$row[10];
		if(!($row[5]&USER_IS_LOCKED))
			$this->v16compat_active_users[$row[0]]=&$this->v16compat_all_users_2d['name'][$row[0]];

	}

	var $v16compat_active_users = array();
	var $v16compat_all_users_2d = array();
	function &v16compat_init_users($force=FALSE){

		$ref=&$this->v16compat_all_users_2d;

		if(!$force && count($this->v16compat_active_users) && count($this->v16compat_all_users_2d))
			return $ref;

		$query=$this->sql_query." ORDER BY first_name, last_name";
		//echo "$query <br>\n";
		if(!($result=mysql_unbuffered_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from users table.');

		while($row=mysql_fetch_row($result))
			$this->update_cache_from_row($row);

		mysql_free_result($result);

		asort($this->v16compat_active_users);
		$this->cache_initialized=TRUE;
		return $ref;
	}

	function &v16compat_active_users(){
		$this->v16compat_init_users();
		$ref=&$this->v16compat_active_users;
		return $ref;
	}

	function all_uids(){
		if(!$this->cache_initialized)
			$this->v16compat_init_users(TRUE);

		return array_keys($this->v16compat_all_users_2d['un']);
	}

	function get_yoxelid($uid){
		global $asp_mode;

		if(!$this->exists($uid))
			return '';

		$un=$this->v16compat_all_users_2d['un'][$uid];
		if(!$asp_mode)
			return $un;

		return $un.'@'.$_SESSION['cldn'];

	}

	function set_password($uid,$pw){
		if(!$pw || !$uid)
			return;

		$pw=escape_data($pw);

		$query = "UPDATE users SET password=PASSWORD('$pw') WHERE uid=$uid";
		if(!@mysql_unbuffered_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not update users table.');
	}

	function authenticate($yoxelid,$passwd){

		$ldap=FALSE;
		if(defined('YXL_AUTH_MODE') && (strtoupper(YXL_AUTH_MODE)=='LDAP'))
			$ldap=TRUE;

		if(!$passwd || empty($passwd)){
			if($ldap)
				error_alert(" Empty password specified. ");
			return FALSE;
		}

		if($ldap){
			if(!($con=@ldap_connect(YXL_LDAP_SERVER))){
				error_alert(" Could not connect to LDAP server: ".ldap_error($con));
				return FALSE;
			}

			ldap_set_option($con, LDAP_OPT_DEBUG_LEVEL, 7);
			ldap_set_option($con, LDAP_OPT_PROTOCOL_VERSION, 3);
			ldap_set_option($con, LDAP_OPT_REFERRALS, 0);
			//ldap_set_option($con, LDAP_OPT_TIMELIMIT, 30);

			$bind=array();
			if(defined('YXL_LDAP_BIND_DN'))
				$bind=explode(':',YXL_LDAP_BIND_DN);

			if((count($bind)==2) && $bind[1])
				$r=@ldap_bind($con,$bind[0],$bind[1]);
			else
				$r=@ldap_bind($con);

			if(!$r){
				error_alert(" Could not bind to LDAP server: ".ldap_error($con));
				return FALSE;
			}

			$deffered_group_check_failed=FALSE;
			if(defined('YXL_LDAP_GROUP_DN')){
				$filter=sprintf(YXL_LDAP_GROUP_CHECK,$yoxelid);
				$sr=@ldap_search($con, YXL_LDAP_GROUP_DN, $filter);
				$ginfo =@ldap_get_entries($con, $sr);
				if($ginfo['count']==0)
					$deffered_group_check_failed=TRUE;
			}

			$filter="(".YXL_LDAP_ATTR_UID."=$yoxelid)";
			$sr=@ldap_search($con, YXL_LDAP_BASE_DN, $filter, array('dn', 'givenName', 'sn', YXL_LDAP_ATTR_MAIL));
			//$sr=ldap_search($con, YXL_LDAP_BASE_DN, "(".YXL_LDAP_ATTR_UID."=*)", array('givenName', 'sn', 'mail'));
			$info =@ldap_get_entries($con, $sr);

			$ldap_ok=TRUE;
			if($info['count']!=1){
				if($info['count'])
					error_alert(" Ambigous LDAP UID(".YXL_LDAP_ATTR_UID.") $yoxelid");
				else
					error_alert(" Unknown LDAP UID(".YXL_LDAP_ATTR_UID.") $yoxelid");

				$ldap_ok=FALSE;
			}

			if($ldap_ok){
				if(!($r=@ldap_bind($con,$info[0]['dn'],$passwd)))
					return FALSE;

				if($deffered_group_check_failed){
					error_alert(" LDAP group check failed for $yoxelid");
					return FALSE;
				}

				$user=array('username'=>$yoxelid,
					'first_name'=>$info[0]['givenname'][0],
					'last_name'=>$info[0]['sn'][0],
					'password'=>$passwd,
					'user_is'=>USER_IS_LDAP);


				$mtag=strtolower(YXL_LDAP_ATTR_MAIL);
				if(isset($info[0][$mtag][0]) && is_email($info[0][$mtag][0]))
					$user['email']=$info[0][$mtag][0];

				if($u=$this->username_exists($yoxelid)){
					$user['user_is']|=$this->user_is($u);
					$this->update_user($u,$user);
				}else
					$this->add_user($user,FALSE);
			}
		}

		$query = "SELECT uid, username, first_name, last_name, spec, user_is, report_to, license, last_login, last_login < reg_date AS isfl, email FROM users WHERE username='$yoxelid' AND password=PASSWORD('$passwd')";
		//echo "$cdb_name: $query <br>";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from users table. ');

		if(($n=mysql_num_rows($result))!=1){
			if($n){
				if($ldap)
					error_alert(" Ambigous YoxelID $yoxelid.");
			}else{
				if($ldap)
					error_alert(" Unknown YoxelID $yoxelid.");
			}
			return FALSE;
		}

		$row=mysql_fetch_array($result, MYSQL_ASSOC);

		if(!($row['user_is']&USER_IS_LOCKED)){
			$query="UPDATE users SET last_login=NOW() WHERE uid=".$row['uid'];
			if(!@mysql_query($query))
				_die2(__FILE__.':'.__LINE__.' Could not update users table. ');
		}

		$_SESSION['uid']=$row['uid'];
		$_SESSION['un']=$row['username'];
		$_SESSION['ufn']=$row['first_name'];
		$_SESSION['uln']=$row['last_name'];
		$_SESSION['uspec']=$row['spec'];
		$_SESSION['uis']=$row['user_is'];
		$_SESSION['report_to']=$row['report_to'];
		$_SESSION['lic']=$row['license'];
		$_SESSION['last_login']=$row['last_login'];
		$_SESSION['uem']=$row['email'];

		return $row;
	}

	function add_user($user,$is_customer=FALSE){
		global $MyDomain;
		global $lic2name;
		global $uid;

		if(!isset($user['username'])){
			_live_error('YoxelID is not specified.');
			return FALSE;
		}

		if(!isset($user['first_name']) && !isset($user['last_name'])){
			_live_error('Neither first name nor last name mapping is specified.');
                        return FALSE;
		}

		$lic=0;
		foreach(array_keys($lic2name) as $l)
			$lic|=$l;

		$defaults=array('email'=>$user['username'].'@'.$MyDomain,
			'customer_id' =>$is_customer,
			'added_by'=>$uid,
			'license'=>$lic);

		foreach($defaults as $k => $v)
			if(!isset($user[$k]))
				$user[$k]=$defaults[$k];

		if($is_customer){
			$cont=array();
			foreach($user as $k => $v)
				$cont['u.'.$k]=$v;

			// Add handling of add_contact FALSE return
			return $this->add_contact($cont);
		}

		$sql_ins_f=array(); $sql_ins_v=array();
		foreach($user as $k => $v){
			if(!$v) continue;
			array_push($sql_ins_f,$k);
			if($k=='password')
				array_push($sql_ins_v,"PASSWORD('".escape_data($v)."')");
			else
				array_push($sql_ins_v,"'".escape_data($v)."'");
		}
		array_push($sql_ins_f,'reg_date');
		array_push($sql_ins_v,'NOW()');

		$ins_f_str=implode(', ',$sql_ins_f);
		$ins_v_str=implode(', ',$sql_ins_v);

		//echo "Add <br>";
		$query="INSERT INTO users ($ins_f_str) VALUES ($ins_v_str)";
		//die("$query<br>\n");
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not insert into users table.');

		return mysql_insert_id();
	}

	function update_user($puid,$user){
		global $MyDomain;
		global $lic2name;
		global $uid;

		if(!$this->exists($puid))
			return FALSE;

		if($this->user_is($puid)&USER_IS_CUSTOMER){
			$cont=array();
			foreach($user as $k => $v)
				$cont['u.'.$k]=$v;

			// Add handling of update_contact FALSE return
			return $this->update_contact($cont);
		}

		$sql_update=array();
		foreach($user as $k => $v){
			if($k=='password')
				array_push($sql_update,"$k=PASSWORD('".escape_data($v)."')");
			else
				array_push($sql_update,"$k='".escape_data($v)."'");
		}

		$sql_update_str=implode(', ',$sql_update);

		//echo "Add <br>";
		$query="UPDATE users SET $sql_update_str WHERE uid=$puid";
		//echo "$query<br>\n";
		if(!mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not update users table.');

		return $puid;
	}

	function password_match($uid,$pw){
		$query = "SELECT uid FROM users WHERE uid=$uid AND password=PASSWORD('".escape_data($pw)."') LIMIT 1";
		if($uid==simple_query($query))
			return TRUE;

		return FALSE;
	}

	function exists($uid){
		if(isset($this->v16compat_all_users_2d['name'][$uid]))
			return TRUE;

		$query=$this->sql_query." AND uid=$uid";
		if(!($row=simple_query($query)))
			return FALSE;

		$this->update_cache_from_row($row);
		if(isset($this->v16compat_all_users_2d['name'][$uid]))
			return TRUE;

		return FALSE;
	}

	function name($uid,$hidden=FALSE){
		if(!$this->exists($uid))
			return '';

		$tag=$hidden?'_name':'name';

		return $this->v16compat_all_users_2d[$tag][$uid];
	}

	function email($uid,$hidden=FALSE){
		if(!$this->exists($uid))
			return '';

		$tag=$hidden?'_email':'email';

		return $this->v16compat_all_users_2d[$tag][$uid];
	}

	function full_email($uid,$hidden=FALSE){
		if(!$this->exists($uid))
			return '';

		$fem='"'.$this->name($uid,$hidden).'" <'.$this->email($uid,$hidden).'>';

		return $fem;
	}

	function output_user_info($shortcuts){
		global $is_customer;
		global $uid;
		global $user_is;
		global $user_spec2str;
		global $dir_name;
?>

	<table width="90%" align=center valign=top border="0">
	<tr>
		<td align=left>
		<strong>Welcome <?php echo $_SESSION['ufn'].'&nbsp;'.$_SESSION['uln']; ?></strong><br>
		<ul>
<?php
	if($is_customer){
		$cname=simple_query("SELECT name, sls_mgr_uid, cae_mgr_uid FROM customers WHERE cid=$is_customer");
		if(!$cname)
			_die(__FILE__.':'.__LINE__.' Can not select from customers table.');
		echo '
			<li>You are using a <strong>customer account ['.html_sp($cname[0]).']</strong> with limited permissions.</li>';
		if($cname[1])
			echo '
			<li>Your ['.$_SESSION['crn'].'] business contact is <a href=mailto:'.$this->email($cname[1]).' style="text-decoration: underline">'.html_sp($this->name($cname[1])).'</a>.</li>';
		if($cname[2])
			echo '
			<li> Your ['.$_SESSION['crn'].'] technical contact is <a href=mailto:'.$this->email($cname[2]).' style="text-decoration: underline">'.html_sp($this->name($cname[2])).'</a>.</li>';
	}else{
		// $sgn=substr(md5(uniqid(rand(),1)), 3, 7);
		// echo '<li>SGN: '.$sgn.'</li>';
		echo '
			<li>You belong to <strong>'.$user_spec2str[$_SESSION['uspec']].'</strong> group</li>';
		if($user_is&USER_IS_MGR)
			echo '
			<li> You are a <strong>manager</strong></li>';

		if(isset($_SESSION['report_to']) && ($_SESSION['report_to']!=$uid) && $this->exists($_SESSION['report_to']))
			echo '
			<li> You report to <a href=mailto:'.$this->email($_SESSION['report_to']).' style="text-decoration: underline">'.html_sp($this->name($_SESSION['report_to'])).'</a></li>';

		$query = "SELECT CONCAT(first_name,'&nbsp;',last_name), email FROM users WHERE (user_is&".USER_IS_MU.") AND (user_is&".USER_IS_LOCKED.")=0 ";
		if(!($result = @mysql_unbuffered_query($query)))
			_die2(__FILE__.':'.__LINE__.' Can not select from users table.');

		$mus=array();
		while($row=mysql_fetch_row($result)){
			array_push($mus,'<a href=mailto:'.$row[1].' style="text-decoration: underline">'.html_sp($row[0]).'</a>');
		}
		mysql_free_result($result);
		if(count($mus)>0){
			$mus_str=implode(', ',$mus);
			echo '
			<li> Master Users Of This Site: '.$mus_str.'.</li>';
		}
	}

?>

		</ul>
		</td>
<?php
		if(is_array($shortcuts) && count($shortcuts)){
			echo '
		<td align="center" width="40%">';

			for($i=0;$i<count($shortcuts);$i++){
				$sc=&$shortcuts[$i];
				echo '
			<input type="button" class="gscbtn" name="" value="'.$sc[1].'" onClick="document.location=\''.$dir_name.'/'.$sc[0].'\'"><br>';
			}

			echo '
		</td>';
		}
?>
	</tr>
	</table>
<?php
	}

	function get_active_mu(){
		if($uid=simple_query("SELECT uid FROM users WHERE user_is&".USER_IS_MU." AND !(user_is&".(USER_IS_LOCKED|USER_IS_HIDDEN|USER_IS_CUSTOMER).") ORDER BY uid ASC LIMIT 1"))
			return $uid;

		return 1;
        }

	function added_by_trace($uid){
		$abt = array();

		$puid=$uid;
		for($i=0;$i<30;$i++){
			if(!$this->exists($puid))
				return $abt;

			if(!($u=$this->v16compat_all_users_2d['added_by'][$puid]))
				return $abt;

			if($u==$puid){
				_warn_yoxel("get_added_by_trace0: potential loop detected!");
				return $abt;
			}

			array_push($abt,$u);
			$puid=$u;
		}

		_warn_yoxel("get_added_by_trace1: potential loop detected!");
		return($abt);
	}

	function report_to($uid){
		if(!$this->exists($uid))
			return FALSE;

		return $this->v16compat_all_users_2d['report_to'][$uid];
	}

	function user_is($uid){
		if(!$this->exists($uid))
			return FALSE;

		return $this->v16compat_all_users_2d['user_is'][$uid];
	}

	function username($uid){
		if(!$this->exists($uid))
			return FALSE;

		return $this->v16compat_all_users_2d['un'][$uid];
	}

	function username_exists($un){

		if(isset($this->v16compat_all_users_2d['un']) && ($uid=array_search(strtolower($un),$this->v16compat_all_users_2d['un'])))
			return $uid;

		$query = "SELECT uid FROM users WHERE username='".escape_data($un)."' LIMIT 1";
		if($uid=simple_query($query ))
			return $uid;

		return FALSE;
	}

	function spec($uid){
		if(!$this->exists($uid))
			return FALSE;

		return $this->v16compat_all_users_2d['spec'][$uid];
	}

	function added_by($uid){
		if(!$this->exists($uid))
			return FALSE;

		return $this->v16compat_all_users_2d['added_by'][$uid];
	}

	function license($uid){
		if(!$this->exists($uid))
			return FALSE;

		return $this->v16compat_all_users_2d['license'][$uid];
	}
}

class YxlUsers {
    function InstallCheck($force=FALSE) {
        global $yxl_users;

        if($force || !isset($yxl_users))
                $yxl_users = new Users($force?FALSE:TRUE);
    }

    function &v16compat_init_users() {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->v16compat_init_users();
    }

    function &v16compat_active_users() {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->v16compat_active_users();
    }

    function find_user_by_email($uem) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->find_user_by_email($uem);
    }

    function customer($u) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->customer($u);
    }

    function get_active_mu() {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->get_active_mu();
    }

    function password_match($u,$p) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->password_match($u,$p);
    }

    function exists($u) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->exists($u);
    }

    function username_exists($un) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->username_exists($un);
    }

    function name($u,$hidden=FALSE) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->name($u,$hidden);
    }

    function email($u,$hidden=FALSE) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->email($u,$hidden);
    }

    function full_email($u,$hidden=FALSE) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->full_email($u,$hidden);
    }

    function report_to($u) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->report_to($u);
    }

    function user_is($u) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->user_is($u);
    }

    function username($u) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->username($u);
    }

    function spec($u) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->spec($u);
    }

    function added_by($u) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->added_by($u);
    }

    function license($u) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->license($u);
    }

    function all_uids() {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->all_uids();
    }

    function add_user(&$user,$is_customer=FALSE) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->add_user($user,$is_customer);
    }

    function update_user($u,&$user) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->update_user($u,$user);
    }

    function authenticate($u,$p) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->authenticate($u,$p);
    }

    function added_by_trace($u) {
        global $yxl_users;

        YxlUsers::InstallCheck();
        return $yxl_users->added_by_trace($u);
    }

    function current_uid() {
        global $uid;
	return $uid;
    }
}

?>
