<?php // Standard include file for  Work Flow subsystem
// $Header: /home/CVS/rps/includes/wf.inc,v 1.65 2008/06/30 02:20:54 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

	define('P2_STATE_NULL',		0x0000000);
	define('P2_STATE_OPEN',		0x0000001);
        define('P2_STATE_MOREINFO',    0x0000008);
        define('P2_STATE_ASSIGNED',    0x0000040);
        define('P2_STATE_INWORK',      0x0000200);
        define('P2_STATE_FIXED',       0x0001000);
        define('P2_STATE_VERIFIED',    0x0008000);
        define('P2_STATE_CLOSED',      0x0040000);
        define('P2_STATE_WONTFIX',     0x0200000);
        define('P2_STATE_DUPLICATE',   0x0400000);
        define('P2_STATE_FAKE',        0x1000000);

	define('P2S_F', 'power2states_%s');
	define('CDB_CREATE_POWER2STATES_TBL_F', "CREATE TABLE IF NOT EXISTS ".P2S_F."
		(state INT UNSIGNED,
		name VARCHAR(128),
		options INT UNSIGNED DEFAULT 0 NOT NULL,
		UNIQUE KEY (state),
		UNIQUE KEY (name)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");


	define('WFREQCLASS_OPT_PRIVATE', 0x0001); // Not for customers
	define('WFREQCLASS_OPT_XRIDS', 0x0002); // For list of external PRs
	define('WFREQCLASS_OPT_RPS', 0x0004); // RPS can plan this class
	define('WFREQCLASS_OPT_PM', 0x0004);

	define('WFREQCLASS_TYPE_BUG', 0x0001);

	define('CDB_CREATE_WFREQCLASSES_TBL', "CREATE TABLE IF NOT EXISTS wfreqclasses
		(wfid VARCHAR(32),
		class INT UNSIGNED NOT NULL,
		name VARCHAR(64),
		options INT UNSIGNED DEFAULT 0 NOT NULL,
		type INT UNSIGNED,
		UNIQUE KEY (wfid, class)
		)");

	define('WFSTATE_OPT_REMIND',0x0001);
	define('WFSTATE_OPT_FIRST',0x0002);
	define('WFSTATE_OPT_INWORK',0x0004);
	define('WFSTATE_OPT_FIXED',0x0008);
	define('WFSTATE_OPT_VERIFIED',0x0010);
	define('WFSTATE_OPT_LAST',0x0020);
	define('WFSTATE_OPT_DUP',0x0040);

	define('CDB_CREATE_WFSTATES_TBL', "CREATE TABLE IF NOT EXISTS wfstates
		(wfid VARCHAR(32),
		class INT UNSIGNED,
		state INT UNSIGNED,
		owner CHAR(128),
		options INT UNSIGNED DEFAULT 0 NOT NULL,
		UNIQUE KEY (wfid, class, state)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('WFACTION_OPT_AUTO',1);		// Auto switch to the next state
	define('WFACTION_OPT_UPDATE',2);	// Update fields without changing state
	define('WFACTION_OPT_CLONE',4);		// Special clone operation

	define('CDB_CREATE_WFACTIONS_TBL', "CREATE TABLE IF NOT EXISTS wfactions
		(wf_action_id INT UNSIGNED NOT NULL AUTO_INCREMENT,
		wfid VARCHAR(32),
		class INT UNSIGNED,
		state INT UNSIGNED,
		name VARCHAR(128),
		email_status VARCHAR(32),
		prev_state INT UNSIGNED,
		next_state INT UNSIGNED,
		options INT UNSIGNED DEFAULT 0 NOT NULL,
		PRIMARY KEY (wf_action_id)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('WFGROUP_TYPE_RWUSER', 0x0001);
        define('WFGROUP_TYPE_RWFIELD', 0x0002);
	define('WFGROUP_TYPE_DEFAULT', 0x0003);
	define('WFGROUP_TYPE_EMAIL', 0x0004);

	define('WFGROUP_EMAIL_OPT_CC', 0x0001);
	define('WFGROUP_RWFIELD_OPT_SKIP', 0x0001);

        define('CDB_CREATE_WFGROUPS_TBL', "CREATE TABLE IF NOT EXISTS wfgroups
                (id INT UNSIGNED NOT NULL,
                xstr TEXT,
                xstr2 TEXT,
                xstr3 TEXT,
		options INT UNSIGNED DEFAULT 0 NOT NULL,
                type INT UNSIGNED NOT NULL,
		FOREIGN KEY (id) REFERENCES wfactions (wf_action_id) on delete cascade
                ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

	define('WFSTAT_TYPE_ACTION_FREQ',1);
        define('CDB_CREATE_WFSTATS_TBL', "CREATE TABLE IF NOT EXISTS wfstats
                (id INT UNSIGNED NOT NULL,
		uid INT UNSIGNED NOT NULL,
		class INT UNSIGNED NOT NULL,
		state INT UNSIGNED NOT NULL,
                xval INT UNSIGNED NOT NULL,
                type INT UNSIGNED NOT NULL,
		UNIQUE KEY (id,uid,class,state,type),
		FOREIGN KEY (id) REFERENCES wfactions (wf_action_id) on delete cascade
                ) DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci");

if(!$cmd_line_mode && $uid){
	$query = CDB_CREATE_WFSTATS_TBL;
	if(!@mysql_query ($query))
		_die2(__FILE__.':'.__LINE__.' Could not create wfstats table. ');
}

class WorkFlow {

	var $wfid;
	var $p2_states=array();
	var $classes=array();
	var $state_actions=array();
	var $state_rw_fields=array();
	var $state_rw_afo=array();
	var $class;
	var $state;
	var $prev_state;
	var $null_state_action=array();
	var $first_state=array();
	var $inwork_state_mask=array();
	var $fixed_state_mask=array();
	var $verified_state_mask=array();
	var $last_state_mask=array();
	var $wfstate_options=array();
	var $rps_class_mask=0;
	var $sql_states_str='';
	var $sql_fixed_states_str='';
	var $sql_verified_states_str='';
	var $sql_closed_states_str='';
	var $sql_last_states_str='';

	function workflow($wfid=WFID_BTS){
		$this->wfid=$wfid;

		$p2s_tbl=sprintf(P2S_F,$wfid);
		$query = "SELECT state, name FROM $p2s_tbl";
	        if(!($result=@mysql_query($query)))
                	_die2(__FILE__.':'.__LINE__." Can not select from $p2s_tbl table.");
        	while($row=mysql_fetch_array($result, MYSQL_NUM))
                	$this->p2_states[$row[0]]=$row[1];

		$query = "SELECT c.class, c.name, c.options, c.type, s.state, s.options FROM wfreqclasses AS c INNER JOIN wfstates AS s ON c.class&s.class WHERE c.wfid='$wfid' AND s.wfid='$wfid'";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from wfreqclasses table.');

		$sql=array();$fsql=array();$vsql=array();$csql=array();$lsql=array();
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			//print_r($row);echo "<br>\n";
			if(!$row[4])
				_die(' NULL state is not allowed in wfstates table (class='.$row[0].')!');

			if(!isset($this->classes['name'][$row[0]])){
				$this->classes['name'][$row[0]]=$row[1];
				$this->classes['options'][$row[0]]=$row[2];
				$this->classes['type'][$row[0]]=$row[3];
				$this->inwork_state_mask[$row[0]]=0;
				$this->fixed_state_mask[$row[0]]=0;
				$this->verified_state_mask[$row[0]]=0;
				$this->last_state_mask[$row[0]]=0;
				if($row[2]&WFREQCLASS_OPT_RPS)
					$this->rps_class_mask|=$row[0];

				//echo "nul $row[1]<br>\n";
			}

			//echo "state=$row[4], opt=$row[5]<br>\n";
			if($row[5]&WFSTATE_OPT_INWORK)
				$this->inwork_state_mask[$row[0]]|=$row[4];
			if($row[5]&WFSTATE_OPT_FIXED)
				$this->fixed_state_mask[$row[0]]|=$row[4];
			if($row[5]&WFSTATE_OPT_VERIFIED)
				$this->verified_state_mask[$row[0]]|=$row[4];
			if($row[5]&WFSTATE_OPT_LAST)
				$this->last_state_mask[$row[0]]|=$row[4];
			//echo "fsm=".$this->fixed_state_mask[$row[0]]." vsm=".$this->verified_state_mask[$row[0]]." lsm=".$this->last_state_mask[$row[0]]."<br>\n";

			$this->wfstate_options[$row[0]][$row[4]]=$row[5];
		}

		foreach($this->classes['options'] as $c => $o){
			array_push($sql,"(r.class=$c AND (r.state&".$this->last_state_mask[$c].")=0)");
			array_push($fsql,"(r.class=$c AND r.state&".$this->fixed_state_mask[$c].")");
			array_push($vsql,"(r.class=$c AND r.state&".$this->verified_state_mask[$c].")");
			array_push($csql,"(r.class=$c AND r.state&".$this->last_state_mask[$c]." AND r.state&".$this->verified_state_mask[$c].")");
			array_push($lsql,"(r.class=$c AND r.state&".$this->last_state_mask[$c].")");
		}
		if(count($sql)<1)
			_die(__FILE__.':'.__LINE__.' Could not construct proper sql_states_str.');

		$this->sql_states_str="(".implode(' OR ',$sql).")";
		$this->sql_fixed_states_str="(".implode(' OR ',$fsql).")";
		$this->sql_verified_states_str="(".implode(' OR ',$vsql).")";
		$this->sql_closed_states_str="(".implode(' OR ',$csql).")";
		$this->sql_last_states_str="(".implode(' OR ',$lsql).")";

		$query = "SELECT next_state, class, wf_action_id FROM wfactions WHERE wfid='$wfid' AND state=".P2_STATE_NULL;
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from wfactions table.');
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			//print_r($row); echo "<br>\n";
			if(!$row[0]) continue;
			foreach($this->classes['name'] as $c => $n){
				if(!($c&$row[1])) continue;
				if(isset($this->first_state[$row[1]]))
					_die(' Only one null state action is allowed!');
				$this->first_state[$c]=$row[0];
				$this->null_state_action[$c]=$row[2];
			}
		}

		foreach($this->classes['name'] as $c => $n)
			if(!isset($this->null_state_action[$c]))
				_die(' No null state action is found for class='.$c.'!');
	}

	function request_owner($class, $state, &$xstr2uid){

		$amu=get_active_mu();

		$wfid=&$this->wfid;
		$query = "SELECT owner FROM wfstates WHERE wfid='$wfid' AND class&$class AND state&$state LIMIT 1";
		//echo "$query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from wfstates table.');

		$row=mysql_fetch_array($result, MYSQL_NUM);
		if(!$row || !$row[0]){
			_warn_yoxel("Owners are not set for workflow states: $wfid,$class,$state.");
			return $amu;
		}
		$t=$this->xstr2uids($row[0],$xstr2uid);
		return($t[0]);
	}

	function set_state_action($class, $state, $prev_state, $wfaid, &$xstr2uid, $except_next_wfstate_opt_mask=FALSE, $only_next_wfstate_opt_mask=FALSE){
		global $uid;

		$wfid=&$this->wfid;
		$this->class=$class;
		$this->state=$state;
		$this->prev_state=$prev_state;

		$this->state_actions=array();
		$this->state_actions['name']=array();
		$this->state_actions['next_state']=array();
		$this->state_actions['options']=array();
		$this->state_actions['frequency']=array();
		$this->state_rw_fields=array();
		$this->state_rw_afo=array();
		$auto_next_state=FALSE;
		$lsm=$this->last_state_mask($class);

		// Commented out on 07/19/06 to enable return from last states
		//if($state&$lsm)
		//	return FALSE;

		$query="SELECT a.wf_action_id, a.name, a.next_state, a.options, a.state, g.xstr, g.xstr2, g.id FROM wfactions AS a INNER JOIN wfgroups AS g ON a.wf_action_id=g.id AND g.type=".WFGROUP_TYPE_RWUSER." WHERE a.wfid='$wfid' AND (a.class&$class OR a.class IS NULL)  AND (a.state&$state OR a.state IS NULL)".($prev_state?" AND (prev_state&$prev_state OR prev_state IS NULL)":'').(($state&$lsm)?" AND (!(a.next_state&$lsm) OR a.next_state IS NULL)":'')." ORDER BY state DESC";
		//echo "$lsm: $query <br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from wfactions table.');

		$explicit_action_is_set=array();
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
		//echo "state: $state, action: $row[0] -> $row[1], [$row[4] -> $row[2]], gid=$row[7] <br>\n";
			// Ignore actions leading to forbidden next states
			//echo "Check exception. <br>\n";
			if($except_next_wfstate_opt_mask){
				if($row[2] && ($this->wfstate_options[$class][$row[2]]&$except_next_wfstate_opt_mask))
					continue;
			}

			if($only_next_wfstate_opt_mask){
				if($row[2] && !($this->wfstate_options[$class][$row[2]]&$only_next_wfstate_opt_mask))
					continue;
			}

			//echo "yes=$row[5] no=$row[6]<br>\n";
			$yes=$this->xstr2uids($row[5],$xstr2uid);
			$no=$this->xstr2uids($row[6],$xstr2uid);
			//echo "yes="; print_r($yes); echo " uid=$uid<br>\n";
			//echo "no="; print_r($no); echo "<br>\n";
			//echo "Check RWUSER.<br>\n";
			if(!in_array($uid,$yes) || in_array($uid,$no))
				continue;

			//echo "Check Explicit rule.<br>\n";
			if($row[4] && $row[2]){
				//echo "Found Explicit rule $row[4] -> $row[2]<br>\n";
				$explicit_action_is_set[$row[2]]=$row[1];
			//}elseif(!$row[4] && isset($explicit_action_is_set[$row[2]]))
			}elseif(!$row[4] && in_array($row[1],$explicit_action_is_set))
				continue;

			//echo "Check duplicate rule. <br>\n";
			if(isset($this->state_actions['name'][$row[0]]))
				continue;

			$this->state_actions['name'][$row[0]]=$row[1];
			$this->state_actions['next_state'][$row[0]]=$row[2]?$row[2]:$state;
			$this->state_actions['options'][$row[0]]=$row[3];
			$this->state_actions['frequency'][$row[0]]=0;
			if($row[3]&WFACTION_OPT_AUTO)
				$auto_next_state=$row[2];
		}

		if(count($this->state_actions['frequency'])){
			$query="SELECT id, SUM(xval) FROM wfstats WHERE type=".WFSTAT_TYPE_ACTION_FREQ." AND class=$class AND state=$state AND id IN (".implode(',',array_keys($this->state_actions['frequency'])).") GROUP BY id";
			//echo "$query<br>\n";
			if(!($result=@mysql_query($query)))
				_die2(__FILE__.':'.__LINE__.' Could not select from wfstats table.');

			while($row=mysql_fetch_array($result, MYSQL_NUM))
				$this->state_actions['frequency'][$row[0]]=$row[1];

			//if(!in_array(0,$this->state_actions['frequency']))
				arsort($this->state_actions['frequency']);
		}

		if($wfaid && in_array($wfaid,array_keys($this->state_actions['options']))){
			//capture statistics; $state $wfid
			$where="WHERE type=".WFSTAT_TYPE_ACTION_FREQ." AND id=$wfaid AND uid=$uid AND class=$class AND state=$state";
			//echo "$where <br>\n";
			if($xval=simple_query("SELECT xval FROM wfstats $where")){
				$xval++;
				$query="UPDATE wfstats SET xval=$xval $where";
				if(!@mysql_query($query))
					_die2(__FILE__.':'.__LINE__.' Could not update wfstats table.');
			}else{
				$query="INSERT INTO wfstats (type, id, uid, class, state, xval) VALUES (".WFSTAT_TYPE_ACTION_FREQ.", $wfaid, $uid, $class, $state, 1)";
				if(!@mysql_query($query))
					_die2(__FILE__.':'.__LINE__.' Could not insert into wfstats table.');
			}
		}

		if(!$wfaid || in_array($wfaid,array_keys($this->state_actions['options'])))
			$this->actions2fields($wfaid);

		return($auto_next_state);
	}

	function first_state($class){
		if(isset($this->first_state[$class]))
			return $this->first_state[$class];
		return FALSE;
	}

	function null_state_action($class){
		if(isset($this->null_state_action[$class]))
                        return $this->null_state_action[$class];
                return FALSE;
	}

	function inwork_state_mask($class){
		if(isset($this->inwork_state_mask[$class]))
			return $this->inwork_state_mask[$class];
		return FALSE;
	}

	function fixed_state_mask($class){
		if(isset($this->fixed_state_mask[$class]))
			return $this->fixed_state_mask[$class];
		return FALSE;
	}

	function verified_state_mask($class){
		if(isset($this->verified_state_mask[$class]))
			return $this->verified_state_mask[$class];
		return FALSE;
	}

	function last_state_mask($class){
		if(isset($this->last_state_mask[$class]))
			return $this->last_state_mask[$class];
		return FALSE;
	}

	function state_is_dup($class,$state){
		return($this->wfstate_options[$class][$state]&WFSTATE_OPT_DUP);
	}

	function rwfield_to_state_mask($fn){
		$query="SELECT a.next_state FROM wfactions AS a, wfgroups AS g WHERE a.wf_action_id=g.id AND g.type=".WFGROUP_TYPE_RWFIELD." AND (wf_state_id=".$this->wf_state_id." OR wf_state_id IS NULL)".($this->prev_state?" AND (prev_state=".$this->prev_state." OR prev_state IS NULL)":'')." AND g.xstr='$fn'";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from wfactions table.');
		$mask=0;
		while($row=mysql_fetch_array($result, MYSQL_NUM))
			$mask|=$row[0];
		return $mask;
	}

	function actions2fields($wfaid=FALSE){
		$this->state_rw_fields=array();
		$this->state_rw_afo=array();

		if(!count($this->state_actions['options']))
			return FALSE;

		$query="SELECT xstr, xstr2, id, options FROM wfgroups WHERE id IN (".implode(',',array_keys($this->state_actions['options'])).") AND type=".WFGROUP_TYPE_RWFIELD;
		//echo "$query<br>\n";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from wfgroups table.');

		while($row=mysql_fetch_row($result)){
			$this->state_rw_fields[$row[0]]=$row[1];
			$this->state_rw_afo[$row[2]][$row[0]]=$row[3];
		}

		return $this->state_rw_fields;
	}

	function get_fields_options($wfaid){
		if(!isset($this->state_rw_afo[$wfaid]))
			return array();

		return $this->state_rw_afo[$wfaid];
	}

	function get_rw_fields($wfaid){
		if($wfaid)
			$a=array($wfaid);
		else
			$a=array_keys($this->state_rw_afo);

		$rw_fields=array();
		foreach($a as $aid){
			if(!isset($this->state_rw_afo[$aid])) continue;
			foreach(array_keys($this->state_rw_afo[$aid]) as $f)
				$rw_fields[$f]=$this->state_rw_fields[$f];
		}

		return $rw_fields;
	}

	function is_rw_field($fn){
		return in_array($fn,array_keys($this->state_rw_fields));
	}

	function default_value($fn,$wfaid,&$xstr2uid){
		$wfid=$this->wfid;
		$query="SELECT xstr2 FROM wfgroups WHERE (id=$wfaid OR id IS NULL) AND xstr='$fn' AND type=".WFGROUP_TYPE_DEFAULT." ORDER BY id DESC LIMIT 1";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from wfgroupd table.');
		$row=mysql_fetch_array($result, MYSQL_NUM);
		//echo "$row[0]<br>\n";
		$a=$this->xstr2uids($row[0],$xstr2uid);
		return $a[0];
	}

	function f2v_for_action($wfaid,&$xstr2uid,$class=FALSE){
		$wfid=$this->wfid;

		$query="SELECT xstr, xstr2 FROM wfgroups WHERE (id=$wfaid OR id IS NULL) AND type=".WFGROUP_TYPE_DEFAULT.($class?" AND $class&xstr3":'')." ORDER BY id DESC";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from wfgroupd table.');

		$f2v=array();
		while($row=mysql_fetch_array($result, MYSQL_NUM)){
			//echo "$row[0] = $row[1] <br>\n";
			$a=$this->xstr2uids($row[1],$xstr2uid);
			if(substr($a[0],0,5)!="%inp_")
				$f2v[$row[0]]=$a[0];
		}
		return $f2v;
	}

	function xstr2uids($xstr,&$xstr2uid){
		global $uid;

		//echo "$xstr <br>\n";
		$a=explode('|',$xstr);
		foreach($a as $k => $x)
			if((substr($x,0,1) == "%") && isset($xstr2uid[$x])){
				$a[$k]=$xstr2uid[$x];
			}elseif($x=='%user')
				$a[$k]=$uid;
		return $a;
	}

	function forbidden4parent_next_wfstate_opt($class,$state){

		if(!($this->fixed_state_mask[$class]&$state)){
			if($this->last_state_mask[$class]&$state)
				return (WFSTATE_OPT_FIXED|WFSTATE_OPT_VERIFIED);
			return (WFSTATE_OPT_FIXED|WFSTATE_OPT_VERIFIED|WFSTATE_OPT_LAST);
		}

		if(!($this->verified_state_mask[$class]&$state))
			return (WFSTATE_OPT_VERIFIED|WFSTATE_OPT_LAST);

		if(!($this->last_state_mask[$class]&$state))
			return (WFSTATE_OPT_LAST);
	}

	function request_state_is_wfstate($class,$state,$wfstate_opt_mask){
		return($this->wfstate_options[$class][$state]&$wfstate_opt_mask);
	}

	function request_state_has_clone_action(){
		foreach($this->state_actions['options'] as $opt){
			if($opt&WFACTION_OPT_CLONE)
				return TRUE;
		}
		return FALSE;
	}

	function sa_next_state($wfaid){
		return $this->state_actions['next_state'][$wfaid];
	}

	function sa_action_name($wfaid){
		return $this->state_actions['name'][$wfaid];
	}

	function sa_action_is_clone($wfaid){
		return $this->state_actions['options'][$wfaid]&WFACTION_OPT_CLONE;
	}

	function sa_actions_leading_to_fix($class,$state,$prev_state){
		$wfaids=array();
		foreach($this->state_actions['options'] as $wfaid => $o){
			if($o&WFSTATE_OPT_FIXED)
				arr_push($wfaids,$wfaid);
		}
		return $wfaids;
	}

	function &get_state_actions(){
		$ref = &$this->state_actions['frequency'];
		return $ref;
	}

	function get_state_action_name($wfaid){
		return $this->state_actions['name'][$wfaid];
	}

	function is_update($wfaid){
		return $this->state_actions['options'][$wfaid]&WFACTION_OPT_UPDATE;
	}
}

?>
