<?php

$_help['it']['itpm']['hdr']='ITPM';

$_help['it']['itpm_projects']['hdr']='ITPM: SUMMARY OF PROJECTS';
$_help['it']['itpm_projects']['msg']= '
<p>This page lists all your projects by IT environment.</p>
<p>You can start a new project, check progress of an ongoing project or generate reports for finished projects. Please click on highlithed items to proceed.
</p>';

$_help['it']['itpm_new']['hdr']='ITPM: NEW PROJECT';

$_help['it']['itpm_plan']['hdr']='ITPM: PROJECT PLANNING';
$_help['it']['itpm_plan']['msg']= "
<p>Forming a project plan in Yoxel is a collaborative process that is why at
the project creation step your project owner usually assigns a few people,
project members, to help him with that. Project members can add requests
to the plan, remove requests from the plan, specify their priority votes,
modify resource allocation, ... The project owner has additional privilege
to override the automatically computed priority (which is based on the
combined votes from the project members) with its own.</p>

<p>The important plan modifications are captured in project history log.
Switch to the history panel to see what other project members have done already
and comment on any project related activity that interests you.
</p>

<p>The recommended sequence of actions for each project member that visits
this plan page is the following:
<ol>
  <li>Read the description of the project goals. The very first record
  in the project history log will show you the project goal/objective.</li>
  <li>With that objective in mind review the current plan and add any important
  requests that are missing. You can add a new request if there is none yet
  in the backlog.</li>
  <li>Vote your priority. For each request in the plan express your personal
  opinion of what the priority should be, in the context of the current project goals.
  The priority votes are used to do preliminary sorting of the items in the plan,
  they also help all project members to see other member's opinion
  (use 'show details' mode and click on 'members vote' link).</li>
  <li>The project owner has special order setting privilegies. After he has entered
  all his votes the system automatically switches into 'manual voting' mode which means
  that automatic ordering based on the combined members vote is not applied
  anymore. From now on the project owner decides on the exact order of the requests
  in the plan. He can always sort the requests according to the combined vote
  by clicking on 'apply voted order'+[update] but the purpose of this
  mode is to be able to fine tune the exact 1,2,3,4,... order.
  It is his responsibility to know which items in the plan are the
  'must have' requests for the project and which ones he could possibly
  remove later.</li>
  <li>The priorities entered by project members start to shape up
  the best order for the requests in your plan. At this point start
  inputting effort estimates. Usually your IT teams will
  have to get involved in the process and enter their estimates
  for each of the requests.</li>
  <li>It is always a good idea to have IT managers among the project members.
Let them be the judges of the resource allocation. By default, Yoxel tries
to balance the resource load automatically but more often it is the case that
the managers know the best who will/should be doing what.</li>
  <li>Use 'time sharing' section/menu if you are in the situation
  when the same resources are working on several projects
  for different IT envirnments or if you have learnt from your previous iterations
  that certain % of their time they always spend on other, unrelated to the project tasks.</li>
  <li>As your plan fills with the estimates start paying more attention
  to the details of the plan ('show details') and Gantt charts.
  Look for the requests that are <span class='fade_n_cross'>crossed</span>
  (Yoxel thinks these are not making it into the project). Is that
  an important, not a 'must have' request, may be it is ok to remove
  it from the current plan? See if its estimate is reasonable
  (or entered at all). See if you can balance the resource allocation better.
  May be the project deadline should be adjusted. You can always
  collaborate with other project members by posting your comments
  in the project history log.</li>
  <li>Pay attention to warning messages in red and green that Yoxel gives you.
  Try to resolve those, use reminders. Allow some time to converge
  on a final plan with reasonable resource allocation and time table.
  Once all project members are in agreement, the project owner can save
  the plan and start the project implementation phase!</li>
</ul>
</p>";


$_help['it']['itpm_ts']['hdr']='ITPM: TIME SHARING';
$_help['it']['itpm_ts']['msg']= "
<p>Time sharing settings help you more accurately model situations when your
resources work on more than one project simultaneously or some of their time
is allocated to certain activity unrelated to any project (like handling
critical/unexpected customer requests or working part time).
</p>

<p>For each resource listed you simply need to specify what % of his/her
time he/she usually spends on project work related to each IT environment.
</p>

<p>You have a chance to change the settings only during a project planning phase.
</p>
";

$_help['it']['itpm_history']['hdr']='ITPM: HISTORY LOG';
$_help['it']['itpm_history']['msg']= "
<p>The history log captures important activity and collaboration
related to your project work.
</p>
<p>When you add comments or ask questions a notification email is sent to selected
project members with a link to this page.
</p>";

$_help['it']['itpm_estimate']['hdr']='ITPM: ESTIMATE';
$_help['it']['itpm_estimate']['msg']= '<p>If you are assigned to implement or test
a request please enter estimated time it may take you to do it.
This information is used by project planner/tracker. The more accurate information
you enter here the more efficient the project planning session will be.</p>';

$_help['it']['itpm_track']['hdr']='ITPM: PROJECT TRACKING';
$_help['it']['itpm_track']['msg']= "
<p>Project tracking is a very important capability that allows all members of your team
to monitor project progress in real time, and collaborate. Any time a request implementer
changes status of the request (resolved, % completeness, more_info)
the project tracker updates the project summary and re-computes its timetable.</p>
<p>The automatic re-computation of the timetable for the remaining part of the project
(for not completely implemented requests) allows you to predict when the
project may be finishing.
</p>
<p>The recommended usage of the tracker is the following:
  <ul>
  <li>Visit this page regularly. For each project item in the list Yoxel shows
originally planned start and finish dates. Yoxel always compares planned start/finish
dates vs. actual start/finish dates and highlights in red those items that
do not behave as planned (work has not started yet as planned / work has not finished yet as planned).</li>
  <li>For any project item highlighted in red take appropriate action to find out
what is going on. Click on the item to get a detailed description of the request and check
if the implementer added any comments recently. Contact the implementer/manager directly
or discuss these requests in an appropriate meeting. Unless the project priorities have changed
you should try to stick with the original plan.</li>
  <li>Check Gantts charts to see what Yoxel thinks of the project finish date. Is that acceptable?</li>
  <li>Use project history log panel to collaborate with other project members
on topics related to the project.</li>
  <li>At some point you may be in a situation when it is pretty clear that
some of the requests can not meet your planned deadline. At this point it is
your judgment call whether to de-commit the remaining items or violate
the project deadline. Most common practice is to continue project work
until all 'must have' requests are done and de-commit the rest.</li>
  </ul>
</p>
<p>Once your implementation phase has finished you will be able to officially finish
the project and mark it as 'done'. Yoxel will take you to a summary/statistics
page where you should spend some time looking at the numbers that will help you
plan your next project better.
</p>";

$_help['it']['itpm_done']['hdr']='ITPM: PROJECT STATISTICS';
$_help['it']['itpm_done']['msg']= "<p>The statistics gathered for a project
can be extremely useful to better understand capabilities and specifics
of your team and to create a more realistic plan for the next projects.
</p>
<p>Here is how we recommend you to use this page:
  <ul>
  <li>Look through all originally scheduled requests. These are the ones for which your
team members entered their estimates during planning phase. Examine 'e/a' columns,
these are 'estimated vs. actual' work hours. If possible make sure everyone has entered
their actual numbers and they make sense (enter perfect work hours). As a manager you
may override some of these.</li>
  <li>For the items where estimated is very different from actual check with your
implementer to understand why. That will be useful for the future projects.</li>
  <li>Now, scroll to the bottom and examine per implementer statistics:
     <ol>
	<li>planned/done - how many items were assigned to a person and how many he/she has done</li>
	<li>avg e/a hrs - on average how many hours per task he/she estimated and
how long it actually took. This might help your members estimate better in the future.</li>
	<li>reported/total hrs - how many hours an implementer worked during the project.
	This might be useful in determining % of time your resource actually spent on planned project requests (we call this % ?time share?) vs. other unplanned stuff. Reported numbers that are higher than total may indicate overtime work or incorrect reporting.</li>
    </ol>
  </li>
  <li>Examine those statistics averaged (over all implementers): planned/done, e/a hrs, reported/total hrs. Next time you are starting a new project in Yoxel you can drive the preliminary plan generator better with these.</li>
</ul>
</p>";

?>
