<?php
// $Header: /home/CVS/rps/itpm/itpm_remind.php,v 1.8 2008/05/04 00:19:13 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

	$hide_header=TRUE;
	require_once('../includes/db.inc');
	require_once('includes/itpm/itp.inc');
	include_once('includes/header.inc');

	if($is_customer)
		_quit_error("You are not allowed to use this part of the site.");

	if(isset($_GET['proj_id']))
		$proj_id=$_GET['proj_id'];
	else
		_die2(__FILE__.':'.__LINE__.' proj_id is not specified.');

	if(isset($_GET['type']))
		$type=$_GET['type'];
	else
		_die2(__FILE__.':'.__LINE__.' type is not specified.');

	if(isset($_GET['uid']))
		$ruid=$_GET['uid'];
	else
		$ruid=FALSE;

	$pl = simple_query("SELECT CONCAT(q.name,'/',r.label) FROM itprojects AS r, queues AS q WHERE r.proj_id=$proj_id AND r.qid=q.qid");
	if(!$pl)
		_die2(__FILE__.':'.__LINE__.' Could not select from itprojects table.');

	init_users();
	$itp= new ITPlan($proj_id);
	switch($_GET['type']){
		case REMIND_MEMPRI:
			$Subject = "Please set your priorities for the project.";
			$itp->init_proj_members($proj_id,1);
			$m=array();
			if($ruid)
				$m[$ruid]=$itp->mem_pri[$ruid];
			else
				$m=$itp->mem_pri;
			foreach ($m as $u => $upris) {
				$all_good=TRUE;
				$pr_list=array();
				foreach ($upris as $rid => $v) {
					//echo "uid=$u rid=$rid pri=$v <br>";
					if(!$v)
						array_push($pr_list,$rid);
				}
				if(count($pr_list)){ // Send mail to the user.
					$pr_list_str=implode(', ',$pr_list);
					$To=YxlUsers::full_email($u);
					$mail= 'Hello '.YxlUsers::name($u).",\n\n".
					"  The project plannig phase for $pl is under way and you are one of the project members. You have not yet specified your opinion regarding priorities of the following requests:\n\t\t$pr_list_str\n\n".
					"  Please do so at your earliest convenience by following the link below\n".
					"  \t$https_path/itpm/itpm_plan.php?proj_id=$proj_id\n\n";
					yxl_mail($To, $Subject, format_text($mail.$itp->proj_m_sign), $itp->mail_headers);
					echo '<pre>Sending email to '.html_safe_text($To).'</pre>';
					echo '<pre>'.format_text($mail.$itp->proj_m_sign).'</pre>';
				}

			}
			break;
		case REMIND_NOFET:
			$Subject = "Please estimate your effort to resolve issues.";
			$itp->init_fixers($proj_id);
			$itp->init_ets($proj_id);
			$tmp_2d=array();
			$uns=array();
			foreach ($itp->rid2qid_2d as $r => $cids){
				$uns=$itp->users_for_rid_without_fet($r);
				//echo "rid=$r $uns <br>";
				foreach ($uns as $i => $u){
					if($ruid){
						if($ruid==$u)
							$tmp_2d[$u][$r]=$r;
						continue;
					}else
						$tmp_2d[$u][$r]=$r;
				}
			}

			$cgi_pr_list_str='';
			foreach ($tmp_2d as $u => $v){
					$pr_list_str=implode(', ',$v);
					$cgi_pr_list_str=implode(':',$v);

					$To=YxlUsers::full_email($u);
					$mail= 'Hello '.YxlUsers::name($u).",\n\n".
					"  The project plannig phase for $pl is under way and you are one of the IT specialists to whom some work is assigned. You have not yet estimated your effort for the following requests:\n\t\t$pr_list_str\n\n".
					"  Please do so at your earliest convenience by following the link below:\n".
					"  \t$https_path/itpm/itpm_estimate.php?rid=$cgi_pr_list_str\n\n";
					yxl_mail($To, $Subject, format_text($mail.$itp->proj_m_sign), $itp->mail_headers);
					echo '<pre>Sending email to '.html_safe_text($To).'</pre>';
					echo '<pre>'.format_text($mail.$itp->proj_m_sign).'</pre>';
			}
			break;
		case REMIND_FET:
			$Subject = "Please complete resolution effort estimation.";
			$itp->init_fixers($proj_id);
			$itp->init_ets($proj_id);

			$a=array();
			if($ruid)
				$a[$ruid]=$itp->all_fixers[$ruid];
			else
				$a=$itp->all_fixers;
			foreach ($a as $u => $v) {
				$prs=$itp->rids_without_fet_by_user($u);
				if(count($prs)){
					$pr_list_str=implode(', ',$prs);
					$cgi_pr_list_str=implode(':',$prs);

					$To=YxlUsers::full_email($u);
					$mail= 'Hello '.YxlUsers::name($u).",\n\n".
					"  The project plannig phase for $pl is under way and you are one of possible IT specialists to be assigned some work. The IT Project Management System needs your effort estimations to do more accurate planning. Please enter your estimates for the following requests:\n\t\t$pr_list_str\n\n".
					"  You may do it at your earliest convenience by following the link below:\n".
					"  \t$https_path/itpm/itpm_estimate.php?rid=$cgi_pr_list_str\n\n";
					yxl_mail($To, $Subject, format_text($mail.$itp->proj_m_sign), $itp->mail_headers);
					echo '<pre>Sending email to '.html_safe_text($To).'</pre>';
					echo '<pre>'.format_text($mail.$itp->proj_m_sign).'</pre>';
				}
			}
			break;
		default:
			break;
	}
	echo '
	<br><br><br>
	<center>
	<p>
	<form>
		<input type="button" class="btn_large" value="  CLOSE WINDOW  " onClick="window.close();">
	</form>
	</p>
	</center>';

	include_once('includes/footer.inc');
?>
