#!/usr/local/bin/perl -w
# $Header: /home/CVS/rps/parsers/parse_bugzilla_pr_html.pl,v 1.20 2007/09/29 17:33:32 yoxel Exp $
# ----START-LICENCE----
# Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
# -----END-LICENCE-----


  use HTML::Parser;

   die "Usage:\n\tparse_bugzilla_pr.pl <bugzilla_page.html>\n"
  	unless($#ARGV==0);
   $fn=shift @ARGV;

   $in_pre=0;
   $cn=0;
   $oi=0;
   $sel='';
   %pr=();
   %m2v=();
   @sel_names=("product", "component", "version", "priority", "bug_severity", "rep_platform", "op_sys");
   @inp_names=("short_desc", "dependson", "qa_contact", 'delta_ts');
   @td_keywords=("status:", "resolution:", "reporter:", 'assigned', 'product:', 'component:', "version:", "priority:", 'severity:');
   @ta_names=();
   @td2_keywords=("opened:");
   %keyword2meaning=();
   $keyword2meaning{'product'}='product';
   $keyword2meaning{'product:'}='product';
   $keyword2meaning{'category'}='product';
   $keyword2meaning{'component'}='component';
   $keyword2meaning{'component:'}='component';
   $keyword2meaning{'version'}='version';
   $keyword2meaning{'version:'}='version';
   $keyword2meaning{'bug_severity'}='severity';
   $keyword2meaning{'severity:'}='severity';
   $keyword2meaning{'priority'}='pri';
   $keyword2meaning{'priority:'}='pri';
   $keyword2meaning{'short_desc'}='syn';
   $keyword2meaning{'dependson'}='dependson';
   $keyword2meaning{'status:'}='status';
   $keyword2meaning{'resolution:'}='resolution';
   $keyword2meaning{'reporter:'}='submitter';
   $keyword2meaning{'assigned'}='owner';
   $keyword2meaning{'opened:'}='reg_date';
   $keyword2meaning{'qa_contact'}='tester';
   $keyword2meaning{'rep_platform'}='hardware';
   $keyword2meaning{'op_sys'}='os';
   $keyword2meaning{'delta_ts'}='modified';

   $a_txt='';
   $found_td=0;
   $in_td='';
   $h = HTML::Parser->new(
	api_version => 3,
	text_h => [ sub {
       		my ($txt) = @_;
		if($in_td || $in_ta || $in_pre){
			$a_txt.=$txt;
		}
	}, "dtext" ],
	start_h => [ sub {
       		my ($self, $tagname, $attr, $attrseq, $txt) = @_;
		if($tagname eq "pre"){
			$in_pre=1;
		}elsif( ($tagname eq "input") && ((defined($attr->{type}) && ($attr->{type} =~ /^(text|hidden)$/i)) || !defined($attr->{type}))){
			$str=lc($attr->{name});
			if(grep(/$str/i,@inp_names)){
				$m2v{$keyword2meaning{$str}}=$attr->{value};
        			#print "INPUT: ".$attr->{name}."\n";
			}
		}elsif($tagname eq "select"){
			$str=lc($attr->{name});
			#print STDERR "SEL: '",$str,"'\n";
			if(grep(/$str/i,@sel_names)){
				$sel=$keyword2meaning{$str};
				$oi=0;
			}
		}elsif($tagname eq "option"){
			if($sel){
				$m2v{$sel}=$attr->{value} if($oi==0);
				$m2v{$sel}=$attr->{value} if($attr->{selected});
				$oi++;
			}
                }elsif($tagname =~ /td|th/i){
			$a_txt='';
			$in_td=1;
                }elsif($tagname eq "textarea"){
			$str=lc($attr->{name});
			if(grep(/$str/i,@ta_names)){
				$in_ta=$str;
			}
		}

	}, "self, tagname, attr, attrseq, text" ],
	end_h  => [ sub {
       		my ($self, $tagname, $attr, $txt) = @_;
		if( $tagname eq "pre"){
			$descr.="\n\n ===== Next Comment =====\n" if($cn++);
			$descr.=$a_txt;
			$a_txt='';
			$in_pre=0;
		}elsif($tagname =~ /td|th/i){
			$a_txt=~s/^\s+//g;
			$a_txt=~s/\s+$//g;
			#print STDERR "TDTXT: '$a_txt'\n" if($a_txt =~ /assigned/i);
			if($found_td){
				#print STDERR "TEXT: $found_td $a_txt\n";
				$m2v{$keyword2meaning{$found_td}}=$a_txt;
				$found_td='';
			}else{
				$match='';
				foreach $w (@td_keywords){
					next if(!($a_txt =~ /$w/i));
					$match=$w; last;
				}
				if($match){
					$found_td=lc($match);
					#print STDERR "FOUND1: $found_td\n";
				}

				$match='';
				foreach $w (@td2_keywords){
					next if(!($a_txt =~ /$w/i));
					$match=$w; last;
				}
				if($match){
					$a_txt=~s/^\s*$match\s*//ig;
					$a_txt=~s/\s*$//g;
					$m2v{$keyword2meaning{$match}}=$a_txt;
					#print STDERR "FOUND2: $match $a_txt\n";
				}
			}
			$a_txt='';
			$in_td=0;
		}elsif($tagname eq "select"){
			if($sel){
        			#print "SELECT: $sel ",$m2v{$sel},"\n";
				$found_td=0;
				$a_txt='';
			}
			$sel='';
			$oi=0;
		}elsif( $tagname eq "textarea"){
			if($in_ta){
				#print STDERR "$in_ta \n";
				$m2v{$keyword2meaning{$in_ta}}=$a_txt;
			}
			$a_txt='';
			$in_ta=0;
		}
        }, "self, tagname, text" ]);

   $h->parse_file($fn);
   # Post-process meaning2value array:
   die "Nothing has been parsed!\n" unless(keys %m2v);
   $pr{descr}=$descr;
   $pr{product}=$m2v{product};
   $pr{component}=$m2v{component} unless($m2v{component} =~ /^\s*(General|All|Any)\s*$/);
   $pr{version}=$m2v{version};
   $pr{syn}=$m2v{syn};
   $pr{reg_date}=$m2v{reg_date};

   $pr{submitter}=norm_email($m2v{'submitter'});
   $pr{tester}=norm_email($m2v{'tester'});
   $pr{fixer}=norm_email($m2v{'owner'});

   if($m2v{'modified'} =~ /\s+/){
	$pr{'modified'}=$m2v{'modified'};
   }else{
	$year=substr($m2v{'modified'},0,4);
	$month=substr($m2v{'modified'},4,2);
	$day=substr($m2v{'modified'},6,2);
	$hr=substr($m2v{'modified'},8,2);
	$min=substr($m2v{'modified'},10,2);
	$pr{'modified'}="$year-$month-$day $hr:$min";
   }

   #$m2v{hardware};
   #$m2v{os};
   $class='bug';
   $state='open';
   $s=lc($m2v{status});
   @sr=split /\s+/, $s;
   $r=lc($m2v{resolution});
   if(!$r && $#sr){
	$s=shift @sr;
	$r=join ' ',@sr;
   }
   print STDERR "{status=$s,resolution=$r} ";
   $xrid=0;
   if($s =~ /needinfo/i){
   	$state='more_info';
   }elsif ($s eq 'resolved'){
	$state='fixed';
	if(($r eq 'invalid') || ($r eq 'wontfix')){
		$state='wont_fix';
	}elsif(($r =~ /duplicate/) || ($r =~ /moved/)){
		$state='duplicate';
		($xrid)= $r=~/(\d+)\s*$/;
	}elsif($r =~ /worksforme/i){
		$state='more_info';
	}elsif($r =~ /moved/i){
		$state='wont_fix';
	}elsif($r =~ /expired/i){
		$state='closed';
	}
   }elsif($s eq 'verified'){
   	$state='verified';
	if(($r =~ /duplicate/) || ($r =~ /moved/)){
		$state='duplicate';
		($xrid)= $r=~/(\d+)\s*$/;
	}
   }elsif($s eq 'closed'){
	$state='closed';
	if(($r =~ /duplicate/) || ($r =~ /moved/)){
		$state='duplicate';
		($xrid)= $r=~/(\d+)\s*$/;
	}
   }
   $pr{'dup_xrid'}=$xrid if($xrid);
   print STDERR "{state --> $state $xrid} ";

   $pri='low';
   $p=lc($m2v{pri});
   $s=lc($m2v{severity});
   if(($p eq 'p0') || ($p eq 'p1')){
        $pri='critical';
   }elsif(($s eq 'blocker') || ($s eq 'critical')){
        $pri='high';
   }elsif($s eq 'major'){
        $pri='medium';
   }elsif(($s eq 'normal') || ($s eq 'minor')){
        $pri='low';
   }elsif($s eq 'enhancement'){
        $class='enhancement';
        $pri='medium';
   }
   print STDERR $m2v{severity},'-->',$pri,' ';

   $pr{class}=$class;
   $pr{state}=$state;
   $pr{pri}=$pri;
   $pr{x_bpri}=$p;

   open HASHF, ">$fn".".hf" || die $!;
   foreach $k (keys %pr){
   	#print STDERR $k,":",$pr{$k},"\n";
   	print HASHF $k,":",$pr{$k},"\n%%\n%%\n" if($pr{$k});
   }
   close HASHF;


sub norm_email {
   my $e = shift @_;
   my $fname;
   my $dn;
   return '' unless($e);
   return '' if($e =~ /nobody/);

   if($e =~ /<.+>/){
   	if($e =~ /^\w+\s+.*</){
   		$ne=$e;
   	}else{
   		($fname,$dn) = $e =~ /<\s*(\S+)@(\S+)\s*>/;
   		$ne="$fname <$fname@$dn>";
   	}
   }elsif($e =~ /(\S+)@\S+/){
   	$ne=$1.' <'.$e.'>';
   }
   #print STDERR "'$e' --> '$ne', ";
   return $ne;
}
