#!/usr/local/bin/perl -w
# $Header: /home/CVS/rps/parsers/parse_gnats_pr_html.pl,v 1.4 2007/09/29 17:33:33 yoxel Exp $
# ----START-LICENCE----
# Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
# -----END-LICENCE-----


  use HTML::Parser;

   die "Usage:\n\tparse_bugzilla_pr_html.pl <bugzilla_page.html>\n"
  	unless($#ARGV==0);
   $fn=shift @ARGV;

   $in_pre=0;
   #$cn=0;
   $oi=0;
   $sel='';
   %pr=();
   %m2v=();
   @sel_names=("category", "priority", "severity", "responsible", "state", "class", "submitter-id", "confidential");
   @inp_names=("synopsis", "release");
   @ta_names=("description", "environment", "how-to-repeat");
   @td_keywords=();
   %keyword2meaning=();
   $keyword2meaning{category}='category';
   $keyword2meaning{priority}='pri';
   $keyword2meaning{severity}='severity';
   $keyword2meaning{responsible}='responsible';
   $keyword2meaning{state}='state';
   $keyword2meaning{class}='class';
   $keyword2meaning{synopsis}='syn';
   $keyword2meaning{release}='version';
   $keyword2meaning{description}='descr';
   $keyword2meaning{environment}='env';
   $keyword2meaning{'how-to-repeat'}='htr';
   $keyword2meaning{'submitter-id'}='cust';
   $keyword2meaning{'confidential'}='not_vbc';
   $a_txt='';
   $found_td=0;
   $in_td='';
   $h = HTML::Parser->new(
	api_version => 3,
	text_h => [ sub {
       		my ($txt) = @_;
		if($in_td || $in_ta || $in_pre){
			$a_txt.=$txt;
		}
	}, "dtext" ],
	start_h => [ sub {
       		my ($self, $tagname, $attr, $attrseq, $txt) = @_;
		if($tagname eq "pre"){
			$in_pre=1;
		}elsif( ($tagname eq "input") && ((defined($attr->{type}) && ($attr->{type} eq "text")) || !defined($attr->{type}))){
			$str=lc($attr->{name});
			if(grep(/$str/i,@inp_names)){
				$m2v{$keyword2meaning{$str}}=$attr->{value};
        			#print "INPUT: ".$attr->{name}."\n";
			}
		}elsif($tagname eq "select"){
			$str=lc($attr->{name});
			#print STDERR "SEL: '",$str,"'\n";
			if(grep(/$str/i,@sel_names)){
				$sel=$keyword2meaning{$str};
				$oi=0;
			}
		}elsif($tagname eq "option"){
			if($sel){
				$m2v{$sel}=$attr->{value} if($oi==0);
				$m2v{$sel}=$attr->{value} if($attr->{selected});
				$oi++;
			}
                }elsif($tagname eq "td"){
			$in_td=1;
                }elsif($tagname eq "textarea"){
			$str=lc($attr->{name});
			if(grep(/$str/i,@ta_names)){
				$in_ta=$str;
			}
		}

	}, "self, tagname, attr, attrseq, text" ],
	end_h  => [ sub {
       		my ($self, $tagname, $attr, $txt) = @_;
		if( $tagname eq "pre"){
			$m2v{comments}.=$a_txt;
			$a_txt='';
			$in_pre=0;
		}elsif( $tagname eq "td"){
			if($found_td){
				$a_txt=~s/^\s+//g;
				$a_txt=~s/\s+$//g;
				$m2v{$keyword2meaning{$found_td}}=$a_txt;
				#print "TEXT: $found_td $a_txt \n";
				$found_td='';
			}else{
				$ok=0;
				foreach $w (@td_keywords){
					next if(!($a_txt =~ /$w:/i));
					$ok=1; last;
				}
				if($ok){
					$a_txt=~s/^\s+//g;
					$a_txt=~s/\s+$//g;
					$found_td=lc(chomp($a_txt));
				}
			}
			$a_txt='';
			$in_td=0;
		}elsif($tagname eq "select"){
			if($sel){
        			#print "SELECT: $sel ",$m2v{$sel},"\n";
			}
			$sel='';
			$oi=0;
		}elsif( $tagname eq "textarea"){
			if($in_ta){
				#print STDERR "$in_ta \n";
				$m2v{$keyword2meaning{$in_ta}}=$a_txt;
			}
			$a_txt='';
			$in_ta=0;
		}
        }, "self, tagname, text" ]);

   $h->parse_file($fn);
   # Post-process meaning2value array:
   die "Nothing has been parsed!\n" unless(keys %m2v);
   @a=split(/-/,$m2v{category});
   @b = $a[0] =~ /^([A-Z]*)([a-z]+\w+)\s*$/;
   @b = $a[0] =~ /^([a-z]*)([A-Z]+\w+)\s*$/ unless($b[0]);
   @b = ('UNKNOWN', $a[0]) unless($b[0]);
   $pr{product}=$b[0];
   $pr{component}=$b[1];
   $pr{version}=$m2v{version} if(defined($m2v{version}));
   $pr{syn}=$m2v{syn};
   $pr{class}='bug';
   if($m2v{class} =~ /change/){
	$pr{class}='enhancement';
   }elsif($m2v{class} =~ /support/){
	$pr{class}='support';
   }

   $pr{pri}='low';
   if(($m2v{severity} =~ /critical/) && ($m2v{pri} =~ /high/)){
	$pr{pri}='critical';
   }elsif((($m2v{severity} =~ /critical/) && ($m2v{pri} =~ /medium/)) || (($m2v{severity} =~ /serious/) && ($m2v{pri} =~ /high/))){
   	$pr{pri}='high';
   }elsif((($m2v{severity} =~ /serious/) && ($m2v{pri} =~ /medium/)) || (($m2v{severity} =~ /critical/) && ($m2v{pri} =~ /low/))){
	$pr{pri}='medium';
   }

   $pr{descr}="\n\n ===== Environment =====\n".$m2v{env} unless($m2v{env} =~ /^\s*$/);
   $pr{descr}.="\n\n ===== Description =====\n".$m2v{descr} unless($m2v{descr} =~ /^\s*$/);
   $pr{descr}.="\n\n ===== How To Reproduce =====\n".$m2v{htr} unless($m2v{htr} =~ /^\s*$/);
   #$pr{descr}.="\n\n ===== Comments =====\n".$m2v{comments} unless($m2v{comments} =~ /^\s*$/);
   $pr{state}=$m2v{state};
   $pr{state}='assigned' if($m2v{state} =~ /analyzed/);
   $pr{state}='more_info' if($m2v{state} =~ /more/);
   $pr{state}='wont_fix' if($m2v{state} =~ /wontfix/);
   $pr{cust}=$m2v{cust};
   $pr{vbc}=$m2v{not_vbc} =~ /yes/?0:1;

   open HASHF, ">$fn".".hf" || die $!;
   foreach $k (keys %pr){
   	#print STDERR $k,":",$pr{$k},"\n";
   	#print STDERR $k,"\n";
   	print HASHF $k,":",$pr{$k},"\n%%\n%%\n";
   }
   close HASHF;
