#!/usr/local/bin/perl -w
# $Header: /home/CVS/rps/parsers/parse_mysql_pr_html.pl,v 1.9 2007/09/29 17:33:33 yoxel Exp $
# ----START-LICENCE----
# Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
# -----END-LICENCE-----


  use HTML::Parser;

   die "Usage:\n\tparse_bugzilla_pr.pl <bugzilla_page.html>\n"
  	unless($#ARGV==0);
   $fn=shift @ARGV;

   $in_pre=0;
   $cn=0;
   $oi=0;
   $sel='';
   %pr=();
   %m2v=();
   @sel_names=();
   @inp_names=();
   @td_keywords=('bug.#', "submitted:", "from:", "status:", "severity:", "category:", "version:", "modified:", 'assigned to:', 'os:');
   @ta_names=();
   @td2_keywords=();
   %keyword2meaning=();
   $keyword2meaning{'bug.#'}='syn';
   $keyword2meaning{'category:'}='category';
   $keyword2meaning{'version:'}='version';
   $keyword2meaning{'severity:'}='severity';
   $keyword2meaning{'status:'}='status';
   $keyword2meaning{'from:'}='submitter';
   $keyword2meaning{'modified:'}='modified';
   $keyword2meaning{'assigned to:'}='owner';
   $keyword2meaning{'submitted:'}='reg_date';
   $keyword2meaning{'os:'}='os';

   $a_txt='';
   $found_td=0;
   $in_td='';
   $h = HTML::Parser->new(
	api_version => 3,
	text_h => [ sub {
       		my ($txt) = @_;
		if($in_td || $in_ta || $in_pre){
			$a_txt.=$txt;
		}
	}, "dtext" ],
	start_h => [ sub {
       		my ($self, $tagname, $attr, $attrseq, $txt) = @_;
		if($tagname eq "pre"){
			$in_pre=1;
		}elsif( ($tagname eq "input") && ((defined($attr->{type}) && ($attr->{type} =~ /^(text|hidden)$/i)) || !defined($attr->{type}))){
			$str=lc($attr->{name});
			if(grep(/$str/i,@inp_names)){
				$m2v{$keyword2meaning{$str}}=$attr->{value};
        			#print "INPUT: ".$attr->{name}."\n";
			}
		}elsif($tagname eq "select"){
			$str=lc($attr->{name});
			#print STDERR "SEL: '",$str,"'\n";
			if(grep(/$str/i,@sel_names)){
				$sel=$keyword2meaning{$str};
				$oi=0;
			}
		}elsif($tagname eq "option"){
			if($sel){
				$m2v{$sel}=$attr->{value} if($oi==0);
				$m2v{$sel}=$attr->{value} if($attr->{selected});
				$oi++;
			}
                }elsif($tagname =~ /td|th/i){
			$a_txt='';
			$in_td=1;
                }elsif($tagname eq "textarea"){
			$str=lc($attr->{name});
			if(grep(/$str/i,@ta_names)){
				$in_ta=$str;
			}
		}

	}, "self, tagname, attr, attrseq, text" ],
	end_h  => [ sub {
       		my ($self, $tagname, $attr, $txt) = @_;
		if( $tagname eq "pre"){
			$descr.="\n\n ===== Next Comment =====\n" if($cn++);
			$descr.=$a_txt;
			$a_txt='';
			$in_pre=0;
		}elsif($tagname =~ /td|th/i){
			$a_txt=~s/^\s+//g;
			$a_txt=~s/\s+$//g;
			if($found_td){
				$m2v{$keyword2meaning{$found_td}}=$a_txt;
				#print STDERR "TEXT: $found_td $a_txt\n";
				$found_td='';
			}else{
				#print STDERR "KKK: $a_txt\n";
				$match='';
				foreach $w (@td_keywords){
					next if(!($a_txt =~ /$w/i));
					$match=$w; last;
				}
				if($match){
					$found_td=lc($match);
					#print STDERR "FOUND1: $found_td\n";
				}

				$match='';
				foreach $w (@td2_keywords){
					next if(!($a_txt =~ /$w/i));
					$match=$w; last;
				}
				if($match){
					$a_txt=~s/^\s*$match\s*//ig;
					$a_txt=~s/\s*$//g;
					$m2v{$keyword2meaning{$match}}=$a_txt;
					#print STDERR "FOUND2: $match $a_txt\n";
				}
			}
			$a_txt='';
			$in_td=0;
		}elsif($tagname eq "select"){
			if($sel){
        			#print "SELECT: $sel ",$m2v{$sel},"\n";
			}
			$sel='';
			$oi=0;
		}elsif( $tagname eq "textarea"){
			if($in_ta){
				#print STDERR "$in_ta \n";
				$m2v{$keyword2meaning{$in_ta}}=$a_txt;
			}
			$a_txt='';
			$in_ta=0;
		}
        }, "self, tagname, text" ]);

   $h->parse_file($fn);
   # Post-process meaning2value array:
   die "Nothing has been parsed!\n" unless(keys %m2v);
   die "No Synopsis specified!\n" unless($m2v{syn});
   die "No Category specified!\n" unless($m2v{category});

   @a=split(/\s*[:\/]\s*/,$m2v{category});
   $p=shift @a;
   $pr{product}=$p;
   #$m2v{category} =~ s/$p(:|\/)//i;
   $m2v{category} = join '/', @a;
   $m2v{category} =~ s/^\s*//i;
   $pr{component}= $m2v{category};
   $pr{descr}=$descr;
   $pr{bldo}=$m2v{version};
   ($pr{version})= $m2v{version} =~ /^\D*(\d+\.\d+)\D*/;
   if(defined($pr{version})){
   	$pr{version} =~ s/\.$//;
   	$pr{version} =~ s/^\.//;
   }
   $pr{syn}=$m2v{syn};
   $pr{reg_date}=fix_date($m2v{reg_date});
   #$pr{submitter}=norm_email($m2v{'submitter'});

   if(defined($m2v{'modified'})){
   if($m2v{'modified'} =~ /\s+/){
	$pr{'modified'}=fix_date($m2v{'modified'});
   }else{
	$year=substr($m2v{'modified'},0,4);
	$month=substr($m2v{'modified'},4,2);
	$day=substr($m2v{'modified'},6,2);
	$hr=substr($m2v{'modified'},8,2);
	$min=substr($m2v{'modified'},10,2);
	$pr{'modified'}="$year-$month-$day $hr:$min";
   }
   }

   #$m2v{hardware};
   #$m2v{os};
   $class='bug';
   $state='open';
   $s=lc($m2v{status});
   $xrid=0;
   if($s =~ /(under\s+dev|in\s+progress)/i){
   	$state='in_work';
   }elsif ($s =~ /patch/i){
	$state='fixed';
   }elsif($s =~ /verified/i){
   	$state='verified';
   }elsif($s =~ /duplicate/i){
   	$state='duplicate';
   	($xrid)= $descr =~ /#(\d+)\D*[^#]*$/;
   }elsif($s =~ /won\'t\s+fix/i){
   	$state='wont_fix';
   }elsif($s =~ /(repeat|feedback)/i){
   	$state='more_info';
   }elsif($s =~ /closed|(not\s+a\s+bug)/i){
	$state='closed';
   }
   $pr{'dup_xrid'}=$xrid if($xrid);
   print STDERR "status=$s --> $state ".($xrid?$xrid:'')." ";

   $pri='low';
   $s=lc($m2v{severity});
   if($s =~ /s1/i){
	$pri='critical';
	$pri='high' if($state eq 'more_info');
   }elsif($s =~ /s2/i){
	$pri='high';
   }elsif($s =~ /s3/i){
	$pri='medium';
   }elsif($s =~ /s4/i){
	$class='enhancement';
	$pri='medium';
   }
   #print STDERR $m2v{severity},'-->',$pri;

   $pr{class}=$class;
   $pr{state}=$state;
   $pr{pri}=$pri;
   open HASHF, ">$fn".".hf" || die $!;
   foreach $k (keys %pr){
   	#print STDERR $k,":",$pr{$k},"\n";
   	print HASHF $k,":",$pr{$k},"\n%%\n%%\n" if($pr{$k});
   }
   close HASHF;


sub fix_date {
   my $d = shift @_;
   return '' unless($d);

   @tm=localtime;
   @a=split(/\s+/,$d);
   return $d if(@a >= 4);
   return $a[0].' '.$a[1].' '.(1900+$tm[5]).' '.$a[2];
}
