#!/usr/local/bin/perl -w
# $Header: /home/CVS/rps/parsers/parse_retro_pr_html.pl,v 1.6 2008/05/16 23:12:34 yoxel Exp $
# ----START-LICENCE----
# Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
# -----END-LICENCE-----


  use HTML::Parser;
  use Encode;
  use HTML::Entities;

   die "Usage:\n\tparse_retro_pr_html.pl <retro_page.html>\n"
  	unless($#ARGV==0);

   $fn=shift @ARGV;

   $descr=$sel=$mb='';
   $in_div=$oi=0;
   %pr=(); %m2v=();
   @sel_names=('ticket[status_id]','ticket[priority_id]');
   @inp_names=();

   # Look for keyword identifier where the value is in the next th/td
   #@td_keywords=("component:", "release:", "assigned to:", "reported by:");
   @td_keywords=("component:", "release:", "assigned to:");

   # Look for keyword identifier where the value is in same th/td
   @td2_keywords=();
   @ta_names=();

   %keyword2meaning=();
   $keyword2meaning{'component:'}='product';
   $keyword2meaning{'release:'}='version';
   $keyword2meaning{'ticket[priority_id]'}='pri';
   $keyword2meaning{'short_desc'}='syn';
   $keyword2meaning{'ticket[status_id]'}='status';
   $keyword2meaning{'reported by:'}='submitter';
   $keyword2meaning{'assigned to:'}='owner';
   $keyword2meaning{'opened:'}='reg_date';
   $keyword2meaning{'qa_contact'}='tester';
   $keyword2meaning{'rep_platform'}='hardware';
   $keyword2meaning{'op_sys'}='os';
   $keyword2meaning{'delta_ts'}='modified';

   $descr=$a_txt='';
   $found_td=$in_td=$in_opt=$descr_divn=0;

   $h = HTML::Parser->new(
	api_version => 3,

	text_h => [ sub {
       		my ($txt) = @_;
		if($in_td || $in_ta || $in_div || $in_opt){
			#$txt=decode_utf8($txt);
			_decode_entities($txt, {nbsp => " "});
			$txt=decode_entities($txt);
			#$txt=encode("iso-8859-1",$txt);
			#$txt=pack "U0C*", unpack "C*", $txt;
			$a_txt.=$txt;
		}
	}, "text" ],
	#dtext

	start_h => [ sub {
       		my ($self, $tagname, $attr, $attrseq, $txt) = @_;
		if( ($tagname eq "input") && ((defined($attr->{type}) && ($attr->{type} =~ /^(text|hidden)$/i)) || !defined($attr->{type}))){
			$str=lc($attr->{name});
			if(grep(/$str/i,@inp_names)){
				$m2v{$keyword2meaning{$str}}=$attr->{value};
        			#print "INPUT: ".$attr->{name}."\n";
			}
		}elsif($tagname eq "select"){
			$gstr=$str=lc($attr->{name});
			$gstr =~ s/(\W)/\\$1/g;
			if(grep(/$gstr/i,@sel_names)){
				#print STDERR "SEL: '",$str,"'\n";
				$sel=$keyword2meaning{$str};
				$oi=$soi=0;
			}
		}elsif($tagname eq "option"){
			$in_opt=1;$a_txt='';
			if($sel){
				 if(($oi==0) || $attr->{selected}){
				 	$m2v{$sel}=$attr->{value};
				 	$soi=1;
				}
				$oi++;
			}
                }elsif($tagname eq "textarea"){
			$str=lc($attr->{name});
			if(grep(/$str/i,@ta_names)){
				$in_ta=$str;
			}
		}elsif($tagname =~ /td|th/i){
			$a_txt='';
			$in_td=1;
                }elsif($tagname =~ /script/i){
			$sin_div=$in_div;
			$in_div=0;
		}elsif($tagname =~ /div|span/i){
			$div_id=defined($attr->{id})?$attr->{id}:'';
			$div_cl=defined($attr->{class})?$attr->{class}:'';
			$in_div++;
			$descr_divn=$in_div if($div_cl eq "ticket-change");
			#print STDERR "<div $div_cl $div_id: $in_div $descr_divn\n";
		}

	}, "self, tagname, attr, attrseq, text" ],

	end_h  => [ sub {
       		my ($self, $tagname, $txt) = @_;
       		if($tagname =~ /script/i){
			$in_div=$sin_div;
		}elsif($tagname =~ /div|span/i){
			#print STDERR "</div $div_cl $div_id: $in_div $descr_divn\n";
			if($div_id eq "ticket-summary"){
				chomp $a_txt;
				($m2v{'syn'})= ($a_txt =~ /^\s*#\d+:\s*(\S+.+)\s*$/si);
			}if($div_id eq "ticket-content"){
				$descr=$a_txt;
			}elsif($div_cl eq "ticket-created"){
				chomp $a_txt;
				($m2v{'reg_date'})= ($a_txt =~ /^\s*(\S+.+)\s*$/si);
				$m2v{'reg_date'} =~ s/\*//g;
			}else{
				 if(($descr_divn>0) && ($descr_divn<=$in_div)){
				 	 if($a_txt =~ /modified\s+by/i){
				 	 	$a_txt =~ s/[\n\r]//g;
				 	 	chomp $a_txt;
				 	 	($mb) = ($a_txt =~ /modified\s+by\s*(\S+.+)\s*$/i);
				 	 	$mb =~ s/\*//g;
				 	 	$m2v{modified}=$mb;
				 		$descr.="=== Modified on $mb\n";
				 	}else{
				 		$descr.=$a_txt;
				 	}
				}
				$descr_divn=0 if($descr_divn==$in_div);
			}
			$in_div--;
			$a_txt=$div_id=$div_cl='';
		}elsif($tagname =~ /td|th/i){
			$a_txt=~s/^\s+//g;
			$a_txt=~s/\s+$//g;
			#print STDERR "TDTXT: '$a_txt'\n" if($a_txt =~ /assigned/i);
			if($found_td){
				#print STDERR "TEXT: $found_td '$a_txt' \n";
				$m=$keyword2meaning{$found_td};
				$m2v{$m}=$a_txt unless(defined($m2v{$m}));
				$found_td='';
			}else{
				$match='';
				foreach $w (@td_keywords){
					next if(!($a_txt =~ /$w/i));
					$match=$w; last;
				}
				if($match){
					$found_td=lc($match);
					#print STDERR "FOUND1: $found_td\n";
				}

				$match='';
				foreach $w (@td2_keywords){
					next if(!($a_txt =~ /$w/i));
					$match=$w; last;
				}
				if($match){
					$a_txt=~s/^\s*$match\s*//ig;
					$a_txt=~s/\s*$//g;
					$m2v{$keyword2meaning{$match}}=$a_txt;
					#print STDERR "FOUND2: $match $a_txt\n";
				}
			}
			$a_txt='';
			$in_td=0;
		}elsif($tagname eq "select"){
			if($sel){
        			#print "SELECT: $sel ",$m2v{$sel},"\n";
				$found_td=0;
				$a_txt='';
			}
			$sel='';
			$oi=0;
		}elsif($tagname eq "option"){
			$m2v{$sel}=$a_txt if($sel && $soi);
			$in_opt=$soi=0; $a_txt='';
		}elsif( $tagname eq "textarea"){
			if($in_ta){
				#print STDERR "$in_ta \n";
				$m2v{$keyword2meaning{$in_ta}}=$a_txt;
			}
			$a_txt='';
			$in_ta=0;
		}
        }, "self, tagname, text" ]);

   $h->unbroken_text(1);
   $h->utf8_mode(1);
   #open(my $fh, "<:utf8", $fn) || die;
   $h->parse_file($fn);

   # Post-process meaning2value array:
   die "Nothing has been parsed!\n" unless(keys %m2v);

   $pr{descr}=$descr;
   $pr{product}=$m2v{product};
   #$pr{component}=$m2v{component} unless($m2v{component} =~ /^\s*(General|All|Any)\s*$/);
   $pr{version}=$m2v{version};
   $pr{syn}=$m2v{syn};
   $pr{reg_date}=$m2v{reg_date};

   #$pr{submitter}=norm_email($m2v{'submitter'});
   #$pr{tester}=norm_email($m2v{'tester'});
   #$pr{fixer}=norm_email($m2v{'owner'});

   $pr{'modified'}=$m2v{modified};

   #$m2v{hardware};
   #$m2v{os};
   $class='bug';
   $state='open';
   $s=lc($m2v{status});

   $xrid=0;
   if ($s eq 'fixed'){
	$state='fixed';
   }elsif(($s eq 'invalid') || ($s eq 'wontfix')){
		$state='wont_fix';
   }elsif(($s =~ /duplicate/) || ($s =~ /moved/)){
		$state='duplicate';
		($xrid)= $s=~/(\d+)\s*$/;
   }elsif($s =~ /worksforme/i){
		$state='more_info';
   }elsif($s eq 'verified'){
   	$state='verified';
	if(($r =~ /duplicate/) || ($r =~ /moved/)){
		$state='duplicate';
		($xrid)= $r=~/(\d+)\s*$/;
	}
   }elsif($s eq 'closed'){
	$state='closed';
	if(($r =~ /duplicate/) || ($r =~ /moved/)){
		$state='duplicate';
		($xrid)= $r=~/(\d+)\s*$/;
	}
   }
   $pr{'dup_xrid'}=$xrid if($xrid);


   $pri='low';
   $p=lc($m2v{pri});
   if(($p eq 'blocker') || ($p eq 'critical')){
        $pri='critical';
   }elsif($p eq 'major'){
        $pri='high';
   }elsif($p eq 'normal'){
        $pri='medium';
   }elsif($p eq 'enhancement'){
        $class='enhancement';
        $pri='medium';
   }

   print STDERR "{class --> $class $s --> $state $p --> $pri} ";

   $pr{class}=$class;
   $pr{state}=$state;
   $pr{pri}=$pri;

   open HASHF, ">$fn".".hf" || die $!;
   binmode HASHF, ":utf8";
   #binmode HASHF, ":encoding(cp1250)";
   foreach $k (keys %pr){
#   	print STDERR $k,": '",$pr{$k},"'\n";
   	print HASHF $k,":",$pr{$k},"\n%%\n%%\n" if($pr{$k});
   }
   close HASHF;


sub norm_email {
   my $e = shift @_;
   my $fname;
   my $dn;
   return '' unless($e);
   return '' if($e =~ /nobody/);

   if($e =~ /<.+>/){
   	if($e =~ /^\w+\s+.*</){
   		$ne=$e;
   	}else{
   		($fname,$dn) = $e =~ /<\s*(\S+)@(\S+)\s*>/;
   		$ne="$fname <$fname@$dn>";
   	}
   }elsif($e =~ /(\S+)@\S+/){
   	$ne=$1.' <'.$e.'>';
   }
   #print STDERR "'$e' --> '$ne', ";
   return $ne;
}
