#!/usr/local/bin/perl -w
# $Header: /home/CVS/rps/parsers/parse_trac_pr_html.pl,v 1.4 2008/05/19 22:10:17 yoxel Exp $
# ----START-LICENCE----
# Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
# -----END-LICENCE-----


  use HTML::Parser;
  use Encode;
  use HTML::Entities;

   die "Usage:\n\tparse_trac_pr_html.pl <trac_page.html>\n"
  	unless($#ARGV==0);

   $fn=shift @ARGV;

   $descr=$sel='';
   $in_div=$oi=0;
   %pr=(); %m2v=();

   # Look for <select
   @sel_names=('field_type', 'type');

   # Look for <input
   @inp_names=('field_summary', 'summary');

   # Look for keyword identifier where the value is in the next th/td
   @td_keywords=("reported by:", "priority:", "severity:", "component:", "milestone:", "version:", "owned by:", "keywords:");

   # Look for keyword identifier where the value is in same th/td
   @td2_keywords=();

   # Look for textarea
   @ta_names=();

   %keyword2meaning=();
   $keyword2meaning{'reported by:'}='submitter';
   $keyword2meaning{'priority:'}='pri';
   $keyword2meaning{'severity:'}='severity';
   $keyword2meaning{'component:'}='product';
   $keyword2meaning{'milestone:'}='version';
   $keyword2meaning{'version:'}='build';
   $keyword2meaning{'owned by:'}='owner';
   $keyword2meaning{'field_summary'}='syn';
   $keyword2meaning{'summary'}='syn';
   $keyword2meaning{'field_type'}='class';
   $keyword2meaning{'type'}='class';
   $keyword2meaning{'keywords:'}='keywords';

   #$keyword2meaning{'modified'}='reg_date';
   #$keyword2meaning{'delta_ts'}='modified';

   $descr=$a_txt='';
   $found_td=$in_td=$in_opt=$descr_divn=$in_sum_h2=0;

   $h = HTML::Parser->new(
	api_version => 3,

	text_h => [ sub {
       		my ($txt) = @_;
		if($in_td || $in_ta || $in_div || $in_opt){
			#$txt=decode_utf8($txt);
			_decode_entities($txt, {nbsp => " "});
			$txt=decode_entities($txt);
			#$txt=encode("iso-8859-1",$txt);
			#$txt=pack "U0C*", unpack "C*", $txt;
			$a_txt.=$txt;
		}
	}, "text" ],
	#dtext

	start_h => [ sub {
       		my ($self, $tagname, $attr, $attrseq, $txt) = @_;
		if( ($tagname eq "input") && ((defined($attr->{type}) && ($attr->{type} =~ /^(text|hidden)$/i)) || !defined($attr->{type}))){
			$str=lc($attr->{name});
			if(grep(/$str/i,@inp_names)){
				$m2v{$keyword2meaning{$str}}=$attr->{value};
        			#print "INPUT: ".$attr->{name}."\n";
			}
		}elsif($tagname eq "select"){
			$gstr=$str=lc($attr->{name});
			$gstr =~ s/(\W)/\\$1/g;
			if(grep(/$gstr/i,@sel_names)){
				#print STDERR "SEL: '",$str,"'\n";
				$sel=$keyword2meaning{$str};
				$oi=$soi=0;
			}
		}elsif($tagname eq "option"){
			$in_opt=1;$a_txt='';
			if($sel){
				 if(($oi==0) || $attr->{selected}){
				 	$m2v{$sel}=$attr->{value};
				 	$soi=1;
				}
				$oi++;
			}
                }elsif($tagname eq "textarea"){
			$str=lc($attr->{name});
			if(grep(/$str/i,@ta_names)){
				$in_ta=$str;
			}
		}elsif($tagname =~ /td|th/i){
			$a_txt='';
			$in_td=1;
                }elsif($tagname =~ /script/i){
			$sin_div=$in_div;
			$in_div=0;
		}elsif($tagname =~ /div|span/i){
			$div_id=defined($attr->{id})?$attr->{id}:'';
			$div_cl=defined($attr->{class})?$attr->{class}:'';
			$in_div++;
			#print STDERR "<div $div_cl $div_id: $in_div $descr_divn\n"; 
			if(($div_cl eq "description") || ($div_id eq "changelog")){
				#print STDERR "***<div $div_cl $div_id: $in_div $descr_divn\n"; 
				$descr_divn=$in_div;
			}

			$status_divn=$in_div if($div_cl eq "status");
		}elsif($tagname =~ /h2/i){
			$in_sum_h2=1 if(defined($attr->{class}) && ($attr->{class} =~ /^\s*summary\s*/));
		}

	}, "self, tagname, attr, attrseq, text" ],

	end_h  => [ sub {
       		my ($self, $tagname, $txt) = @_;
       		if($tagname =~ /script/i){
			$in_div=$sin_div;
		}elsif($tagname =~ /div|span/i){
			#print STDERR "</div $div_cl: $in_div $descr_divn\n";
			if($status_divn && ($div_cl eq "status")){
				($m2v{rid},$m2v{srt}) = $a_txt =~ /ticket\s+\#(\d+?)\s+\(\s*(.+?)\s*\)/i;
				#print STDERR "$a_txt";
			}elsif($descr_divn && ($descr_divn<=$in_div)){
				chomp $a_txt;
				#print STDERR "*** </div $div_cl: $in_div $descr_divn $a_txt";
				$descr.=$a_txt;
				$descr_divn=0 if($descr_divn==$in_div);
			}
			$in_div--;
			$a_txt=$div_id=$div_cl='';
		}elsif($tagname =~ /td|th/i){
			$a_txt=~s/^\s+//g;
			$a_txt=~s/\s+$//g;
			#print STDERR "TDTXT: '$a_txt'\n" if($a_txt =~ /assigned/i);
			if($found_td){
				#print STDERR "TEXT: $found_td '$a_txt' \n";
				$m=$keyword2meaning{$found_td};
				$m2v{$m}=$a_txt unless(defined($m2v{$m}));
				$found_td='';
			}else{
				$match='';
				foreach $w (@td_keywords){
					next if(!($a_txt =~ /$w/i));
					$match=$w; last;
				}
				if($match){
					$found_td=lc($match);
					#print STDERR "FOUND1: $found_td\n";
				}

				$match='';
				foreach $w (@td2_keywords){
					next if(!($a_txt =~ /$w/i));
					$match=$w; last;
				}
				if($match){
					$a_txt=~s/^\s*$match\s*//ig;
					$a_txt=~s/\s*$//g;
					$m2v{$keyword2meaning{$match}}=$a_txt;
					#print STDERR "FOUND2: $match $a_txt\n";
				}
			}
			$a_txt='';
			$in_td=0;
		}elsif($tagname eq "select"){
			if($sel){
        			#print "SELECT: $sel ",$m2v{$sel},"\n";
				$found_td=0;
				$a_txt='';
			}
			$sel='';
			$oi=0;
		}elsif($tagname eq "option"){
			$m2v{$sel}=$a_txt if($sel && $soi);
			$in_opt=$soi=0; $a_txt='';
		}elsif( $tagname eq "textarea"){
			if($in_ta){
				#print STDERR "$in_ta \n";
				$m2v{$keyword2meaning{$in_ta}}=$a_txt;
			}
			$a_txt='';
			$in_ta=0;
		}elsif($tagname =~ /h2/i){
			if($in_sum_h2){
				$m2v{syn}=$a_txt;
				$in_sum_h2=0;
				$a_txt='';
			}
		}
        }, "self, tagname, text" ]);

   $h->unbroken_text(1);
   $h->utf8_mode(1);
   #open(my $fh, "<:utf8", $fn) || die;
   #$h->parse_file($fh);
   $h->parse_file($fn);

   die "Nothing has been parsed!\n" unless(keys %m2v);

   #
   # Post-process meaning2value array:
   # Do special mapping of found Trac fields to Yoxel fields
   #

   $pr{descr}=$descr;
   $pr{product}=$m2v{product};
   @a = split '/',$m2v{product};
   if(@a>1){
	$pr{product}=shift @a;
	$pr{component}=join '/', @a;
   }

   $pr{version}=$m2v{version};
   $pr{build}=$m2v{build};
   $m2v{syn} =~ s/[\n\r]//g;
   $pr{syn}=$m2v{syn};

   #$pr{'modified'}=$m2v{modified};
   #$pr{reg_date}=$m2v{reg_date};
   #$pr{submitter}=norm_email($m2v{'submitter'});
   #$pr{tester}=norm_email($m2v{'tester'});
   #$pr{fixer}=norm_email($m2v{'owner'});
   #$m2v{hardware};
   #$m2v{os};

   $c=$r=$s='';
   if($m2v{srt} =~ /:/){
	($c,$r) = $m2v{srt} =~ /\s+(\w+)\s*:\s*(\w+)$/;
	$s=$r;
   }else{
	($s,$c) = $m2v{srt} =~ /^\s*(\w+)\s+(\w+)\s*$/;
   }

   $class='enhancement';
   #$c=$m2v{class};
   if ($c eq 'defect'){
	$class='bug';
   }elsif($c eq 'task'){
	$class='new development';
   }


   $xrid=0;
   $state='open';

   if($r){
   # When resolution is set
   	$state='closed';
	if(($r =~ /invalid/i) || ($r =~ /wontfix/i)){
		$state='wont_fix';
	}elsif(($r =~ /duplicate/i) || ($r =~ /moved/i)){
        	$state='duplicate';
	}elsif(($r =~ /worksforme/i) || ($r =~ /incomplete/i)){
		$state='more_info';
	}elsif($r =~ /untested/i){
		$state='fixed';
	}elsif($r =~ /verified/i){
		$state='verified';
	}
   }elsif($s){
   # When not resolved yet
	$state=$s;
	if(defined($m2v{keywords}) && ($m2v{keywords} =~ /needinfo/i)){
		$state='more_info';
	}elsif($s =~ /reopened/i){
		$state='open';
	}
   }

   $pr{'dup_xrid'}=$xrid if($xrid);

   $pri='low';
   $p=lc($m2v{pri});
   if(($p eq 'blocker') || ($p eq 'critical') || ($p eq 'highest')){
        $pri='critical';
   }elsif($p eq 'high'){
        $pri='high';
   }elsif($p eq 'normal'){
        $pri='medium';
   }elsif($p eq 'enhancement'){
        $class='enhancement';
        $pri='medium';
   }

   print STDERR "{class --> $class, $s --> $state, $p --> $pri} ";

   $pr{class}=$class;
   $pr{state}=$state;
   $pr{pri}=$pri;

   open HASHF, ">$fn".".hf" || die $!;
   binmode HASHF, ":utf8";
   #binmode HASHF, ":encoding(cp1250)";
   foreach $k (keys %pr){
#   	print STDERR $k,": '",$pr{$k},"'\n";
   	print HASHF $k,":",$pr{$k},"\n%%\n%%\n" if($pr{$k});
   }
   close HASHF;


sub norm_email {
   my $e = shift @_;
   my $fname;
   my $dn;
   return '' unless($e);
   return '' if($e =~ /nobody/);

   if($e =~ /<.+>/){
   	if($e =~ /^\w+\s+.*</){
   		$ne=$e;
   	}else{
   		($fname,$dn) = $e =~ /<\s*(\S+)@(\S+)\s*>/;
   		$ne="$fname <$fname@$dn>";
   	}
   }elsif($e =~ /(\S+)@\S+/){
   	$ne=$1.' <'.$e.'>';
   }
   #print STDERR "'$e' --> '$ne', ";
   return $ne;
}
