<?php
// $Header: /home/CVS/rps/project/chart_gantts.php,v 1.4 2008/05/04 00:19:13 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('../includes/db.inc');
require_once("jpgraph/jpgraph.php");
require_once("jpgraph/jpgraph_gantt.php");
require_once('includes/yoxel_jpg.inc');

if(!isset($_GET['wfid']))
	_quit_error('Improper use of the script: wfid.');

$wfid=$_GET['wfid'];

if(!isset($_GET['proj_id']))
	_quit_error('Improper use of the script: proj_id.');

$proj_id=$_GET['proj_id'];

if(!isset($_GET['mode']))
	_quit_error('Improper use of the script: mode.');

$mode=$_GET['mode'];

$suffix=$wfid.'proj'.$proj_id;

if(!isset($_SESSION['title_'.$suffix]) || !isset($_SESSION['info_'.$suffix]) || !isset($_SESSION['fix_'.$suffix]))
	_die('Please refresh your '.$wfid.' project plan.');

// Information about title (multi-phase) requests
// 0 - rid
// 1 - start_ch
// 2 -  end_ch
// 3 - synopsis
$title_info=&$_SESSION['title_'.$suffix];

// General information about the project
$proj_info=&$_SESSION['info_'.$suffix];

// Information about requests in the project
// 0 - rid: synop
// 1 - start date
// 2 - end date
// 3 - dependency shift reason (rid)
// 4 - subrequest of rid
// 5 - fixer
// 6 - fix time
// 7 - 0
// 8 - pre-adjust plan start date
$fix_info=&$_SESSION['fix_'.$suffix];

if(isset($_SESSION['test_'.$suffix]))
	$test_info=&$_SESSION['test_'.$suffix];
elseif($proj_info['state']=='test')
	_quit_error('Test info is missing.');

$ttf=YxlI18N::jpgraph_ttf();
$ttf=defined($ttf)?constant($ttf):FF_FONT0;

// A new graph with automatic size
$graph = new GanttGraph (0,0,"auto");
$graph->SetShadow();

if($mode==1)
	$graph->subtitle->Set("(Grouped-by-parent order)");
else
	$graph->subtitle->Set("(Grouped-by-priority order)");

// Add title and subtitle
if($proj_info['state']=='plan'){
	$graph->title->Set("Project/Iteration Plan ".$proj_info['label']);
}elseif($proj_info['state']=='implement'){
	$graph->title->Set("Implementation phase progress ".$proj_info['label']);
}elseif($proj_info['state']=='test'){
	$graph->title->Set("Test phase progress ".$proj_info['label']);
}
$graph->title-> SetFont($ttf,FS_NORMAL,12);

// Show day, week and month scale
$graph->ShowHeaders( GANTT_HDAY | GANTT_HWEEK | GANTT_HMONTH);
//$graph->ShowHeaders( GANTT_HWEEK | GANTT_HMONTH);

// Instead of week number show the date for the first day in the week
// on the week scale
$graph->scale->week->SetStyle(WEEKSTYLE_FIRSTDAY2WNBR);

// Make the week scale font smaller than the default
//$graph->scale->week->SetFont($ttf,FS_NORMAL,8);

// Use the short name of the month together with a 2 digit year
// on the month scale
$graph->scale->month->SetStyle(MONTHSTYLE_SHORTNAMEYEAR2);

//$graph->scale->actinfo->SetBackgroundColor('green:0.5@0.5');
//$graph->scale->actinfo->SetFont( FF_MINCHO, FS_NORMAL,10);
//$graph->scale->actinfo->vgrid->SetStyle ('solid');
//$graph->scale->actinfo->vgrid->SetColor ('gray');
//$graph->scale->actinfo->SetStyle(ACTINFO_2D);
//$graph->scale->actinfo->SetColor('navy');

//$graph->scale->divider->SetWeight(3);
//$graph->scale->divider->SetColor( "navy");
//$graph->scale->dividerh->SetWeight(3);
//$graph->scale->dividerh->SetColor( "navy");

$graph->scale->SetDateLocale('en_US.ISO8859-1');

// Construct a hash of [rid -> which requests it is blocking]
$new_order=array();
if($mode==1){
	$tmp_added=array();
	foreach(array_keys($fix_info) as $rid){
		if(isset($tmp_added[$rid])) continue;
		$a=&$fix_info[$rid];
		if($a[4]){
		// Is subrequest
			// Add title first
			array_push($new_order,array(FALSE,$a[4]));

			// Now add all subrequests
			foreach(array_keys($fix_info) as $j){
				if($fix_info[$j][4]==$a[4]){
					array_push($new_order,array(TRUE,$j));
					$tmp_added[$j]=$j;
				}
			}
		}else{
			// Add regular request
			array_push($new_order,array(TRUE,$rid));
			$tmp_added[$rid]=$rid;
		}
	}
}else{
	//print_r($fix_info);_die("<br>");
	$prev_title_rid=FALSE;
	foreach(array_keys($fix_info) as $rid){
		$a=&$fix_info[$rid];
		if($a[4] && ($a[4]!=$prev_title_rid)){
		// Is subrequest & 1st
			// Add title first
			array_push($new_order,array(FALSE,$a[4]));
			$prev_title_rid=$a[4];
		}elseif(!$a[4])
			$prev_title_rid=0;
		// Add regular request
		array_push($new_order,array(TRUE,$rid));
	}
}

// Lets build constraints
$rid2rows=array();
for($k=0;$k<count($new_order);$k++){
	// Only for regular requests/subrequests
	if(!$new_order[$k][0]) continue;

	$rid=$new_order[$k][1];
	$a=&$fix_info[$rid];
	if(!isset($rid2rows[$rid]))
		$rid2rows[$rid]=array();
	if(!isset($rid2rows[$a[3]]))
		$rid2rows[$a[3]]=array();
	if($a[3])
		array_push($rid2rows[$a[3]],$k);
}
//print_r($rid2rows);_die("<br>");


// Might want to do a safer uid2color picking later
// Use count($uids) vs. count($cn) to figure out the right step

if($mode<2){
	if($proj_info['state']=='test')
		$graph->scale->tableTitle->Set('Testing phase');
	else
		$graph->scale->tableTitle->Set('Implementation phase');
	//$graph->scale-> tableTitle-> SetFont($ttf,FS_NORMAL,12);
	$graph->scale->tableTitle->SetColor('white');
	$graph->scale->tableTitle->Show(true);

	$graph->scale->actinfo->SetColTitles (array('Request','Hrs To Go', 'Start', 'Finish'));

	$graph->scale->SetTableTitleBackground('#66789C');

	$i=0;
	foreach($new_order as $row){
		if($row[0]){
		// If regular request/subrequest
			$rid=$row[1];
			$a=&$fix_info[$rid];

			if($proj_info['state']=='test'){
				$start=date_sql2norm($test_info[$rid][1],TRUE);
				$end=date_sql2norm($test_info[$rid][2],TRUE);
			}else{
				$start=date_sql2norm($a[1],TRUE);
				$end=date_sql2norm($a[2],TRUE);
			}

			$activity = new GanttBar ($i, array(($a[4]?'   ':'').$a[0],' '.$a[6],$start,$end), $a[1], $a[2], 'F');

			$activity->title->SetFont($ttf,FS_NORMAL,8);
			$activity ->SetPattern(BAND_RDIAG, "gray");
			$activity ->SetFillColor(my_color($graph,$a[5]));

			foreach($rid2rows[$rid] as $r)
				$activity -> SetConstrain($r,CONSTRAIN_ENDSTART);

			$activity->progress->Set($a[7]);
			$graph->Add($activity);

			if(isset($a[9])){
				foreach($a[9] as $r){
					$activity = new GanttBar ($i, array('','','',''), $r[0], $r[1], '');
					$activity ->SetPattern(BAND_HVCROSS, "white");
					$activity ->SetFillColor("lightgray");
					$graph->Add($activity);
				}
			}

			if(!isset($test_info)){
				$i++;
				continue;
			}

			$b=&$test_info[$rid];

			if(!isset($tsd) || !$tsd)
				$tsd=$b[1];

			$activity = new GanttBar ($i, array('','','',''), $b[1], $b[2], 'T');

			$activity->title->SetFont($ttf,FS_NORMAL,8);
			$activity ->SetPattern(BAND_LDIAG, "blue");
			$activity ->SetFillColor (my_color($graph,$b[3]));

			$activity->progress->Set($b[5]);
			$activity->title->SetFont($ttf,FS_NORMAL,8);
			$graph->Add( $activity);

			if(isset($b[6])){
				foreach($b[6] as $r){
					$activity = new GanttBar ($i, array('','','',''), $r[0], $r[1], '');
					$activity ->SetPattern(BAND_HVCROSS, "white");
					$activity ->SetFillColor("lightgray");
					$graph->Add($activity);
				}
			}

			$i++;
		}else{
		// If task/title request
			$rid=$row[1];
			$a=&$title_info[$rid];
			$start=date_sql2norm($a[1],TRUE);
			$end=date_sql2norm($a[2],TRUE);
			$activity = new GanttBar ($i++, array($a[0],"",$start,$end), $a[1], $a[2]);

			$activity->title->SetFont($ttf,FS_NORMAL,8);
			$activity->SetPattern(BAND_RDIAG, "gray");
			$activity->SetFillColor ("yellow");
			$activity->SetHeight(4);

			$activity->rightMark->Show();
			$activity->rightMark->SetType(MARK_RIGHTTRIANGLE);
			$activity->rightMark->SetWidth(4);
			$activity->rightMark->SetColor('black');
			$activity->rightMark->SetFillColor('black');

			$activity->leftMark->Show();
			$activity->leftMark->SetType(MARK_LEFTTRIANGLE);
			$activity->leftMark->SetWidth(4);
			$activity->leftMark->SetColor('black');
			$activity->leftMark->SetFillColor('black');

			$graph->Add($activity);
		}
	}

	//if($proj_info['state']!='plan'){
		$vline = new GanttVLine(date("Y-m-j",time()), "", "darkred", 1, "dashed");
		$vline-> SetDayOffset(0.5);
		$graph->Add($vline);

		$milestone = new MileStone(++$i,array("","",""),date("Y-m-j",time()),"today");
		$milestone->mark->SetType(MARK_X);
		$graph->Add($milestone);
	//}

	$emd=date_sql2norm($proj_info['estimated_fix_end'],TRUE);
	if($proj_info['state']=='plan')
		$milestone = new MileStone(++$i,array("Planned Implementation Phase ",'','',$emd),$emd,$emd);
	else{
		$smd=date_sql2norm($proj_info['implement_start_date'],TRUE);
		$milestone = new MileStone(++$i,array("Planned Implementation Phase ",'',$smd,$emd),$emd,$emd);
	}
	$milestone->mark->SetType(MARK_X);
	$graph->Add($milestone);

	$vline = new GanttVLine($proj_info['estimated_fix_end'], "", "darkred", 1, "dashed");
	$vline-> SetDayOffset(0);
	$graph->Add($vline);

	if(isset($test_info)){
		$smd=date_sql2norm($proj_info['estimated_fix_end'],TRUE);
		$emd=date_sql2norm($proj_info['estimated_test_end'],TRUE);
		$milestone = new MileStone(++$i,array("Planned Testing Phase",'',$smd,$emd),$emd,$emd);
		$milestone->mark->SetType(MARK_X);
		$graph->Add($milestone);

		$vline = new GanttVLine($proj_info['estimated_test_end'], "", "darkred", 1, "dashed");
		$vline-> SetDayOffset(0);
		$graph->Add($vline);
	}

	$md=date_sql2norm($proj_info['proj_deadline'],TRUE);
	$milestone = new MileStone(++$i,array("Project/Iteration Deadline ",'','',$md),$md,$md);
	$milestone->mark->SetType(MARK_X);
	$graph->Add($milestone);

	$vline = new GanttVLine($proj_info['proj_deadline'], "", "darkred", 1, "dashed");
	$vline-> SetDayOffset(0.5);
	$graph->Add($vline);

	//if($proj_info['state']=='plan'){
		$uid2row=array();
		$i++;$i++;

		$milestone = new MileStone($i++,
			array("--------- Resource Load ---------","","",""), date("Y-m-j 9:00", time()));
		$milestone->mark->Show(0);
		$graph->Add($milestone);

		foreach(array_keys($fix_info) as $rid){
			$a=&$fix_info[$rid];

			if($a[8]){
				if(!isset($uid2row[$a[5]]))
					$uid2row[$a[5]]=$i++;

				$activity = new GanttBar ($uid2row[$a[5]], YxlUsers::name($a[5]), $a[8], $a[2]);

				$activity->title->SetFont($ttf,FS_NORMAL,8);
				$activity ->SetPattern(BAND_RDIAG, "gray");
				$activity ->SetFillColor (my_color($graph,$a[5]));
				$graph->Add($activity);
			}

			if(!isset($test_info))
				continue;

			$b=&$test_info[$rid];

			if($b[1] != $b[2]){
				if(!isset($uid2row[$b[3]]))
					$uid2row[$b[3]]=$i++;

				$activity = new GanttBar ($uid2row[$b[3]],YxlUsers::name($b[3]), $b[1], $b[2]);

				$activity->title->SetFont($ttf,FS_NORMAL,8);
				$activity ->SetPattern(BAND_LDIAG, "blue");
				$activity ->SetFillColor (my_color($graph,$b[3]));
				$graph->Add($activity);
			}


		}

		foreach(array_keys($uid2row) as $u){
			if(!isset($proj_info['time_off'][$u]))
				continue;

			foreach($proj_info['time_off'][$u] as $r){
				$activity = new GanttBar ($uid2row[$u], array('','','',''), $r[0], $r[1], '');
				$activity ->SetPattern(BAND_HVCROSS, "white");
				$activity ->SetFillColor("lightgray");
				$graph->Add($activity);
			}
		}
	//}
}
/*
elseif($mode==2){
	$graph->scale->actinfo->SetColTitles (array('Request','Planned Start', 'Planned Finish'));
	$graph->scale->tableTitle->Set('Implementation phase');
	$graph->scale->SetTableTitleBackground('#66789C');
	$graph->scale->tableTitle->SetColor('white');
	$graph->scale->tableTitle->Show(true);

	$i=0;
	foreach($new_order as $row){
		if($row[0]){
		// If regular request/subrequest
			$rid=$row[1];
			$a=&$fix_info[$rid];

			$start=explode(' ',$a[1]);$start=date_sql2norm($start[0],TRUE);
			$end=explode(' ',$a[2]);$end=date_sql2norm($end[0],TRUE);
			$activity = new GanttBar ($i, array(($a[4]?'   ':'').$a[0],$start,$end), $a[1], $a[2], YxlUsers::['un'][$a[5]]);

			$activity->title->SetFont($ttf,FS_NORMAL,8);
			$activity ->SetPattern(BAND_RDIAG, "gray");
			$activity ->SetFillColor(my_color($graph,$a[5]));

			foreach($rid2rows[$rid] as $r)
				$activity -> SetConstrain($r,CONSTRAIN_ENDSTART);
			$activity->progress->Set($a[7]);
			$graph->Add($activity);
			$i++;
		}else{
		// If task/title request
			$rid=$row[1];
			$a=&$title_info[$rid];
			$start=explode(' ',$a[1]);$start=date_sql2norm($start[0],TRUE);
			$end=explode(' ',$a[2]);$end=date_sql2norm($end[0],TRUE);
			$activity = new GanttBar ($i++, array($a[0],$start,$end), $a[1], $a[2]);

			$activity->title->SetFont($ttf,FS_NORMAL,8);
			$activity->SetPattern(BAND_RDIAG, "yellow");
			$activity->SetFillColor ("black");
			$activity->SetHeight(4);

			$activity->rightMark->Show();
			$activity->rightMark->SetType(MARK_RIGHTTRIANGLE);
			$activity->rightMark->SetWidth(4);
			$activity->rightMark->SetColor('black');
			$activity->rightMark->SetFillColor('black');

			$activity->leftMark->Show();
			$activity->leftMark->SetType(MARK_LEFTTRIANGLE);
			$activity->leftMark->SetWidth(4);
			$activity->leftMark->SetColor('black');
			$activity->leftMark->SetFillColor('black');

			$graph->Add($activity);
		}
	}

	//$vline = new GanttVLine( $proj_info['estimated_fix_end'], "Fix Phase", "darkred",1,"dotted" );
	$vline = new GanttVLine( date("Y-m-j",time()), "", "darkred", 1, "dashed");
	$vline-> SetDayOffset(0.5);

	$graph->Add($vline);

	$milestone = new MileStone(++$i,array("","",""),date("Y-m-j",time()),"today");
	$milestone->mark-> SetType(MARK_X);
	$graph->Add($milestone);

	$milestone = new MileStone(++$i,array("Estimated end of implementation",'',date_sql2norm($proj_info['estimated_fix_end'],TRUE)),date_sql2norm($proj_info['estimated_fix_end'],TRUE),date_sql2norm($proj_info['estimated_fix_end'],TRUE));
	$milestone->mark-> SetType(MARK_X);
	$graph->Add($milestone);
}
*/


// Display the Gantt chart
if($proj_info['state']=='plan')
	$graph->SetDateRange(date("Y-m-j",time()-2*SECS_IN_DAY),$proj_info['gantts_limit']);
else
	$graph->SetDateRange(date("Y-m-j",time()-7*SECS_IN_DAY),$proj_info['gantts_limit']);

$graph->Stroke();
?>
