<?php

$_help['sw']['rps']['hdr']='RPS';

$_help['sw']['rps_status']['hdr']='RPS: SUMMARY';
$_help['sw']['rps_status']['msg']= '
<p>This page lists all your software releases by product.
</p>
<p>You can start a new release, check progress of an ongoing release or generate reports for finished releases. Please click on highlithed items to proceed.
</p>';

$_help['sw']['rps_new']['hdr']='RPS: NEW RELEASE';

$_help['sw']['rps_plan']['hdr']='RPS: RELEASE PLANNING';
$_help['sw']['rps_plan']['msg']= "
<p>Forming a release plan in Yoxel is a collaborative process that is why at
the release creation step your release owner (product manager or Scrum Master)
usually assigns a few people, release members, to help him with that.
Release members can add requests to the plan, remove requests from the plan,
specify their priority votes, modify resource allocation, ... The release owner has
additional privilege to override the automatically computed priority (which is based on the
combined votes from the release members) with its own.</p>

<p>The important plan modifications are captured in release history log.
Switch to the history panel to see what other release members have done already
and comment on any release related activity that interests you.
</p>

<p>The recommended sequence of actions for each release member that visits
this plan page is the following:
<ol>
  <li>Read the description of the release goals. The very first record
  in the release history log will show you the release goal/objective.</li>
  <li>With that objective in mind review the current plan and add any important
  requests that are missing. You can add a new request if there is none yet
  in the backlog.</li>
  <li>Vote your priority. For each request in the plan express your personal
  opinion of what the priority should be, in the context of the current release goals.
  The priority votes are used to do preliminary sorting of the items in the plan,
  they also help all release members to see other member's opinion
  (use 'show details' mode and click on 'members vote' link).</li>
  <li>The release owner has special order setting privilegies. After he has entered
  all his votes the system automatically switches into 'manual voting' mode which means
  that automatic ordering based on the combined members vote is not applied
  anymore. From now on the release owner decides on the exact order of the requests
  in the plan. He can always sort the requests according to the combined vote
  by clicking on 'apply voted order'+[update] but the purpose of this
  mode is to be able to fine tune the exact 1,2,3,4,... order.
  It is his responsibility to know which items in the plan are the
  'must have' requests for the release and which ones he could possibly
  remove later.</li>
  <li>The priorities entered by release members start to shape up
  the best order for the requests in your plan. At this point start
  inputting effort estimates. Usually your R&D and QA teams will
  have to get involved in the process and enter their estimates
  for each of the requests.</li>
  <li>It is always a good idea to have representatives from your
  R&D, QA, support teams, marketing (CTO, Director of R&D/QA, Managers)
  as your release members in addition to a product manager. Let the
  R&D and QA release members be the judges of the resource allocation.
  By default, Yoxel tries to balance the resource load automatically
  but more often it is the case that the managers know the best
  who will/should be doing what. Agile teams that do not like
  the idea of resource allocation at this stage, can use the automatic
  balancing and ignore the actual names listed.</li>
  <li>Use 'time sharing' section/menu if you are in the situation
  when the same resources are working on several projects
  for different products or if you have learnt from your previous iterations
  that certain % of their time they always spend on other,
  unrelated to the project tasks.</li>
  <li>As your plan fills with the estimates start paying more attention
  to the details of the plan ('show details') and Gantt charts.
  Look for the requests that are <span class='fade_n_cross'>crossed</span>
  (Yoxel thinks these are not making it into the release). Is that
  an important, not a 'must have' request, may be it is ok to remove
  it from the current plan? See if its estimate is reasonable
  (or entered at all). See if you can balance the resource allocation better.
  May be the release deadline should be adjusted. You can always
  collaborate with other release members by posting your comments
  in the release history log.</li>
  <li>Pay attention to warning messages in red and green that Yoxel gives you.
  Try to resolve those, use reminders. Allow some time to converge
  on a final plan with reasonable resource allocation and time table.
  Once all release members are in agreement, the release owner can save
  the plan and start the release implementation phase!</li>
</ul>
</p>";


$_help['sw']['rps_ts']['hdr']='RPS: TIME SHARING';
$_help['sw']['rps_ts']['msg']= "
<p>Time sharing settings help you more accurately model situations when your release
resources work on more than one project simultaneously or some of their time
is allocated to certain activity unrelated to any project (like handling
critical/unexpected customer requests or working part time).
</p>

<p>For each resource listed you simply need to specify what % of his/her
time he/she usually spends on release work related to each product.
</p>

<p>You have a chance to change the settings only during a release planning phase.
</p>
";

$_help['sw']['rps_history']['hdr']='RPS: HISTORY LOG';
$_help['sw']['rps_history']['msg']= "
<p>The history log captures important activity and collaboration
related to your release work.
</p>
<p>When you add comments or ask questions a notification email is sent to selected
release members with a link to this page.
</p>";

$_help['sw']['rps_estimate']['hdr']='RPS: ESTIMATE';
$_help['sw']['rps_estimate']['msg']= '<p>If you are assigned to implement or test
a request please enter estimated time it may take you to do it.
This information is used by release planner/tracker. The more accurate
information you enter here the more efficient the release planning session will be.</p>';

$_help['sw']['rps_track']['hdr']='RPS: RELEASE TRACKING';
$_help['sw']['rps_track']['msg']= "
<p>Release tracking is a very important capability that allows all members of your team
to monitor project progress in real time, and collaborate. Any time a developer or a tester
changes status of his/her request (fixed, % completeness, verified, more_info)
the release tracker updates the project summary and re-computes its timetable.</p>
<p>The automatic re-computation of the timetable for the remaining part of the project
(for not completely implemented or tested requests) allows you to predict when the
project may be finishing.
</p>
<p>The recommended usage of the tracker is the following:
  <ul>
  <li>Visit this page regularly. For each release item in the list Yoxel shows
originally planned start and finish dates. Yoxel always compares planned start/finish
dates vs. actual start/finish dates and highlights in red those items that
do not behave as planned (work has not started yet as planned / work has not finished yet as planned).</li>
  <li>For any release item highlighted in red take appropriate action to find out
what is going on. Click on the item to get a detailed description of the request and check
if the developer/tester added any comments recently. Contact the developer/tester/manager directly
or discuss these requests in an appropriate meeting. Unless the release priorities have changed
you should try to stick with the original plan.</li>
  <li>Check Gantts charts to see what Yoxel thinks of the project finish date. Is that acceptable?</li>
  <li>Use release history log panel to collaborate with other release members
on topics related to the project.</li>
  <li>At some point you may be in a situation when it is pretty clear that
some of the requests can not meet your planned deadline. At this point it is
your judgment call whether to de-commit the remaining items or violate
the release deadline. Most common practice is to continue release work
until all 'must have' requests are done and de-commit the rest.</li>
  </ul>
</p>
<p>Yoxel allows you to track the release work over multiple project phases.
The default project template assumes two phase approach for software release: planning
and tracking. The two phases are 'implementation' and 'testing/acceptance'. Although
the assumption is that release testing phase will start after implementation phase is done
(after code freeze) this should not worry you because as a release
member you can move the tracking to the testing phase any time you like.
Such a two phase approach is used to be a little more conservative during
prediction of remaining release work. Many development teams do actually
start system testing after their initial code freeze.
</p>
<p>So once your implementation is done or you have decided to start the testing phase
anyway you can move to tracking your testing/acceptance phase. At this point your
QA should get heavily involved unless they have not done that yet. The tracking panel
will look the same only the comparison of planned start/finish vs. actual start/finish
dates will be for the testing work instead of implementation.
</p>
<p>Once your testing phase has finished you will be able to officially finish
the release and mark it as 'done'. Yoxel will take you to a summary/statistics
page where you should spend some time looking at the numbers that will help you
plan your next release better.
</p>";

$_help['sw']['rps_done']['hdr']='RPS: RELEASE STATISTICS';
$_help['sw']['rps_done']['msg']= "<p>The statistics gathered for a release
can be extremely useful to better understand capabilities and specifics
of your team, and to create a more realistic plan for the next releases.
This summary page can also be useful in creating your release notes,
it lists which requests have made it into the release (including ones
that have not been planned).
</p>
<p>Here is how we recommend you to use this page:
  <ul>
  <li>Look through all originally scheduled requests. These are the ones for which your
team members entered their estimates during planning phase. Examine 'e/a' columns,
these are 'estimated vs. actual' work hours. If possible make sure everyone has entered
their actual numbers and they make sense (enter perfect work hours). As a manager you
may override some of these.</li>
  <li>For the items where estimated is very different from actual check with your
developer/tester to understand why. That will be useful for the future projects.</li>
  <li>Now, scroll to the bottom and examine per developer/tester statistics:
     <ol>
	<li>planned/done - how many items were assigned to a person and how many he/she has done</li>
	<li>avg e/a hrs - on average, how many hours per task he/she estimated and
how long it actually took. This might help your members estimate better in the future.</li>
	<li>reported/total hrs - how many hours a developer/tester worked during the release.
	This might be useful in determining % of time your resource actually spent on planned project requests (we call this % ?time share?) vs. other unplanned stuff. Reported numbers that are higher than total may indicate overtime work or incorrect reporting.</li>
    </ol>
  </li>
  <li>Examine those statistics averaged (over all developers/testers): planned/done, e/a hrs, reported/total hrs. Next time you are starting a new release in Yoxel you can drive the preliminary plan generator better with these.</li>
</ul>
</p>";

?>
