<?php
// $Header: /home/CVS/rps/rps/rps_remind.php,v 1.10 2007/09/21 05:23:24 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

	$hide_header=TRUE;
	require_once('../includes/db.inc');
	require_once('includes/rps/rps.inc');
	include_once('includes/header.inc');

	if($is_customer)
		_quit_error("You are not allowed to use this part of the site.");

	if(isset($_GET['proj_id']))
		$proj_id=$_GET['proj_id'];
	else
		_quit_error('Project id is not specified.');

	if(isset($_GET['type']))
		$type=$_GET['type'];
	else
		_quit_error('Riminder type is not specified.');

	if(isset($_GET['uid']))
		$ruid=$_GET['uid'];
	else
		$ruid=FALSE;

	$pl = simple_query("SELECT CONCAT(p.name,'/',r.label) FROM releases AS r, products AS p WHERE r.rel_id='$proj_id' AND r.pid=p.pid");
	if(!$pl)
		_die2(__FILE__.':'.__LINE__.' Could not select from releases table.');

	init_users();
	$rps= new ReleasePlan($proj_id);
	switch($_GET['type']){
		case REMIND_MEMPRI:
			$Subject = "Please set your priorities for the release.";
			$uid2rids=&$rps->members_without_vote($ruid?array($ruid):FALSE);
			foreach (array_keys($uid2rids) as $u) {
				$pr_list_str=implode(', ',$uid2rids[$u]);
				$To=$all_users_2d['name'][$u].' <'.$all_users_2d['email'][$u].'>';
				$mail= 'Hello '.$all_users_2d['name'][$u].",\n\n".
				"  The release plannig phase for $pl is under way and you are one of the release members. You have not yet specified your opinion regarding priorities of the following requests:\n\t\t$pr_list_str\n\n".
				"  Please do so at your earliest convenience by following the link below\n".
				"  \t".$https_path."/rps/rps_plan.php?proj_id=$proj_id\n\n";
				yxl_mail($To, $Subject, format_text($mail.$rps->proj_m_sign), $rps->mail_headers);
				echo '<pre>Sending email to '.$all_users_2d['email'][$u].'</pre>';
				echo '<pre>'.format_text($mail.$rps->proj_m_sign).'</pre>';
			}
			break;
		case REMIND_NOFET:
			$Subject = "Please estimate your effort to implement requests.";
			$rps->init_fixers();
			$rps->init_ets();
			$uid2rids=&$rps->rids_wihtout_any_estimate(1,$ruid?array($ruid):FALSE);
			foreach (array_keys($uid2rids) as $u){
				$pr_list_str=implode(', ',$uid2rids[$u]);
				$cgi_pr_list_str=implode(':',$uid2rids[$u]);
				$To=$all_users_2d['name'][$u].' <'.$all_users_2d['email'][$u].'>';
				$mail= 'Hello '.$all_users_2d['name'][$u].",\n\n".
				"  The release plannig phase for $pl is under way and you are one of the developers. You have not yet estimated your effort for the following requests:\n\t\t$pr_list_str\n\n".
				"  Please do so at your earliest convenience by following the link below:\n".
				"  \t".$https_path."/rps/rps_estimate.php?rid=$cgi_pr_list_str\n\n";
				yxl_mail($To, $Subject, format_text($mail.$rps->proj_m_sign), $rps->mail_headers);
				echo '<pre>Sending email to '.$all_users_2d['email'][$u].'</pre>';
				echo '<pre>'.format_text($mail.$rps->proj_m_sign).'</pre>';
			}
			break;
		case REMIND_NOTET:
			$Subject = "Please estimate your effort to test requests.";
			$rps->init_testers();
			$rps->init_ets();
			$uid2rids=&$rps->rids_wihtout_any_estimate(2,$ruid?array($ruid):FALSE);
			foreach (array_keys($uid2rids) as $u){
				$pr_list_str=implode(', ',$uid2rids[$u]);
				$cgi_pr_list_str=implode(':',$uid2rids[$u]);
				$To=$all_users_2d['name'][$u].' <'.$all_users_2d['email'][$u].'>';
				$mail= 'Hello '.$all_users_2d['name'][$u].",\n\n".
				"  The release plannig phase for $pl is under way and you are one of the testers. You have not yet estimated your effort for the following requests:\n\t\t$pr_list_str\n\n".
				"  Please do so at your earliest convenience by following the link below:\n".
				"  \t".$https_path."/rps/rps_estimate.php?rid=$cgi_pr_list_str\n\n";
				yxl_mail($To, $Subject, format_text($mail.$rps->proj_m_sign), $rps->mail_headers);
				echo '<pre>Sending email to '.$all_users_2d['email'][$u].'</pre>';
				echo '<pre>'.format_text($mail.$rps->proj_m_sign).'</pre>';
			}
			break;
		case REMIND_FET:
			$Subject = "Please complete implementation effort estimation.";
			$rps->init_fixers();
			$rps->init_ets();
			$uid2rids=&$rps->users_wihtout_rid_estimate(1,$ruid?array($ruid):FALSE);
			foreach (array_keys($uid2rids) as $u){
				$pr_list_str=implode(', ',$uid2rids[$u]);
				$cgi_pr_list_str=implode(':',$uid2rids[$u]);
				$To=$all_users_2d['name'][$u].' <'.$all_users_2d['email'][$u].'>';
				$mail= 'Hello '.$all_users_2d['name'][$u].",\n\n".
				"  The release plannig phase for $pl is under way and you are one of the possible developers. The Release Planning System needs your effort estimations to do more accurate planning. Please enter your estimates for the following requests:\n\t\t$pr_list_str\n\n".
				"  You may do it at your earliest convenience by following the link below:\n".
				"  \t".$https_path."/rps/rps_estimate.php?rid=$cgi_pr_list_str\n\n";
				yxl_mail($To, $Subject, format_text($mail.$rps->proj_m_sign), $rps->mail_headers);
				echo '<pre>Sending email to '.$all_users_2d['email'][$u].'</pre>';
				echo '<pre>'.format_text($mail.$rps->proj_m_sign).'</pre>';
			}
			break;
		case REMIND_TET:
			$Subject = "Please complete test effort estimation.";
			$rps->init_testers();
			$rps->init_ets();
			$uid2rids=&$rps->users_wihtout_rid_estimate(2,$ruid?array($ruid):FALSE);
			foreach (array_keys($uid2rids) as $u){
				$pr_list_str=implode(', ',$uid2rids[$u]);
				$cgi_pr_list_str=implode(':',$uid2rids[$u]);
				$To=$all_users_2d['name'][$u].' <'.$all_users_2d['email'][$u].'>';
				$mail= 'Hello '.$all_users_2d['name'][$u].",\n\n".
				"  The release plannig phase for $pl is under way and you are one of the possible testers. The Release Planning System needs your effort estimations to do more accurate planning. Please enter your estimates for the following requests:\n\t\t$pr_list_str\n\n".
				"  You may do it at your earliest convenience by following the link below:\n".
				"  \t".$https_path."/rps/rps_estimate.php?rid=$cgi_pr_list_str\n\n";
				yxl_mail($To, $Subject, format_text($mail.$rps->proj_m_sign), $rps->mail_headers);
				echo '<pre>Sending email to '.$all_users_2d['email'][$u].'</pre>';
				echo '<pre>'.format_text($mail.$rps->proj_m_sign).'</pre>';
			}
			break;
		default:
			break;
	}
	echo '
	<br><br><br>
	<center>
	<p>
	<form>
		<input type="button" class="btn_large" value="  CLOSE WINDOW  " onClick="window.close();">
	</form>
	</p>
	</center>';

	include_once('includes/footer.inc');
?>
