<?php
// $Header: /home/CVS/rps/rts/bts_charts.php,v 1.20 2008/03/03 21:01:17 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('../includes/db.inc');
require_once('includes/rts/bts.inc');
require_once('includes/params/user_filters.inc');
include_once('includes/header.inc');

  $rts = new BugTracker();
  $pqs_2d=&$rts->products_2d;

  $chtype=array(
  	1 => array('name' => 'Pie',
  	'sub_types_title' => 'Pie Slice Types',
  	'sub_types' => array(
		'pid' => array(
			'name' => 'Product/Component',
			'values' => &$pqs_2d['name'],
			'one_level' => 'IF(c.parent=0,c.pid,c.parent)'),
		'customer_pri' => array(
			'name' => 'Customer Urgency',
			'values' => &$pri2str),
		'state' => array(
			'name' => 'Request State',
			'values' => &$rts->state2str),
		'class' => array(
			'name' => 'Request Class',
			'values' => &$rts->class2str),
		)
  	),

  	2 => array('name' => 'Line over time',
  	'sub_types_title' => 'Weekly Statistics',
  	'sub_types' => array(
		'opened_weekly' => array(
			'name' => 'Requests Opened',
			'end_date' => 'reg_date'),
		'fixed_weekly' => array(
			'name' => 'Requests Fixed',
			'end_date' => 'fixed_date'),
		'verified_weekly' => array(
			'name' => 'Requests Verified',
			'end_date' => 'verified_date'),
		'opened_total' => array(
			'name' => 'Total Requests Opened',
			'end_date' => 'reg_date',
			'total' => TRUE),
		'fixed_total' => array(
			'name' => 'Total Requests Fixed',
			'end_date' => 'fixed_date',
			'total' => TRUE),
		'verified_total' => array(
			'name' => 'Total Requests Verified',
			'end_date' => 'verified_date',
			'total' => TRUE),
		'unfixed_weekly' => array(
			'name' => 'Backlog rate of unfixed requests',
			'end_date' => 'reg_date',
			'minus_end_date' => 'fixed_date'),
		'unfixed_backlog' => array(
			'name' => 'Backlog of unfixed requests',
			'end_date' => 'reg_date',
			'minus_end_date' => 'fixed_date',
			'total' => TRUE)
		)
	)
  );


  $wfid=$rts->wfid();
  $filters=new UserFilters($wfid);
  $fls=$filters->get_filters();
  $fls[0]='<No Filter, All Requests>';

  $ccid=$wfid.'/charts';
  $configs=new UserFilters($ccid,"MY LAST CHART");
  $cnfgs=$configs->get_filters();
  $last_cnfg=&$configs->get_last_filter($lcid);

  $chart_type=$last_cnfg->pget('chart_type');
  foreach(array_keys($chtype) as $chtk)
  	$ch_sub_fils[$chtk]=explode(',',$last_cnfg->pget('chart_subtype'.$chtk));

  if(isset($_POST['saveConfig'])){
	if($_POST['fcid'])
		$configs->update_filter_from_id($_POST['fcid'],$lcid);
	elseif(is_synopsis($_POST['new_config']) && $lcid)
		$ncid=$configs->create_filter_from_id($lcid,$_POST['new_config']);
	header("Location: ".$_SERVER['PHP_SELF']."?cnfgid=$ncid");
        exit;
  }

  if(isset($_POST['which_chart']) && $_POST['which_chart']){
	$chart_type=$_POST['which_chart'];
	$ch_sf=$_POST['ch_subtype'.$chart_type];
	$last_cnfg->pset('chart_type',$chart_type);
	$last_cnfg->pset('chart_subtype'.$chart_type,$ch_sf);

	$a=explode(',',$ch_sf);
	$b=array();
	while($sf=array_pop($a)){
		//echo "$sf <br>\n";
		$c=explode(':',$sf);
		if(count($c)!=2) continue;
		arr_push($b,$c[1]);
	}
	$last_cnfg->save($b);
	header("Location: ".$_SERVER['PHP_SELF']."?cnfgid=$lcid");
        exit;
  }
?>

<?php
  if(isset($_GET['cnfgid'])){
	$cid=$_GET['cnfgid'];
	if(!$cid)
  		$fcnfg=&$configs->get_last_filter($cid);
	else
		$fcnfg=&$configs->get_filter_by_id($cid);
  	$chart_type=$fcnfg->pget('chart_type');
  	$ch_fils=explode(',',$fcnfg->pget('chart_subtype'.$chart_type));
	$_SESSION[$ccid.'/sub_types'.$chart_type]=$chtype[$chart_type]['sub_types'];
	$_SESSION[$ccid.'/ch_subtype'.$chart_type]=$ch_fils;
	$_SESSION[$ccid.'/sql_fw']=$rts->request_query_sqlstr_fw(FALSE);
?>

<script language='JavaScript'>
<!--

function cntrl_inp(form){
	if(form.fcid.selectedIndex){
		form.new_config.disabled=true;
		form.new_config.style.visibility="hidden";
	}else{
		form.new_config.disabled=false;
		form.new_config.style.visibility="visible";
	}
}

function go(form) {
	if(!form.fcid.selectedIndex){
		if (text_check(form.new_config))
                	return alert("Please, enter new configuration name.");
	}

        form.submit();
        disable_form(form);
}

//-->
</script>

<form action='<?php echo $_SERVER['PHP_SELF']; ?>' method='post'>
<input type='hidden' name='saveConfig' value='saveConfig'>
<table border="0" cellpadding="1" cellspacing="1" width="90%" class="dgray" align="center">
<tr class="lgray">
        <td colspan="<?php echo $colspan; ?>" align="right">
        <input class="wbtn" type="button" value="Refine Chart" onClick="document.location='<?php echo $_SERVER['PHP_SELF']; ?>'" />
        <input class="wbtn" type="button" value="Save As" onClick='go(this.form);' />
        <select class="selec" style="width: 20em" name="fcid" onChange="cntrl_inp(this.form);">
                <option value="0">=NEW CONFIGURATION=</option>
<?php


        foreach($cnfgs as $fid => $s){
        	if(!$configs->is_rw($fid))
        		continue;
                echo '
                <option value="'.$fid.'">'.html_safe_text($s).'</option>';
	}

?>

        </select>
        <input class="inp" type="text" name="new_config" value="" size="32" maxlength="127" />&nbsp;&nbsp;&nbsp;
        [<a href="javascript:filters_open('<?php echo $ccid; ?>')">Manage Saved Configurations</a>]
	</td>
</tr>

<?php

  if(isset($_SESSION[$ccid.'/sub_types'.$chart_type]))
    switch($chart_type){
	case 1:
		foreach($ch_fils as $tf){
			$a=explode(':',$tf);
			echo '
<tr class="lgray">
	<td align="center">
	<img src="'.$dir_name.'/rts/chart_pie.php?rts_type='.$ccid.'&slice='.$a[0].'&fid='.$a[1].'">
	</td>
</tr>';
		}
		break;
	case 2:
		echo '
<tr class="lgray">
	<td align="center">
	<img src="'.$dir_name.'/rts/chart_line.php?rts_type='.$ccid.'">
	</td>
</tr>';
		break;
	default:
		break;

    }
		echo '
</table>
</form>';
	include_once('includes/footer.inc');
        exit;
  }

?>

<div id="modalLayer" style="position:absolute; top:0; width:100%; height:100%; z-index:100; visibility:hidden;">
  <div id="ConBox" style="position:absolute; width:400px; background: #E0E0E0; border:2px outset">
  <h3 style="text-align:left; background:#C0C0C0">Please, select a filter to apply:</h3>
  <div style="text-align:center">
	<form name="conf">
	<input type="hidden" name="chtype" value="<?php echo $chart_type; ?>">
	<select name="ch_filter" class="selec" style="width: 20em" onChange="HideModal(this.form)">
		<option value="" selected>=Pick a Filter=</option>
<?php
	foreach($fls as $f => $n)
		echo '
		<option value="'.$f.'">'.html_safe_text($n).'</option>';
?>
	</select>
	</form>
  </div>
  </div>
</div>

<script language='JavaScript'>
<!--

function chtype_change(form, preserve_fcid){
	var chid=form.chart_type.options[form.chart_type.selectedIndex].value;
	if ((arguments.length <2) || !preserve_fcid)
		form.fcid.selectedIndex = 0;
<?php
	foreach(array_keys($chtype) as $chtk)
		echo '
	document.getElementById("chtk" + '.$chtk.').style.display="none";
		';
?>
	if(chid<1)
		return;
	document.getElementById("chtk" + chid).style.display='';

	if(form.elements["__ch_subtype" + chid].options.length>0){
		form.elements["draw" + chid].style.visibility="visible";
		form.elements["draw" + chid].disabled=false;
	}else{
		form.elements["draw" + chid].style.visibility="hidden";
		form.elements["draw" + chid].disabled=true;
	}
}

function form_set_filter(form,fid){
<?php
	foreach($cnfgs as $cid => $cname){
		$c=&$configs->get_filter_by_id($cid);
		if(!($chtk=$c->pget('chart_type')))
			continue;
		echo '
	if(fid=='.$cid.'){
	/* Config \''.$cname.'\' */
		form.chart_type.selectedIndex='.$chtk.';';
		$sfs=explode(',',$c->pget('chart_subtype'.$chtk));
        	for($i=0;$i<count($sfs);$i++){
        		$a=explode(':',$sfs[$i]);
        		if((count($a)<2) || !isset($fls[$a[1]]))
        			continue;
        		$str=$fls[$a[1]];
			echo '
		form.__ch_subtype'.$chtk.'.options['.$i.']=new Option("'.$chtype[$chtk]['sub_types'][$a[0]]['name'].' : ['.$str.']","'.$sfs[$i].'",false,false);';
		}
		echo '
		chtype_change(form,true);
	}';
	}
?>

}

function go(form, what){
	if(what == 'pick'){
		i=form.fcid.selectedIndex;
		if(!i)
			return;
		form_clear(form);
		form.fcid.selectedIndex = i;
		form_set_filter(form,form.fcid.options[i].value);
		return;
	}else if(what != 'draw')
		return;

	var chid=form.chart_type.options[form.chart_type.selectedIndex].value;

	if(!chid)
		return alert('Please select chart type.');
        form.which_chart.value=chid;
        collect_all(form);
        form.submit();
        disable_form(form);
}

function CenterContent(){
	if( typeof window.innerWidth  == 'number' ) {
                pageW = window.innerWidth;
                pageH = window.innerHeight;
	}else if(document.documentElement && document.documentElement.clientWidth ) {
               pageW = document.documentElement.clientWidth;
               pageH = document.documentElement.clientHeight;
	}else{
               pageW = document.body.clientWidth;
               pageH = document.body.clientHeight;
	}
	boxW = document.getElementById("ConBox").offsetWidth;
	boxH = document.getElementById("ConBox").offsetHeight;

          document.getElementById("modalLayer").style.height = (pageH - 20) + "px";
          placeW = Math.floor((pageW - boxW)/2) + "px";
          placeH = Math.floor((pageH - boxH)/2) + "px";
          document.getElementById("ConBox").style.left = placeW;
          document.getElementById("ConBox").style.top = placeH;
}

function ShowModal(chtk){
	/* document.getElementById("message").innerHTML=mess; */
	document.getElementById("modalLayer").style.visibility="visible";
	document.getElementById("ConBox").style.visibility="visible";
	document.forms['conf'].chtype.value=chtk;
	document.forms['conf'].ch_filter.selectedIndex=0;
	document.forms['conf'].ch_filter.focus();
	CenterContent();
}

function HideModal(form){
	if(form.ch_filter.selectedIndex<1)
		return;
	document.getElementById("modalLayer").style.visibility="hidden";
	document.getElementById("ConBox").style.visibility="hidden";
	my_sel_add(form.chtype.value);
	chtype_change(document.forms['chart']);
}

function my_sel_add(chtk){
	tt=document.forms['conf'].ch_filter;
	sel_add(document.forms['chart'].elements['_ch_subtype' + chtk][0],tt.options[tt.selectedIndex].value,'[' + tt.options[tt.selectedIndex].text + ']');
}

function form_clear(form){
        var i, el;

        for (i = 0; i < form.length; i++){
                el = form.elements[i];

                if (el.type == 'text')        el.value = '';
                if (el.name.charAt(0) == '_') el.selectedIndex = -1;
                if (el.name.substr(0, 2) == '__') el.options.length = 0;
        }
        chtype_change(form);
}

//-->
</script>

<form name="chart" action="<?php echo $_SERVER['PHP_SELF']; ?>" method="POST">
<input type="hidden" name="which_chart" value="<?php echo $chart_type;?>">
<input type='hidden' name='fid' value='0'>
<table border='0' cellpadding='1' cellspacing='1' width='90%' class=dgray align="center">
<tr class="lgray" valign="top">
        <td>
        <strong>LOADED CHART CONFIGURATION:</strong>
        <select class="selec" style="width: 30em" name="fcid" onChange="go(this.form,'pick')">
                <option value="0">=PICK A CONFIGURATION=</option>
<?php


        foreach($cnfgs as $fid => $s)
                echo '
                <option value="'.$fid.'"'.($fid==$lfid?' selected':'').'>'.html_safe_text($s).'</option>';

?>

        </select>

        </td>
        <td align="right">
                [<a href="<?php echo $dir_name; ?>/rts/rts_manage_filters.php?wfid=<?php echo $ccid; ?>" target="_filters" onClick="filters_open('<?php echo $ccid; ?>')">Manage Saved Configurations</a>]
        </td>
</tr>
<tr style='height: 1' class='separator'>
 <td colspan=2></td>
</tr>

<tr>
	<th colspan=2>Chart:
	<select name="chart_type" class="selec" onChange="chtype_change(this.form)">
		<option value="0">=Select Chart Type=</option>
<?php
		foreach(array_keys($chtype) as $chtk)
			echo '
		<option value="'.$chtk.'"'.($chtk==$chart_type?' selected':'').'>'.$chtype[$chtk]['name'];
?>
	</select>
        </th>
</tr>
<?php
	foreach(array_keys($chtype) as $chtk){
		$subtypes=&$chtype[$chtk]['sub_types'];
		echo '
<tr class=lgray id="chtk'.$chtk.'"'.($chtk==$chart_type?'':' style="display:none;"').'>
<td colspan=2>
<table width="100%" border=0 cellpadding=1 cellspacing=1 class=dgray>
	<tr class="lgray">
		<th>'.$chtype[$chtk]['sub_types_title'].'</th>
		<td align="center"><input class="wbtn" type="button" value="Clear" onClick="form_clear(this.form)" /></td>
		<th>'.$chtype[$chtk]['sub_types_title'].' : [Filter]</th>
	</tr>
	<tr class="lgray">
	<td align="center">
		<input type="hidden" name="ch_subtype'.$chtk.'" value="">
		<select name="_ch_subtype'.$chtk.'" size=10 class="selec" style="width:40em" onChange="ShowModal('.$chtk.');">';
		foreach(array_keys($subtypes) as $stk)
			echo '
		<option value="'.$stk.'">'.$subtypes[$stk]['name'].'</option>';
		echo '
		</select>
	</td>
	<td align="center">
		<input type="button" class="wbtn" value="Add >>" disabled><br>
		<input type="button" name="_ch_subtype'.$chtk.'" class="wbtn" value="<< Delete" onClick="sel_del(this); chtype_change(this.form);"><br>
	</td>
	<td align="center">
		<select name="__ch_subtype'.$chtk.'" size=10 class="selec" style="width:40em">';

		foreach($ch_sub_fils[$chtk] as $tf){
			$a=explode(':',$tf);
			if((count($a)!=2) || !isset($fls[$a[1]])) continue;
			//print_r($a);
			echo '
		<option value="'.$tf.'">'.$subtypes[$a[0]]['name'].' : ['.html_safe_text($fls[$a[1]]).']</option>';
		}
		echo '
                </select>
        </td>
	</tr>
	<tr id="draw_tr" class=lgray>
		<th colspan="3">
		<input type="button" class="gbtn" name="draw'.$chtk.'" value="DRAW" onClick="go(this.form,\'draw\')">
		</th>
	</tr>
</table>
</td>
</tr>';
	}
?>
</table>
</form>


<?php
include_once('includes/footer.inc');
?>
