<?php
// $Header: /home/CVS/rps/rts/chart_pie.php,v 1.13 2006/11/08 07:31:10 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

require_once('../includes/db.inc');

  if(!isset($_GET['rts_type']))
	_die('RTS type is not specified.');
  $ccid=$wfid=$_GET['rts_type'];
  if($p=strrpos($ccid,'/'))
	$wfid=substr($ccid,0,$p);

require_once('includes/params/user_filters.inc');

require_once("jpgraph/jpgraph.php");
require_once("jpgraph/jpgraph_pie.php");
require_once("jpgraph/jpgraph_pie3d.php");


  if(!isset($_SESSION[$ccid.'/sub_types1']) || !isset($_SESSION[$ccid.'/sql_fw']))
  	_die('The session is not set up for chart drawing.');

  $sub_types=&$_SESSION[$ccid.'/sub_types1'];
  $sql_fw=$_SESSION[$ccid.'/sql_fw'];

  $WHERE = '';
  if(!isset($_GET['slice']))
	_die('slice option is not specified.');
  $stype=$_GET['slice'];

  $gtitle=$sub_types[$stype]['name'].' : [No Filters, All requests]';
  if(isset($_GET['fid']) && $_GET['fid']){
	$fid=$_GET['fid'];
	$filters= new UserFilters($wfid);
	$gtitle=$sub_types[$stype]['name'].' : ['.$filters->get_filter_comment_by_id($fid).']';;
  	$WHERE=$filters->filter2sql_where($fid);
  }

  $group_by="r.$stype AS grp";
  if(isset($sub_types[$stype]['one_level']) && $sub_types[$stype]['one_level']){
  	$ol=$sub_types[$stype]['one_level'];
  	if(simple_query("SELECT COUNT(DISTINCT($ol)) $sql_fw $WHERE")>1)
  		$group_by='IF(c.parent,c.parent,c.pid) AS grp';
  }
  $id2str=$sub_types[$stype]['values'];

  $query = "SELECT $group_by, COUNT(r.rid) AS cnt $sql_fw $WHERE GROUP BY grp ORDER BY cnt DESC";
  //die("$query <br>\n");
  if(!($result=@mysql_query($query)))
	_die2(__FILE__.':'.__LINE__.' Could not select from requests table. ');
  $data=array();
  $legend=array();
  while($row=mysql_fetch_array($result, MYSQL_NUM)){
	$data[$row[0]]=$row[1];
	if(isset($id2str[$row[0]]))
		$legend[$row[0]]=$id2str[$row[0]].' ('.$row[1].')';
	else{
		$legend[$row[0]]='unknown ('.$row[1].')';
		_warn_yoxel("Inconsistant database for $wfid,$stype = ".$row[0]);
	}
	//echo $row[0].", ".$legend[$row[0]].", ".$data[$row[0]]."<br>\n";
}
//print_r($data);
//exit;

// Create the Pie Graph.
$graph = new PieGraph(700,500,"auto");
$graph->SetShadow();
$graph->legend->Pos( 0.05,0.03,"right" ,"top");

// Set A title for the plot
//$graph->title->Set("Request States");
//$graph->title->SetFont(FF_FONT1,FS_BOLD);

// Create plots
$size=150;
$x=0.3;
$y=0.5;
$s=190;
$i=1;

$p1 = &new PiePlot(array_values($data));
$p1->SetTheme("sand");
//$p1->ExplodeAll();
//$p1->SetLegends(array_slice($legend, 0, 20));
$p1->SetLegends(array_values($legend));
$p1->SetSize($size);
$p1->SetCenter($x, $y);
//$p1->SetStartAngle(30);

$p1->SetLabelType(PIE_VALUE_ABS);
//$p1->SetLabels($legend);
//$p1->SetLabelPos(1.2);
//$p1->SetGuideLines(true,false);
$p1->value->SetFont(FF_FONT0);
$p1->value->SetFormat('%d');
$p1->title->Set($gtitle);
$p1->title->SetMargin(30);

$graph->Add($p1);
$graph->Stroke();

?>
