<?php
// $Header: /home/CVS/rps/rts/wf_bts_query.php,v 1.27 2008/03/03 21:01:17 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

  require_once('../includes/db.inc');
  require_once('includes/rps/rps.inc');

  $rps = new ReleasePlan();
  $projects_2d=&$rps->init_projects(FALSE,TRUE);
  $rts = &$rps->rts;
  $pqs_2d=&$rts->init_pqs();

  $proj_names=array();
  foreach($projects_2d['pqid'] as $proj_id => $pqid){
  	if(!isset($pqs_2d['name'][$pqid])) continue;
  	$proj_names[$proj_id]=$pqs_2d['name'][$pqid].' '.$projects_2d['lbl'][$proj_id];
  }
  asort($proj_names);

  $FldList = array(
	'r|pid' => array(
		'name'=>'Product',
		'input' => 'select',
		'values' => &$pqs_2d['name'],
		'vbc'=>TRUE),
	'r|state'=> array(
		'name'=>'State',
		'input' => 'select',
		'values' => &$rts->state2str,
		'vbc'=>TRUE),
	'class'=> array(
		'name'=>'Class',
		'input' => 'select',
		'values' => &$rts->class2str,
		'vbc'=>TRUE),
	'customer_pri'=> array(
		'name'=>'Urgency',
		'input' => 'select',
		'values' => &$rts_pri2str,
		'vbc'=>TRUE),
	'customer_id'=> array(
		'name'=>'Customer',
		'input' => 'select',
		'values' => &$customers_2d['name'],
		'vbc'=>FALSE),
	'fixer_uid'=> array(
		'name'=>'Implementer',
		'input' => 'select',
		'values' => '%workers',
		'vbc'=>FALSE),
	'tester_uid'=> array(
		'name'=>'Tester',
		'input' => 'select',
		'values' => '%workers',
		'vbc'=>FALSE),
	'filed_by'=> array(
		'name'=>'Submitter',
		'input' => 'select',
		'values' => '%submitters',
		'vbc'=>TRUE),
	'release_id'=> array(
		'name'=>'Planned for/Fixed in Release',
		'input' => 'select',
		'values' => &$proj_names,
		'vbc'=>TRUE,
		'extra_sql' => "r.in_release=IF(proj.state='plan','plan','yes')"),
	'r|reg_date'=> array(
		'name'=>'Arrival Date',
		'input' => 'date',
		'vbc'=>TRUE),
	'synopsis'=>array(
		'name'=>'Synopsis',
		'input' => 'text',
		'vbc'=>TRUE),
	'r|description'=>array(
		'name'=>'Description',
		'input' => 'text',
		'vbc'=>TRUE),
	'rpp' => array(
		'name'=>'Requests Per Page',
		'input' => 'rselect',
		'local' => TRUE,
		'values' => array(10=>10,20=>20,25=>25,50=>50),
		'vbc'=>TRUE)
	);

  // Refer to $rts->request_query_sqlstr function that defines an SQL query like this
  //SELECT r.rid, IF(c.parent=0,c.name,CONCAT(p.name, '/', c.name)) AS pq_name, r.synopsis, r.fixer_uid, r.tester_uid, r.class, r.state, r.phase_of_rid, r.customer_pri, r.filed_by, c.rnd_mgr, c.qa_mgr, cust.cae_mgr_uid, cust.sls_mgr_uid, DATE_FORMAT(r.reg_date,'%m/%d/%y') AS rdate FROM requests AS r, products AS c LEFT JOIN products AS p ON c.parent=p.pid, customers AS cust WHERE r.pid=c.pid AND r.customer_id=cust.cid;

  $OutputFormat =array(
	'ID' => array('field' => 'rid',
			'eval' => '
		$tmp=$row[\'phase_of_rid\']?(\'&#8658;&nbsp;\'.$row[\'rid\']):($row[\'rid\'].\'&nbsp;&nbsp;\');'
		),
	'Arrival' => array('field' => 'rdate', 'sort_field' => 'r.reg_date'),
	'Product' => array('field' => 'pq_name'),
	'State' => array('field' => 'state',
			'eval'=>'$tmp=$obj->state2str[$row[\'state\']];',
			'align'=>'center'),
	'Responsible' => array('align'=>'center',
			'eval'=>'
		$xstr2uid=array(); $obj->xstr2uid($row,$xstr2uid);
		$ruid=$obj->request_owner($row[\'class\'], $row[\'state\'], $xstr2uid);
		$tmp=isset($all_users_2d[\'name\'][$ruid])?$all_users_2d[\'name\'][$ruid]:"N/A";'),
	'Synopsis' => array('field' => 'synopsis',
				'eval' => '$tmp=html_safe_text($row[\'synopsis\']);'),
	);

  require_once('includes/rts/rts_query_inc.php');
?>


