<?php
// $Header: /home/CVS/rps/rts/wf_bts_view.php,v 1.97 2008/05/06 05:25:26 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

 $hide_header = true;
 $hide_logo = true;
 require_once "../includes/db.inc";
 require_once "includes/rps/rps.inc";

 define('ACTION_NORMAL', 0x0000);
 define('ACTION_SYNC', 0x0001);
 define('ACTION_STARTIMP', 0x0002);
 define('ACTION_STOPIMP', 0x0003);
 define('ACTION_RESUMEIMP', 0x0004);
 define('ACTION_DELRID', 0x0005);

 $rts = new BugTracker();
 $products_2d=&$rts->products_2d;
 $x_fields_2d=&$rts->init_extra();

 $rts->request_view_common_handler();
 $xstr2uid=array();

if (isset($_GET['cc_add']) || isset($_GET['cc_del'])){
	require_once('includes/rts/cc_add_del_inc.php');
}

if (isset($_GET['history'])){	// Request history ...

	$id = ereg_replace("[^0-9]", "", $_GET['history']);
	$RInfo=$rts->request_info($id,$xstr2uid);
	$ruid=$rts->request_owner($RInfo['class'],$RInfo['state'],$xstr2uid);

	// Read CC list
	$CCList = $rts->get_cc_list($id);
	$rts->add_to_cc_list($CCList,$ruid);
	$rts->add_to_cc_list($CCList,$RInfo['filed_by']);

	$Hist = &$rts->read_history($RInfo);

	$on_resize_str="save_geom('geom_req')";
	require_once "includes/header.inc";

	// Output data from $Hist
	require_once("includes/rts/show_history_inc.php");

	require_once("includes/footer.inc");
	exit;

}


if (($_SESSION['lic']&LIC_X) && isset($_GET['xid']) && !$is_customer){

	$xid = ereg_replace("[^0-9]", "", $_GET['xid']);
	$RInfo=$rts->request_info($xid,$xstr2uid);
	$Opt = $RInfo['options'];

	// Read xfields - Leha's modified smart algorithm
	$xfids = array();
	foreach($x_fields_2d['options'] as $fid => $opt){
		if (!($opt&FIELD_OPT_X))
			continue;
		array_push($xfids,$fid);
	}
	$xField=&$rts->x_get_fields($xid,$xfids);

	$on_resize_str="save_geom('geom_req')";
	//$on_load_str="bts_view_set_size()";
	require_once "includes/header.inc";
	require_once("includes/rts/js_view_filter_inc.php");
	view_menu($xid,RTS_VIEW_IS_EXTRA);
?>

<form method='post' action='<?php print $_SERVER['PHP_SELF'] ?>'>
<input type='hidden' name='xid' value='<?php print $xid ?>'>
<table width='100%' border=0 cellpadding=0 cellspacing=1 align="center" class="dgray">
<tr class='ddgray'>
 <th colspan="2" class='title'><?php print html_safe_text($RInfo['synopsis']) ?></th>
</tr>
<tr class='lgray'>
 <th style='width: 25%'>Show&nbsp;in&nbsp;X-Reports</th>
 <td style='width: 75%'>
  <input type='radio' name='xshow' value='1'<?php print ($Opt&REQ_OPT_X?' checked':'') ?>>Yes&nbsp; &nbsp;
  <input type='radio' name='xshow' value='0'<?php print ($Opt&REQ_OPT_X?'':' checked') ?>>No
 </td>
</tr>

<?php
	foreach($xField as $fid => $fval){
		print "<tr class='lgray'>\n";
		print " <th>".$x_fields_2d['long_name'][$fid]."</th>\n";
		print " <td>";

		switch($x_fields_2d['field_type'][$fid])
		{
			case 'number':
				print "<input name='xfield$fid' class='inp' size=7 maxlength=10 value='$fval'>";
				break;

			case 'date':
				print "<input name='xfield$fid' class='inp' size=10 maxlength=10 value='".date_sql2norm($fval)."'>";
				break;

			case 'text_line':
				print "<input name='xfield$fid' class='inp' size=56 maxlength=128 value='$fval'>";
				break;

			case 'text_area':
				print "<textarea name='xfield$fid' rows='3' style='width: 100%'>".html_safe_text($fval)."</textarea>";
				break;

			case 'username':
				print "\n  <select name='xfield$fid' class='selec'>\n";
				print "   <option value=''>\n";
				foreach ($all_users_2d['name'] as $k => $v){
					if($all_users_2d['user_is'][$k]&(USER_IS_HIDDEN|USER_IS_CUSTOMER)) continue;
					print "   <option value='$k'";
					if ($k == $fval) print ' selected';
					print ">$v\n";
				}
				print "  </select>\n";
				break;

			default:
                                echo 'N/A';
		}

		print "</td>\n";
		print "</tr>\n";
	}
	print "<tr class='lgray'>\n";
	print " <td colspan=2 align='center'><input type='button' value='&gt; Update &lt;' class='btn_small' onClick='go(this.form)'></td>\n";
	print "</tr></table></form>\n";
	$rts->request_view_frm_Close($RInfo);
	require_once("includes/footer.inc");
	exit;
}

if (isset($_POST['xid'])){
	$xid = ereg_replace("[^0-9]", "", $_POST['xid']);

	// Read options
	$Opt = simple_query("SELECT options FROM requests WHERE rid = $xid");
	$Opt &= ~REQ_OPT_X;
	if (isset($_POST['xshow']) && ($_POST['xshow'] == '1')) $Opt |= REQ_OPT_X;
	if (!mysql_query("UPDATE requests SET options = $Opt WHERE rid = $xid"))
		_die2("Error updating requests table.");

	foreach($x_fields_2d['options'] as $fid => $opt){
		if (!($opt & FIELD_OPT_X)) continue;

		$fval = $_POST["xfield$fid"];
		if ($x_fields_2d['field_type'][$fid] == 'date')
			$fval = date_norm2sql($fval);
		$rts->update_xfid_extra_for_rid($xid,$fid,$fval);
	}

	header("Location: ".$_SERVER['PHP_SELF']."?xid=$xid");
	exit;
}

if (isset($_GET['help'])){
	$id = ereg_replace("[^0-9]", "", $_GET['help']);
	$RInfo=$rts->request_info($id,$xstr2uid);
	$dstag='sw/rts/wf_bts_view';

	$on_resize_str="save_geom('geom_req')";
	require_once "includes/header.inc";
	require_once("includes/rts/js_view_filter_inc.php");
	view_menu($id,RTS_VIEW_IS_HELP);
	if(!isset($help_msg))
		_quit_error('Help sub-system is not initialized.');
	$help_msg->output($dstag,'Request Tracking Systems');
	$rts->request_view_frm_Close($RInfo);
	require_once("includes/footer.inc");
	exit;
}


if (isset($_POST['id'])){
	$id = ereg_replace("[^0-9]", "", $_POST['id']);
	$RInfo=$rts->request_info($id,$xstr2uid);

	$prev_state = $RInfo['prev_state'];
	$state		= $RInfo['state'];
	$class		= $RInfo['class'];
	$qa_mgr		= $products_2d['qa_mgr'][$RInfo['pid']];
	$cae_mgr	= $customers_2d['cae_mgr'][$RInfo['customer_id']];
	$sls_mgr	= $customers_2d['sls_mgr'][$RInfo['customer_id']];
	$fixer		= $RInfo['fixer_uid'];
	$tester		= $RInfo['tester_uid'];
	$submitter	= $RInfo['filed_by'];
	$rid_is_external = ($RInfo['options']&REQ_OPT_EXTERNAL);
	$main_pid=$products_2d['parent'][$RInfo['pid']]?$products_2d['parent'][$RInfo['pid']]:$RInfo['pid'];

	$rps= new ReleasePlan();
	$rps->init_projects($main_pid,TRUE);
	$releases_2d=&$rps->projects_2d;

	$ism=$rts->inwork_state_mask[$class];
	$fsm=$rts->fixed_state_mask[$class];
	$vsm=$rts->verified_state_mask[$class];
	$lsm=$rts->last_state_mask($class);

	if (isset($_POST['just_comment'])){
		$comment = "\n".str_replace("\r", "", $_POST['just_comment']);
		$To = $rts->request_owner($class, $state, $xstr2uid);
		$rts->add_comment($RInfo, $comment, $To, $products_2d, isset($_POST['cc'])?$_POST['cc']:FALSE);
		header("Location: ".$_SERVER['PHP_SELF']."?history=$id");
		exit;
	}

	$a=explode(':',$_POST['actn']);
	$action = ereg_replace("[^0-9]", "", $a[0]);
	$wfaid = ereg_replace("[^0-9]", "", $a[1]);

	$SQL = array();
	$descr = "\n".str_replace("\r", "", $_POST['descr']);
	$SQLStr = ''; $comment = '';
	$Flags = $RInfo['options'];

	if(($action == ACTION_DELRID) && ($state&$lsm) && ($user_is&USER_IS_MU)){
		$rts->request_delete($RInfo);

		$on_resize_str="save_geom('geom_req')";
		$on_load_str="rts_view_init(true);window.close();";
		$hide_header=TRUE;
		require_once("includes/header.inc");
		require_once("includes/footer.inc");
		exit;
	}

	if ($action == ACTION_STARTIMP){
	// Turn list of external PRs to import phases of the support request
		$comment = "Action: Import Requests List\n";
		if($rid_is_external)
			_die(__FILE__.':'.__LINE__.' External request can not have sub-requests.');
		if(!isset($_SESSION['x_bts_url']))
			_die(__FILE__.':'.__LINE__.' Importing engine is not set-up properly.');
		$ExtPRList=array();
		$query="SELECT xid FROM members WHERE type=".MEMB_TYPE_BTSXRID." AND uid= '$id'";
		if(!($result=@mysql_query($query)))
		_die2(__FILE__.':'.__LINE__.' Could not select from members table.');
		while($row=mysql_fetch_array($result, MYSQL_NUM))
			array_push($ExtPRList,$row[0]);
		if(count($ExtPRList)){
			$n=0;
			$rts=new BugTracker;
			while($r=array_pop($ExtPRList))
				if($rts->import_external_pr($r, $RInfo['customer_id'], FALSE,$id)) $n++;
			mysql_query("DELETE FROM members WHERE type=".MEMB_TYPE_BTSXRID." AND uid= $id");
		}
		if(count($ExtPRList))
			$comment .= "Imported requests (#".implode(', #',$ExtPRList).") from external BTS.\n";
		header("Location: ".$_SERVER['PHP_SELF']."?id=$id&reload=true");
		exit;
	}

	if ($action == ACTION_RESUMEIMP){ // Resume import of the PR
		$comment = "Action: Request Import\n";
		if($rid_is_external)
			_die(__FILE__.':'.__LINE__.' The request is already external.');
		if(!$RInfo['xrid'])
			_die(__FILE__.':'.__LINE__.' This request has not been external before.');
		$query="UPDATE requests SET options=options|".REQ_OPT_EXTERNAL." WHERE rid= $id";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not update requests table.');
		$comment .= "Request #$id is an external request again.\n";
		header("Location: ".$_SERVER['PHP_SELF']."?id=$id");
		exit;
	}

	// Turn import PR into regular Yoxel PR
	// Only is there is BTS license
	if (($action == ACTION_STOPIMP) && (!$asp_mode || (check_out_license(LIC_BTS)<0))){
		$comment = "Action: Stop Import\n";
		if(!$rid_is_external)
			_die(__FILE__.':'.__LINE__.' The request is not external.');
		$query="UPDATE requests SET options=options&~".REQ_OPT_EXTERNAL." WHERE rid= $id";
		//echo "$query <br>\n";
		if(!@mysql_query($query))
			_die2(__FILE__.':'.__LINE__.' Could not update requests table.');
		$comment .= "Request #$id is a regular internal request now.\n";
	}

	if($rid_is_external && ($action==ACTION_SYNC)){
		$comment = "Action: Sync&Update\n";
		if($RInfo['xrid']){
			if($rid=$rts->import_external_pr($RInfo['xrid'])){
				$comment .= "Imported request #{$RInfo['xrid']} from external BTS.\n";
				$RInfo=$rts->request_info($rid,$xstr2uid);
			}
		}
	}

	if($rid_is_external && (($action==ACTION_SYNC) || ($action == ACTION_STOPIMP))){
		$res=$rts->process_view_fields($RInfo,$xstr2uid,$releases_2d,FALSE);
		$SQLStr= "state=".$RInfo['state'];
		$SQLStr.=array_shift($res);
		$comment.=array_shift($res);
		$descr = "$comment$descr";
		$rts->log_history($RInfo,$uid,$descr);
		//echo "$SQLStr <br>\n";

		$rts->request_view_update($RInfo,$SQLStr);
		header("Location: ".$_SERVER['PHP_SELF']."?id=$id&reload=true");
		exit;
	}elseif($action!=ACTION_NORMAL)
		_quit_error('Unknown action ...');

	$rts->set_state_action($class, $state, $prev_state, $wfaid, $xstr2uid);
	$new_state=$rts->state_actions['next_state'][$wfaid];
	$action_name=$rts->state_actions['name'][$wfaid];
	$action_is_clone=$rts->state_actions['options'][$wfaid]&WFACTION_OPT_CLONE;
	$comment = "Action: $action_name\n";
	//foreach($rts->state_rw_fields as $k => $v)
	//	echo "$k --> $v <br>\n";
	//foreach($_POST as $k => $v)
	//	echo "P: $k --> $v <br>\n";


	$res=$rts->process_view_fields($RInfo,$xstr2uid,$releases_2d,$action_is_clone);
	$SQLStr.=array_shift($res);
	$comment.=array_shift($res);

	// Each action comes with default updates
	$f2v=$rts->f2v_for_action($wfaid,$xstr2uid,$RInfo['class']);
	//print_r($f2v);
	foreach($f2v as $f =>$v)
		$SQLStr.=", $f='".escape_data($v)."'";

	$RInfo['state']=$new_state;

	if($action_is_clone){
		$cloned_rid=$rts->clone_request($id);
		$sql_str=$rts->detect_state_change($cloned_rid,$new_state);
		//$CRInfo=$RInfo;$rts->request_info($cloned_rid,$x2u);
		$CRInfo=$RInfo;
		$CRInfo['rid']=$cloned_rid;
		$rts->log_history($CRInfo,$uid,$comment."Cloned from request: $id\n".$descr);

		$SQLStr = " state=$new_state $sql_str".($Flags!=$RInfo['options']?", options = {$RInfo['options']}":'')." $SQLStr";

		$RInfo['rid']=$cloned_rid;
		$RInfo['state']=$new_state;
		$rts->request_view_update($RInfo,$SQLStr);

		if($production_mode || !$at_isp)
			$rts->notify_by_email($cloned_rid, $uid, $_POST['descr'], $wfaid, false);
		$_POST=array();
		header("Location: ".$_SERVER['PHP_SELF']."?id=$cloned_rid&reload=true");
	}else{
		$descr = "$comment$descr";
		$sql_str=$rts->detect_state_change($id,$new_state);
		$rts->log_history($RInfo,$uid,$descr);

		$SQLStr = " state=$new_state $sql_str".($Flags!=$RInfo['options']?", options = {$RInfo['options']}":'')." $SQLStr";
		$rts->request_view_update($RInfo,$SQLStr);

		if($production_mode || !$at_isp)
			$rts->notify_by_email($id, $uid, $_POST['descr'], $wfaid, false);
		$_POST=array();
		header("Location: ".$_SERVER['PHP_SELF']."?id=$id&reload=true");
	}
	exit;
}	// isset($_POST['id'])


if (isset($_GET['id'])){

	require_once('includes/rts/view_get_start_inc.php');

	$main_pid=$products_2d['parent'][$RInfo['pid']]?$products_2d['parent'][$RInfo['pid']]:$RInfo['pid'];

	$rps= new ReleasePlan();
	$rps->init_projects($main_pid,TRUE);
	$releases_2d=&$rps->projects_2d;
	$fet=$rps->raw_ph_fixer_et(1,$id,$fixer);
	$tet=$rps->raw_ph_fixer_et(2,$id,$fixer);

	//foreach($rts->state_rw_fields as $k => $v)
	//	echo "$k --> $v <br>\n";

	// Fix priority - bug 50
	if (!$RInfo['customer_pri'])
		$RInfo['customer_pri'] = REQ_PRI_MEDIUM;

	$RDate = date("M d, Y", $RInfo['reg_date_tm']);
	//$RDate = explode("-", $RDate[0]);

	$aList=array();
	$ExtPRList=array();
	$a2f=array();
	if($rid_is_external){
		foreach(array_keys($rts->state_actions['frequency']) as $wfaid){
			$n=$rts->state_actions['name'][$wfaid];
			//echo "$n ".$rts->state_actions['options'][$wfaid]."<br>\n";
			if(!($rts->state_actions['options'][$wfaid]&WFACTION_OPT_UPDATE)) continue;
			array_push($aList,ACTION_NORMAL.':'.$wfaid.':'.$n);
			$a2f[$wfaid]=$rts->get_rw_fields($wfaid);
		}
		array_push($aList, ACTION_SYNC.':0:Sync');
		if(!$asp_mode || (check_out_license(LIC_BTS)<0))
		// Only if there is BTS license
			array_push($aList, ACTION_STOPIMP.':0:Stop importing from external BTS');

	}else{
		foreach($rts->state_actions['frequency'] as $wfaid => $f){
			$n=$rts->state_actions['name'][$wfaid];
			array_push($aList,ACTION_NORMAL.':'.$wfaid.':'.$n.':'.$f);
			$a2f[$wfaid]=$rts->get_rw_fields($wfaid);
		}
		$query="SELECT xid FROM members WHERE type=".MEMB_TYPE_BTSXRID." AND uid= '$id'";
		if(!($result=@mysql_query($query)))
			_die2(__FILE__.':'.__LINE__.' Could not select from members table.');

		while($row=mysql_fetch_array($result, MYSQL_NUM))
			array_push($ExtPRList,$row[0]);

		if($RInfo['xrid']){ // xrid is defined. this RID used to be external
			array_push($aList, ACTION_RESUMEIMP.':0:Resume importing from the external BTS');
		}elseif(count($ExtPRList) && isset($_SESSION['x_bts_url']))
			array_push($aList, ACTION_STARTIMP.':0:Start importing external requests associated with this request.');
	}

	if (($state&$lsm) && ($user_is&USER_IS_MU))
                array_push($aList, ACTION_DELRID.':0:Delete request');

	$on_resize_str="save_geom('geom_req')";
	$on_load_str="rts_view_init(".isset($_GET['reload']).")";

	require_once("includes/header.inc");
	if(!$rid_is_external && $asp_mode)
		if(($licn=check_out_license(LIC_BTS))>-1){
			if($licn>0)
				_quit_error('License checkout failed. Licensed number of users ('.$licn.') for BTS already reached.');
			else
				_quit_error('License checkout failed. No license to use this part of BTS.');
		}

  require_once("includes/rts/js_view_filter_inc.php");
  view_menu($id,RTS_VIEW_IS_MAIN);

  $rts->request_view_frm_Start($RInfo);
  $rts->request_view_tr_Action($RInfo,$aList);
  $rts->request_view_tr_IDnDon($RInfo);
  $rts->request_view_tr_Submitter($RInfo);
  $rts->request_view_tr_State($RInfo);
  $rts->request_view_tr_Class($RInfo);
  $rts->request_view_tr_PQ($RInfo,$xstr2uid,'Product - Component');
  $rts->request_view_tr_Synopsis($RInfo);
  $rts->request_view_tr_Fixer($RInfo,$xstr2uid,FALSE,FALSE,$fet);
  $rts->request_view_tr_Tester($RInfo,$xstr2uid,$tet);
  $rts->request_view_tr_AddRemoveCC($RInfo,$CCList,$inCCList);
  //$rts->request_view_tr_ReportedInRelease($RInfo,$releases_2d);
?>

<tr class='lgray'>
 <th>Reported in Release</th>
 <td colspan="2">
 	<table width="100%" border=0 cellpadding=0 cellspacing=0>
	<tr><td width="40%"><?php

  if ($rts->is_rw_field('reported_in_rel_id') && !$rid_is_external){
	print "  <select name='reported_in_rel_id' class='selec'>\n\t<option value='0'>N/A</option>\n";
	foreach($releases_2d['lbl'] as $k => $v){
		print "   <option value='$k'";
		if ($k == $RInfo['reported_in_rel_id']) print " selected";
		print ">$v\n";
	}
	print "  </select>\n";
  }else
	print isset($releases_2d['lbl'][$RInfo['reported_in_rel_id']])?$releases_2d['lbl'][$RInfo['reported_in_rel_id']]:'N/A';

  echo '
  </td><td>build:&nbsp;';
  if ($rts->is_rw_field('reported_in_build') && !$rid_is_external)
	print "<input name='reported_in_build' class='inp' size=10 maxlength=15 value='{$RInfo['reported_in_build']}'>";
  else
	print ($RInfo['reported_in_build']?$RInfo['reported_in_build']:'N/A');
?>
	</td></tr>
	</table>
  </td>
</tr>
<tr class='lgray'>
 <th><?php
 	if ($state&$fsm)
		echo 'Fixed in Release';
	else
		echo 'Planned for Release';
 ?></th>
 <td colspan="2">
 	<table  width="100%" border=0 cellpadding=0 cellspacing=0>
	<tr><td width="40%"><?php

//  if ($rts->is_rw_field('release_id')){
//	print "  <select name='release' class='selec'>\n\t<option value='$k'>N/A</option>\n";
//	foreach($releases_2d['lbl'] as $k => $v){
//		print "   <option value='$k'";
//		if ($k == $RInfo['release_id']) print " selected";
//		print ">$v\n";
//	}
//	print "  </select>\n";
//  }else
	print (isset($releases_2d['lbl'][$RInfo['release_id']]) && ($RInfo['in_release']!='no'))?$releases_2d['lbl'][$RInfo['release_id']]:'N/A';

  echo '
  </td><td>build:&nbsp;';
  if ($rts->is_rw_field('fixed_in_build') && !$rid_is_external && !($state&$fsm))
	print "<input name='fixed_in_build' class='inp' size=10 maxlength=15 value='{$RInfo['fixed_in_build']}'>";
  else
	print ($RInfo['fixed_in_build']?$RInfo['fixed_in_build']:'N/A');
?>
	</td></tr>
	</table>
  </td>
</tr>

<?php
  if($state&$ism && !($state&$fsm))
  	$rts->request_view_tr_FixCompletePct($RInfo);
  $rts->request_view_tr_Platform($RInfo);
  $rts->request_view_tr_Customer($RInfo,TRUE);
  $rts->request_view_tr_CustUrgency($RInfo);
  $rts->request_view_tr_VBC($RInfo);

  $rts->request_view_tr_Parent($RInfo,isset($PhList)?$PhList:FALSE,isset($Parent)?$Parent:FALSE);
  $rts->request_view_tr_SubRequests($RInfo,isset($PhList)?$PhList:FALSE);
  $rts->request_view_tr_Description($RInfo);

if($ExtPRList){
	echo '
<tr class="lgray">
	<th align=right class="dgray">External IDs: </th>
	<td colspan=2>'.implode(', ',$ExtPRList).'</td>
</tr>';
}

  $rts->request_view_frm_Close($RInfo);

?>


<script language='JavaScript'>
<!--
	filter_fields(document.view_frm<?php echo $aList?'':',true'; ?>);
//-->
</script>

<?php
	require_once("includes/footer.inc");
	exit;
} // isset($_GET['id'])

_quit_error("Unknown mode: ".$_SERVER['QUERY_STRING']." ...");

	function view_menu($id,$rts_view_menu=RTS_VIEW_IS_MAIN){
	  global $dir_name;
	  global $is_customer;
	  global $help_msg;

		$main_here	= ($rts_view_menu == RTS_VIEW_IS_MAIN)   ? 'class="here"' : '';
		$history_here	= ($rts_view_menu == RTS_VIEW_IS_HISTORY)? 'class="here"' : '';
		$extra_here	= ($rts_view_menu == RTS_VIEW_IS_EXTRA)? 'class="here"' : '';
		if(isset($help_msg))
			$help_here = ($rts_view_menu == RTS_VIEW_IS_HELP)? 'class="here"' : '';

		$phrase_param = isset($_GET['phrase'])?'&phrase='.$_GET['phrase']:'';

		echo '
	<ul id="topnav">
            <li>'.yxl_gen_link('/rts/wf_bts_view.php?id='.$id.$phrase_param,'main view',$main_here).'</li>
            <li>'.yxl_gen_link('/rts/wf_bts_view.php?history='.$id.$phrase_param,'history',$history_here).'</li>';

		if(!$is_customer && ($_SESSION['lic']&LIC_X))
			echo '
            <li>'.yxl_gen_link('/rts/wf_bts_view.php?xid='.$id.$phrase_param,'extra fields',$extra_here).'</li>';

		if(isset($help_msg))
			echo '
            <li>'.yxl_gen_link('/rts/wf_bts_view.php?help='.$id.$phrase_param,'help',$help_here).'</li>';

		echo '
	</ul>';
	}
?>





