<?php
// $Header: /home/CVS/rps/stsc/js_drag_obj.php,v 1.2 2007/06/28 06:38:33 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

$RequireLogin=-1;
require_once('../includes/db.inc');
header("content-type: application/x-javascript");

?>
// Global object to hold drag/pointer information.
var dragObj = new Object();

dragObj.zIndex = 0;
dragObj.callMyDropHandler = false;
dragObj.ptrX = 0;
dragObj.ptrY = 0;

function getPointerXY(e){

  if (!e) // works on IE, but not NS (we rely on NS passing us the event)
  	e = window.event;

  if (e){
    if (e.pageX || e.pageY){ // this doesn't work on IE6!! (works on FF,Moz,Opera7)
      dragObj.ptrX = e.pageX;
      dragObj.ptrY = e.pageY;
      algor = '[e.pageX]';
      if (e.clientX || e.clientY) algor += ' [e.clientX] '
    }else if (e.clientX || e.clientY){ // works on IE6,FF,Moz,Opera7
      dragObj.ptrX = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
      dragObj.ptrY = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
      algor = '[e.clientX]';
      if (e.pageX || e.pageY) algor += ' [e.pageX] '
    }
  }
}

function dragStart(e, id, call_drop_handler) {

  // If an element id was given, find it.
  // Otherwise use the element being clicked on.
  if (id)
    dragObj.elNode = document.getElementById(id);
  else {
    if (browser.isIE)
      dragObj.elNode = window.event.srcElement;

    if (browser.isNS || browser.isOp)
      dragObj.elNode = e.target;

    // If this is a text node, use its parent element.
    if (dragObj.elNode.nodeType == 3)
      dragObj.elNode = dragObj.elNode.parentNode;
  }

  // Get cursor position with respect to the page.
  getPointerXY(e)

  // Save starting positions of cursor and element.
  dragObj.cursorStartX = dragObj.ptrX;
  dragObj.cursorStartY = dragObj.ptrY;

  /* getObjectAbsXY(dragObj.elNode) */
  dragObj.elStartLeft  = parseInt(dragObj.elNode.style.left, 10);
  dragObj.elStartTop   = parseInt(dragObj.elNode.style.top,  10);

  if (isNaN(dragObj.elStartLeft)) dragObj.elStartLeft = 0;
  if (isNaN(dragObj.elStartTop))  dragObj.elStartTop  = 0;

  // Update element's z-index.
  dragObj.elNode.style.zIndex = ++dragObj.zIndex;

  // Capture mousemove and mouseup events on the page.
  if (browser.isIE) {
    document.attachEvent("onmousemove", dragGo);
    document.attachEvent("onmouseup",   dragStop);
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }

  if (browser.isNS || browser.isOp) {
    document.addEventListener("mousemove", dragGo,   true);
    document.addEventListener("mouseup",   dragStop, true);
    e.preventDefault();
  }

  if(call_drop_handler)
	dragObj.callMyDropHandler=true;
}

function dragGo(e) {

  // Get cursor position with respect to the page.
  getPointerXY(e);

  // Move drag element by the same amount the cursor has moved.
  dragObj.elNode.style.left = (dragObj.elStartLeft + dragObj.ptrX - dragObj.cursorStartX) + "px";
  dragObj.elNode.style.top  = (dragObj.elStartTop  + dragObj.ptrY - dragObj.cursorStartY) + "px";

  if (browser.isIE) {
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS || browser.isOp)
    e.preventDefault();
}

function dragStop(e) {
  var nDate = new Date();

  // Get cursor position with respect to the page.
  getPointerXY(e)

  // Stop capturing mousemove and mouseup events.
  if (browser.isIE) {
    document.detachEvent("onmousemove", dragGo);
    document.detachEvent("onmouseup",   dragStop);
  }
  if (browser.isNS || browser.isOp) {
    document.removeEventListener("mousemove", dragGo,   true);
    document.removeEventListener("mouseup",   dragStop, true);
  }

  if(dragObj.elNode){
  	getObjectAbsXY(dragObj.elNode);
	cStr = dragObj.elNode.id + '_geom=' + objX + ',' + objY;
	nDate.setFullYear(nDate.getFullYear() + 1);
	nDate = nDate.toGMTString();
  	cStr += '; expires=' + nDate + '; path=<?php echo $dir_name?$dir_name:''; ?>/';
  	document.cookie = cStr;
  	if(dragObj.callMyDropHandler){
		dragObj.callMyDropHandler=false;
  		MyDropHandler(dragObj.elNode.id,dragObj.ptrX,dragObj.ptrY)
	}
  }
}
