#!/usr/local/bin/php
<?php
// $Header: /home/CVS/rps/utils/imap_mail_handler.php,v 1.9 2008/05/06 04:38:55 yoxel Exp $
/*
 * ----START-LICENCE----
 * Copyright 2002-2008 Yoxel Systems, Santa Clara, CA, USA (info@yoxel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 * -----END-LICENCE-----
 */

  if($_SERVER['argc']<2)
	die("<yoxel_root_dir> parameter is required.\n");

  $rps_dir=$_SERVER['argv'][1];
  if(!is_dir($rps_dir))
	die("Directory specified by <yoxel_root_dir> does not exist.\n");

  $hide_header=TRUE;
  $RequireLogin=FALSE;
  chdir($rps_dir);
  require_once('./includes/db.inc');
  if($asp_mode)
  	require_once('includes/asp/imap_mail_handler_inc.php');

  $my_domain=implode('\.',explode('.',$MyDomain));

//*************************************************************
// This utility requires PHP's IMAP extention:
// 	http://php.net/manual/en/imap.setup.php
//
// ** pre-configured for compilation --with-imap=${LOCALBASE} [--with-imap-ssl]

// *************************************************************
// The parameters below allow you to configure the utility to
// find the right right mail in your IMAP mailbox and do certain
// things with it: attach as comments or file as a new request.

  $https_srvr='https://yoxel.com';


// Specify an IMAP mailbox the utility should poll
// For moredetails on mailbox specification see:
// 	http://php.net/manual/en/function.imap-open.php
//
//$mailbox = "{imap.gmail.com:993/imap/ssl/novalidate-cert}";
//
  $mailbox = "{imap-host}";
  $user = "username";
  $pass = "password";

// The utility tries to handle email for multiple Yoxel modules,
// i.e. RequestTracket, IT TicketTracker, KnowledgeBase, ...
// The first step when analyzing an email message is to determine
// which module it is addressed to. The following array defines
// which email parts to parse and what regular expressions to apply.
//
//   Each Yoxel module is identified by a tag (bts, tts, kbs, ...)
// and regular expressions to be used on email parts are defined by
// the following key words:
//	* to_addr_re - a regexp to be applied to To and CC headers
//	* from_addr_re - a regexp to be applied to From header
//
//   The first regexp to result in a match determines the module to
// be used in the further processing.
//
//   * from_addr_check parameter specifies whether the utility should
// try to find an email sender's address in Yoxel's users table.
//
  $class_detect=array(
 	'bts'=>array(
 		'to_addr_re'=>array(
			array("/[br]ts(\S*)@".$my_domain."/i",''),
			array("/support@".$my_domain."/i",'')
		),

 		'from_addr_re'=>array(),
 		'from_addr_check'=>TRUE
 	),

 	'tts'=>array(
 		'to_addr_re'=>array(
			array("/tts(\S*)@".$my_domain."/i",''),
			array("/info@".$my_domain."/i",'')
		),

		'from_addr_re'=>array(),
 		'from_addr_check'=>FALSE
 	),

 	'kbs'=>array(
 		'to_addr_re'=>array(
			array("/kbs(\S*)@".$my_domain."/i",'')
		),

		'from_addr_re'=>array(),
 		'from_addr_check'=>FALSE
 	)
  );

//   Whenever *from_addr_check=TRUE Yoxel will try to make sure
// an email sender is a registered Yoxel user. Additional domain
// name translation is provided by the following array.
//
//   To translate domain name of email 'From:' field to domain name
// that Yoxel knows your email by. To accept email comments from
// domains other than that registered in your Yoxel account.
//
  $translate_domain=array('example.com'=>$MyDomain,
  		'sub.example.net'=>$MyDomain);

//   The following array of parameters is used to detect whether
// an email is a comment to an existing Yoxel request or a brand new request.
//
//   Again, for each module you specify regular expresssions that apply for
// certain email parts (here you can list more than one regexp):
//	* subject_re - multiple regexp's to be tried against email Subject header
//	* body_re - multiple regexp's to be tried against email body texta
// (TRUE/FALSE in the regexp array tell the utility if this is a hidden comment)
//
// If none of the regexp's for a given module produced a match
// an email is treated as a new request that need to be filed.
//
  $comment_detect=array(
 	'bts'=>array(
 		'subject_re'=>array(
 			array("/^\s*\[Bug\s+([\d\s]+)\s*\]/i",TRUE),
 			array("/[^\d]*(\d+):/i",FALSE)
 		),
 		'body_re'=>array()
 	),

	'tts'=>array(
 		'subject_re'=>array(
 			array("/[^\d]*(\d+):/i",FALSE)
 		),
 		'body_re'=>array()
 	),

	'kbs'=>array(
 		'subject_re'=>array(
 			array("/[^\d]*(\d+):/i",FALSE)
 		),
 		'body_re'=>array()
 	)
  );

//   For the new requests (emails that are not comments) the utility
// tries to determine more details, i.e. request class (bug, enhancement, ticket),
// product/environment or component/queue it should be filed under, customer urgency.
// The following regexp can be defined:
//	* subject_re - array(regexp for Subject, value in case of a match)
//	* body_re - array(regexp for body text, value in case of a match)
//
// to detect that information for:
//	* class_name - request class
//	* pq_name - Product(bts), Environment(tts), Category(kbs)
//	* sub_pq_name - Component(bts), Queue(tts), Sub-category(kbs)
//	* urgency - customer priority
//
  $details_detect=array(
  	'bts'=>array(
		'class_name' => array(
			'default' => 'support'
		),

 		'pq_name' => array(
 			'subject_re' => array('/.*/','Yoxel'),
 			'default' => 'Yoxel'),

 		'sub_pq_name' => array(
 			'body_re' => array('/.*/i','General'),
 			'default' => 'General'),

 		'urgency' =>array(
 			'subject_re' => array('/\s*critical\s*/i','critical'),
 			'default' => 'medium')
 	),

 	'tts'=>array(
		'class_name' => array(
			'default' => 'it ticket'
		),

		'pq_name' => array(
 			'subject_re' => array('/from\s+(\d+.+\s*)$/','IT'),
 			'default' => 'IT'),

 		'sub_pq_name' => array(
 			'body_re' => array('/Windows\s+NT/i','NT'),
 			'default' => 'General'),

 		'urgency' =>array(
 			'subject_re' => array('/\s+DOWN\s*/i','critical'),
 			'default' => 'medium')
 	),

 	'kbs'=>array(
		'class_name' => array(
			'default' => 'question'
		),

		'pq_name' => array(
 			'subject_re' => array('/from\s+(\d+.+\s*)$/','Yoxel'),
 			'default' => 'Yoxel'),

 		'sub_pq_name' => array(
 			'body_re' => array('/kbs/i','General'),
 			'default' => 'General')
 	)
  );

  //$mbox = imap_open ($mailbox, $user, $pass, CL_EXPUNGE|OP_SECURE);
  $mbox = imap_open ($mailbox, $user, $pass, CL_EXPUNGE) or
  	die ("Could not connect: " . imap_last_error() ."\n");

  $msgs=imap_search($mbox,"UNDELETED");
  if(!is_array($msgs))
  	exit;

  foreach($msgs as $mnum){
	if(!($mh=imap_headerinfo($mbox,$mnum)))
		continue;
	//print_r($mh);

	if(!($mtext=fetch_text_part($mbox,$mnum)))
		continue;

	$sig=FALSE;
	if(!($ctag=detect_handler_class($mh,$sig)))
		continue;

	if($asp_mode){
		if(!($cid=select_db_by_sig($sig))){
			print_r($mh);
			continue;
		}
		YxlUsers::InstallCheck(TRUE);
	}

	if(!($uid=valid_from_address($ctag,$mh->from))){
		_live_error("Unknown sender: ".$mh->fromaddress);
		continue;
	}

	if($ctag == "bts"){
		require_once('includes/rts/bts.inc');
		$rts=new BugTracker($cid);
		$pq_fn='pid';
  	}elseif($ctag == "tts"){
		require_once('includes/itrts/tts.inc');
		$rts=new TicketTracker($cid);
		$pq_fn='qid';
  	}elseif($ctag == "kbs"){
		require_once('includes/kbs/kbs.inc');
		$rts=new KnowledgeBase($cid);
		$pq_fn='cid';
  	}else{
		_live_error('Unknown module tag.');
		continue;
	}

	$hide_comment=FALSE;
	$rids=message_is_comment($ctag,$mh,$mtext,$hide_comment);
	if(is_array($rids) && count($rids)){
	// Add comment
		$one_logged=FALSE;
		foreach($rids as $rid){
  			if(!$rid)
				continue;

  			$xstr2uid=array();
  			if(!($RInfo=$rts->request_info($rid,$xstr2uid,"return")))
				continue;

			if($hide_comment)
				$RInfo['options']&=~(REQ_OPT_VBC|REQ_OPT_VBC2);

  			$rts->log_history($RInfo,$uid,"Action: Email comment\n\n".$mtext);
  			//print_r($rids);echo "*** $ctag, $sig, uid: $uid\n $mtext\n";
  			//echo "*** $ctag, $sig, uid: $uid\n";
			$one_logged=TRUE;
  		}
		if($one_logged)
			imap_delete($mbox,$mnum);
	}else{
	// File new
		//echo "*** NEW *** $ctag $mtext\n";
		$details=detect_message_details($ctag,$mh,$mtext);
		//print_r($details);

		$fields=array();
		$fields['synopsis']=$mh->subject;
		$fields['description']='From: '.$mh->fromaddress."\n".
			'To: '.$mh->toaddress."\n".
			"\n".$mtext;

		if(!($class=$rts->str2class($details['class_name']))){
                        _live_error('Unknown class: '.$details['class_name']);
			continue;
                }
		$fields['class']=$class;

		$pqinfo=$rts->pq_find_by_name($details['pq_name']);
		if(!$pqinfo){
			_live_error("Product/Environment/Category '".$details['pq_name']."' does not exist!\n");
			continue;
		}
		$pqid=$pqinfo['pqid'];

		if(strtolower($details['sub_pq_name'])!='general'){
			$pqinfo=$rts->pq_find_by_name($details['sub_pq_name'],FALSE,$pqid);
			if($pqinfo)
				$pqid=$pqinfo['pqid'];
			else
				_live_error("Component/Queue/Sub-category '".$details['sub_pq_name']."' does not exist!\n");
		}
		$fields[$pq_fn]=$pqid;

		$fields['customer_id']=YxlUsers::customer($uid);
		$fields['customer_pri']=array_search($details['urgency'],$pri2str);

		$rts->file_request($fields);
		imap_delete($mbox,$mnum);
	}

  }
  imap_close($mbox);

  function detect_message_details($ctag,&$headers,&$mtext){
  	global $details_detect;

  	$rek2str=array('subject_re'=>$headers->subject, 'body_re'=>$mtext);

  	$result['synopsis']=$headers->subject;

  	foreach(array_keys($details_detect[$ctag]) as $field){
  		$tmp=&$details_detect[$ctag][$field];
  		$result[$field]=$tmp['default'];

		foreach($tmp as $rek => $re2v){
			if(!isset($rek2str[$rek]))
				continue;

			if(!preg_match($re2v[0],$rek2str[$rek],$matches))
				continue;

			$result[$field]=count($matches)>1?$matches[1]:$re2v[1];
		}
  	}
  	return $result;
  }

  function message_is_comment($ctag,&$headers,&$text,&$hide_commen){
  	global $comment_detect;

  	if(isset($comment_detect[$ctag]['subject_re']) && count($comment_detect[$ctag]['subject_re'])){
  		foreach($comment_detect[$ctag]['subject_re'] as $re){
  			if(!preg_match($re[0],$headers->subject,$matches))
				continue;

			$hide_comment=$re[1];

  			$rids=preg_split("/[\pP\pZs]+/u",$matches[1],-1,PREG_SPLIT_NO_EMPTY);
			$uniq=array();
			foreach($rids as $r)
				arr_push($uniq,$r);

			return $uniq;
  		}
  	}

  	if(isset($comment_detect[$ctag]['body_re']) && count($comment_detect[$ctag]['body_re'])){
  		foreach($comment_detect[$ctag]['body_re'] as $re){
  			if(!preg_match($re[0],$text,$matches))
				continue;

  			$rids=preg_split("/[\pP\pZs]+/u",$matches[1],PREG_SPLIT_NO_EMPTY);
			$hide_comment=$re[1];
			return $rids;
  		}
  	}
  }

  function valid_from_address($ctag,&$from){
  	global $class_detect;
  	global $translate_domain;

  	for($i=0;$i<count($from);$i++){
  		$host=$from[$i]->host;
		if(isset($translate_domain[$host]))
			$host=$translate_domain[$host];

		$uem=$from[$i]->mailbox.'@'.$host;

		if($uid=YxlUsers::find_user_by_email($uem))
			return $uid;
	}

	if(!$class_detect[$ctag]['from_addr_check'])
  		return get_active_mu();

	return FALSE;
  }

  function detect_handler_class(&$headers,&$sig){
  	global $class_detect;
  	global $hdetector;
  	global $MyDomain;

  	$hdetector=array( 'to_addr_re'=>array('to','cc'), 'from_addr_re'=>array('from'));

	foreach($hdetector as $rek => $hks){
		foreach(array_keys($class_detect) as $ctag){
			if(!isset($class_detect[$ctag][$rek]) || !$class_detect[$ctag][$rek])
				continue;

  			foreach($hks as $hk){
				$hdr=&$headers->$hk;
  				for($i=0;$i<count($hdr);$i++){
  					$host=isset($hdr[$i]->host)?$hdr[$i]->host:$MyDomain;
  					$addr=$hdr[$i]->mailbox.'@'.$host;
  					//echo "$hk: $addr\n";

					foreach($class_detect[$ctag][$rek] as $re2v){
  						if(!preg_match($re2v[0],$addr,$matches))
							continue;

						$sig=count($matches)>1?$matches[1]:$re2v[1];
						return $ctag;
					}
				}
  			}
  		}
  	}

  	return FALSE;

  }


  function fetch_text_part($mbox,$mnum){
	$enc=FALSE;

	$bstruct=imap_fetchstructure ($mbox,$mnum);
	//print_r($bstruct);

	$pnum=first_text_part($bstruct,$enc);
	if(!$pnum)
		return FALSE;

	//echo "$pnum $enc\n";
	$body=imap_fetchbody($mbox,$mnum,$pnum);
	if($enc==3)
		return(imap_base64($body));
	elseif($enc==4)
		return(imap_qprint($body));

	return $body;
  }

  function first_text_part(&$part, &$enc, $pn=''){
	$pbt=$part->type;
	//if(($pbt=="text") || ($ctp=="message")){
	if(($pbt==0) || ($pbt==2)){
		if(!$pn)
			$pn='1';

		$enc=$part->encoding;
		return $pn;
	}elseif($pbt==1){
	// multipart
		if($pn)
			$pn.='.';

		for($i=0;$i<count($part->parts);$i++)
			if($pnum=first_text_part($part->parts[$i],$enc,$pn.($i+1)))
				return $pnum;
	}
	return FALSE;
  }


?>
